#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
//#include <libds.h>
#include "LibCD.h"
#include "LibEtc.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
#include "main.h"
#include "mathbits.h"
#include "screen.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "pads.h"
#include "sound.h"
#include "cd.h"
#include "frontend.h"

/* variable definitions */

uint8		param[8];				/* Parameters for CD control */
//char		cdbuffer[260100];
char		*cdbuffer;
uint8		cdloadstate;
uint32		cdfilelen;
//CdlFILE  	fipos[2][4];          /* file pointer */
//CdlFILE		tfp1[6];
unsigned long		*oldcallback;
CdlFILE		tempfp;

#define FORM1_SIZE     2048
#define Sectors(x) ((x+FORM1_SIZE-1)/FORM1_SIZE)


uint32 readcdbuf(uint32 start,char* readto,int32 num)
{
	uint32 i,j;
	j=start;
	for (i=0;i<num;i++)
	{
		*(readto+i)=cdbuffer[start+i];
		j++;
	}
	return j;
}

/*********************************************************************/
/** this routine loads a file from the cd into a buffer in main ram **/
/** buffer                                                          **/
/*********************************************************************/
void load_cd(char* filename,unsigned long* buffer)
{

CdlFILE  fp;          /* file pointer */
long   file_length;     /* length of file in bytes */
int   num_sectors;     /* whole number of secotors required */
int   mode = 0;       /* cd mode                           */
long   counter;

u_long*  addr;    /* pointer to an address in main ram */


printf("loading file %s\n",filename);

/* return file location and size from file name */
if (!CdSearchFile(&fp,filename))
    {
  printf("ERROR: could not find file\n");
//  exit(0);
  }

/* blocking seek to start of file */
if (!CdControlB(CdlSeekL,(unsigned char *)&fp.pos, 0))
//if (!CdControl(CdlSeekL,(unsigned char *)&fp.pos, 0))
    {
  printf("ERROR: could not do seek\n");
//  exit(0);
  }


/* calculate the number of whole sectors (2k) that need to be loaded */
/* in order to load the whole file                                   */

file_length = fp.size;
num_sectors = Sectors(file_length);

printf("File size %d bytes  sectors %d\n",file_length,num_sectors);

mode |= CdlModeSpeed;  /* double speed */


/*set the address where the file will be loaded to*/
addr=(unsigned long *)buffer;

/*execute the read */
if(!CdRead(num_sectors,addr,mode))
    {
  printf("ERROR: could not exectute read\n");
//  exit(0);
  }


printf("\n");

}
/************************************************************************/

void load_fpcd(CdlFILE* fp,unsigned long* buffer)
{

long   file_length;     /* length of file in bytes */
int   num_sectors;     /* whole number of secotors required */
int   mode = 0;       /* cd mode                           */
long   counter;

u_long*  addr;    /* pointer to an address in main ram */


//printf("loading file %s\n",filename);

/* return file location and size from file name */

/* blocking seek to start of file */
if (!CdControlB(CdlSeekL,&(fp->pos), 0))
//if (!CdControl(CdlSeekL,(unsigned char *)&fp.pos, 0))
    {
  printf("ERROR: could not do seek\n");
//  exit(0);
  }


/* calculate the number of whole sectors (2k) that need to be loaded */
/* in order to load the whole file                                   */

file_length = fp->size;
cdfilelen=file_length;
num_sectors = Sectors(file_length);

printf("File size %d bytes  sectors %d\n",file_length,num_sectors);

mode |= CdlModeSpeed;  /* double speed */


/*set the address where the file will be loaded to*/
addr=(unsigned long *)buffer;

/*execute the read */
if(!CdRead(num_sectors,addr,mode))
    {
  printf("ERROR: could not exectute read\n");
//  exit(0);
  }


printf("\n");

}
/************************************************************************/

void temploadtrackcontrol(uint32 no,uint32 a,uint32 b, uint32 c, uint32 d)
{
	trackcontrol[no].entry=d;  /* normal or entry right split */
	trackcontrol[no].entry+=c<<16;  /* entry left split if any */
	trackcontrol[no].exit=a; /* normal or exit right split */
	trackcontrol[no].exit+=b<<16;  /* exit left split if any */
}


void initfilesystem( void )
{
	numloadedtracks=73;
	numloadedobjects=210;
#ifdef CD
//	CdInit();
//	CdSetDebug(2);
	/* initialise file pointers */
	printf("blagging the chill valley file load\n");
	while (!CdSearchFile(&trackname[0],"\\TRACKS\\FOREST\\FORS1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[1],"\\TRACKS\\FOREST\\FORS2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[2],"\\TRACKS\\FOREST\\FORS3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[3],"\\TRACKS\\FOREST\\FORS4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[4],"\\TRACKS\\FOREST\\FORS5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[5],"\\TRACKS\\FOREST\\FORS6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[6],"\\TRACKS\\FOREST\\FORS7.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[7],"\\TRACKS\\FOREST\\FORS8.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[8],"\\TRACKS\\FOREST\\FORS9.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[9],"\\TRACKS\\FOREST\\FORS10.SEG;1"))
    	{
  	}

	while (!CdSearchFile(&trackname[10],"\\TRACKS\\FREERIDE\\FREE1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[11],"\\TRACKS\\FREERIDE\\FREE2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[12],"\\TRACKS\\FREERIDE\\FREE3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[13],"\\TRACKS\\FREERIDE\\FREE4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[14],"\\TRACKS\\FREERIDE\\FREE5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[15],"\\TRACKS\\FREERIDE\\FREE6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[16],"\\TRACKS\\FREERIDE\\FREE7.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[17],"\\TRACKS\\FREERIDE\\FREE8.SEG;1"))
    	{
  	}

	while (!CdSearchFile(&trackname[18],"\\TRACKS\\IT2\\IT2S5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[19],"\\TRACKS\\IT2\\IT2S6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[20],"\\TRACKS\\IT4\\IT4S1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[21],"\\TRACKS\\IT4\\IT4S2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[22],"\\TRACKS\\IT4\\IT4S3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[23],"\\TRACKS\\IT4\\IT4S4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[24],"\\TRACKS\\IT4\\IT4S5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[25],"\\TRACKS\\IT4\\IT4S6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[26],"\\TRACKS\\IT4\\IT4S7.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[27],"\\TRACKS\\IT4\\IT4S8.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[28],"\\TRACKS\\IT4\\IT4S9.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[29],"\\TRACKS\\IT4\\IT4S10.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[30],"\\TRACKS\\IT4\\IT4S11.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[31],"\\TRACKS\\IT4\\IT4S12.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[32],"\\TRACKS\\EX1\\EX1S1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[33],"\\TRACKS\\EX1\\EX1S2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[34],"\\TRACKS\\EX1\\EX1S3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[35],"\\TRACKS\\EX1\\EX1S4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[36],"\\TRACKS\\EX1\\EX1S5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[37],"\\TRACKS\\NOV1\\NT1S1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[38],"\\TRACKS\\NOV1\\NT1S2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[39],"\\TRACKS\\NOV1\\NT1S3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[40],"\\TRACKS\\NOV1\\NT1S4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[41],"\\TRACKS\\NOV1\\NT1S5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[42],"\\TRACKS\\NOV1\\NT1S6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[43],"\\TRACKS\\NOV1\\NT1S7.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[44],"\\TRACKS\\2PLAY\\TWPY1.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[45],"\\TRACKS\\2PLAY\\TWPY2.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[46],"\\TRACKS\\2PLAY\\TWPY3.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[47],"\\TRACKS\\2PLAY\\TWPY4.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[48],"\\TRACKS\\2PLAY\\TWPY5.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[49],"\\TRACKS\\2PLAY\\TWPY6.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[50],"\\TRACKS\\2PLAY\\TWPY7.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[51],"\\TRACKS\\2PLAY\\TWPY8.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[52],"\\TRACKS\\GLACIER\\GT1S1.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[53],"\\TRACKS\\GLACIER\\GT1S2.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[54],"\\TRACKS\\GLACIER\\GT1S3.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[55],"\\TRACKS\\GLACIER\\GT1S4.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[56],"\\TRACKS\\GLACIER\\GT1S5.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[57],"\\TRACKS\\GLACIER\\GT1S6.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[58],"\\TRACKS\\GLACIER\\GT1S7.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[59],"\\TRACKS\\GLACIER\\GT1S8.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[60],"\\TRACKS\\GLACIER\\GT1S9.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[61],"\\TRACKS\\GLACIER\\GT1S10.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[62],"\\TRACKS\\GLACIER\\GT1S11.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[63],"\\TRACKS\\GLACIER\\GT1S12.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[64],"\\TRACKS\\GLACIER\\GT1S13.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[65],"\\TRACKS\\GLACIER\\GT1S14.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[66],"\\TRACKS\\GLACIER\\GT1S15.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[67],"\\TRACKS\\GLACIER\\GT1S16.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[68],"\\TRACKS\\GLACIER\\GT1S17.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[69],"\\TRACKS\\GLACIER\\GT1S18.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[70],"\\TRACKS\\GLACIER\\GT1S19.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[71],"\\TRACKS\\GLACIER\\GT1S20.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[72],"\\TRACKS\\GLACIER\\GT1S21.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[73],"\\TRACKS\\GLACIER\\GT1S22.SEG;1"))
	{

	}


/* music files */

	musiccatalog[0].numtunes=2;
	while (!CdSearchFile(&musiccatalog[0].tunes[0].vabheader,"\\MUSIC\\BONEBGM\\OZRIC.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[0].vabbody,"\\MUSIC\\BONEBGM\\OZRIC.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[0].mainsep,"\\MUSIC\\BONEBGM\\OZRIC.SEP;1"))
    	{
   	}
	while (!CdSearchFile(&musiccatalog[0].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[1].vabheader,"\\MUSIC\\BONEBGM\\GRUNDGE.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[1].vabbody,"\\MUSIC\\BONEBGM\\GRUNDGE.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[1].mainsep,"\\MUSIC\\BONEBGM\\GRUNDGE.SEP;1"))
    	{
   	}
	while (!CdSearchFile(&musiccatalog[0].tunes[1].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

	musiccatalog[1].numtunes=2;
	while (!CdSearchFile(&musiccatalog[1].tunes[0].vabheader,"\\MUSIC\\GOATBGM\\FLEX.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[0].vabbody,"\\MUSIC\\GOATBGM\\FLEX.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[0].mainsep,"\\MUSIC\\GOATBGM\\FLEX.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[1].vabheader,"\\MUSIC\\GOATBGM\\SABRES.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[1].vabbody,"\\MUSIC\\GOATBGM\\SABRES.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[1].mainsep,"\\MUSIC\\GOATBGM\\SABRES.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[1].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

	musiccatalog[2].numtunes=2;
	while (!CdSearchFile(&musiccatalog[2].tunes[0].vabheader,"\\MUSIC\\TRIXBGM\\FREE.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[0].vabbody,"\\MUSIC\\TRIXBGM\\FREE.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[0].mainsep,"\\MUSIC\\TRIXBGM\\FREE.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[1].vabheader,"\\MUSIC\\TRIXBGM\\REDEYE.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[1].vabbody,"\\MUSIC\\TRIXBGM\\REDEYE.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[1].mainsep,"\\MUSIC\\TRIXBGM\\REDEYE.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[1].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

	musiccatalog[3].numtunes=5;
	while (!CdSearchFile(&musiccatalog[3].tunes[0].vabheader,"\\MUSIC\\YOYOBGM\\BUZZ.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[0].vabbody,"\\MUSIC\\YOYOBGM\\BUZZ.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[0].mainsep,"\\MUSIC\\YOYOBGM\\BUZZ.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[1].vabheader,"\\MUSIC\\YOYOBGM\\DOGZ.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[1].vabbody,"\\MUSIC\\YOYOBGM\\DOGZ.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[1].mainsep,"\\MUSIC\\YOYOBGM\\DOGZ.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[1].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[2].vabheader,"\\MUSIC\\YOYOBGM\\TECH1.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[2].vabbody,"\\MUSIC\\YOYOBGM\\TECH1.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[2].mainsep,"\\MUSIC\\YOYOBGM\\TECH1.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[2].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[3].vabheader,"\\MUSIC\\YOYOBGM\\TECH2.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[3].vabbody,"\\MUSIC\\YOYOBGM\\TECH2.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[3].mainsep,"\\MUSIC\\YOYOBGM\\TECH2.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[3].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[4].vabheader,"\\MUSIC\\YOYOBGM\\TRANCE.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[4].vabbody,"\\MUSIC\\YOYOBGM\\TRANCE.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[4].mainsep,"\\MUSIC\\YOYOBGM\\TRANCE.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[4].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	musiccatalog[4].numtunes=1;
	while (!CdSearchFile(&musiccatalog[4].tunes[0].vabheader,"\\MUSIC\\FRONTEND\\FRONTEND.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[4].tunes[0].vabbody,"\\MUSIC\\FRONTEND\\FRONTEND.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[4].tunes[0].mainsep,"\\MUSIC\\FRONTEND\\FRONTEND.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[4].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

/* texture pages */

	while (!CdSearchFile(&Texturenames[0],"\\TEXTURES\\PAGE1.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[1],"\\TEXTURES\\PAGE2.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[2],"\\TEXTURES\\PAGE3.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[3],"\\TEXTURES\\PAGE4.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[4],"\\TEXTURES\\PAGE5.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[5],"\\TEXTURES\\PAGE6.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[6],"\\TEXTURES\\PAGE7.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[7],"\\TEXTURES\\PAGE8.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[8],"\\TEXTURES\\PAGE9.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[9],"\\TEXTURES\\PAGE10.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[10],"\\TEXTURES\\PAGE1F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[11],"\\TEXTURES\\PAGE2F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[12],"\\TEXTURES\\PAGE3F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[13],"\\TEXTURES\\PAGE4F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[14],"\\TEXTURES\\PAGE5F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[15],"\\TEXTURES\\PAGE6F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[16],"\\TEXTURES\\PAGE1P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[17],"\\TEXTURES\\PAGE2P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[18],"\\TEXTURES\\PAGE3P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[19],"\\TEXTURES\\PAGE4P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[20],"\\TEXTURES\\PAGE5P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[21],"\\TEXTURES\\PAGE6P.TIM;1"))
		{
	}

/* object loadfiles */

	while (!CdSearchFile(&objectnames[0][0],"\\OBJECTS\\FOREST.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[0][1],"\\OBJECTS\\FOREST.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[1][0],"\\OBJECTS\\2PLAY.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[1][1],"\\OBJECTS\\2PLAY.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[3][0],"\\OBJECTS\\GLACIER.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[3][1],"\\OBJECTS\\GLACIER.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[4][0],"\\OBJECTS\\FOREST.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[4][1],"\\OBJECTS\\FOREST.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[8][0],"\\OBJECTS\\2PLAY.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[8][1],"\\OBJECTS\\2PLAY.CHO;1"))
		{
	}


	cdloadstate=0;

#else
//	PCinit();

	sprintf(&trackname[0][0],"tracks/forest/fors1.seg");
	sprintf(&trackname[1][0],"tracks/forest/fors2.seg");
	sprintf(&trackname[2][0],"tracks/forest/fors3.seg");
	sprintf(&trackname[3][0],"tracks/forest/fors4.seg");
	sprintf(&trackname[4][0],"tracks/forest/fors5.seg");
	sprintf(&trackname[5][0],"tracks/forest/fors6.seg");
	sprintf(&trackname[6][0],"tracks/forest/fors7.seg");
	sprintf(&trackname[7][0],"tracks/forest/fors8.seg");
	sprintf(&trackname[8][0],"tracks/forest/fors9.seg");
	sprintf(&trackname[9][0],"tracks/forest/fors10.seg");

	sprintf(&trackname[10][0],"tracks/freeride/free1.seg");
	sprintf(&trackname[11][0],"tracks/freeride/free2.seg");
	sprintf(&trackname[12][0],"tracks/freeride/free3.seg");
	sprintf(&trackname[13][0],"tracks/freeride/free4.seg");
	sprintf(&trackname[14][0],"tracks/freeride/free5.seg");
	sprintf(&trackname[15][0],"tracks/freeride/free6.seg");
	sprintf(&trackname[16][0],"tracks/freeride/free7.seg");
	sprintf(&trackname[17][0],"tracks/freeride/free8.seg");

	sprintf(&trackname[18][0],"tracks/it2/it2s5.seg");
	sprintf(&trackname[19][0],"tracks/it2/it2s6.seg");
	sprintf(&trackname[20][0],"tracks/it4/it4s1.seg");
	sprintf(&trackname[21][0],"tracks/it4/it4s2.seg");
	sprintf(&trackname[22][0],"tracks/it4/it4s3.seg");
	sprintf(&trackname[23][0],"tracks/it4/it4s4.seg");
	sprintf(&trackname[24][0],"tracks/it4/it4s5.seg");
	sprintf(&trackname[25][0],"tracks/it4/it4s6.seg");
	sprintf(&trackname[26][0],"tracks/it4/it4s7.seg");
	sprintf(&trackname[27][0],"tracks/it4/it4s8.seg");
	sprintf(&trackname[28][0],"tracks/it4/it4s9.seg");
	sprintf(&trackname[29][0],"tracks/it4/it4s10.seg");
	sprintf(&trackname[30][0],"tracks/it4/it4s11.seg");
	sprintf(&trackname[31][0],"tracks/it4/it4s12.seg");
	sprintf(&trackname[32][0],"tracks/ex1/ex1s1.seg");
	sprintf(&trackname[33][0],"tracks/ex1/ex1s2.seg");
	sprintf(&trackname[34][0],"tracks/ex1/ex1s3.seg");
	sprintf(&trackname[35][0],"tracks/ex1/ex1s4.seg");
	sprintf(&trackname[36][0],"tracks/ex1/ex1s5.seg");
	sprintf(&trackname[37][0],"tracks/nov1/nt1s1.seg");
	sprintf(&trackname[38][0],"tracks/nov1/nt1s2.seg");
	sprintf(&trackname[39][0],"tracks/nov1/nt1s3.seg");
	sprintf(&trackname[40][0],"tracks/nov1/nt1s4.seg");
	sprintf(&trackname[41][0],"tracks/nov1/nt1s5.seg");
	sprintf(&trackname[42][0],"tracks/nov1/nt1s6.seg");
	sprintf(&trackname[43][0],"tracks/nov1/nt1s7.seg");
	sprintf(&trackname[44][0],"tracks/2play/twpy1.seg");
	sprintf(&trackname[45][0],"tracks/2play/twpy2.seg");
	sprintf(&trackname[46][0],"tracks/2play/twpy3.seg");
	sprintf(&trackname[47][0],"tracks/2play/twpy4.seg");
	sprintf(&trackname[48][0],"tracks/2play/twpy5.seg");
	sprintf(&trackname[49][0],"tracks/2play/twpy6.seg");
	sprintf(&trackname[50][0],"tracks/2play/twpy7.seg");
	sprintf(&trackname[51][0],"tracks/2play/twpy8.seg");
	sprintf(&trackname[52][0],"tracks/glacier/gt1s1.seg");
	sprintf(&trackname[53][0],"tracks/glacier/gt1s2.seg");
	sprintf(&trackname[54][0],"tracks/glacier/gt1s3.seg");
	sprintf(&trackname[55][0],"tracks/glacier/gt1s4.seg");
	sprintf(&trackname[56][0],"tracks/glacier/gt1s5.seg");
	sprintf(&trackname[57][0],"tracks/glacier/gt1s6.seg");
	sprintf(&trackname[58][0],"tracks/glacier/gt1s7.seg");
	sprintf(&trackname[59][0],"tracks/glacier/gt1s8.seg");
	sprintf(&trackname[60][0],"tracks/glacier/gt1s9.seg");
	sprintf(&trackname[61][0],"tracks/glacier/gt1s10.seg");
	sprintf(&trackname[62][0],"tracks/glacier/gt1s11.seg");
	sprintf(&trackname[63][0],"tracks/glacier/gt1s12.seg");
	sprintf(&trackname[64][0],"tracks/glacier/gt1s13.seg");
	sprintf(&trackname[65][0],"tracks/glacier/gt1s14.seg");
	sprintf(&trackname[66][0],"tracks/glacier/gt1s15.seg");
	sprintf(&trackname[67][0],"tracks/glacier/gt1s16.seg");
	sprintf(&trackname[68][0],"tracks/glacier/gt1s17.seg");
	sprintf(&trackname[69][0],"tracks/glacier/gt1s18.seg");
	sprintf(&trackname[70][0],"tracks/glacier/gt1s19.seg");
	sprintf(&trackname[71][0],"tracks/glacier/gt1s20.seg");
	sprintf(&trackname[72][0],"tracks/glacier/gt1s21.seg");
	sprintf(&trackname[73][0],"tracks/glacier/gt1s22.seg");


/* texture names */

	sprintf(&Texturenames[0][0],"textures/page1.tim");
	sprintf(&Texturenames[1][0],"textures/page2.tim");
	sprintf(&Texturenames[2][0],"textures/page3.tim");
	sprintf(&Texturenames[3][0],"textures/page4.tim");
	sprintf(&Texturenames[4][0],"textures/page5.tim");
	sprintf(&Texturenames[5][0],"textures/page6.tim");
	sprintf(&Texturenames[6][0],"textures/page7.tim");
	sprintf(&Texturenames[7][0],"textures/page8.tim");
	sprintf(&Texturenames[8][0],"textures/page9.tim");
	sprintf(&Texturenames[9][0],"textures/page10.tim");
	sprintf(&Texturenames[10][0],"textures/page1f.tim");
	sprintf(&Texturenames[11][0],"textures/page2f.tim");
	sprintf(&Texturenames[12][0],"textures/page3f.tim");
	sprintf(&Texturenames[13][0],"textures/page4f.tim");
	sprintf(&Texturenames[14][0],"textures/page5f.tim");
	sprintf(&Texturenames[15][0],"textures/page6f.tim");
	sprintf(&Texturenames[16][0],"textures/page1p.tim");
	sprintf(&Texturenames[17][0],"textures/page2p.tim");
	sprintf(&Texturenames[18][0],"textures/page3p.tim");
	sprintf(&Texturenames[19][0],"textures/page4p.tim");
	sprintf(&Texturenames[20][0],"textures/page5p.tim");
	sprintf(&Texturenames[21][0],"textures/page6p.tim");



/* object name files */

	sprintf(&objectnames[0][0][0],"objects/forest.obt");
	sprintf(&objectnames[0][1][0],"objects/forest.cho");
	sprintf(&objectnames[1][0][0],"objects/2play.obt");
	sprintf(&objectnames[1][1][0],"objects/2play.cho");
	sprintf(&objectnames[3][0][0],"objects/glacier.obt");
	sprintf(&objectnames[3][1][0],"objects/glacier.cho");
	sprintf(&objectnames[4][0][0],"objects/forest.obt");
	sprintf(&objectnames[4][1][0],"objects/forest.cho");
	sprintf(&objectnames[10][0][0],"objects/2play.obt");
	sprintf(&objectnames[10][1][0],"objects/2play.cho");

#endif
	temploadtrackcontrol(0,1,0,0,0);  /* no, {r,l exit}, {r,l entry } */
	temploadtrackcontrol(1,2,0,1,0);
	temploadtrackcontrol(2,3,5,2,0);
	temploadtrackcontrol(3,4,0,2,0);
	temploadtrackcontrol(4,7,0,3,0);
	temploadtrackcontrol(5,6,0,2,0);
	temploadtrackcontrol(6,7,0,5,0);
	temploadtrackcontrol(7,8,0,4,6);
	temploadtrackcontrol(8,9,0,7,0);
	temploadtrackcontrol(9,9,0,8,0);

	temploadtrackcontrol(10,11,0,0,7);
	temploadtrackcontrol(11,12,0,10,0);
	temploadtrackcontrol(12,13,0,9,11);
	temploadtrackcontrol(13,14,0,12,0);
	temploadtrackcontrol(14,15,0,13,0);
	temploadtrackcontrol(15,16,0,14,0);
	temploadtrackcontrol(16,17,0,15,0);
	temploadtrackcontrol(17,17,0,16,0);

	temploadtrackcontrol(18,19,0,17,0);
	temploadtrackcontrol(19,6,0,18,0);
	temploadtrackcontrol(20,21,23,5,0);
	temploadtrackcontrol(21,22,0,20,0);
	temploadtrackcontrol(22,30,0,21,23);
	temploadtrackcontrol(23,22,0,20,0);
	temploadtrackcontrol(24,26,0,30,0);
	temploadtrackcontrol(25,26,0,30,0);
	temploadtrackcontrol(26,27,0,24,25);
	temploadtrackcontrol(27,28,0,26,0);
	temploadtrackcontrol(28,29,0,27,0);
	temploadtrackcontrol(29,31,0,28,0);
	temploadtrackcontrol(30,24,25,22,0);
	temploadtrackcontrol(31,0,0,29,0);
	temploadtrackcontrol(32,33,0,0,0);
	temploadtrackcontrol(33,34,0,32,0);
	temploadtrackcontrol(34,35,0,33,0);
	temploadtrackcontrol(35,36,0,34,0);
	temploadtrackcontrol(36,36,0,35,0);
	temploadtrackcontrol(37,38,0,0,0);
	temploadtrackcontrol(38,39,0,37,0);
	temploadtrackcontrol(39,40,0,38,0);
	temploadtrackcontrol(40,41,0,39,0);
	temploadtrackcontrol(41,42,0,40,0);
	temploadtrackcontrol(42,43,0,41,0);
	temploadtrackcontrol(43,43,0,42,0);

	temploadtrackcontrol(44,45,0,0,0);
	temploadtrackcontrol(45,46,0,44,0);
	temploadtrackcontrol(46,47,0,45,0);
	temploadtrackcontrol(47,48,0,46,0);
	temploadtrackcontrol(48,49,0,47,0);
	temploadtrackcontrol(49,50,0,48,0);
	temploadtrackcontrol(50,51,0,49,0);
	temploadtrackcontrol(51,51,0,50,0);

	temploadtrackcontrol(52,53,0,0,0);
	temploadtrackcontrol(53,54,0,52,0);
	temploadtrackcontrol(54,55,0,53,0);
	temploadtrackcontrol(55,56,0,54,0);
	temploadtrackcontrol(56,57,0,55,0);
	temploadtrackcontrol(57,58,0,56,0);
	temploadtrackcontrol(58,59,0,57,0);
	temploadtrackcontrol(59,60,0,58,0);
	temploadtrackcontrol(60,61,0,59,0);
	temploadtrackcontrol(61,62,65,60,0);

	temploadtrackcontrol(62,63,0,61,0);
	temploadtrackcontrol(63,64,0,62,0);
	temploadtrackcontrol(64,68,0,63,0);

	temploadtrackcontrol(65,66,0,61,0);
	temploadtrackcontrol(66,67,0,65,0);
	temploadtrackcontrol(67,68,0,66,0);

	temploadtrackcontrol(68,69,0,64,68);
	temploadtrackcontrol(69,70,0,68,0);
	temploadtrackcontrol(70,71,0,69,0);
	temploadtrackcontrol(71,72,0,70,0);
	temploadtrackcontrol(72,73,0,71,0);
	temploadtrackcontrol(73,73,0,72,0);
}

void cdsynccallback (void)
{
	cdloadstate++;
//	if (cdloadstate==4)
//	{
//		printf("callback reached %d\n",cdloadstate);
//	}
	return;
}


uint8 loadtobuffer(unsigned long* buffer,CdlFILE *fp1)
{

long   file_length;     /* length of file in bytes */
int   num_sectors;     /* whole number of secotors required */
int   mode = 0;       /* cd mode                           */
long   counter;
long fin,pcfilesize;
static u_long*  addr;    /* pointer to an address in main ram */


	switch (cdloadstate)
	{
		case (0):
		{
			oldcallback=CdSyncCallback(&cdsynccallback);
			tempfp.pos.minute=fp1->pos.minute;
			tempfp.pos.second=fp1->pos.second;
			tempfp.pos.sector=fp1->pos.sector;
			tempfp.pos.track=fp1->pos.track;
			tempfp.size=fp1->size;
			if (!CdControl(CdlSeekL,(unsigned char *)&tempfp, 0))
    		{
  				printf("ERROR: could not do seek\n");
//  				exit(0);
  			}
			cdloadstate=1;
			return 0;
			break;
		}
		case (1):
		{
//			cdloadstate=1;
			break;
		}
		case (2):
		{
//			oldcallback=CdSyncCallback(oldcallback);
//			oldcallback=CdReadCallback(&cdsynccallback);

			file_length = tempfp.size;
			num_sectors = Sectors(file_length);

//			printf("File size %d bytes  sectors %d\n",file_length,num_sectors);

			mode |= CdlModeSpeed;  /* double speed */


			/*set the address where the file will be loaded to*/
			addr=(unsigned long *)buffer;
			if (!CdControl(CdlSeekL,(unsigned char *)&(tempfp.pos), 0))
    		{
  				printf("ERROR: could not do seek\n");
//  				exit(0);
  			}
						/*execute the read */
/*			if (!CdControl(CdlSetloc,(unsigned char *)&(tempfp.pos), 0))
    		{
 				printf("ERROR: could not do setloc\n");
//  				exit(0);
 			}   */
						/*execute the read */
			if(!CdRead(num_sectors,addr,mode))
				{
  			printf("ERROR: could not exectute read\n");
//  			exit(0);
  			}

//				printf("\n");
			cdloadstate=3;
			return 0;
			break;
		}
		case (3):
		{
//			cdloadstate=3;
			break;
		}

		case (4):
		{
			oldcallback=CdSyncCallback(oldcallback);
			cdloadstate=0;
			return 1;
			break;
		}
	}
}




