/* tracks.c */

#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibEtc.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
#include "main.h"
#include "cd.h"
#include "sound.h"
#include "mathbits.h"
#include "screen.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "pads.h"
#include "profile.h"
#include "skeleton.h"
#include "who.h"
#include "frontend.h"
#include "plume.h"
#include "rotmeshs.h"
#include "animctrl.h"
#include <inline_o.h>
#include <gtemac.h>
#include "avalanch.h"

/* variable definitions */

#define DMPSX_MACRO

long	polys_taken;
uint32	currentfile[2]={ 0 , 0 };
uint8	setdisplay=0;
uint8	fileloaded[2];
long	unusedpolys[2];
uint8		display_id;
uint8		otid;
uint8		rotid;
uint8		TopScreenDrawn;
uint32		OrderingTable[4][OTLENGTH];
uint32		*OTPtr;
trackdispbuffer Tb[2];
uint32		align1;
incomingtrackbuffer Ib1[2], Ib2[2], *IBuf[2], *LoadBuf[2];
int32	d1,height;
int32	last[2];
int32	CPoly[2];
int32	CSub[2];
int32  cos90;
int32	sin90;
uint32	geomtree=340;
uint32	nopolyG3s;
POLY_G3	trackprims[4][1000];
POLY_G3	codeprim;

VECTOR	tX,tY;
int32	pX,pZ,lX,lZ;
uint16	skiablecp;

uint8	novsyncs=0;
uint8	noframes=0;
uint8	fps;
/* split tracks shit */

uint32	teststrip[2];
uint32	endstrip[2];
uint32	splittaken[2];

/* chill valley file stuff */

uint8	CP;
uint16  Cnt;
uint16	cntadjust;
uint8	bufftest0;
uint8	bufftest;
uint8	bufftest2;
/* object shit */
trackobject *objectptr;

MATRIX		ObjectRotation;
MATRIX		ObjectTrans;
char		ObjectSpace[135168];
SVECTOR		textrotvec;
MATRIX		textmatrix;
objheader	ChillObjects[220];

POLY_FT4	polyf4s[4][400];
POLY_FT3	polyf3s[4][100];
POLY_F4		poly4s[4][10];
POLY_F3		poly3s[4][10];
long		nopolyf4s;
long		nopoly4s;
long		nopolyf3s;
long		nopoly3s;
//__attribute__((section("spad.text")))
//long		sxy[200]  __attribute__((section("spad.text")));
long		sxy[200];
//long		p[200];
long		ootz[200];
CVECTOR		outputcolour;
SVECTOR		*vertexptr;
objpolygon	*polyptr;
SVECTOR		redtreeverts[4];
uint32		objaddress;
long		*longptr;
long		numverts;
long		numpolys;
uint16		objtpage;
uint16		objclut;
uint32		objectno;
uint32		objecttype;
uint8		firstobject;
long		maxobjot;
//long		stripots[MAX_VIEW_STRIPS];
long		obbufferswap[2];
//objotsort	objsort[100] __attribute__((section("spad.text")));
uint16		maxdrawn=0;
long		mountfog=400;
uint8		cablecarno;
uint8		noccars;
cableinfo	cars[10];

/* collision detection shit */

uint8	firstgety[2];
uint8	pstartcount;
uint8	pendcount;

iscoll	thiscollision[4];
int32	objectheight;
int32	objectlowheight;
int32	innerrad;
int32	outerrad;
int32	prad;
int32	scalerad;
uint8	skiablefound[2];
VECTOR	angvec1;
VECTOR	angvec2;
VECTOR  angvec3;
VECTOR	angvec4;
VECTOR	B1;
VECTOR	B2;
VECTOR 	B3;
VECTOR	B4;
VECTOR	S1;
VECTOR	S2;
VECTOR	S3;
VECTOR	S4;
SVECTOR singlerotvec;
MATRIX	singlematrix;
MATRIX	collmatrix;
int32	thisx;
int32	thisy;
int32	thisz;
int32	vx[5];
int32	vz[5];
int32	cres[5];
int32	res[5];
int32	temp1;
int32	thisres;

long nodivs;
long maxcharot;

/* character shit */

//objotsort	charsort[800];
uint8		charprimsdrawn=0;

/* textured track polys */

texttrackpoly *textptr;
//POLY_FT3	polygt3s[4][250];
CVECTOR		outcols[4][6];
MATRIX		texttransmatrix;
uint8		outcoltog=0;
uint16		textno=0;
uint8		firsttextpoly;

/* mountain grid */

int32		z1,d2;
CVECTOR		fc1,bc1;
POLY_F4		mist[4];
int32		skieddown[2];
int32		startski[2]={0,0};

int16 *address;

VECTOR		Scale;

MATRIX		mountmatrix[2];

/* track direction stuff */

uint8		firstdirection[2];
int16	    trackdirection[2];
int16		newdirection[2]={1,1};
uint8		revswapped;
MATRIX		dirrotmat;
SVECTOR		dirrotvec;
//uint8		bufstartcnt[P->Buffer]=0;

/* split tracks */

uint8		whichside[2];
stinfo		previousinfo[2][100];
uint8		previouscount[2];
uint8		bufferswappos[2];
int16 		bufferswapcount[2];
uint8		bufferfilled[2];
uint32		splitdecode1[2];
uint32		splitdecode2[2];
uint32		splitdecode3[2];
uint32		splitdecode4[2];
uint32		filetoload[2];
uint32		endtrack[2];


DIVPOLYGON3 divwork3;
DIVPOLYGON4 divwork4;
DIVPOLYGON3 *divptr;

/* weather */

long noflines;
uint8 numflakes=0;
uint8 howsnowy[2]={0,0};
uint16 howfoggy[2]={0,0};
uint8 snowspeed=10;
uint8 currsnowy=0;
SVECTOR flakeverts[150];
//VECTOR flaketrans[400];
LINE_F2 flakelines[4][200];
long ssx=0;
long ssy=0;
long ssz=0;
int32 randarray[40];
int32 randcount;

/* moveable objects */

//char challbuffer[6144];
moveobj *moveptr;
//POLY_F4 pickshads[4][30];
uint16	noshads;
uint8	trainmove;

/* overlays */

uint32 globaltime[2];
uint8  clockon[2]={0,0};
uint8 clockset[2];
uint8	clockststrip;
uint8	clocksttrack;
uint32 hours;
uint32 minutes;
uint32 seconds;
uint32 decsecs;
char timestr[20];
POLY_FT4 timepolys[4];
POLY_FT4 chillpolys[4];
POLY_FT4 scorepolys[4];
POLY_FT4 trickpolys[4];
POLY_FT4 speedpolys[4];
POLY_FT4 namepolys[8][3];
RECT timecopyrect;
uint32	tempchill=0;
uint16  lastchillscore;
uint16	scorecounter;
uint32	lasttime;
uint32	lastscore;
uint8	framelock;


POLY_F4	clipblag[4];
int16	maxmounty;
uint32	*vertstoreaddr=0x1f800000;
uint8	arsecandle=0;
uint8	carson;

uint32	storecount[2],storepcount[2];
long	lastcompvalue[2],lastretvalue[2];

int32	fuckbox=0;

/* temp music*/

uint8	musiccnt=0;
uint32	deltime;
uint8	playwhoah=0;



#ifndef CD
uint32	numloadedtracks;
char 	trackname[MAX_TRACKS][100];
uint32	numloadedobjects;
#else
uint32	numloadedtracks;
CdlFILE trackname[MAX_TRACKS];
uint32	numloadedobjects;
#endif
tcontrol trackcontrol[MAX_TRACKS];

long	retvalue,compvalue,tempcomp;
int32 dirdot;




	char floatinput[100],floatoutput[100];
	double floatcos,floatinvcos;
	long cosangle,invcosangle,thisrem,thisdiv,thisdigit;


uint8	Collision(uint8 PlayerNumber)
{
	player *P=&Player[PlayerNumber];

	return thiscollision[P->Buffer].type;
}

vec3	CollidePoint(uint8 PlayerNumber)
{
	player *P=&Player[PlayerNumber];

	return (thiscollision[P->Buffer].point);
}

chfloat CollideAngle(uint8 PlayerNumber)
{
	player *P=&Player[PlayerNumber];
	uint8	i,j,k,neg;

/*	cosangle=thiscollision[P->Buffer].angle;
	cosangle*=10000;
	cosangle/=4096;
	thisdiv=10000;
	neg=0;
	if (cosangle<0)
	{
//		cosangle=-cosangle;
		neg=1;
		j=0;
	}
	else
	{
		j=0;
	}
	for (i=0;i<5;i++)
	{
		thisdigit=(cosangle/thisdiv)+48;
		floatinput[j]=(char *)thisdigit;
		cosangle-=((thisdigit-48)*thisdiv);
		thisdiv/=10;
		j++;
		if (i==0)
		{
			floatinput[j]='.';
			j++;
		}
	}
	floatinput[j]=0;
	floatcos=atof(&floatinput[0]);
	if (neg==1)
	{
		floatcos=-floatcos;
	}
	floatinvcos=acos(floatcos);
	floatinvcos*=100000;
	printf2("f G:%g \n",floatinvcos);
	sprintf2(&floatoutput[0],"%g",floatinvcos);
	invcosangle=atol(&floatoutput[0]);
	printf("invcos rads = %d\n",invcosangle);
	invcosangle*=2048;
	invcosangle/=31416;
	invcosangle/=10;
//	if (neg==1)
//	{
//		invcosangle=-invcosangle;
//	}
	printf("invcos deg = %d\n",(invcosangle*360/4096));
  	return(P->Rot.Y-(invcosangle<<12));	*/
	printf("angle %d\n",thiscollision[P->Buffer].angle*360/4096);
	return (thiscollision[P->Buffer].angle<<12);
}

chfloat RailAngle(uint8	PlayerNumber)
{
	player *P=&Player[PlayerNumber];

	return thiscollision[P->Buffer].angle;
}


void initobjects(void )
{
	uint32		fh;
	long		filesize;
	uint8		c1;
	uint8		*objloadptr;
	uint32		a1,a2,a3,a4;

	objloadptr	=	&ObjectSpace;
	a4=&ObjectSpace;
#ifndef CD
	fh			=	PCopen( &objectnames[thistrack][1][0], 0, 0 );
	filesize	=	PClseek( fh, 0, 2 );
	PClseek( fh, 0, 0 );
	PCread( fh, (char *)&ChillObjects[0], filesize );
	PCclose( fh );

#else
	load_fpcd(&objectnames[thistrack][1],(char *)&ChillObjects[0]);
	do
 	{
	}
 	while (CdReadSync(1,0) > 0 );
	filesize=cdfilelen;
#endif

#ifndef CD
	fh			=	PCopen( &objectnames[thistrack][0][0], 0, 0 );
	filesize	=	PClseek( fh, 0, 2 );
	PClseek( fh, 0, 0 );
	PCread( fh, (char *)objloadptr, filesize );
	PCclose( fh );

#else
	load_fpcd(&objectnames[thistrack][0],(char *)objloadptr);
	do
 	{
	}
 	while (CdReadSync(1,0) > 0 );
	filesize=cdfilelen;
#endif
	for (c1=0;c1<numloadedobjects;c1++)
	{
		if (ChillObjects[c1].loaded==1)
		{
			a1=ChillObjects[c1].vertptr;
			a1+=a4;
			ChillObjects[c1].vertptr=a1;
			a2=ChillObjects[c1].polyptr;
			a2+=a4;
			ChillObjects[c1].polyptr=a2;
			a3=ChillObjects[c1].collptr;
			a3+=a4;
			ChillObjects[c1].collptr=a3;
		}
	}
}

void DrawMountains(playerno)
{
	trackobject *objectptr;
	objcoll     *collisionptr;
	unsigned long address;
	player *P=&Player[playerno];
	uint32	i,j,whichaddr,maxprims;
	uint16  stripno;
	VECTOR	Y,ObjectScale,ST,RT;
	SVECTOR	ObjRotVec,GlobalRot,X,loadvert;
	long	XY0,XY1,XY2,depth,flag,thisotz,thisp,outer,tempvz;
	long	coldx,coldz,collength,thisouter,nodrawnpolys;
	long	mask=0xff;
	uint32	textus;
	uint32	textvs;
	uint32	verts;
	uint32 tmatid;
	POLY_FT4 *ft4ptr;

	if (ConsolePlayers==2)
	{
		if (currentsave.options[SPLIT_SET]==0)
		{
			gte_SetGeomOffset(60,160);
		}
		else
		{
			gte_SetGeomOffset(120,80);
		}
	}
	else
	{
		gte_SetGeomOffset(120,160);
	}
	gte_SetGeomScreen(geomscreen);

//	ST.vy=P->Cam.ObjectView.m[ 0 ][ 1 ];
//	ST.vz=P->Cam.ObjectView.m[ 0 ][ 2 ];
//	RT.vx=P->Cam.ViewMatrix.m[ 1 ][ 0 ];
//	RT.vy=P->Cam.ViewMatrix.m[ 1 ][ 1 ];
//	RT.vz=P->Cam.ViewMatrix.m[ 1 ][ 2 ];


//	P->Cam.ObjectView.m[ 0 ][ 1 ]/=2;
//	P->Cam.ObjectView.m[ 0 ][ 2 ]/=4;
//	P->Cam.ViewMatrix.m[ 1 ][ 0 ]/=2;
//	P->Cam.ViewMatrix.m[ 1 ][ 1 ]/=2;
//	P->Cam.ViewMatrix.m[ 1 ][ 2 ]/=2;

	gte_SetRotMatrix(&P->Cam.ViewMatrix);

	ObjRotVec.vx=0;
	ObjRotVec.vy=0;
   	ObjRotVec.vz=0;

	X.vx=0;
	X.vy=-200;
//	X.vy=fuckbox;
	X.vz=0;

	ApplyRotMatrix(&X,&Y);
	ObjectTrans.t[1]=Y.vx;
	ObjectTrans.t[0]=Y.vy+skieddown[P->Buffer];
//	ObjectTrans.t[0]=Y.vy;
	ObjectTrans.t[2]=Y.vz;
	tempvz=ObjRotVec.vz;
	ObjRotVec.vz=0;
	RotMatrix(&ObjRotVec,&ObjectRotation);
	RotMatrixZ(tempvz,&ObjectRotation);
//	gte_SetRotMatrix(&P->Cam.ObjectView);
	gte_SetRotMatrix(&mountmatrix[P->Buffer]);
	MulRotMatrix(&ObjectRotation);

	ObjectScale.vx=4096;
	ObjectScale.vy=5096;
	ObjectScale.vz=4096;
	ScaleMatrix(&ObjectRotation,&ObjectScale);
	gte_SetRotMatrix(&ObjectRotation);
	gte_SetTransMatrix(&ObjectTrans);
	numverts=ChillObjects[0].numverts;
	numpolys=ChillObjects[0].numpolys;
	vertexptr=ChillObjects[0].vertptr;
	polyptr=ChillObjects[0].polyptr;

	/* object collision detection */
	thisp=howfoggy[P->Buffer]*164;
	if (thisp>4096)
	{
		thisp=4096;
	}
	loadvert.vx=vertexptr->vx;
	loadvert.vy=vertexptr->vy;
	loadvert.vz=vertexptr->vz;
	for (i=0;i<numverts;i++)
	{
		gte_ldv0(&loadvert);
        gte_rtps();
		loadvert.vx=(vertexptr+(i+1))->vx;
		loadvert.vy=(vertexptr+(i+1))->vy;
		loadvert.vz=(vertexptr+(i+1))->vz;
        gte_stsxy(vertstoreaddr+i);
//	    gte_stdp(&p[i]);
		gte_stszotz(vertstoreaddr+125+i);
	}
	thisp/=1024;
	maxmounty=239;
	for (i=0;i<numpolys;i++)
	{
		thisotz=0;
		for (j=0;j<(polyptr+i)->numverts;j++)
		{
			thisotz+=*(vertstoreaddr+125+(((polyptr+i)->vertptr>>(8*j))&0xff));
//			thisp+=p[(polyptr+i)->vertptr[j]];
		}
		thisotz/=(polyptr+i)->numverts;
		if ((thisotz>=16)&&(thisotz<2000))
		{
//			gte_NormalClip(*(vertstoreaddr+(((polyptr+i)->vertptr>>24)&0xff)),*(vertstoreaddr+(((polyptr+i)->vertptr>>8)&0xff)),
//					  				*(vertstoreaddr+(((polyptr+i)->vertptr)&0xff)),&thisouter);
//			if (thisouter>=0)
			if (1)
			{
				SKBADDPRIMLOCALS

//				setRGB0(&polyf4s[otid][nopolyf4s],127,127,127);

				ft4ptr=&polyf4s[otid][nopolyf4s];
				textus=(polyptr+i)->textus;
				textvs=(polyptr+i)->textvs;
				verts=(polyptr+i)->vertptr;
				tmatid=(polyptr+i)->tmatid;

				*(uint32 *)&(ft4ptr->r0)=(44<<24)|(132<<16)|(132<<8)|132;

				*(uint16 *)&(ft4ptr->u0)=(textvs&0xff)<<8|textus&0xff;
//				ft4ptr->v0=;
				*(uint16 *)&(ft4ptr->u1)=((textvs>>8)&0xff)<<8|(textus>>8)&0xff;
//				ft4ptr->v1=;
				*(uint16 *)&(ft4ptr->u2)=((textvs>>24)&0xff)<<8|(textus>>24)&0xff;
//				ft4ptr->v2=;
				*(uint16 *)&(ft4ptr->u3)=((textvs>>16)&0xff)<<8|(textus>>16)&0xff;
//				ft4ptr->v3=;
				ft4ptr->tpage=tids[tmatid].textpage;
				ft4ptr->clut=tids[tmatid].clutline[thisp];
				ft4ptr->x0=(*(vertstoreaddr+((verts&mask))))>>16;
				ft4ptr->y0=(*(vertstoreaddr+((verts&mask))))&0xffff;
				ft4ptr->x1=(*(vertstoreaddr+((verts>>8)&mask)))>>16;
				ft4ptr->y1=(*(vertstoreaddr+((verts>>8)&mask)))&0xffff,
				ft4ptr->x2=(*(vertstoreaddr+((verts>>24)&mask)))>>16,
				ft4ptr->y2=(*(vertstoreaddr+((verts>>24)&mask)))&0xffff,
				ft4ptr->x3=(*(vertstoreaddr+((verts>>16)&mask)))>>16,
				ft4ptr->y3=(*(vertstoreaddr+((verts>>16)&mask)))&0xffff;

/*				setXY4(&polyf4s[otid][nopolyf4s],((*(vertstoreaddr+((polyptr+i)->vertptr&0xff)))&0xffff0000)>>16,
											(*(vertstoreaddr+((polyptr+i)->vertptr&0xff)))&0xffff,
											((*(vertstoreaddr+(((polyptr+i)->vertptr>>8)&0xff)))&0xffff0000)>>16,
											(*(vertstoreaddr+(((polyptr+i)->vertptr>>8)&0xff)))&0xffff,
											((*(vertstoreaddr+(((polyptr+i)->vertptr>>24)&0xff)))&0xffff0000)>>16,
											(*(vertstoreaddr+(((polyptr+i)->vertptr>>24)&0xff)))&0xffff,
											((*(vertstoreaddr+(((polyptr+i)->vertptr>>16)&0xff)))&0xffff0000)>>16,
											(*(vertstoreaddr+(((polyptr+i)->vertptr>>16)&0xff)))&0xffff);	*/

				if (ft4ptr->y0<maxmounty)
				{
					if ((ft4ptr->x0>0)&&(ft4ptr->x0<320))
					{
						maxmounty=ft4ptr->y0;
						if (maxmounty<0)
						{
							maxmounty=0;
						}
					}
				}
//				SetPolyFT4(ft4ptr);
				OTPtr=&(OrderingTable[otid][OTLENGTH-2]);
				SKBADDPRIM(OTPtr,ft4ptr)
//				AddPrim(OTPtr,&polyf4s[otid][nopolyf4s]);
				nopolyf4s++;
			}
		}
	}
//	ObjectScale.vx=7168;
//	ObjectScale.vy=4096;
//	ObjectScale.vz=4096;
//	ScaleMatrix(&P->Cam.ViewMatrix,&ObjectScale);

//	P->Cam.ObjectView.m[ 0 ][ 1 ]=ST.vy;
//	P->Cam.ObjectView.m[ 0 ][ 2 ]=ST.vz;
//	P->Cam.ViewMatrix.m[ 1 ][ 0 ]=RT.vx;
//	P->Cam.ViewMatrix.m[ 1 ][ 1 ]=RT.vy;
//	P->Cam.ViewMatrix.m[ 1 ][ 2 ]=RT.vz;
}

uint8	CheckBounds(int32 x,int32 z,uint16 strip,uint16 poly,uint8 pno,uint8 whichtest)
{
	int16 f1,f2;
	int32 v1x,v1z,v2x,v2z,temp,res1,res2,cres1,cres2,v2xstore,v2zstore;
	player *P=&Player[ pno ];
	int32 length;
	uint32 a1;
	SVECTOR dirx,*svptr1,*svptr2;
	VECTOR result,diry;

	if (whichtest==0)
	{
/*		x>>=12;
		x=-x;
		z>>=12;
		length=P->Track->Meshes[ strip ].TMesh.len-1;
		address=(P->Track->Meshes[ strip ].TMesh.v);
		a1=((length-1)*4);
		address+=a1;
		f1=P->Track->Meshes[ strip ].TMesh.v->vx;
		f2=*address;
		v1x=f2-f1;
		address=P->Track->Meshes[ strip ].TMesh.v;
		a1=((length-1)*4);
		a1+=2;
		address+=a1;
		f1=P->Track->Meshes[ strip ].TMesh.v->vz;
		f2=*address;
		v1z=f2-f1;
		address=P->Track->Meshes[ strip ].TMesh.v;
		a1=4;
		address+=a1;
		f1=*address;
		address=P->Track->Meshes[ strip ].TMesh.v;
		a1=length*4;
		address+=a1;
		f2=*address;
		v2x=f2-f1;
		address=P->Track->Meshes[ strip ].TMesh.v;
		a1=4;
		a1+=2;
		address+=a1;
		f1=*address;
		address=P->Track->Meshes[ strip ].TMesh.v;
		a1=length*4;
		a1+=2;
		address+=a1;
		f2=*address;
		v2z=f2-f1;

//		x-=P->Cam.TransMatrix.t[0];                 transform if not first segment
//		z+=P->Cam.TransMatrix.t[2];					transform if not first segment
		*/
	}
	else
	{
		length=poly*2;
		f1=(P->Track->Meshes[ strip ].TMesh.v+length)->vx;
		f2=(P->Track->Meshes[ strip ].TMesh.v+length+2)->vx;
		v1x=f2-f1;
		f1=(P->Track->Meshes[ strip ].TMesh.v+length)->vz;
		f2=(P->Track->Meshes[ strip ].TMesh.v+length+2)->vz;
		v1z=f2-f1;
		f1=(P->Track->Meshes[ strip ].TMesh.v+length+1)->vx;
		f2=(P->Track->Meshes[ strip ].TMesh.v+length+3)->vx;
		v2x=f2-f1;
		f1=(P->Track->Meshes[ strip ].TMesh.v+length+1)->vz;
		f2=(P->Track->Meshes[ strip ].TMesh.v+length+3)->vz;
		v2z=f2-f1;
	}
	temp=v1x;
	v1x=((v1x*cos90)-(v1z*sin90))>>6;
	v1z=((temp*sin90)+(v1z*cos90))>>6;
	temp=v2x;
	v2x=((v2x*cos90)-(v2z*sin90))>>6;
	v2z=((temp*sin90)+(v2z*cos90))>>6;
//	v2xstore=v2x;
//	v2zstore=v2z;
	if (whichtest==0)
	{
/*		address=P->Track->Meshes[ strip ].TMesh.v;
		a1=(length-1)*4;
		f1=*(address+a1);
		f2=*(address+a1+2);
		cres1=-((v1x*f1)+(v1z*f2));
		a1=length*4;
		f1=*(address+a1);
		f2=*(address+a1+2);
		cres2=-((v2x*f1)+(v2z*f2));	*/
	}
	else
	{
		address=P->Track->Meshes[ strip ].TMesh.v;
		a1=(length+2)*4;
		f1=*(address+a1);
		f2=*(address+a1+2);
		cres1=-((v1x*f1)+(v1z*f2));
		a1=(length+3)*4;
		f1=*(address+a1);
		f2=*(address+a1+2);
		cres2=-((v2x*f1)+(v2z*f2));
	}
	res1=-((v1x*x)+(v1z*z));
	res2=-((v2x*x)+(v2z*z));
	if ((res1<=cres1)&&(res2>=cres2))
	{
		if (whichtest==0)
		{
/*			length=P->Track->Meshes[ strip ].TMesh.len-1;
			address=(P->Track->Meshes[ strip ].TMesh.v);
			a1=4;
			address+=a1;
			f1=P->Track->Meshes[ strip ].TMesh.v->vx;
			f2=*address;
			v1x=f2-f1;
			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=4;
			a1+=2;
			address+=a1;
			f1=P->Track->Meshes[ strip ].TMesh.v->vz;
			f2=*address;
			v1z=f2-f1;
			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=(length-1)*4;
			address+=a1;
			f1=*address;
			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=length*4;
			address+=a1;
			f2=*address;
			v2x=f2-f1;
			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=(length-1)*4;
			a1+=2;
			address+=a1;
			f1=*address;
			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=length*4;
			a1+=2;
			address+=a1;
			f2=*address;
			v2z=f2-f1;   */
		}
		else
		{
			length=poly*2;
			f1=(P->Track->Meshes[ strip ].TMesh.v+length)->vx;
			f2=(P->Track->Meshes[ strip ].TMesh.v+length+1)->vx;

			v1x=f2-f1;

			f1=(P->Track->Meshes[ strip ].TMesh.v+length)->vz;
   			f2=(P->Track->Meshes[ strip ].TMesh.v+length+1)->vz;
			v1z=f2-f1;

			f1=(P->Track->Meshes[ strip ].TMesh.v+length+2)->vx;
   			f2=(P->Track->Meshes[ strip ].TMesh.v+length+3)->vx;

			v2x=f2-f1;

			f1=(P->Track->Meshes[ strip ].TMesh.v+length+2)->vz;
   			f2=(P->Track->Meshes[ strip ].TMesh.v+length+3)->vz;

			v2z=f2-f1;

		}
		temp=v1x;
		v2xstore=v1x;
		v2zstore=-v1z;
		v1x=((v1x*cos90)-(v1z*sin90))>>6;
		v1z=((temp*sin90)+(v1z*cos90))>>6;
		temp=v2x;
		v2x=((v2x*cos90)-(v2z*sin90))>>6;
		v2z=((temp*sin90)+(v2z*cos90))>>6;
//		v2xstore=v2x;
//		v2zstore=v2z;

		if (whichtest==0)
		{
/*			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=4;
			f1=*(address+a1);
			f2=*(address+a1+2);
			cres1=-((v1x*f1)+(v1z*f2));
			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=length*4;
			address+=a1;
			f1=*address;
			address+=2;
			f2=*address;
			cres2=-((v2x*f1)+(v2z*f2));
			res1=-((v1x*x)+(v1z*z));
			res2=-((v2x*x)+(v2z*z));
			if (res1<cres1)
			{
				thiscollision[P->Buffer].type=TRACKEDGE;
				vx[4]=(P->Pos.X-P->LastPos.X)>>12;
				vz[4]=(P->Pos.Z-P->LastPos.Z)>>12;
				temp1=vx[5];
				vx[4]=((vx[4]*cos90)-(vz[4]*sin90));
				vz[4]=((temp1*sin90)+(vz[4]*cos90));
				angvec1.vx=vx[4];
				angvec1.vy=0;
				angvec1.vz=vz[4];
				angvec2.vx=v1x;
				angvec2.vz=v1z;
				thiscollision[P->Buffer].angle=PSX_Dot(&angvec1,&angvec2)>>12;
				thiscollision[P->Buffer].angle*=2;
				thisx=P->Pos.X-P->LastPos.X;
				thisy=P->Pos.Y-P->LastPos.Y;
				thisz=P->Pos.Z-P->LastPos.Z;
				thisres=-((v1x*(P->Pos.X+thisx))*(v1z*(P->LastPos.Z)+thisz));
				thiscollision[P->Buffer].point.X=P->Pos.X+thisx;
				thiscollision[P->Buffer].point.Y=P->Pos.Y+thisy;
				thiscollision[P->Buffer].point.Z=P->Pos.Z+thisz;
			}
			if (res2>cres2)
			{
				thiscollision[P->Buffer].type=TRACKEDGE;
				vx[4]=(P->Pos.X-P->LastPos.X)>>12;
				vz[4]=(P->Pos.Z-P->LastPos.Z)>>12;
				temp1=vx[4];
				vx[4]=((vx[4]*cos90)-(vz[4]*sin90));
				vz[4]=((temp1*sin90)+(vz[4]*cos90));
				angvec1.vx=vx[4];
				angvec1.vy=0;
				angvec1.vz=vz[4];
				angvec2.vx=v2x;
				angvec2.vz=v2z;
				thiscollision[P->Buffer].angle=PSX_Dot(&angvec1,&angvec2)>>12;
				thiscollision[P->Buffer].angle*=2;
				thisx=P->Pos.X-P->LastPos.X;
				thisy=P->Pos.Y-P->LastPos.Y;
				thisz=P->Pos.Z-P->LastPos.Z;
				thisres=-((v2x*(P->Pos.X+thisx))*(v2z*(P->Pos.Z)+thisz));
				thiscollision[P->Buffer].point.X=P->Pos.X+thisx;
				thiscollision[P->Buffer].point.Y=P->Pos.Y+thisy;
				thiscollision[P->Buffer].point.Z=P->Pos.Z+thisz;
			}   */
		}
		else
		{
			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=length*4;
			f1=*(address+a1);
			f2=*(address+a1+2);
			cres1=-((v1x*f1)+(v1z*f2));
			address=P->Track->Meshes[ strip ].TMesh.v;
			a1=(length+2)*4;
			address+=a1;
			f1=*address;
			address+=2;
			f2=*address;
			cres2=-((v2x*f1)+(v2z*f2));
	   		res1=-((v1x*x)+(v1z*z));
			res2=-((v2x*x)+(v2z*z));
		}
		if ((res1>=cres1)&&(res2<=cres2))
		{
			if (firstdirection[P->Buffer]==0)
			{
//				dirrotvec.vx=dirrotvec.vz=0;
//				dirrotvec.vy=P->Rot.Y>>12;
//				dirx.vx=0;
//				dirx.vy=0;
//				dirx.vz=4096;
//				dirx.vx=((dirx.vx*rcos(dirrotvec.vy))-(dirx.vz*rsin(dirrotvec.vy)))>>12;
//				dirx.vz=((dirx.vy*rsin(dirrotvec.vy))+(dirx.vz*rcos(dirrotvec.vy)))>>12;
/*				result.vx=rsin((P->Cam.SweepAngle>>12));
				result.vy=0;
				result.vz=rcos((P->Cam.SweepAngle>>12));
//				VectorNormalS(&dirx,&result);
				result.vy=0;
				diry.vx=v2xstore;
				diry.vy=0;
				diry.vz=v2zstore;
				VectorNormalS(&diry,&dirx);
				diry.vx=dirx.vx;
				diry.vy=dirx.vy;
				diry.vz=dirx.vz;  */

				dirrotvec.vx=dirrotvec.vz=0;
//				dirrotvec.vy=(P->Rot.Y>>12)&4095;
				dirrotvec.vy=(P->Cam.SweepAngle>>12)&4095;
				RotMatrix(&dirrotvec,&dirrotmat);
//				gte_SetRotMatrix(&P->Cam.ObjectView);
				dirx.vx=0;
				dirx.vy=0;
				dirx.vz=4096;
				ApplyMatrix(&dirrotmat,&dirx,&result);
//				ApplyRotMatrix(&dirx,&result);
	//			result.vx=((P->Pos.X+1)-P->LastPos.X)>>12;
	//			result.vy=0;
	//			result.vz=((P->Pos.Z+1)-P->LastPos.Z)>>12;
//				result.vx>>=12;
				result.vy=0;
//				result.vz>>=12;
				diry.vx=v2xstore;
				diry.vy=0;
				diry.vz=v2zstore;
				VectorNormalS(&diry,&dirx);
				diry.vx=dirx.vx;
				diry.vy=dirx.vy;
				diry.vz=dirx.vz;

				dirdot=PSX_Dot(&diry,&result);

				if (trackdirection[P->Buffer]==1)
				{
					if (dirdot<(1000<<12))
					{
						newdirection[P->Buffer]=0;
					}
					else
					{
						newdirection[P->Buffer]=1;
					}
				}
				else
				{
					if (trackdirection[P->Buffer]==0)
					{

						if (dirdot>1200<<12)
						{
							newdirection[P->Buffer]=1;
						}
						else
						{
							newdirection[P->Buffer]=0;
						}
					}
				}
				firstdirection[P->Buffer]=1;
			}
			return 1;
		}
		else
		{
			return 0;
		}
	}
	else
	{
		return 0;
	}

}



chfloat	GetYAt(chfloat px, chfloat pz, uint8 pno)
{
	player *P;
	uint8	found,letthrough;
	uint16	count,thispoly,polycount;
	VECTOR	v1,v2,cross;
	VECTOR TempVertex;
	int32  x,z;
	TMESH *tmeshptr;
	trianglemesh *meshptr;
	unsigned long	tag_val;

	found=0;
	retvalue=0;
	letthrough=0;
	x=px>>12;
	x=-x;
	z=pz>>12;
	if ((pno&0x80)==0x80)
	{
		pno-=0x80;
		firstgety[Player[pno].Buffer]=0;
	}
	P=&Player[ pno ];
//	x-=P->Cam.TransMatrix.t[0];      if not first segment transform
//	z+=P->Cam.TransMatrix.t[2];		 if not first segment transform
	if ((thiscollision[P->Buffer].type==TOP)||(thiscollision[P->Buffer].type==RAILSLIDE))
	{
		x-=P->Track->Meshes[skiablecp].OffsetX;
		z-=P->Track->Meshes[skiablecp].OffsetZ;
//		x=-x;
		TempVertex.vx=S1.vx;
		TempVertex.vy=(S1.vy);	//+thiscollision[P->Buffer].height;
		TempVertex.vz=S1.vz;
		v1.vx=S2.vx;
		v1.vy=(S2.vy);	//+thiscollision[P->Buffer].height;
		v1.vz=S2.vz;
		v2.vx=S3.vx;
		v2.vy=(S3.vy);	//+thiscollision[P->Buffer].height;
		v2.vz=S3.vz;
		v1.vx-=TempVertex.vx;
		v1.vy-=TempVertex.vy;
		v1.vz-=TempVertex.vz;
		v2.vx-=TempVertex.vx;
		v2.vy-=TempVertex.vy;
		v2.vz-=TempVertex.vz;
		gte_OuterProduct0(&v1,&v2,&cross);
		cross.vx>>12;
		cross.vy>>12;
		cross.vz>>12;

		if (cross.vy!=0)
		{
			d1=-((cross.vx*TempVertex.vx)+(cross.vy*TempVertex.vy)+(cross.vz*TempVertex.vz));
			height=(-((cross.vx*x)+(cross.vz*z)+d1))/(cross.vy);
			return (height)<<12;
		}
	}
	else
	{
		for (count=0;count<P->NoTaggedPolys;count++)
		{
			if (firstgety[P->Buffer]==1)
			{
				count=storecount[P->Buffer];
			}
			thispoly=P->TaggedPolys[ count ];
			meshptr=&P->Track->Meshes[thispoly];
			tmeshptr=&meshptr->TMesh;
			if (firstgety[P->Buffer]==1)
			{
				if (whichside[P->Buffer]==1)
				{
					pstartcount=1;
					pendcount=(tmeshptr->len)/4+3;
				}
				else
				{
					pstartcount=(tmeshptr->len)/4-3;
					pendcount=(tmeshptr->len)/2-1;
				}
			}
			else
			{
				pstartcount=1;
				pendcount=(tmeshptr->len)/2-1;
			}

//			for (polycount=1;polycount<((tmeshptr->len)/2-1);polycount++)
			for (polycount=pstartcount;polycount<pendcount;polycount++)
			{
				x=px>>12;
				x=-x;
				z=pz>>12;
				x-=meshptr->OffsetX;
				z-=meshptr->OffsetZ;
				if (firstgety[P->Buffer]==1)
				{
					polycount=storepcount[P->Buffer];
					letthrough=1;
				}
				else
				{
					letthrough=CheckBounds(x,z,thispoly,polycount,pno,1);
				}
				if (letthrough==1)
				{
					tag_val = (meshptr->SplitTag & 0x0000ffff);
					if ((tag_val==0)||(tag_val==3))
					{
						if (polycount>(tmeshptr->len/4))
						{
					   		whichside[P->Buffer]=2;
						}
						else
						{
							whichside[P->Buffer]=1;
						}
					}
					if (firstgety[P->Buffer]==1)
					{
						compvalue=lastcompvalue[P->Buffer];
						retvalue=lastretvalue[P->Buffer];
					}
					else
					{
						storecount[P->Buffer]=count;
						storepcount[P->Buffer]=polycount;
						v1.vx=(tmeshptr->v+((polycount*2)+1))->vx;
						v1.vy=0;
						v1.vz=(tmeshptr->v+((polycount*2)+1))->vz;
						v2.vx=(tmeshptr->v+((polycount*2)+2))->vx;
						v2.vy=0;
						v2.vz=(tmeshptr->v+((polycount*2)+2))->vz;
						cross.vx=v2.vx-v1.vx;
						cross.vz=v2.vz-v1.vz;
						tempcomp=cross.vx;
						cross.vx=((cross.vx*cos90)-(cross.vz*sin90))>>6;
						cross.vz=((tempcomp*sin90)+(cross.vz*cos90))>>6;
						retvalue=-((cross.vx*(tmeshptr->v+((polycount*2)+1))->vx)+
						 		(cross.vz*(tmeshptr->v+((polycount*2)+1))->vz));
						compvalue=-((cross.vx*x)+(cross.vz*z));
						lastcompvalue[P->Buffer]=compvalue;
						lastretvalue[P->Buffer]=retvalue;
						firstgety[P->Buffer]=1;
					}
					if (compvalue>=retvalue)
					{
						TempVertex.vx=(tmeshptr->v+(polycount*2))->vx;
						TempVertex.vy=(tmeshptr->v+(polycount*2))->vy;
						TempVertex.vz=(tmeshptr->v+(polycount*2))->vz;
						v1.vx=(tmeshptr->v+((polycount*2)+1))->vx;
						v1.vy=(tmeshptr->v+((polycount*2)+1))->vy;
						v1.vz=(tmeshptr->v+((polycount*2)+1))->vz;
						v2.vx=(tmeshptr->v+((polycount*2)+2))->vx;
						v2.vy=(tmeshptr->v+((polycount*2)+2))->vy;
						v2.vz=(tmeshptr->v+((polycount*2)+2))->vz;
					}
					else
					{
						TempVertex.vx=(tmeshptr->v+((polycount*2)+1))->vx;
						TempVertex.vy=(tmeshptr->v+((polycount*2)+1))->vy;
						TempVertex.vz=(tmeshptr->v+((polycount*2)+1))->vz;
						v1.vx=(tmeshptr->v+((polycount*2)+3))->vx;
						v1.vy=(tmeshptr->v+((polycount*2)+3))->vy;
						v1.vz=(tmeshptr->v+((polycount*2)+3))->vz;
						v2.vx=(tmeshptr->v+((polycount*2)+2))->vx;
						v2.vy=(tmeshptr->v+((polycount*2)+2))->vy;
						v2.vz=(tmeshptr->v+((polycount*2)+2))->vz;
					}
					v1.vx-=TempVertex.vx;
					v1.vy-=TempVertex.vy;
					v1.vz-=TempVertex.vz;
					v2.vx-=TempVertex.vx;
					v2.vy-=TempVertex.vy;
					v2.vz-=TempVertex.vz;
					gte_OuterProduct0(&v1,&v2,&cross);
					cross.vx>>12;
					cross.vy>>12;
					cross.vz>>12;

					if (cross.vy!=0)
					{
						d1=-((cross.vx*TempVertex.vx)+(cross.vy*TempVertex.vy)+(cross.vz*TempVertex.vz));
						height=(-((cross.vx*x)+(cross.vz*z)+d1))/(cross.vy);
						if (height!=0)
						{
							tempcomp=P->Track->CurrentStrip+1;
							if (tempcomp==MAX_VIEW_STRIPS)
							{
								tempcomp=0;
							}
							unusedpolys[P->Buffer]=(meshptr->StripNo)-(P->Track->Meshes[tempcomp].StripNo)-1;
						    CPoly[ P->Buffer ]=thispoly;
							CSub[ P->Buffer ]=polycount;
							/* challenge stuff - temp */
							if (clockon[P->Buffer]==0)
							{
								if ((meshptr->StripNo==clockststrip)&&(currentfile[P->Buffer]==clocksttrack))
								{
									clockon[P->Buffer]=1;
									clockststrip=255;
									clocksttrack=255;
								}
							}
							if (clockon[P->Buffer]==1)
							{
								if ((meshptr->StripNo==clockststrip)&&(currentfile[P->Buffer]==clocksttrack))
								{
									clockon[P->Buffer]=0;
 									clockststrip=255;
									clocksttrack=255;
									lasttime=globaltime[P->Buffer];
									lastscore=tempchill;
								}
							}
							if ((meshptr->StripNo==104)&&(currentfile[P->Buffer]==36))
							{
								gameexit=1;
							}
/*							if ((currentfile[P->Buffer]==Mountain[thismount].endtrack)&&
								(meshptr->StripNo==Mountain[thismount].endstrip[P->Buffer]))
							{
								Playerscores[thismount].time=globaltime[P->Buffer];
							}	*/

							if (unusedpolys[P->Buffer]>2)
							{
								unusedpolys[P->Buffer]=1;
							}
							if (thispoly>2)
							{
								if (unusedpolys[ P->Buffer ]<0)
								{
									if (unusedpolys[ P->Buffer ]>-4)
									{
										unusedpolys[ P->Buffer ]=0;
									}
									else
									{
										unusedpolys[ P->Buffer ]=1;
									}
								}
							}
							if (trackdirection[P->Buffer]==0)
							{
								unusedpolys[P->Buffer]=0;
							}
							last[ P->Buffer ]=height;
							return (height)<<12;
						}
						else
						{
							if (firstgety[P->Buffer]==1)
							{
								return last[ P->Buffer ]<<12;
							}
						}
					}
					else
					{
						if (firstgety[P->Buffer]==1)
						{
							return last[ P->Buffer ]<<12;
						}
					}
				}
			}
		}
	}
	if (CPoly[ P->Buffer ]!=0)
	{
//		printf("shit no poly found!\n");
	}
	return last[ P->Buffer ]<<12;
}

void initoverlays(void)
{
	uint32 abc,def;

	globaltime[0]=globaltime[1]=0;
	scorecounter=0;
	lastchillscore=0;
	for (abc=0;abc<4;abc++)
	{
		setRGB0(&timepolys[abc],127,127,127);
		timepolys[abc].u0=0;
		timepolys[abc].v0=239;
		timepolys[abc].u1=128;
		timepolys[abc].v1=239;
		timepolys[abc].u2=0;
		timepolys[abc].v2=255;
		timepolys[abc].u3=128;
		timepolys[abc].v3=255;
		timepolys[abc].tpage=tids[0].textpage;
		timepolys[abc].clut=tids[8].clutline[0];
		if (ConsolePlayers==1)
		{
			setXY4(&timepolys[abc],182,215,310,215,182,231,310,231);
		}
		else
		{
			if (currentsave.options[SPLIT_SET]==0)
			{
				setXY4(&timepolys[abc],182,103,310,103,182,119,310,119);
			}
			else
			{
				setXY4(&timepolys[abc],42,215,160,215,42,232,160,232);
			}
		}
		SetPolyFT4(&timepolys[abc]);
		setRGB0(&chillpolys[abc],127,127,127);
		chillpolys[abc].u0=0;
		chillpolys[abc].v0=160;
		chillpolys[abc].u1=31;
		chillpolys[abc].v1=160;
		chillpolys[abc].u2=0;
		chillpolys[abc].v2=191;
		chillpolys[abc].u3=31;
		chillpolys[abc].v3=191;
		chillpolys[abc].tpage=tids[8].textpage;
		chillpolys[abc].clut=tids[8].clutline[0];
		setXY4(&chillpolys[abc],10,13,41,13,10,37,41,37);
		SetPolyFT4(&chillpolys[abc]);
		setRGB0(&scorepolys[abc],127,127,127);
		scorepolys[abc].u0=0;
		scorepolys[abc].v0=222;
		scorepolys[abc].u1=111;
		scorepolys[abc].v1=222;
		scorepolys[abc].u2=0;
		scorepolys[abc].v2=238;
		scorepolys[abc].u3=111;
		scorepolys[abc].v3=238;
		scorepolys[abc].tpage=tids[0].textpage;
		scorepolys[abc].clut=tids[8].clutline[0];
		setXY4(&scorepolys[abc],14,18,127,18,14,34,127,34);
		SetPolyFT4(&scorepolys[abc]);
		setRGB0(&speedpolys[abc],127,127,127);
		speedpolys[abc].u0=112;
		speedpolys[abc].v0=222;
		speedpolys[abc].u1=208;
		speedpolys[abc].v1=222;
		speedpolys[abc].u2=112;
		speedpolys[abc].v2=238;
		speedpolys[abc].u3=208;
		speedpolys[abc].v3=238;
		trickpolys[abc].u0=0;
		trickpolys[abc].v0=208;
		trickpolys[abc].u1=80;
		trickpolys[abc].v1=208;
		trickpolys[abc].u2=0;
		trickpolys[abc].v2=221;
		trickpolys[abc].u3=80;
		trickpolys[abc].v3=221;
		trickpolys[abc].tpage=tids[0].textpage;
		trickpolys[abc].clut=tids[8].clutline[0];
		SetPolyFT4(&trickpolys[abc]);
		speedpolys[abc].tpage=tids[0].textpage;
		speedpolys[abc].clut=tids[8].clutline[0];
		setXY4(&speedpolys[abc],15,215,105,215,15,231,105,231);
		SetPolyFT4(&speedpolys[abc]);
		for (def=0;def<3;def++)
		{
			if (ConsolePlayers==1)
			{
				setXY4(&namepolys[abc][def],260+(def*16),15,260+(def*16)+15,15,260+(def*16),31,260+(def*16)+15,31);
			}
			else
			{
				if (currentsave.options[SPLIT_SET]==0)
				{
					setXY4(&namepolys[abc][def],260+(def*16),15,260+(def*16)+15,15,260+(def*16),31,260+(def*16)+15,31);
				}
				else
				{
					setXY4(&namepolys[abc][def],100+(def*16),15,100+(def*16)+15,15,100+(def*16),31,100+(def*16)+15,31);
				}
			}
			setRGB0(&namepolys[abc][def],127,127,127);
			if (ConsolePlayers==1)
			{
			   uvchar(&Player[0].Name[def],&namepolys[abc][def]);
			}
			else
			{
				if ((abc%2)==0)
				{
					uvchar(&Player[0].Name[def],&namepolys[abc][def]);
				}
				else
				{
					uvchar(&Player[1].Name[def],&namepolys[abc][def]);
				}
			}
			namepolys[abc][def].tpage=tids[8].textpage;
			namepolys[abc][def].clut=tids[8].clutline[0];
			SetPolyFT4(&namepolys[abc][def]);
//			setXY4(&namepolys[abc+2][def],260+(def*16),15,260+(def*16)+15,15,260+(def*16),31,260+(def*16)+15,31);
//			setRGB0(&namepolys[abc+2][def],127,127,127);
//			namepolys[abc+2][def].tpage=tids[8].textpage;
//			namepolys[abc+2][def].clut=tids[8].clutline[0];
//			SetPolyFT4(&namepolys[abc+2][def]);
		}
		for (def=0;def<200;def++)
		{
			setLineF2(&flakelines[abc][def]);
		}
/*		for (def=0;def<1200;def++)
		{
			setPolyG3(&trackprims[abc][def]);
		}   */
	}
	for (abc=0;abc<40;abc++)
	{
		randarray[abc]=rand();
	}
}

void setcarvec(VECTOR *v,long x,long y,long z)
{
	v->vx=x;
	v->vy=y;
	v->vz=z;
}
/*
void initcablecars(void)
{
	uint8 i;

	noccars=6;
	if (arsecandle==0)
	{
		cars[0].strip=57;
		setcarvec(&cars[0].start,2658,-4253,4648);
		setcarvec(&cars[0].end,2896,-4665,5482);
		cars[1].strip=60;
		setcarvec(&cars[1].start,2916,-4665,5482);
		setcarvec(&cars[1].end,2678,-4253,4648);
		cars[2].strip=65;
		setcarvec(&cars[2].start,2896,-4665,5482);
		setcarvec(&cars[2].end,3168,-4828,6438);
		cars[3].strip=70;
		setcarvec(&cars[3].start,3188,-4828,6438);
		setcarvec(&cars[3].end,2916,-4665,5482);
		cars[4].strip=75;
		setcarvec(&cars[4].start,3168,-4828,6438);
		setcarvec(&cars[4].end,3416,-4772,7377);
		cars[5].strip=78;
		setcarvec(&cars[5].start,3436,-4772,7377);
		setcarvec(&cars[5].end,3188,-4828,6438);
		arsecandle=1;
	}
	for (i=0;i<6;i++)
	{
	   setcarvec(&cars[i].carpos,cars[i].start.vx*256,cars[i].start.vy*256,cars[i].start.vz*256);
	   cars[i].movevector.vx=((cars[i].end.vx-cars[i].start.vx)*256)/160;
	   cars[i].movevector.vy=((cars[i].end.vy-cars[i].start.vy)*256)/160;
	   cars[i].movevector.vz=((cars[i].end.vz-cars[i].start.vz)*256)/160;
	}
}
*/


void InitialiseTrackEngine( uint8 PlayerNo )
{
	long 	filehandle,filereadsize;
	short	*filepointer;
	long 	dumpnormals[3];
	player *P=&Player[ PlayerNo ];
	uint32	address,*addrptr;

	trackobject *frigobject;

	long i,j,k;

//	starttrack=32;
	currentfile[P->Buffer]=starttrack;
#ifndef CD
//	filehandle	=	PCopen( "tracks/t1s1.seg", 0, 0 );
	printf("init track %s\n",&trackname[currentfile[P->Buffer]]);
	filehandle	=	PCopen( &trackname[currentfile[P->Buffer]], 0, 0 );
	filereadsize	=	PClseek( filehandle, 0, 2 );
	PClseek( filehandle, 0, 0 );
	PCread( filehandle, (char *)&Ib1[P->Buffer].CurrentStripPtr, filereadsize );
	PCclose( filehandle );
#else
	load_fpcd(&trackname[currentfile[P->Buffer]], (char *)&Ib1[P->Buffer].CurrentStripPtr );
	/*wait for the read command to complete*/
do
 {
 /*this is a wait loop, you could do anything here..... eggtimer ?*/
 }
 while (CdReadSync(1,0) > 0 );
#endif
	printf("Reading %d polygon strips\n", Ib1[P->Buffer].NumStrips);
	address=&Ib1[P->Buffer].CurrentStripPtr;
	address+=Ib1[P->Buffer].CurrentTexturePtr;
	addrptr=address;
	address=*addrptr;
	Ib1[P->Buffer].CurrentTexturePtr+=4;
	Ib1[P->Buffer].NumTextures=address;
	printf("Reading %d textured track polys\n",Ib1[P->Buffer].NumTextures);
	address=&Ib1[P->Buffer].CurrentStripPtr;
	address+=Ib1[P->Buffer].CurrentObjectPtr;
	addrptr=address;
	address=*addrptr;
	Ib1[P->Buffer].CurrentObjectPtr+=4;
	Ib1[P->Buffer].NumObjects=address;
	printf("Reading %d Objects\n",Ib1[P->Buffer].NumObjects);
	printf("x:%d z:%d\n",Ib1[P->Buffer].OffsetX,Ib1[P->Buffer].OffsetZ);
/* challenge stuff */
	textptr=&Ib1[P->Buffer].CurrentTexturePtr;
	if (thistrack==9)
	{
		P->Pos.X=-Ib1[P->Buffer].OffsetX<<12;
		P->Pos.Z=Ib1[P->Buffer].OffsetZ<<12;
		P->LastPos.X=-Ib1[P->Buffer].OffsetX<<12;
		P->LastPos.Z=Ib1[P->Buffer].OffsetZ<<12;
		P->Pos.Y=P->LastPos.Y=0;
		P->JumpY=0;

	}
	else
	{
 		P->Pos.X=-Mountain[thistrack].startpos.vx<<12;
 		P->Pos.Z=Mountain[thistrack].startpos.vz<<12;
 		P->LastPos.X=-Mountain[thistrack].startpos.vx<<12;
 		P->LastPos.Z=Mountain[thistrack].startpos.vz<<12;
		P->Pos.Y=P->LastPos.Y=0;
		P->TerrainY=P->LastTerrainY=0;
		P->JumpY=0;
		thiscollision[P->Buffer].type=NONE;

		P->Rot.Y=Mountain[thistrack].roty<<12;
		P->BoardAzimuth = P->Rot.Y;

	}
//	currentfile[P->Buffer]++;
	P->Track->NumberOfStrips = 0;
	P->Track->CurrentStrip=0;
	IBuf[P->Buffer] = &Ib1[P->Buffer];
	LoadBuf[P->Buffer] = &Ib2[P->Buffer];
	unusedpolys[P->Buffer]=0;
	playwhoah=0;
	trainmove=0;
//	AnimStatus[P->Buffer]=0;
	Ib1[P->Buffer].CurrentStrip = 0;
	Ib1[P->Buffer].CurrentObject = 0;
	Ib1[P->Buffer].CurrentTexture = 0;
	Ib1[P->Buffer].CurrentStripPtr = 0;
	Ib2[P->Buffer].CurrentStrip = 0;
	Ib2[P->Buffer].CurrentObject = 0;
	Ib2[P->Buffer].CurrentTexture = 0;
	Ib2[P->Buffer].CurrentStripPtr = 0;

/* split track stuff */
	splitdecode1[P->Buffer]=trackcontrol[currentfile[P->Buffer]].exit;
	splitdecode1[P->Buffer]&=0xFFFF0000;
	splitdecode2[P->Buffer]=trackcontrol[currentfile[P->Buffer]].exit;
	splitdecode2[P->Buffer]&=0x0000FFFF;
	splitdecode1[P->Buffer]>>=16;
	splitdecode3[P->Buffer]=trackcontrol[currentfile[P->Buffer]].entry;
	splitdecode3[P->Buffer]&=0xFFFF0000;
	splitdecode4[P->Buffer]=trackcontrol[currentfile[P->Buffer]].entry;
	splitdecode4[P->Buffer]&=0x0000FFFF;
	splitdecode3[P->Buffer]>>=16;
	if (splitdecode1[P->Buffer]==0)
	{
#ifndef CD
		teststrip[P->Buffer] = IBuf[ P->Buffer ]->NumStrips;
#else
//		teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-20);
		if ((NumberOfPlayers==2)&&(ConsolePlayers==1))
		{
			if (PlayerNo==1)
			{
				teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-15);
			}
			else
			{
				teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-30);
			}
		}
		else
		{
			if (ConsolePlayers==1)
			{
				teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-20);
			}
			else
			{
				teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-30);
			}
		}
#endif
		endstrip[P->Buffer]=IBuf[ P->Buffer ]->NumStrips;
	}
	else
	{
#ifndef CD
		teststrip[P->Buffer] = IBuf[ P->Buffer ]->NumStrips-1;
#else
		teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-30);
#endif
		endstrip[P->Buffer]=IBuf[ P->Buffer ]->NumStrips-1;
	}
/* split track stuff */
	splittaken[P->Buffer]=0;
	fileloaded[P->Buffer]=0;
	previouscount[P->Buffer]=0;
	bufferswapcount[P->Buffer]=0xff;
	bufferfilled[P->Buffer]=0;
	trackdirection[P->Buffer]=1;
	newdirection[P->Buffer]=1;
//	firstdirection[P->Buffer]=0;
	firstgety[P->Buffer]=0;
	last[P->Buffer]=0;
	cos90 = rcos (3072);
	sin90 = rsin (3072);
	obbufferswap[P->Buffer]=0;
	cablecarno=0;
//	initcablecars();
	if (ConsolePlayers==1)
	{
		clockon[P->Buffer]=1;
	}
	else
	{
		if (PlayerNo==1)
		{
			clockon[0]=1;
			clockon[1]=1;
		}
	}
//	clockon[P->Buffer]=0;
	clockset[P->Buffer]=0;
	endtrack[P->Buffer]=0;
	tempchill=0;
	lasttime=0;
	lastscore=0;
	howfoggy[P->Buffer]=0;
	howsnowy[P->Buffer]=0;
	clockststrip=255;
	clocksttrack=255;
	P->NoTaggedPolys=0;
//	initialisemoveableobjects(1);
	InitPlume();
	InitLeaves();
	/* intialise track primitives */

//	initobjects();
//	initmountains();
	z1=15000;
	d2=1000;
	for (i=0;i<4;i++)
	{
		setRGB0(&mist[i],230,230,230);
		mist[i].x0=0;
		mist[i].x1=320;
		mist[i].y2=240;
		mist[i].y3=240;
		mist[i].x2=0;
		mist[i].x3=320;
		setRGB0(&clipblag[i],205,218,228);
		SetPolyF4(&clipblag[i]);
	}

	SetPolyG3(&codeprim);
	initoverlays();
	for (i=0;i<4;i++)
	{
		for (j=0;j<400;j++)
		{
			SetPolyFT4(&polyf4s[i][j]);
			if (j<100)
			{
				SetPolyFT3(&polyf3s[i][j]);
			}
			if (j<10)
			{
				SetPolyF4(&poly4s[i][j]);
				SetPolyF3(&poly3s[i][j]);
			}
		}
	}
}

uint8 GetANewTrackPoly ( uint8 PlayerNo )
{
	long 	filehandle,filereadsize;
	short	*filepointer,i,j;
	uint32	striplength;
	player *P=&Player[ PlayerNo ];
	uint8	waythrough;
	uint32	address,*addrptr;
	uint8	returnvalue,prevstrip,thiscount;
	unsigned long tag_val;

//	waythrough=0;
#ifdef CD
	if (( IBuf[ P->Buffer ]->CurrentStrip >= teststrip[P->Buffer] )&&(trackdirection[P->Buffer]==1))
#else
	if ( IBuf[ P->Buffer ]->CurrentStrip >= teststrip[P->Buffer] )
#endif
	{
		if ((PlayerNo==1)&&(fileloaded[0]!=0)&&(fileloaded[0]!=4))
		{
			goto SKIPLOAD;
		}
		if ((PlayerNo==0)&&(fileloaded[1]!=0)&&(fileloaded[1]!=4))
		{
			goto SKIPLOAD;
		}
#ifndef CD
		if (splitdecode1[P->Buffer]==0)
		{
			filetoload[P->Buffer]=splitdecode2[P->Buffer];
		}
		else
		{
			if (whichside[P->Buffer]==1)
			{
				filetoload[P->Buffer]=splitdecode2[P->Buffer];
				splittaken[P->Buffer]=1;
			}
			else
			{
				filetoload[P->Buffer]=splitdecode1[P->Buffer];
				splittaken[P->Buffer]=2;
			}
		}
		if ((filetoload[P->Buffer]==currentfile[P->Buffer])&&(endtrack[P->Buffer]==0))
		{
			endtrack[P->Buffer]=1;
		}
		filehandle	=	PCopen( (char *)&trackname[filetoload[P->Buffer]], 0, 0 );
		printf("TRACK %s loading\n",&trackname[filetoload[P->Buffer]]);
		filereadsize	=	PClseek( filehandle, 0, 2 );
		PClseek( filehandle, 0, 0 );
		PCread( filehandle, (char *)&(LoadBuf[P->Buffer]->CurrentStripPtr), filereadsize );
		PCclose( filehandle );
		fileloaded[ P->Buffer ]=3;
#else
		if (fileloaded[ P->Buffer ]==0)
		{
			if (splitdecode1[P->Buffer]==0)
			{
				filetoload[P->Buffer]=splitdecode2[P->Buffer];
			}
			else
			{
				if (whichside[P->Buffer]==1)
				{
					filetoload[P->Buffer]=splitdecode2[P->Buffer];
					splittaken[P->Buffer]=1;
				}
				else
				{
					filetoload[P->Buffer]=splitdecode1[P->Buffer];
					splittaken[P->Buffer]=2;
				}
			}
			if ((filetoload[P->Buffer]==currentfile[P->Buffer])&&(endtrack[P->Buffer]==0))
   			{
   				endtrack[P->Buffer]=1;
   			}
			loadtobuffer((char *)&(LoadBuf[P->Buffer]->CurrentStripPtr),&trackname[filetoload[P->Buffer]]);
			printf("TRACK %d\n",filetoload[P->Buffer]);
			fileloaded[ P->Buffer ]=1;
		}
		if ((fileloaded[ P->Buffer ]==1)&&(loadtobuffer((char *)&(LoadBuf[P->Buffer]->CurrentStripPtr),&trackname[ filetoload[P->Buffer] ] )==1))
		{
			fileloaded[ P->Buffer ]=3;
		}
#endif
		if (fileloaded[ P->Buffer ]==3)
		{
			fileloaded[ P->Buffer ]=4;
			printf("Reading %d polygon strips\n", LoadBuf[P->Buffer]->NumStrips);
			address=&(LoadBuf[P->Buffer]->CurrentStripPtr);
			address+=LoadBuf[P->Buffer]->CurrentTexturePtr;
			addrptr=address;
			address=*addrptr;
			LoadBuf[P->Buffer]->CurrentTexturePtr+=4;
			LoadBuf[P->Buffer]->NumTextures=address;
			printf("Reading %d textured track polys\n",LoadBuf[P->Buffer]->NumTextures);

			address=&(LoadBuf[P->Buffer]->CurrentStripPtr);
			address+=LoadBuf[P->Buffer]->CurrentObjectPtr;
			addrptr=address;
			address=*addrptr;
			LoadBuf[P->Buffer]->CurrentObjectPtr+=4;
			LoadBuf[P->Buffer]->NumObjects=address;
			printf("Reading %d Objects\n",LoadBuf[P->Buffer]->NumObjects);
			printf("x:%d z:%d\n",LoadBuf[P->Buffer]->OffsetX,LoadBuf[P->Buffer]->OffsetZ);

		}
	}
//	else
//	{
//		SKIPLOAD:
//		fileloaded[ P->Buffer ]=4;
//		waythrough=1;
//	}

	SKIPLOAD:
	if (fileloaded[ P->Buffer ]==4)
	{
		if ( IBuf[ P->Buffer ]->CurrentStrip >= endstrip[P->Buffer] )
		{
			static	incomingtrackbuffer *ITemp;

			printf("Swapping Incoming Buffers\n");

			fileloaded[ P->Buffer ]=0;

			IBuf[ P->Buffer ]->CurrentStrip = 0;
			IBuf[ P->Buffer ]->CurrentObject = 0;
			IBuf[ P->Buffer ]->CurrentTexture = 0;
			IBuf[ P->Buffer ]->CurrentStripPtr = 0;
			obbufferswap[P->Buffer]=1;
			ITemp = IBuf[ P->Buffer ];
			IBuf[ P->Buffer ] = LoadBuf[ P->Buffer ];
			LoadBuf[ P->Buffer ] = ITemp;
			IBuf[ P->Buffer ]->CurrentStripPtr=0;
			IBuf[ P->Buffer ]->CurrentStrip=0;
			currentfile[P->Buffer]=filetoload[P->Buffer];
			splitdecode1[P->Buffer]=trackcontrol[currentfile[P->Buffer]].exit;
			splitdecode1[P->Buffer]&=0xFFFF0000;
			splitdecode2[P->Buffer]=trackcontrol[currentfile[P->Buffer]].exit;
			splitdecode2[P->Buffer]&=0x0000FFFF;
			splitdecode1[P->Buffer]>>=16;
			splitdecode3[P->Buffer]=trackcontrol[currentfile[P->Buffer]].entry;
			splitdecode3[P->Buffer]&=0xFFFF0000;
			splitdecode4[P->Buffer]=trackcontrol[currentfile[P->Buffer]].entry;
			splitdecode4[P->Buffer]&=0x0000FFFF;
			splitdecode3[P->Buffer]>>=16;
			musiccnt++;
			clockset[P->Buffer]=0;
			if (splitdecode1[P->Buffer]==0)
			{
#ifndef CD
				teststrip[P->Buffer] = IBuf[ P->Buffer ]->NumStrips;
#else
				if ((NumberOfPlayers==2)&&(ConsolePlayers==1))
				{
					if (PlayerNo==1)
					{
						teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-15);
					}
					else
					{
						teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-30);
					}
				}
				else
				{
					if (ConsolePlayers==1)
					{
						teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-20);
					}
					else
					{
						teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-30);
					}
				}
#endif
				endstrip[P->Buffer]=IBuf[ P->Buffer ]->NumStrips;
			}
			else
			{
#ifndef CD
				teststrip[P->Buffer] = IBuf[ P->Buffer ]->NumStrips-1;
#else
				teststrip[P->Buffer] = (IBuf[ P->Buffer ]->NumStrips-30);
#endif
				endstrip[P->Buffer]=IBuf[ P->Buffer ]->NumStrips-1;
			}
			if (endtrack[P->Buffer]==1)
			{
				clockon[P->Buffer]=0;
				if (ConsolePlayers==1)
				{
					if (endtrack[0]==1)
					{
						gameexit=1;
					}
				}
				else
				{
					if ((endtrack[0]==1)&&(endtrack[1]==1))
					{
						gameexit=1;
					}
				}
			}
		}
//		if (waythrough==1)
//		{
//			fileloaded[ P->Buffer ]=0;
//		}
	}
	if (bufferswapcount[P->Buffer]==0xFF)
	{
		if (splitdecode4[P->Buffer]!=0)
		{
			whichside[P->Buffer]=splittaken[P->Buffer];
		}
		returnvalue=0;
		striplength = (uint32 *)IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer ]->CurrentStripPtr ];
		previousinfo[ P->Buffer ][previouscount[P->Buffer]].address = &IBuf[ P->Buffer ]->TrackData[IBuf[ P->Buffer ]->CurrentStripPtr];
//		previousinfo[ P->Buffer ][previouscount[P->Buffer]].address = IBuf[ P->Buffer ]->CurrentStripPtr;
		P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.len = striplength;
		P->Track->Meshes[ P->Track->CurrentStrip ].StripNo = IBuf[ P->Buffer ]->CurrentStrip;
		previousinfo[ P->Buffer ][previouscount[P->Buffer]].StripNo = IBuf[ P->Buffer ]->CurrentStrip;
		IBuf[ P->Buffer ]->CurrentStripPtr+=4;
		P->Track->Meshes[ P->Track->CurrentStrip ].SplitTag =
		*(uint32 *)&(IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer]->CurrentStripPtr ]);
		IBuf[ P->Buffer ]->CurrentStripPtr+=4;
		tag_val = (P->Track->Meshes[ P->Track->CurrentStrip ].SplitTag & 0x0000ffff);
		if ((tag_val==0)||(tag_val==3))
		{
			if (splitdecode4[P->Buffer]!=0)
			{
				splittaken[P->Buffer]=0;
			}
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.v = &IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer ]->CurrentStripPtr ];
			IBuf[ P->Buffer ]->CurrentStripPtr+=(8*striplength);
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.n = &IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer ]->CurrentStripPtr ];
			IBuf[ P->Buffer ]->CurrentStripPtr+=(8*striplength);
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.c = &IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer ]->CurrentStripPtr ];
			IBuf[ P->Buffer ]->CurrentStripPtr+=(4*striplength);
			P->Track->Meshes[ P->Track->CurrentStrip ].OffsetX = IBuf[ P->Buffer ]->OffsetX;
			P->Track->Meshes[ P->Track->CurrentStrip ].OffsetZ = IBuf[ P->Buffer ]->OffsetZ;
			previousinfo[ P->Buffer ][previouscount[P->Buffer]].unusedadjust=returnvalue;
//				previouscount[P->Buffer]++;
			IBuf[ P->Buffer ]->CurrentStrip++;
		}
		else
		{
			tag_val = (P->Track->Meshes[ P->Track->CurrentStrip ].SplitTag & 0x0000ffff);
			while (tag_val!=whichside[P->Buffer])
			{
				returnvalue++;
				IBuf[ P->Buffer ]->CurrentStripPtr+=(20*striplength);
				IBuf[ P->Buffer ]->CurrentStrip++;
				striplength = (uint32 *)IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer ]->CurrentStripPtr ];
				previousinfo[ P->Buffer ][previouscount[P->Buffer]].address = &IBuf[ P->Buffer ]->TrackData[IBuf[ P->Buffer ]->CurrentStripPtr];
//				previousinfo[ P->Buffer ][previouscount[P->Buffer]].address = IBuf[ P->Buffer ]->CurrentStripPtr;
				P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.len = striplength;
				P->Track->Meshes[ P->Track->CurrentStrip ].StripNo = IBuf[ P->Buffer ]->CurrentStrip;
				previousinfo[ P->Buffer ][previouscount[P->Buffer]].StripNo = IBuf[ P->Buffer ]->CurrentStrip;
				IBuf[ P->Buffer ]->CurrentStripPtr+=4;
				P->Track->Meshes[ P->Track->CurrentStrip ].SplitTag = (uint32 *)IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer]->CurrentStripPtr ];
				IBuf[ P->Buffer ]->CurrentStripPtr+=4;
				tag_val = (P->Track->Meshes[ P->Track->CurrentStrip ].SplitTag & 0x0000ffff);
				if ((tag_val==0)||(tag_val==3))
				{
					if (splitdecode4[P->Buffer]!=0)
					{
						splittaken[P->Buffer]=0;
					}
					break;
				}
			}
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.v = &IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer ]->CurrentStripPtr ];
			IBuf[ P->Buffer ]->CurrentStripPtr+=(8*striplength);
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.n = &IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer ]->CurrentStripPtr ];
			IBuf[ P->Buffer ]->CurrentStripPtr+=(8*striplength);
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.c = &IBuf[ P->Buffer ]->TrackData[ IBuf[ P->Buffer ]->CurrentStripPtr ];
			IBuf[ P->Buffer ]->CurrentStripPtr+=(4*striplength);
			P->Track->Meshes[ P->Track->CurrentStrip ].OffsetX = IBuf[ P->Buffer ]->OffsetX;
			P->Track->Meshes[ P->Track->CurrentStrip ].OffsetZ = IBuf[ P->Buffer ]->OffsetZ;
			previousinfo[ P->Buffer ][previouscount[P->Buffer]].unusedadjust=returnvalue;
			IBuf[ P->Buffer ]->CurrentStrip++;
		}
		/* attatch objects and textures to strip */
		if (IBuf[P->Buffer]->NumObjects!=0)
		{
			address=&IBuf[P->Buffer]->CurrentStripPtr;
			address+=IBuf[P->Buffer]->CurrentObjectPtr+(IBuf[P->Buffer]->CurrentObject*44);
			objectptr=(trackobject *)address;

			while (P->Track->Meshes[P->Track->CurrentStrip].StripNo>objectptr->StripTag)
			{
				IBuf[P->Buffer]->CurrentObject++;
				address=&IBuf[P->Buffer]->CurrentStripPtr;
				address+=IBuf[P->Buffer]->CurrentObjectPtr+(IBuf[P->Buffer]->CurrentObject*44);
				objectptr=(trackobject *)address;
			}
			thiscount=0;
			while (P->Track->Meshes[P->Track->CurrentStrip].StripNo==objectptr->StripTag)
			{
				if (thiscount==0)
				{
					P->Track->Meshes[P->Track->CurrentStrip].Objaddr=objectptr;
				}
				thiscount++;
				IBuf[P->Buffer]->CurrentObject++;
				address=&IBuf[P->Buffer]->CurrentStripPtr;
				address+=IBuf[P->Buffer]->CurrentObjectPtr+(IBuf[P->Buffer]->CurrentObject*44);
				objectptr=(trackobject *)address;
			}
			P->Track->Meshes[P->Track->CurrentStrip].noobj=thiscount;
		}
		else
		{
			P->Track->Meshes[P->Track->CurrentStrip].noobj=0;
		}
		previousinfo[ P->Buffer ][previouscount[P->Buffer]].objaddr=P->Track->Meshes[P->Track->CurrentStrip].Objaddr;
		previousinfo[ P->Buffer ][previouscount[P->Buffer]].noobj=P->Track->Meshes[P->Track->CurrentStrip].noobj;

		if (IBuf[P->Buffer]->NumTextures!=0)
		{
			address=&IBuf[P->Buffer]->CurrentStripPtr;
			address+=IBuf[P->Buffer]->CurrentTexturePtr+(IBuf[P->Buffer]->CurrentTexture*120);
			textptr=(texttrackpoly *)address;

			while (P->Track->Meshes[P->Track->CurrentStrip].StripNo>textptr->StripTag)
			{
				IBuf[P->Buffer]->CurrentTexture++;
				address=&IBuf[P->Buffer]->CurrentStripPtr;
				address+=IBuf[P->Buffer]->CurrentTexturePtr+(IBuf[P->Buffer]->CurrentTexture*120);
				textptr=(texttrackpoly *)address;
			}
			thiscount=0;
			while (P->Track->Meshes[P->Track->CurrentStrip].StripNo==textptr->StripTag)
			{
				if (thiscount==0)
				{
					P->Track->Meshes[P->Track->CurrentStrip].Textaddr=textptr;
				}
				thiscount++;
				IBuf[P->Buffer]->CurrentTexture++;
				address=&IBuf[P->Buffer]->CurrentStripPtr;
				address+=IBuf[P->Buffer]->CurrentTexturePtr+(IBuf[P->Buffer]->CurrentTexture*120);
				textptr=(trackobject *)address;
			}
			P->Track->Meshes[P->Track->CurrentStrip].notext=thiscount;
		}
		else
		{
			P->Track->Meshes[P->Track->CurrentStrip].notext=0;
		}
		previousinfo[ P->Buffer ][previouscount[P->Buffer]].textaddr=P->Track->Meshes[P->Track->CurrentStrip].Textaddr;
		previousinfo[ P->Buffer ][previouscount[P->Buffer]].notext=P->Track->Meshes[P->Track->CurrentStrip].notext;
		previousinfo[ P->Buffer ][previouscount[P->Buffer]].OffsetX=IBuf[ P->Buffer ]->OffsetX;
		previousinfo[ P->Buffer ][previouscount[P->Buffer]].OffsetZ=IBuf[ P->Buffer ]->OffsetZ;
		previouscount[P->Buffer]++;
		if ((previouscount[P->Buffer]-MAX_VIEW_STRIPS)<0)
		{
			if (P->Track->NumberOfStrips==MAX_VIEW_STRIPS)
			{
				prevstrip=100-(MAX_VIEW_STRIPS-previouscount[P->Buffer]);
				returnvalue=previousinfo[P->Buffer][prevstrip].unusedadjust;
			}
			else
			{
				returnvalue=0;
			}
		}
		else
		{
			prevstrip=previouscount[P->Buffer]-MAX_VIEW_STRIPS;
			returnvalue=previousinfo[P->Buffer][prevstrip].unusedadjust;
		}

		if( previouscount[P->Buffer]>= 100 )
		{
			previouscount[P->Buffer] = 0;
			bufferfilled[P->Buffer]=1;
		}

	}
	else
	{
		returnvalue=0;
		addrptr=previousinfo[P->Buffer][bufferswapcount[P->Buffer]].address;
		striplength = *addrptr;
		if (striplength!=0)
		{
			/*P->Track->Meshes[ P->Track->CurrentStrip ].SplitTag=0;*/
			P->Track->Meshes[ P->Track->CurrentStrip ].SplitTag=
				(P->Track->Meshes[ P->Track->CurrentStrip ].SplitTag & 0xffff0000);

			P->Track->Meshes[ P->Track->CurrentStrip ].StripNo = previousinfo[P->Buffer][bufferswapcount[P->Buffer]].StripNo;
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.len = striplength;
			addrptr+=2;
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.v = addrptr;
			addrptr+=(2*striplength);
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.n = addrptr;
			addrptr+=(2*striplength);
			P->Track->Meshes[ P->Track->CurrentStrip ].TMesh.c = addrptr;
			addrptr+=striplength;
			P->Track->Meshes[ P->Track->CurrentStrip ].OffsetX = previousinfo[P->Buffer][bufferswapcount[P->Buffer]].OffsetX;
			P->Track->Meshes[ P->Track->CurrentStrip ].OffsetZ = previousinfo[P->Buffer][bufferswapcount[P->Buffer]].OffsetZ;
			P->Track->Meshes[ P->Track->CurrentStrip ].Objaddr = previousinfo[P->Buffer][bufferswapcount[P->Buffer]].objaddr;
			P->Track->Meshes[ P->Track->CurrentStrip ].Textaddr = previousinfo[P->Buffer][bufferswapcount[P->Buffer]].textaddr;
			P->Track->Meshes[ P->Track->CurrentStrip ].noobj = previousinfo[P->Buffer][bufferswapcount[P->Buffer]].noobj;
			P->Track->Meshes[ P->Track->CurrentStrip ].notext = previousinfo[P->Buffer][bufferswapcount[P->Buffer]].notext;

//				P->Track->CurrentStrip++;
			if (trackdirection[P->Buffer]!=0)
			{
				bufferswapcount[P->Buffer]+=trackdirection[P->Buffer];
			}
			else
			{
				bufferswapcount[P->Buffer]++;
			}
//				bufferswapcount[P->Buffer]--;
			if (bufferswapcount[P->Buffer]<0)
			{
				if (bufferfilled[P->Buffer]==1)
				{
					bufferswapcount[P->Buffer]+=100;
				}
				else
				{
					bufferswapcount[P->Buffer]=0;
//						return;
				}
			}
			if (bufferswapcount[P->Buffer]>=100)
			{
				bufferswapcount[P->Buffer]-=100;
			}
//				if (bufferswapcount[P->Buffer]==bufferswappos[P->Buffer])
			if (bufferswapcount[P->Buffer]==previouscount[P->Buffer])
			{
				bufferswapcount[P->Buffer]=0xff;
//					trackdirection[P->Buffer]=1;
			}
		}

	}
	P->Track->CurrentStrip++;

	if( P->Track->CurrentStrip >= MAX_VIEW_STRIPS )
	{
		P->Track->CurrentStrip = 0;
	}

	if( P->Track->NumberOfStrips < MAX_VIEW_STRIPS )
	{
		P->Track->NumberOfStrips++;
	}
	return returnvalue;
}

void Snow(uint8 amount,uint8 pno)
{
	uint8 sncnt1,sncnt2;
	SVECTOR snrot = {0,0,0};
	MATRIX	sntrans,snrotm;
	player *P=&Player[pno];
	long sfdump,spdump,snot,snowcol;

	SKBADDPRIMLOCALS

	noflines=0;
	if (amount==0)
	{
		numflakes=0;
		currsnowy=0;
		return;
	}
	else
	{
		if (ConsolePlayers==2)
		{
			if (currentsave.options[SPLIT_SET]==0)
			{
				gte_SetGeomOffset(60,160);
			}
			else
			{
				gte_SetGeomOffset(120,80);
			}
		}
		else
		{
			gte_SetGeomOffset(120,160);
		}
		gte_SetGeomScreen(geomscreen);
		if (amount>25)
		{
			amount=25;
		}
		if (amount>currsnowy)
		{
			for (numflakes;numflakes<(amount*5);numflakes++)
			{
				flakeverts[numflakes].vy=500-(rand()%1000);
				flakeverts[numflakes].vx=-500-rand()%250;
				flakeverts[numflakes].vz=rand()%2048;
				currsnowy=amount;
//				flaketrans[numflakes].vx=P->Cam.Pos.X>>12;
//				flaketrans[numflakes].vy=P->Cam.Pos.Y>>12;
//				flaketrans[numflakes].vz=P->Cam.Pos.Z>>12;
			}
		}
		else
		{
			numflakes=amount*5;
		}
		RotMatrix(&snrot,&snrotm);
		gte_SetRotMatrix(&snrotm);
		sntrans.t[0]=ssx;
		sntrans.t[1]=ssy;
		sntrans.t[2]=ssz;
		gte_SetTransMatrix(&sntrans);
		for (sncnt1=0;sncnt1<numflakes;sncnt1++)
		{
			snowcol=200+randarray[randcount]%50;
			randcount++;
			if (randcount==40)
			{
				randcount=1;
			}
			gte_ldv0(&flakeverts[sncnt1]);
			gte_rtps();
			*(uint32 *)&(flakelines[otid][noflines].r0)=(64<<24)|(snowcol<<16)|(snowcol<<8)|(snowcol);
			flakeverts[sncnt1].vx+=snowspeed*3;
			flakeverts[sncnt1].vy+=(P->TurnInert>>13)+(5-randarray[randcount]%10);
			gte_stsxy(vertstoreaddr);
			randcount++;
			if (randcount==40)
			{
				randcount=1;
			}
			gte_stszotz(vertstoreaddr+1);
			flakeverts[sncnt1].vz-=(P->Vel>>10)+(5-randarray[randcount]%10);
			randcount++;
			if (randcount==40)
			{
				randcount=1;
			}

			if(flakeverts[sncnt1].vx>200)
			{
				flakeverts[sncnt1].vx=-500-randarray[randcount]%250;
				randcount++;
				if (randcount==40)
				{
					randcount=1;
				}
			}
			if (flakeverts[sncnt1].vz<0)
			{
				flakeverts[sncnt1].vz+=2048;
			}
			if (flakeverts[sncnt1].vz>2048)
			{
				flakeverts[sncnt1].vz-=2048;
			}
			if (flakeverts[sncnt1].vy<-500)
			{
				flakeverts[sncnt1].vy+=1000;
			}
			if (flakeverts[sncnt1].vy>500)
			{
				flakeverts[sncnt1].vy-=1000;
			}

			*(uint32 *)&(flakelines[otid][noflines].x0)=((*vertstoreaddr)&0xffff)<<16|(((*vertstoreaddr)&0xffff0000)>>16);

			if (*(vertstoreaddr+1)<256)
			{
				*(uint32 *)&(flakelines[otid][noflines].x1)=((*vertstoreaddr)&0xffff)<<16|(((*vertstoreaddr)&0xffff0000)>>16)+1;
//				setLineF2(&flakelines[otid][noflines]);
				SKBADDPRIM(&OrderingTable[ otid ][*(vertstoreaddr+1)],&flakelines[otid][noflines]);
				noflines+=1;
				*(uint32 *)&(flakelines[otid][noflines].r0)=(64<<24)|(snowcol<<16)|(snowcol<<8)|(snowcol);
				*(uint32 *)&(flakelines[otid][noflines].x0)=(((*vertstoreaddr)&0xffff)+1)<<16|((((*vertstoreaddr)&0xffff0000)>>16)+1);
				*(uint32 *)&(flakelines[otid][noflines].x1)=(((*vertstoreaddr)&0xffff)+1)<<16|(((*vertstoreaddr)&0xffff0000)>>16);

//				flakelines[otid][noflines].x0=flakelines[otid][noflines-1].x1;
//				flakelines[otid][noflines].y0=flakelines[otid][noflines-1].y0+1;

//				flakelines[otid][noflines].x1=flakelines[otid][noflines-1].x0;
//				flakelines[otid][noflines].y1=flakelines[otid][noflines-1].y1+1;
//				setLineF2(&flakelines[otid][noflines]);
//				AddPrim(&OrderingTable[ otid ][ snot ],&flakelines[otid][noflines]);
				SKBADDPRIM(&OrderingTable[ otid ][*(vertstoreaddr+1)],&flakelines[otid][noflines]);
				noflines+=1;
			}
			else
			{
				*(uint32 *)&(flakelines[otid][noflines].x1)=((*vertstoreaddr)&0xffff)<<16|(((*vertstoreaddr)&0xffff0000)>>16);
//				flakelines[otid][noflines].x1=flakelines[otid][noflines].x0;
//				flakelines[otid][noflines].y1=flakelines[otid][noflines].y0;
//				setLineF2(&flakelines[otid][noflines]);
				SKBADDPRIM(&OrderingTable[ otid ][*(vertstoreaddr+1)],&flakelines[otid][noflines]);
//				AddPrim(&OrderingTable[ otid ][ snot ],&flakelines[otid][noflines]);
				noflines+=1;

			}
		}
		return;
	}
}

void drawbline(VECTOR v,VECTOR w)
{
	SVECTOR	thisvec,thatvec;
	SKBADDPRIMLOCALS

	thisvec.vx=-v.vx>>12;
	thisvec.vy=v.vy>>12;
	thisvec.vz=v.vz>>12;
	thatvec.vx=-w.vx>>12;
	thatvec.vy=w.vy>>12;
	thatvec.vz=w.vz>>12;
	gte_ldv0(&thisvec);
	gte_rtps();
	*(uint32 *)&(flakelines[otid][noflines].r0)=(64<<24)|(255<<16)|(0<<8)|(0);
	gte_stsxy(vertstoreaddr);
	gte_ldv0(&thatvec);
	gte_rtps();
	*(uint32 *)&(flakelines[otid][noflines].x0)=((*vertstoreaddr)&0xffff)<<16|(((*vertstoreaddr)&0xffff0000)>>16);
	gte_stsxy(vertstoreaddr+1);
	*(uint32 *)&(flakelines[otid][noflines].x1)=((*(vertstoreaddr+1))&0xffff)<<16|((*(vertstoreaddr+1))&0xffff0000)>>16;
	SKBADDPRIM(&OrderingTable[ otid ][0],&flakelines[otid][noflines]);
	noflines+=1;
}

void DrawObjects( uint16 thiscp, uint8 playerno )
{
	player *P=&Player[playerno];
	uint32	i,j,k;
	uint16  stripno;
	VECTOR 	ObjectScale,Y,B1,B2,B3,B4,B5,T1,T2,T3;
	SVECTOR	ObjRotVec,X,loadvert;
	long	thisotz,thisp,tempvz;
	long	thisouter,tempscale,coldx,coldz,collength;
	long	mask=0x0ff;
	POLY_FT4 *polystptr;
	POLY_FT3 *polystptr2;
	uint32 	polyustore;
	uint32	polyvstore;
	uint32	polyvertptr;
	uint32	tmatid;
	uint32	stobjtype;
	uint8	stnumcolls;
	objpolygon	*thispolyptr;
	objcoll     *collisionptr;
	MATRIX	collmatrix;
	uint8	shitbox;


	stripno=P->Track->Meshes[ thiscp ].StripNo;
	objectptr=P->Track->Meshes[ thiscp ].Objaddr;
	shitbox=0;
//	nodrawnpolys=0;
	for (k=0;k<P->Track->Meshes[ thiscp ].noobj;k++)
	{
		gte_SetRotMatrix(&P->Cam.ViewMatrix);

		ObjRotVec.vx=0;
		ObjRotVec.vy=(objectptr->RotY);
		ObjRotVec.vz=0;
		RotMatrix(&ObjRotVec,&collmatrix);

		if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(playerno==1))
		{

		}
		else
		{
			ObjRotVec.vx=(objectptr->RotX);
			ObjRotVec.vy=-(objectptr->RotY);
			ObjRotVec.vz=(objectptr->RotZ);
			cablecarno=0;
			X.vx=(objectptr->TransX+P->Cam.Pos.X)>>12;
			X.vy=(objectptr->TransY-P->Cam.Pos.Y)>>12;
			X.vz=(objectptr->TransZ-P->Cam.Pos.Z)>>12;

			X.vx+=P->Track->Meshes[ thiscp ].OffsetX;
			X.vz+=P->Track->Meshes[ thiscp ].OffsetZ;

			gte_ApplyRotMatrix(&X,&Y);
			ObjectTrans.t[1]=Y.vx;
			ObjectTrans.t[0]=Y.vy;
			ObjectTrans.t[2]=Y.vz;
			tempvz=ObjRotVec.vz;
			ObjRotVec.vz=0;
			RotMatrix(&ObjRotVec,&ObjectRotation);
			RotMatrixZ(tempvz,&ObjectRotation);
			gte_SetRotMatrix(&P->Cam.ObjectView);
			MulRotMatrix(&ObjectRotation);
		}
		objecttype=objectptr->Type;
		if (objecttype>210)
		{
			objecttype=5;
		}
		if (ChillObjects[objecttype].loaded==0)
		{
			objecttype=(rand()%5)+1;
			objectptr->Type=objecttype;
		}
		tempscale=objectptr->ScaleY;
		if (objecttype<6)
		{
			if (tempscale>8192)
			{
				tempscale=8192;
			}
		}
		else
		{
			tempscale=4096;
		}
		ObjectScale.vx=tempscale;
		ObjectScale.vy=tempscale;
		ObjectScale.vz=tempscale;
		ScaleMatrix(&collmatrix,&ObjectScale);
		if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(playerno==1))
		{

		}
		else
		{
			ScaleMatrix(&ObjectRotation,&ObjectScale);
			gte_SetRotMatrix(&ObjectRotation);
			gte_SetTransMatrix(&ObjectTrans);
		}
		numverts=ChillObjects[objecttype].numverts;
		numpolys=ChillObjects[objecttype].numpolys;
		vertexptr=ChillObjects[objecttype].vertptr;
		polyptr=ChillObjects[objecttype].polyptr;
		pX=(P->Pos.X>>12)+P->Track->Meshes[thiscp].OffsetX;
		pZ=(P->Pos.Z>>12)-P->Track->Meshes[thiscp].OffsetZ;
		lX=(P->LastPos.X>>12)+P->Track->Meshes[thiscp].OffsetX;
		lZ=(P->LastPos.Z>>12)-P->Track->Meshes[thiscp].OffsetZ;
		if ((objecttype==25)&&(clockset[P->Buffer]==0))
		{
			clockststrip=stripno;
			clocksttrack=currentfile[P->Buffer];
			clockset[P->Buffer]=1;
		}
#ifdef MUSIC
		if (objecttype==27)
		{
			playsoundeffect(5,1);
		}
		if (objecttype==50)
		{
			playsoundeffect(4,1);
		}
#endif
		if (objecttype>=100)
		{
			loadvert.vx=-(vertexptr)->vx;
		}
		else
		{
			loadvert.vx=(vertexptr)->vx;
		}
		loadvert.vy=(vertexptr)->vy;
		loadvert.vz=(vertexptr)->vz;
		collisionptr=ChillObjects[objecttype].collptr;
		if ((abs(thiscp-CPoly[P->Buffer])<3)&&(thiscollision[P->Buffer].type==NONE))
//		if ((Cnt<5)&&(thiscollision[P->Buffer].type==NONE))
		{
			for (i=0;i<ChillObjects[objecttype].numcolls;i++)
			{
				switch (collisionptr->type)
				{
					default:
					case (0):
					{
						/* radial bounds checking for trees, poles etc */
						objectheight=(collisionptr+i)->info[0].vy>>12;
						objectheight*=tempscale;
						objectheight>>=12;
						if ((P->Pos.Y>>12)<((objectptr->TransY>>12)+objectheight))
						{
							coldx=(pX+(objectptr->TransX>>12));
							coldx=coldx*coldx;
							coldz=(pZ-(objectptr->TransZ>>12));
							coldz=coldz*coldz;
							collength=coldx+coldz;
							coldx=SquareRoot0(collength);

							outerrad=(collisionptr+i)->info[0].vx>>12;
							outerrad*=tempscale;
							outerrad>>=12;

							scalerad=(objectheight<<12)-(P->Pos.Y-objectptr->TransY);
							if (objectheight==0)
							{
								objectheight=1;
							}
							scalerad/=objectheight;
							outerrad*=scalerad;
							outerrad>>=12;
							if (coldx<outerrad)
							{
								if (i!=0)
								{
									prad=coldx;
									thiscollision[P->Buffer].type=SIDES;
									thiscollision[P->Buffer].angle=2048;
									thiscollision[P->Buffer].point.X=P->Pos.X;
									thiscollision[P->Buffer].point.Y=P->Pos.Y;
									thiscollision[P->Buffer].point.Z=P->Pos.Z;
									playsoundeffect(1,1);
								}
								else
								{
									innerrad=(collisionptr+i)->info[0].vz>>12;
	 								innerrad*=tempscale;
									innerrad>>=12;
									innerrad*=scalerad;
									innerrad>>=12;
									if (coldx<innerrad)
									{
										/* stop dead, conjuntive reflection */

										prad=coldx;
										thiscollision[P->Buffer].type=TREEBUMP;	// TREESMACK
										thiscollision[P->Buffer].angle=2048;
										thiscollision[P->Buffer].point.X=P->LastPos.X;
										thiscollision[P->Buffer].point.Y=P->LastPos.Y;
										thiscollision[P->Buffer].point.Z=P->LastPos.Z;
#ifdef MUSIC
										playsoundeffect(20,1);    /* 20 */
										playsoundeffect(21,1);
										playsoundeffect(7,1);
										deltime=globaltime[P->Buffer];
										playwhoah=1;
#endif
									}
									else
									{
										/* reduce speed, deflection */
										if (coldx<((outerrad+innerrad)/2))
										{
											thiscollision[P->Buffer].type=TREEBUMP;
											thiscollision[P->Buffer].angle=rand()%16;
											thiscollision[P->Buffer].point.X=P->LastPos.X;
											thiscollision[P->Buffer].point.Y=P->LastPos.Y;
											thiscollision[P->Buffer].point.Z=P->LastPos.Z;
#ifdef MUSIC
											playsoundeffect(19,1);
											playsoundeffect(22,1);
#endif
										}
										else
										{
											thiscollision[P->Buffer].type=TREESCRAPE;
											thiscollision[P->Buffer].angle=rand()%16;
											thiscollision[P->Buffer].point.X=P->LastPos.X;
											thiscollision[P->Buffer].point.Y=P->LastPos.Y;
											thiscollision[P->Buffer].point.Z=P->LastPos.Z;
#ifdef MUSIC
											playsoundeffect(18,1);
#endif
										}
									}
								}
							}
						}
						break;
					}

					case (1):
					{
						gte_SetRotMatrix(&collmatrix);

						Y.vx=(collisionptr+i)->info[1].vx;
						Y.vy=0;
						Y.vz=(collisionptr+i)->info[2].vz;
						objectlowheight=(collisionptr+i)->info[0].vy>>12;
						(collisionptr+i)->info[0].vy=0;
						(collisionptr+i)->info[1].vy=0;
						(collisionptr+i)->info[2].vy=0;

						ApplyRotMatrixLV(&((collisionptr+i)->info[0]),&B1);     /* rot, scale */
						ApplyRotMatrixLV(&((collisionptr+i)->info[1]),&B2);
						ApplyRotMatrixLV(&((collisionptr+i)->info[2]),&B3);

						ApplyRotMatrixLV(&Y,&B4);
// test coll boxes
/*						Y.vx=((collisionptr+i)->info[0].vx);
						Y.vy=(collisionptr+i)->info[3].vy;
						Y.vz=((collisionptr+i)->info[0].vz);
						ApplyRotMatrixLV(&Y,&B5);

						gte_SetRotMatrix(&P->Cam.ObjectView);
						drawbline(B1,B2);
						drawbline(B4,B3);
						drawbline(B3,B1);
						drawbline(B4,B2);
						drawbline(B1,B5);
						gte_SetRotMatrix(&ObjectRotation);
						gte_SetTransMatrix(&ObjectTrans);	*/
// testcoll boxes
						vx[0]=(B2.vx-B1.vx)>>12;
						vz[0]=(B2.vz-B1.vz)>>12;
						vx[1]=(B4.vx-B3.vx)>>12;
						vz[1]=(B4.vz-B3.vz)>>12;

						temp1=vx[0];
						vx[0]=((vx[0]*cos90)-(vz[0]*sin90))>>12;
						vz[0]=((temp1*sin90)+(vz[0]*cos90))>>12;
						temp1=vx[1];
						vx[1]=((vx[1]*cos90)-(vz[1]*sin90))>>12;
						vz[1]=((temp1*sin90)+(vz[1]*cos90))>>12;
						cres[0]=-((vx[0]*(B1.vx+objectptr->TransX))+(vz[0]*(B1.vz+objectptr->TransZ)));
						cres[1]=-((vx[1]*(B3.vx+objectptr->TransX))+(vz[1]*(B3.vz+objectptr->TransZ)));
						res[0]=-((vx[0]*-pX<<12)+(vz[0]*pZ<<12));
						res[1]=-((vx[1]*-pX<<12)+(vz[1]*pZ<<12));
						if (((res[0]>cres[0])&&(res[1]<cres[1]))||((res[0]<cres[0])&&(res[1]>cres[1])))
						{
							vx[2]=(B3.vx-B1.vx)>>12;
							vz[2]=(B3.vz-B1.vz)>>12;
							vx[3]=(B4.vx-B2.vx)>>12;
							vz[3]=(B4.vz-B2.vz)>>12;
							temp1=vx[2];
							vx[2]=((vx[2]*cos90)-(vz[2]*sin90))>>12;
							vz[2]=((temp1*sin90)+(vz[2]*cos90))>>12;
							temp1=vx[3];
							vx[3]=((vx[3]*cos90)-(vz[3]*sin90))>>12;
							vz[3]=((temp1*sin90)+(vz[3]*cos90))>>12;
							cres[2]=-((vx[2]*(B1.vx+objectptr->TransX))+(vz[2]*(B1.vz+objectptr->TransZ)));
							cres[3]=-((vx[3]*(B2.vx+objectptr->TransX))+(vz[3]*(B2.vz+objectptr->TransZ)));
							res[2]=-((vx[2]*-pX<<12)+(vz[2]*pZ<<12));
							res[3]=-((vx[3]*-pX<<12)+(vz[3]*pZ<<12));
							if (((res[2]>cres[2])&&(res[3]<cres[3]))||((res[2]<cres[2])&&(res[3]>cres[3])))
							{
								objectheight=(collisionptr+i)->info[3].vy>>12;
								objectheight*=tempscale;
								objectheight>>=12;
								objectheight+=objectptr->TransY>>12;
								objectlowheight*=tempscale;
								objectlowheight>>=12;
								objectlowheight+=objectptr->TransY>>12;
								objectlowheight-=20;
								thiscollision[P->Buffer].height=objectheight;
								if (((P->Pos.Y>>12)<objectheight)&&((P->Pos.Y>>12)>objectlowheight))
								{
									if (i==0)
									{
										/* collide with object */

										thiscollision[P->Buffer].type=MAIN_BOX_COLLIDE;
										stobjtype=objecttype;
										stnumcolls=ChillObjects[objecttype].numcolls;
										/* reflection angle */
										for (j=0;j<4;j++)
										{
											thisres=-((vx[j]*lX<<12)+(vz[j]*lZ<<12));
											if (j<2)
											{
												if (thisres<cres[j])
												{
													break;
												}
											}
											else
											{
												if (thisres>cres[j])
												{
													break;
												}
											}
										}
										vx[4]=pX-lX;
										vz[4]=pZ-lZ;
										temp1=vx[4];
										vx[4]=((vx[4]*cos90)-(vz[4]*sin90));
										vz[4]=((temp1*sin90)+(vz[4]*cos90));
										angvec1.vx=vx[4];
										angvec1.vy=0;
										angvec1.vz=vz[4];
										angvec2.vx=vx[j];
										angvec2.vz=vz[j];
										thiscollision[P->Buffer].angle=PSX_Dot(&angvec1,&angvec2)>>12;
										thiscollision[P->Buffer].angle*=2;

										thiscollision[P->Buffer].point.X=P->LastPos.X;
										thiscollision[P->Buffer].point.Y=P->LastPos.Y;
										thiscollision[P->Buffer].point.Z=P->LastPos.Z;

										/* collision point */
									}
									else
									{
										/* collide with sub object */

										thiscollision[P->Buffer].type=SIDES;

										/* reflection angle */
										for (j=0;j<4;j++)
										{
											thisres=-((vx[j]*lX<<12)+(vz[j]*lZ<<12));
											if (j<2)
											{
												if (thisres<cres[j])
												{
													break;
												}
											}
											else
											{
												if (thisres>cres[j])
												{
													break;
												}
											}
										}
										vx[4]=pX-lX;
										vz[4]=pZ-lZ;
										temp1=vx[4];
										vx[4]=((vx[4]*cos90)-(vz[4]*sin90));
										vz[4]=((temp1*sin90)+(vz[4]*cos90));
										angvec1.vx=vx[4];
										angvec1.vy=0;
										angvec1.vz=vz[4];
										angvec2.vx=vx[j];
										angvec2.vz=vz[j];
										thiscollision[P->Buffer].angle=PSX_Dot(&angvec1,&angvec2)>>12;
										thiscollision[P->Buffer].angle*=2;

										thiscollision[P->Buffer].point.X=P->LastPos.X;
										thiscollision[P->Buffer].point.Y=P->LastPos.Y;
										thiscollision[P->Buffer].point.Z=P->LastPos.Z;

										/* collision point */
									}
								}
								else
								{
									thiscollision[P->Buffer].type=OVER_OBJECT;
								}
							}
							else
							{
								if (i==0)
								{
									break;
								}
							}

							}

						gte_SetRotMatrix(&ObjectRotation);

						break;
					}
				}
			}
		}
		if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(playerno==1))
		{

		}
		else
		{
			for (i=0;i<numverts;i++)
			{
				gte_ldv0(&loadvert);
            	gte_rtps();
				if (objecttype>=100)
				{
					loadvert.vx=-(vertexptr+(i+1))->vx;
				}
				else
				{
					loadvert.vx=(vertexptr+(i+1))->vx;
				}
				loadvert.vy=(vertexptr+(i+1))->vy;
   				loadvert.vz=(vertexptr+(i+1))->vz;
 		    	gte_stsxy((vertstoreaddr+i));
				gte_stszotz(&ootz[i]);
			}
			for (i=0;i<numpolys;i++)
			{
				shitbox=0;
				thispolyptr=(polyptr+i);
	//			thisotz=0;
	//			thisp=0;
	//			for (j=0;j<(polyptr+i)->numverts;j++)
	//			{
	//				thisotz+=ootz[((polyptr+i)->vertptr>>(8*j))&0xff];
	//			}
	//			thisotz/=(polyptr+i)->numverts;
				thisotz=ootz[(thispolyptr->vertptr)&0xff];
	//			thisp=(thisotz*2)+(howfoggy[P->Buffer]*122);
				if (thisotz>(800-howfoggy[P->Buffer]*12))
				{
					thisp=((thisotz-500)*howfoggy[P->Buffer])/2;
				}
				else
				{
					thisp=0;
				}
				if (thisp>4096)
				{
					thisp=4096;
				}
				if (thispolyptr->numverts==4)
				{
					if (thispolyptr->polytype>0)
					{
						thisp/=1024;
						if ((thiscollision[P->Buffer].type==MAIN_BOX_COLLIDE)||(thiscollision[P->Buffer].type==OVER_OBJECT))
	//					if (thiscollision[P->Buffer].type==OVER_OBJECT)
						{
							if (((polyptr+i)->polytype==2)&&(skiablefound[P->Buffer]==0))
							{
								gte_SetRotMatrix(&collmatrix);
								Y.vx=(vertexptr+((polyptr+i)->vertptr&mask))->vx;
								Y.vy=(vertexptr+((polyptr+i)->vertptr&mask))->vy;
								Y.vz=(vertexptr+((polyptr+i)->vertptr&mask))->vz;
								ApplyRotMatrixLV(&Y,&S1);
								S1.vx+=objectptr->TransX>>12;
								S1.vy+=objectptr->TransY>>12;
								S1.vz+=objectptr->TransZ>>12;
								Y.vx=(vertexptr+(((polyptr+i)->vertptr>>8)&mask))->vx;
								Y.vy=(vertexptr+(((polyptr+i)->vertptr>>8)&mask))->vy;
								Y.vz=(vertexptr+(((polyptr+i)->vertptr>>8)&mask))->vz;
								ApplyRotMatrixLV(&Y,&S2);
								S2.vx+=objectptr->TransX>>12;
								S2.vy+=objectptr->TransY>>12;
								S2.vz+=objectptr->TransZ>>12;
								Y.vx=(vertexptr+(((polyptr+i)->vertptr>>16)&mask))->vx;
								Y.vy=(vertexptr+(((polyptr+i)->vertptr>>16)&mask))->vy;
								Y.vz=(vertexptr+(((polyptr+i)->vertptr>>16)&mask))->vz;
								ApplyRotMatrixLV(&Y,&S3);
								S3.vx+=objectptr->TransX>>12;
								S3.vy+=objectptr->TransY>>12;
								S3.vz+=objectptr->TransZ>>12;
								Y.vx=(vertexptr+(((polyptr+i)->vertptr>>24)&mask))->vx;
								Y.vy=(vertexptr+(((polyptr+i)->vertptr>>24)&mask))->vy;
								Y.vz=(vertexptr+(((polyptr+i)->vertptr>>24)&mask))->vz;
								ApplyRotMatrixLV(&Y,&S4);
								S4.vx+=objectptr->TransX>>12;
								S4.vy+=objectptr->TransY>>12;
								S4.vz+=objectptr->TransZ>>12;
								pX=(P->Pos.X>>12)+P->Track->Meshes[thiscp].OffsetX;
								pZ=(P->Pos.Z>>12)-P->Track->Meshes[thiscp].OffsetZ;
								pX=-pX;
								vx[0]=(S1.vx-S2.vx);
								vz[0]=(S1.vz-S2.vz);
								vx[1]=(S4.vx-S3.vx);
								vz[1]=(S4.vz-S3.vz);
								temp1=vx[0];
								vx[0]=((vx[0]*cos90)-(vz[0]*sin90))>>12;
								vz[0]=((temp1*sin90)+(vz[0]*cos90))>>12;
								temp1=vx[1];
								vx[1]=((vx[1]*cos90)-(vz[1]*sin90))>>12;
								vz[1]=((temp1*sin90)+(vz[1]*cos90))>>12;
								cres[0]=-((vx[0]*S1.vx)+(vz[0]*S1.vz));
								cres[1]=-((vx[1]*S4.vx)+(vz[1]*S4.vz));
								res[0]=-((vx[0]*pX)+(vz[0]*pZ));
								res[1]=-((vx[1]*pX)+(vz[1]*pZ));
	/*							res[0]/=8192;
								res[1]/=8192;
								cres[0]/=8192;
								cres[1]/=8192;
								res[0]*=8192;
								res[1]*=8192;
								cres[0]*=8192;
								cres[1]*=8192;	*/
								if (((res[0]>=cres[0])&&(res[1]<=cres[1]))||((res[0]<=cres[0])&&(res[1]>=cres[1])))
								{
									vx[2]=(S4.vx-S1.vx);
									vz[2]=(S4.vz-S1.vz);
									vx[3]=(S3.vx-S2.vx);
									vz[3]=(S3.vz-S2.vz);
									temp1=vx[2];
									vx[2]=((vx[2]*cos90)-(vz[2]*sin90))>>12;
									vz[2]=((temp1*sin90)+(vz[2]*cos90))>>12;
									temp1=vx[3];
									vx[3]=((vx[3]*cos90)-(vz[3]*sin90))>>12;
									vz[3]=((temp1*sin90)+(vz[3]*cos90))>>12;
									cres[2]=-((vx[2]*S1.vx)+(vz[2]*S1.vz));
									cres[3]=-((vx[3]*S2.vx)+(vz[3]*S2.vz));
									res[2]=-((vx[2]*pX)+(vz[2]*pZ));
									res[3]=-((vx[3]*pX)+(vz[3]*pZ));
	/*								res[2]/=8192;
									res[3]/=8192;
									cres[2]/=8192;
									cres[3]/=8192;
									res[2]*=8192;
									res[3]*=8192;
									cres[2]*=8192;
									cres[3]*=8192;	*/
									if (((res[2]>=cres[2])&&(res[3]<=cres[3]))||((res[2]<=cres[2])&&(res[3]>=cres[3])))
									{
										skiablefound[P->Buffer]=1;
										shitbox=1;
										skiablecp=thiscp;
										if (((P->Pos.Y>>12)>=S1.vy)||(objecttype==92))
	//									if ((P->Pos.Y>>12)>=(thiscollision[P->Buffer].height+2))
										{
											thiscollision[P->Buffer].type=TOP;
											if (objecttype==22)
											{
												thiscollision[P->Buffer].type=RAILSLIDE;
												thiscollision[P->Buffer].angle=objectptr->RotY<<12;
											}
	#ifdef MUSIC
											switch (objecttype)
											{
												default:
												{
													playsoundeffect(8,1);
													break;
												}
												case 92:
												{
													if (P->Vel!=0)
													{
														playsoundeffect(25,1);
													}
													break;
												}

												case 53:
												{
													playsoundeffect(11,1);
													break;
												}
												case 54:           //sheep
												{
													playsoundeffect(15,1);
													break;
												}
											}
	#endif
										}
									}
								}
							}
						}

	//					if ((thisotz>=1)&&(thisotz<1199)&&(thisp!=4))
						if ((thisotz>=1)&&(thisotz<(OTLENGTH-1)))
						{
							polyvertptr=thispolyptr->vertptr;

	//						gte_NormalClip((vertstoreaddr+(polyvertptr&mask)),(vertstoreaddr+((polyvertptr>>8)&mask)),
	//									   (vertstoreaddr+((polyvertptr>>16)&mask)),&thisouter);
	//						if (thisouter>=0)
							if (1)
							{
								SKBADDPRIMLOCALS

								polystptr=&polyf4s[otid][nopolyf4s];
								polyustore=thispolyptr->textus;
								polyvstore=thispolyptr->textvs;
								tmatid=thispolyptr->tmatid;

	/*							if (shitbox==1)
								{
									*(uint32 *)&(polystptr->r0)=(44<<24)|(255<<16)|(0<<8)|0;
								}
								else
								{
									if ((polyptr+i)->polytype==2)
									{
										*(uint32 *)&(polystptr->r0)=(44<<24)|(0<<16)|(255<<8)|0;
									}
									else
									{	*/
										*(uint32 *)&(polystptr->r0)=(44<<24)|(127<<16)|(127<<8)|127;
	//								}
	//							}
								polystptr->tpage=tids[tmatid].textpage;
								polystptr->clut=tids[tmatid].clutline[thisp];


								*(uint16 *)&(polystptr->u0)=(polyvstore<<8)|(polyustore&mask);
								*(uint16 *)&(polystptr->u1)=((polyvstore>>8)&mask)<<8|((polyustore>>8)&mask);
								*(uint16 *)&(polystptr->u2)=((polyvstore>>24)&mask)<<8|((polyustore>>24)&mask);
								*(uint16 *)&(polystptr->u3)=((polyvstore>>16)&mask)<<8|((polyustore>>16)&mask);
								*((uint32 *)&(polystptr->x0))=((*(vertstoreaddr+(polyvertptr&mask)))>>16)|(((*(vertstoreaddr+(polyvertptr&mask))))<<16);
	//							polystptr->y0=(*(vertstoreaddr+(polyvertptr&mask)))&0xffff;
								*((uint32 *)&(polystptr->x1))=((*(vertstoreaddr+((polyvertptr>>8)&mask)))>>16)|(((*(vertstoreaddr+((polyvertptr>>8)&mask))))<<16);
	//							polystptr->y1=(*(vertstoreaddr+((polyvertptr>>8)&mask)))&0xffff;
								*((uint32 *)&(polystptr->x2))=((*(vertstoreaddr+((polyvertptr>>24)&mask)))>>16)|(((*(vertstoreaddr+((polyvertptr>>24)&mask))))<<16);
	//							polystptr->y2=(*(vertstoreaddr+((polyvertptr>>24)&mask)))&0xffff;
								*((uint32 *)&(polystptr->x3))=((*(vertstoreaddr+((polyvertptr>>16)&mask)))>>16)|(((*(vertstoreaddr+((polyvertptr>>16)&mask))))<<16);
	//							polystptr->y3=(*(vertstoreaddr+((polyvertptr>>16)&mask)))&0xffff;
								OTPtr=&(OrderingTable[otid][thisotz]);
								SKBADDPRIM(OTPtr,polystptr)
	//							AddPrim(OTPtr,polystptr);
								nopolyf4s++;
							}
						}
					}
					else
					{
	/*					if ((thisotz>=16)&&(thisotz<1199)&&(thisp!=4096))
						{
								gte_NormalClip(sxy[(polyptr+i)->vertptr[3]],sxy[(polyptr+i)->vertptr[1]],
											 		sxy[(polyptr+i)->vertptr[1]],&thisouter);
							thisouter=NormalClip(sxy[((polyptr+i)->vertptr>>24)&mask],sxy[(polyptr+i)->vertptr&mask],
												sxy[((polyptr+i)->vertptr>>8)&mask]);

							if (thisouter>=0)
							{
								gte_NormalColorDpq(&(polyptr+i)->normals[0],&(polyptr+i)->basecolour,thisp,&outputcolour);
								setXY4(&poly4s[otid][nopoly4s],((sxy[((polyptr+i)->vertptr)&mask])&0xffff0000)>>16,
															(sxy[((polyptr+i)->vertptr)&mask])&0xffff,
															((sxy[((polyptr+i)->vertptr>>8)&mask])&0xffff0000)>>16,
															(sxy[((polyptr+i)->vertptr>>8)&mask])&0xffff,
															((sxy[((polyptr+i)->vertptr>>24)&mask])&0xffff0000)>>16,
															(sxy[((polyptr+i)->vertptr>>24)&mask])&0xffff,
															((sxy[((polyptr+i)->vertptr>>16)&mask])&0xffff0000)>>16,
															(sxy[((polyptr+i)->vertptr>>16)&mask])&0xffff);
								setRGB0(&poly4s[otid][nopoly4s],outputcolour.r,outputcolour.g,outputcolour.b);
								OTPtr=&(OrderingTable[otid][thisotz]);
								AddPrim(OTPtr,&poly4s[otid][nopoly4s]);
								nopoly4s++;
							}
						}   */
					}
				}
				else
				{
					if (thispolyptr->polytype>0)
					{
						thisp/=1024;
	//					if ((thisotz>=1)&&(thisotz<1199)&&(thisp!=4))
						if ((thisotz>=1)&&(thisotz<(OTLENGTH-1)))
						{

							polyvertptr=thispolyptr->vertptr;

	//						gte_NormalClip((vertstoreaddr+(polyvertptr&mask)),(vertstoreaddr+((polyvertptr>>8)&mask)),
	//									   (vertstoreaddr+((polyvertptr>>16)&mask)),&thisouter);
	//						if (thisouter>=0)
							if(1)
							{
								SKBADDPRIMLOCALS

								polystptr2=&polyf3s[otid][nopolyf3s];
								polyustore=thispolyptr->textus;
								polyvstore=thispolyptr->textvs;
								tmatid=thispolyptr->tmatid;
	/*							if (shitbox==1)
								{
									*(uint32 *)&(polystptr2->r0)=(36<<24)|(255<<16)|(0<<8)|0;
								}
								else
								{
									if ((polyptr+i)->polytype==2)
									{
										*(uint32 *)&(polystptr2->r0)=(36<<24)|(0<<16)|(255<<8)|0;
									}
									else
									{	*/
										*(uint32 *)&(polystptr2->r0)=(36<<24)|(127<<16)|(127<<8)|127;
	//								}
	//							}
								polystptr2->tpage=tids[tmatid].textpage;
								polystptr2->clut=tids[tmatid].clutline[thisp];

								*(uint16 *)&(polystptr2->u0)=(polyvstore<<8)|(polyustore&mask);
								*(uint16 *)&(polystptr2->u1)=((polyvstore>>8)&mask)<<8|((polyustore>>8)&mask);
								*(uint16 *)&(polystptr2->u2)=((polyvstore>>16)&mask)<<8|((polyustore>>16)&mask);
								*(uint32 *)&(polystptr2->x0)=((*(vertstoreaddr+(polyvertptr&mask)))&0xffff)<<16|(*(vertstoreaddr+(polyvertptr&mask)))>>16;
	//							polystptr2->y0=(*(vertstoreaddr+(polyvertptr&mask)))&0xffff;
								*(uint32 *)&(polystptr2->x1)=((*(vertstoreaddr+((polyvertptr>>8)&mask)))&0xffff)<<16|(*(vertstoreaddr+((polyvertptr>>8)&mask)))>>16;
	//							polystptr2->y1=(*(vertstoreaddr+((polyvertptr>>8)&mask)))&0xffff;
								*(uint32 *)&(polystptr2->x2)=((*(vertstoreaddr+((polyvertptr>>16)&mask)))&0xffff)<<16|(*(vertstoreaddr+((polyvertptr>>16)&mask)))>>16;
	//							polystptr2->y2=(*(vertstoreaddr+((polyvertptr>>24)&mask)))&0xffff;

								OTPtr=&(OrderingTable[otid][thisotz]);
								SKBADDPRIM(OTPtr,polystptr2)
	//							AddPrim(OTPtr,polystptr2);
					  			nopolyf3s++;
							}
						}
					}
					else
					{
	/*					if ((thisotz>=16)&&(thisotz<1199)&&(thisp!=4096))
						{
								gte_NormalClip(sxy[(polyptr+i)->vertptr[2]],sxy[(polyptr+i)->vertptr[1]],
											 		sxy[(polyptr+i)->vertptr[0]],&thisouter);
							thisouter=NormalClip(sxy[((polyptr+i)->vertptr>>16)&mask],sxy[((polyptr+i)->vertptr>>8)&mask],
												sxy[((polyptr+i)->vertptr)&mask]);

							if (thisouter>=0)
							{
								NormalColorDpq(&(polyptr+i)->normals[0],&(polyptr+i)->basecolour,thisp,&outputcolour);
								setRGB0(&poly3s[otid][nopoly3s],outputcolour.r,outputcolour.g,outputcolour.b);
								setXY3(&poly3s[otid][nopoly3s],((*(vertstoreaddr+(((polyptr+i)->vertptr)&mask)))&0xffff0000)>>16,
															(*(vertstoreaddr+(((polyptr+i)->vertptr)&mask)))&0xffff,
															((*(vertstoreaddr+(((polyptr+i)->vertptr>>8)&mask)))&0xffff0000)>>16,
															(*(vertstoreaddr+(((polyptr+i)->vertptr>>8)&mask)))&0xffff,
															((*(vertstoreaddr+(((polyptr+i)->vertptr>>16)&mask)))&0xffff0000)>>16,
															(*(vertstoreaddr+(((polyptr+i)->vertptr>>16)&mask)))&0xffff);

								OTPtr=&(OrderingTable[otid][thisotz]);
								AddPrim(OTPtr,&poly3s[otid][nopoly3s]);
								nopoly3s++;
							}
						}   */
					}
				}

			}
		}

		objectptr++;
//		if (Cnt<5)
//		{
//			if ((thisotz>maxobjot)&&(objecttype!=50))
//			{
//				maxobjot=thisotz;
//			}
//		}
	}
	if ((thiscollision[P->Buffer].type==SIDES)&&(stobjtype==92))
	{
		thiscollision[P->Buffer].type=STUMP;
	}
	if (thiscollision[P->Buffer].type==MAIN_BOX_COLLIDE)
	{
#ifdef MUSIC
		playsoundeffect(7,2);
#endif
		if (stnumcolls==1)
		{
			if ((stobjtype==21)||(stobjtype==35))
			{
				thiscollision[P->Buffer].type=STUMP;
			}
			else
			{
				if (stobjtype!=92)
				{
					thiscollision[P->Buffer].type=SIDES;
				}
			}
			if ((stobjtype>=6)&&(stobjtype<=10))
			{
				tempchill+=(stobjtype-5)*100;
				thiscollision[P->Buffer].type=NONE;
			}
		}
		else
		{
			thiscollision[P->Buffer].type=NONE;
		}
	}
#ifdef MUSIC
	if ((thiscollision[P->Buffer].type==STUMP)||(thiscollision[P->Buffer].type==SIDES))
	{
		if ((P->Vel>>12)<15)
		{
			if (objecttype!=53)
			{
				playsoundeffect(22,1);
			}
		}
		else
		{
			if (objecttype!=53)
			{
				playsoundeffect(21,1);
			}
		}
		switch (objecttype)
		{
			default:
			case 20:
			case 27:
			{
				playsoundeffect(1,1);
				break;
			}
			case 21:
			{
				playsoundeffect(2,1);
				break;
			}
			case 22:
			{
				playsoundeffect(3,1);
				break;
			}
			case 23:
			{
				playsoundeffect(6,1);
				break;
			}
			case 53:
			{
				playsoundeffect(10,1);
				break;
			}
			case 54:           //sheep
			{
				playsoundeffect(14,1);
				break;
			}
		}
	}
#endif

//	if (nodrawnpolys>maxdrawn)
//	{
//		maxdrawn=nodrawnpolys;
//	}
}

void DrawTexturedTrackPolys( uint16 thiscp, uint8 playerno )
{
	unsigned long address;
	player *P=&Player[playerno];
	uint8	i,j,k,whichaddr,whichclut,isedge;
	uint16	stripno;
   	long	thisotz,thisp,outer;
	uint8	BCP;
	VECTOR	X,Y;
	POLY_FT4 *ft4ptr;
	uint8	mask=0xff;
	uint32	hoardinginfo;
	int32	testheight;
	CVECTOR	tempcol;
	uint32	u1,u2,u3,u4;
//	MATRIX 	arsetrans;
//	SVECTOR	sv1,sv2,sv3,sv4;

//	thiscp=cp;
	gte_SetRotMatrix(&P->Cam.ObjectView);
	X.vx=-(P->Cam.Pos.X>>12);
	X.vy=-(P->Cam.Pos.Y>>12);
	X.vz=-(P->Cam.Pos.Z>>12);
	X.vx-=P->Track->Meshes[ thiscp ].OffsetX;
	X.vz+=P->Track->Meshes[ thiscp ].OffsetZ;

	ApplyRotMatrixLV(&X,&Y);
//	gte_ApplyRotMatrix(&X,&Y);


	texttransmatrix.t[0]=Y.vx;
	texttransmatrix.t[1]=Y.vy;
	texttransmatrix.t[2]=Y.vz;
	gte_SetTransMatrix(&texttransmatrix);
	gte_SetRotMatrix(&P->Cam.ObjectView);

	/* is it a hoarding? */

	stripno=P->Track->Meshes[ thiscp ].StripNo;
	textptr=P->Track->Meshes[ thiscp ].Textaddr;
	for (k=0;k<P->Track->Meshes[ thiscp ].notext;k++)
	{
		whichclut=(textptr->TID&0xffff)-1;
		hoardinginfo=(textptr->TID)>>16;
		textpage=tids[whichclut].textpage;
//		clutpage=tids[0].clutpage;
		if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(playerno==1))
		{

		}
		else
		{
			gte_ldv3(&(textptr->XYZ[0]),&(textptr->XYZ[1]),&(textptr->XYZ[2]));
			gte_rtpt();
		}
		if (((thiscp-CPoly[P->Buffer])<2)&&((thiscp-CPoly[P->Buffer])>=-1)&&(thiscollision[P->Buffer].type==NONE))
//		if ((Cnt<5)&&(thiscollision[P->Buffer].type==NONE))
		{
			B1.vx=textptr->XYZ[0].vx;
			B1.vy=textptr->XYZ[0].vy;
			B1.vz=textptr->XYZ[0].vz;
			B2.vx=textptr->XYZ[1].vx;
			B2.vy=textptr->XYZ[1].vy;
			B2.vz=textptr->XYZ[1].vz;
			B3.vx=textptr->XYZ[2].vx;
			B3.vy=textptr->XYZ[2].vy;
			B3.vz=textptr->XYZ[2].vz;
			B4.vx=textptr->XYZ[3].vx;
			B4.vy=textptr->XYZ[3].vy;
			B4.vz=textptr->XYZ[3].vz;

			vx[2]=vx[0]=(B3.vx-B1.vx);
			vz[2]=vz[0]=(B3.vz-B1.vz);
			vx[3]=(B4.vx-B2.vx);
			vz[3]=(B4.vz-B2.vz);
			temp1=vx[2];
			vx[2]=((vx[2]*cos90)-(vz[2]*sin90))>>12;
			vz[2]=((temp1*sin90)+(vz[2]*cos90))>>12;
			temp1=vx[3];
			vx[3]=((vx[3]*cos90)-(vz[3]*sin90))>>12;
			vz[3]=((temp1*sin90)+(vz[3]*cos90))>>12;

			pX=(P->Pos.X>>12)+P->Track->Meshes[thiscp].OffsetX;
			pZ=(P->Pos.Z>>12)-P->Track->Meshes[thiscp].OffsetZ;
			cres[2]=-((vx[2]*(B1.vx))+(vz[2]*(B1.vz)));
			if ((hoardinginfo>=1)&&(hoardinginfo<=7))
			{
				lX=(P->LastPos.X>>12)+P->Track->Meshes[thiscp].OffsetX;
				lZ=(P->LastPos.Z>>12)-P->Track->Meshes[thiscp].OffsetZ;
				res[0]=-((vx[2]*pX)+(vz[2]*pZ));
				res[1]=-((vx[2]*lX)+(vz[2]*lZ));

	 			if (((res[0]<cres[2])&&(res[1]>cres[2]))||(abs(res[0]-cres[2])<1000))
//	((res[0]>cres[2])&&(res[1]<cres[2]))
				{
					isedge=0;
					if (B1.vy>B2.vy)
					{
						testheight=B1.vy+80;
					}
					else
					{
						testheight=B2.vy+30;
					}
					if (hoardinginfo==5)
					{
						testheight=(P->Pos.Y>>12)+10;
					}
					if ((P->Pos.Y>>12)<testheight)
					{
						res[0]=-((vx[0]*pX)+(vz[0]*pZ));
						cres[2]=-((vx[0]*(B1.vx))+(vz[0]*(B1.vz)));
						cres[3]=-((vx[0]*(B3.vx))+(vz[0]*(B3.vz)));
						if ((cres[2]>res[0])&&(cres[3]<res[0]))
						{
							if (hoardinginfo==3)
							{
								thiscollision[P->Buffer].type=STUMP;
							}
							else
							{
								thiscollision[P->Buffer].type=SIDES;
							}
							if (hoardinginfo==7)
							{
								thiscollision[P->Buffer].type=NONE;
								P->Pos.Z+=100<<12;
								P->Pos.X-=120<<12;
#ifdef MUSIC
		   						playsoundeffect(12,1);
#endif

							}

#ifdef MUSIC
							playsoundeffect(7,2);
							playsoundeffect(1,1);
#endif

							vx[5]=(B1.vx-B3.vx);
							vz[5]=(B1.vz-B3.vz);
							angvec1.vx=angvec1.vy=0;
							angvec1.vz=1;
							temp1=angvec1.vx;
							vx[4]=(P->Rot.Y>>12)&0x0fff;
							angvec1.vx=(angvec1.vx*rcos(vx[4]))-(angvec1.vz*rsin(vx[4]));
							angvec1.vz=(temp1*rsin(vx[4]))+(angvec1.vz*rcos(vx[4]));
//							temp1=angvec1.vx;
//							angvec1.vx=(angvec1.vx*cos90)-(angvec1.vz*sin90);
//							angvec1.vz=(temp1*sin90)+(angvec1.vz*cos90);

//							vx[4]=pX-lX;
//							vz[4]=pZ-lZ;
//							temp1=vx[4];
//							vx[4]=((vx[4]*cos90)-(vz[4]*sin90));
//							vz[4]=((temp1*sin90)+(vz[4]*cos90));
//							angvec1.vx=vx[4];
//							angvec1.vy=0;
//							angvec1.vz=-vz[4];
/*							VectorNormal( &angvec1, &angvec3 );
							angvec2.vx=vx[5];
							angvec2.vy=0;
							angvec2.vz=vz[5];
							VectorNormal (&angvec2, &angvec4);

							thiscollision[P->Buffer].angle=PSX_Dot(&angvec4,&angvec3)>>12;	*/
							vx[4]=ratan2(vx[5],vz[5]);
							printf("normal angle= %d pa:%d\n",(vx[4]*360)>>12,(-ratan2(angvec1.vz,angvec1.vx)*360)>>12);
							vx[5]=vx[4]+ratan2(angvec1.vz,angvec1.vx);
							printf("angle difference= %d\n",(vx[5]*360)>>12);
							vx[5]/=2;
							thiscollision[P->Buffer].angle=vx[4]+vx[5];
							printf("fa=%d\n",(thiscollision[P->Buffer].angle*360)>>12);
//							thiscollision[P->Buffer].angle=-(ratan2(vz[5],vx[5])-1024);
//							printf("ha:%d,pa:%d,fa:%d\n",(ratan2(vz[5],vx[5])*360)>>12,(ratan2(angvec1.vz,angvec1.vx)*360)>>12,(thiscollision[P->Buffer].angle*360)>>12);

/*							if ((res[0]<cres[2])&&(res[1]>cres[2]))
							{
								thiscollision[P->Buffer].angle=128<<12;
							}
							else
							{
								thiscollision[P->Buffer].angle=-128<<12;
							}	*/
							thisx=P->Pos.X-P->LastPos.X;
							thisy=P->Pos.Y-P->LastPos.Y;
							thisz=P->Pos.Z-P->LastPos.Z;
							thisres=-((vx[2]*(P->Pos.X+thisx))*(vz[2]*(P->LastPos.Z)+thisz));
							thiscollision[P->Buffer].point.X=P->Pos.X+thisx;
							thiscollision[P->Buffer].point.Y=P->Pos.Y+thisy;
							thiscollision[P->Buffer].point.Z=P->Pos.Z+thisz;
						}
					}
				}
			}
			else
			{
				cres[3]=-((vx[3]*(B2.vx))+(vz[3]*(B2.vz)));
				res[2]=-((vx[2]*pX)+(vz[2]*pZ));
				res[3]=-((vx[3]*pX)+(vz[3]*pZ));
				if ((res[2]>cres[2])&&(res[3]<cres[3]))
				{
					vx[0]=(B1.vx-B2.vx);
					vz[0]=(B1.vz-B2.vz);
					vx[1]=(B3.vx-B4.vx);
					vz[1]=(B3.vz-B4.vz);
					temp1=vx[0];
					vx[0]=((vx[0]*cos90)-(vz[0]*sin90))>>12;
					vz[0]=((temp1*sin90)+(vz[0]*cos90))>>12;
					temp1=vx[1];
					vx[1]=((vx[1]*cos90)-(vz[1]*sin90))>>12;
					vz[1]=((temp1*sin90)+(vz[1]*cos90))>>12;
					cres[0]=-((vx[0]*(B1.vx))+(vz[0]*(B1.vz)));
					cres[1]=-((vx[1]*(B3.vx))+(vz[1]*(B3.vz)));
					res[0]=-((vx[0]*pX)+(vz[0]*pZ));
					res[1]=-((vx[1]*pX)+(vz[1]*pZ));
					if ((res[0]>cres[0])&&(res[1]<cres[1]))
					{
						thiscollision[P->Buffer].type=ROCK;
					}
				}
			}
		}
		if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(playerno==1))
		{

		}
		else
		{
			gte_stsxy3(vertstoreaddr,vertstoreaddr+1,vertstoreaddr+2);
	//		gte_stdp(r7);
	//		gte_stflg(r8);
			gte_stszotz((vertstoreaddr+5));
			if (hoardinginfo==0)
			{
				gte_NormalClip(*vertstoreaddr,*(vertstoreaddr+2),*(vertstoreaddr+1),&outer);
			}
			else
			{
				outer=1;
			}
			if (outer>=0)
			{
				if ((*(vertstoreaddr+5)>=1)&&(*(vertstoreaddr+5)<(OTLENGTH-1)))
				{
					SKBADDPRIMLOCALS

	//				thisp=(*(vertstoreaddr+5)*2)+(howfoggy[P->Buffer]*122);
					if (*(vertstoreaddr+5)>(800-howfoggy[P->Buffer]*12))
					{
						thisp=((*(vertstoreaddr+5)-500)*howfoggy[P->Buffer])/2;
	   				}
	   				else
	   				{
						thisp=0;
					}

					if (thisp>4096)
					{
						thisp=4096;
					}
	/*  			if (*(vertstoreaddr+5)<40)
					{
	//					gte_SetRotMatrix(&P->Cam.ObjectView);
	//					gte_SetRotMatrix(&textmatrix);
	//					gte_SetRotMatrix(&P->Cam.ViewMatrix);
	//					gte_SetTransMatrix(&arsetrans);
	//					SetGeomOffset(160,120);
						divwork4.pih=320;
						divwork4.piv=240;
						divwork4.ndiv=3;
						tempcol.cd=44;
						tempcol.r=255;
						tempcol.g=0;
						tempcol.b=0;
						u1=(tids[whichclut].clutline[thisp/1024]<<16)|(textptr->UV[0].vy<<8)|textptr->UV[0].vx;
						u2=(textpage<<16)|(textptr->UV[1].vy<<8)|textptr->UV[1].vx;
						u3=(textptr->UV[3].vy<<8)|textptr->UV[3].vx;
						u4=(textptr->UV[2].vy<<8)|textptr->UV[2].vx;

						DivideFT4(&textptr->XYZ[0],&textptr->XYZ[2],&textptr->XYZ[1],&textptr->XYZ[3],
	//  				DivideFT4(&sv1,&sv2,&sv3,&sv4,
						&u1,&u2,&u3,&u4,&tempcol,&polyf4s[otid][nopolyf4s],&OrderingTable[otid][0],&divwork4);
						nopolyf4s+=64;
	//					SetGeomOffset(120,160);
	//					gte_SetRotMatrix(&textmatrix);
	//					gte_SetTransMatrix(&texttransmatrix);
					}
					else
					{   */
						gte_ldv0(&(textptr->XYZ[3]));
						ft4ptr=&polyf4s[otid][nopolyf4s];

						*(uint32 *)&(ft4ptr->r0)=(44<<24)|(128<<16)|(128<<8)|128;

						*(uint16 *)&(ft4ptr->u0)=(textptr->UV[0].vy<<8)|textptr->UV[0].vx;
						gte_rtps();
						*(uint16 *)&(ft4ptr->u1)=(textptr->UV[1].vy<<8)|textptr->UV[1].vx;
						*(uint16 *)&(ft4ptr->u2)=(textptr->UV[3].vy<<8)|textptr->UV[3].vx;
						*(uint16 *)&(ft4ptr->u3)=(textptr->UV[2].vy<<8)|textptr->UV[2].vx;
						gte_stsxy(vertstoreaddr+3);
						gte_stszotz(vertstoreaddr+6);
						ft4ptr->tpage=textpage;
						ft4ptr->clut=tids[whichclut].clutline[thisp/1024];

						*(uint32 *)&(ft4ptr->x0)=((*(vertstoreaddr))&0xffff)<<16|(*(vertstoreaddr))>>16;
						*(uint32 *)&(ft4ptr->x1)=((*(vertstoreaddr+2))&0xffff)<<16|(*(vertstoreaddr+2))>>16;
						*(uint32 *)&(ft4ptr->x2)=((*(vertstoreaddr+1))&0xffff)<<16|(*(vertstoreaddr+1))>>16;
						*(uint32 *)&(ft4ptr->x3)=((*(vertstoreaddr+3))&0xffff)<<16|(*(vertstoreaddr+3))>>16;
	//					*(uint32 *)&(ft4ptr->x0)=*(vertstoreaddr);
	//					*(uint32 *)&(ft4ptr->x1)=*(vertstoreaddr+2);
	//					*(uint32 *)&(ft4ptr->x2)=*(vertstoreaddr+1);
	//					*(uint32 *)&(ft4ptr->x3)=*(vertstoreaddr+3);

						OTPtr=&(OrderingTable[otid][(*(vertstoreaddr+5)+*(vertstoreaddr+6))>>1]);
						SKBADDPRIM(OTPtr,ft4ptr);
						nopolyf4s++;
	//  			}
				}
				if (Cnt<5)
				{
					if (*(vertstoreaddr+5)>maxobjot)
					{
						maxobjot=*(vertstoreaddr+5);
					}
				}
			}
			if ((textptr->UV[0].vx<=191)&&(textptr->UV[0].vx>=128)&&(textptr->UV[0].vy<=63)&&((textptr->TID&0xffff)==5))
			{
#ifdef MUSIC
				playsoundeffect(13,1);
#endif
				if (thiscollision[P->Buffer].type==ROCK)
				{
					thiscollision[P->Buffer].type=RIVER;
#ifdef MUSIC
					playsoundeffect(24,1);
#endif
				}

				if ((textptr->UV[0].vx<129)||(textptr->UV[2].vx<129))
				{
					for (i=0;i<4;i++)
					{
						textptr->UV[i].vx+=32;
					}
				}
				else
				{
					for (i=0;i<4;i++)
					{
						if (textptr->UV[0].vy>=32)
						{
							textptr->UV[i].vx--;
						}
						else
						{
							textptr->UV[i].vx-=2;
						}
					}
				}
			}
		}
		textptr++;
	}
}

void plotoverlays(uint8 pno)
{
	uint8 def;
	player *P=&Player[pno];

	SKBADDPRIMLOCALS

	hours=globaltime[P->Buffer]/36000000;
	minutes=(globaltime[P->Buffer]-(hours*36000000))/600000;
	seconds=(globaltime[P->Buffer]-(hours*36000000)-(minutes*600000))/10000;
	decsecs=(globaltime[P->Buffer]-(hours*36000000)-(minutes*600000)-(seconds*10000))/100;
//	sprintf(timestr,"%01d:%02d:%02d:%02d\0",hours,minutes,seconds,decsecs);
	sprintf(timestr,"%02d:%02d:%02d\0",minutes,seconds,decsecs);
	for (Cnt=0;Cnt<8;Cnt++)
	{
		timecopyrect.w=8;
		timecopyrect.h=14;
		if (timestr[Cnt]==':')
		{
			timecopyrect.x=712;	/* 704 + 16/2 */
			timecopyrect.y=304;  /* 256 + 48 */
		}
		else
		{
			timecopyrect.x=704;
			timecopyrect.y=256+((timestr[Cnt]-48)*14);
		}
		MoveImage(&timecopyrect,320+(Cnt*8),239);
	}
	OTPtr=&(OrderingTable[otid][0]);
	SKBADDPRIM(OTPtr,&timepolys[otid]);

	SKBADDPRIM(OTPtr,&namepolys[otid][0]);

	SKBADDPRIM(OTPtr,&namepolys[otid][1]);

	SKBADDPRIM(OTPtr,&namepolys[otid][2]);

	if (ConsolePlayers==1)
	{
		sprintf(timestr,"%03d",abs(P->Vel*5)/4096);
		for (Cnt=0;Cnt<7;Cnt++)
		{
			timecopyrect.w=8;
			timecopyrect.h=14;
			timecopyrect.x=704;
			timecopyrect.y=256+((timestr[Cnt]-48)*14);
			MoveImage(&timecopyrect,376+(Cnt*8),222);
		}
		timecopyrect.w=24;
		timecopyrect.h=16;
		timecopyrect.x=704;
		timecopyrect.y=456;
		MoveImage(&timecopyrect,400,222);
		sprintf(timestr,"%07d",tempchill);
		for (Cnt=0;Cnt<7;Cnt++)
		{
			timecopyrect.w=8;
			timecopyrect.h=14;
			timecopyrect.x=704;
			timecopyrect.y=256+((timestr[Cnt]-48)*14);
			MoveImage(&timecopyrect,320+(Cnt*8),222);
		}
		if ((lastchillscore!=0)||(scorecounter!=0))
		{
			if (scorecounter==0)
			{
				sprintf(timestr,"%05d",lastchillscore);
				for (Cnt=0;Cnt<5;Cnt++)
				{
					timecopyrect.w=8;
					timecopyrect.h=14;
					timecopyrect.x=704;
					timecopyrect.y=256+((timestr[Cnt]-48)*14);
					MoveImage(&timecopyrect,320+(Cnt*8),208);
				}
			}
			setXY4(&trickpolys[otid],90+((scorecounter%35)*2),50+((scorecounter%35)/5),230-((scorecounter%35)*2),50+((scorecounter%35)/5),
									 90+((scorecounter%35)*2),64-((scorecounter%35)/5),230-((scorecounter%35)*2),64-((scorecounter%35)/5));
//			setXY4(&trickpolys[otid],125,50,195,50,125,64,195,64);
			setRGB0(&trickpolys[otid],(scorecounter%32)*7,scorecounter,255-((scorecounter%16)*15));
//			setRGB0(&trickpolys[otid],127,127,127);
			SKBADDPRIM(OTPtr,&trickpolys[otid]);
			scorecounter++;
			if (scorecounter==35)
			{
				scorecounter=0;
			}
		}
		SKBADDPRIM(OTPtr,&scorepolys[otid]);
		SKBADDPRIM(OTPtr,&speedpolys[otid]);
	}
}


void TempRenderTrackPolys( uint8 PlayerNumber )
{
	player *Plyr = &Player[ PlayerNumber ];
	short avfound;
//	unsigned short	CP;
	DR_ENV	ChangeEnv[4];
	TMESH *tmeshptr;
	POLY_G3 *g3ptr;
	long count1,count2,address,z0,z1,z2,z_max;
	unsigned long colcodeptr;
	uint8 	cfound;
	uint8	pfound;

	avfound=0;
	cfound=0;
	pfound=0;
	/* if space for new polys in track display buffer, get them */

	if (newdirection[Plyr->Buffer]!=trackdirection[Plyr->Buffer])
	{
		if (bufferswapcount[Plyr->Buffer]==0xff)
		{
			Plyr->Track->NumberOfStrips=0;
			Plyr->Track->CurrentStrip=0;
			CPoly[Plyr->Buffer]=0; //MAX_VIEW_STRIPS/2;
//			bufstartcnt[P->Buffer]=0;	//CPoly[Plyr->Buffer];
//			Plyr->Track->CurrentStrip=MAX_VIEW_STRIPS/2;
			if ((previouscount[Plyr->Buffer]-((MAX_VIEW_STRIPS*3)/2))<0)
			{
				if (bufferfilled[Plyr->Buffer]==1)
				{
					bufferswapcount[Plyr->Buffer]=100-(((MAX_VIEW_STRIPS*3)/2)-previouscount[Plyr->Buffer]);
				}
				else
				{
					bufferswapcount[Plyr->Buffer]=0;
				}
			}
			else
			{
				bufferswapcount[Plyr->Buffer]=previouscount[Plyr->Buffer]-(MAX_VIEW_STRIPS*3)/2;
			}
			trackdirection[Plyr->Buffer]=newdirection[Plyr->Buffer];
		}
		else
		{
			trackdirection[Plyr->Buffer]=newdirection[Plyr->Buffer];
		}
	}

	while ( Plyr->Track->NumberOfStrips < MAX_VIEW_STRIPS )
	{
		GetANewTrackPoly ( PlayerNumber );
	}

	if (unusedpolys[ Plyr->Buffer ]>0)
	{
		for (Cnt=0;Cnt<unusedpolys[ Plyr->Buffer ];Cnt++)
		{
			Cnt+=GetANewTrackPoly ( PlayerNumber );
		}
		unusedpolys[ Plyr->Buffer ]=0;
	}
#if I_AM == JEB
	if ( Pad_State( 0 ) & PAD_BOTTOMRIGHT ) /* && Tb.NumberOfPolys < MAX_VIEW_POLYS ) */
	{
//		GetANewTrackPoly ( PlayerNumber );
	}
#endif
	CP = Plyr->Track->CurrentStrip;		/* CP = Current Polygon */

	/* temp tunnel sound effect */

	if (currentfile[Plyr->Buffer]==35)
	{
		if ((Plyr->Pos.Z>>12>=53400)&&(Plyr->Pos.Z>>12<=58000)&&(whichside[Plyr->Buffer]==2))
		{
			playsoundeffect(30,1);
		}
	}
	if (ConsolePlayers==2)
	{
		if (TopScreenDrawn==0)
		{
			geomx=160;
			geomy=60;
		}
		else
		{
			geomx=160; /* 180 */
			geomy=60;
		}
	}
	else
	{
		geomx=160;
		geomy=120;
	}
#ifndef CD
	gte_SetLightMatrix(&MyLocalLight);
	gte_SetColorMatrix(&MyColourMatrix);
	pollhost();                                  /* temp */

#endif

//	fc.r=230;
//	fc.g=230;
//	fc.b=230;
	z=8000;
	d=500;
	bc.r=255;
	bc.g=255;
	bc.b=255;
	if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(PlayerNumber==1))
	{

	}
	else
	{
		gte_SetFarColor(fc.r,fc.g,fc.b);
		SetFogNear((z-(howfoggy[Plyr->Buffer]*120)),d+(howfoggy[Plyr->Buffer]*12));
		gte_SetBackColor(bc.r,bc.g,bc.b);
		OTPtr=&OrderingTable[otid][0];
		ClearOTagR(OTPtr,OTLENGTH);
#ifdef PROFILE
		ProfileAddOT( &OrderingTable[otid][0] );
		ProfileAddDrawOT( &OrderingTable[otid][0] );
#endif
		if (ConsolePlayers==2)
		{
			mist[otid].y0=mist[otid].y1=0; /* 56-(Plyr->Cam.Rot.X/mistrot) ;	*/
		}
		else
		{
			mist[otid].y0=mist[otid].y1=0; /* 112-(Plyr->Cam.Rot.X/mistrot);   */
		}
		setRGB0(&mist[otid],57+((690*howfoggy[Plyr->Buffer])/100),107+((490*howfoggy[Plyr->Buffer])/100),148+((320*howfoggy[Plyr->Buffer])/100));
		SetPolyF4(&mist[otid]);
		OTPtr=&OrderingTable[otid][OTLENGTH-1];
		AddPrim(OTPtr,&mist[otid]);
		Snow(howsnowy[Plyr->Buffer],PlayerNumber);
		gte_SetRotMatrix(&(Plyr->Cam.ViewMatrix));
		gte_SetGeomOffset(geomx,geomy);
		gte_SetGeomScreen(geomscreen);
		Ingame=1;
		Draw_Character( PlayerNumber, 0);
	}
	unusedpolys[ Plyr->Buffer ]=0;
	Plyr->NoTaggedPolys=0;
	objectno=0;
	textno=0;
	firstdirection[Plyr->Buffer]=0;
	nopolyf4s=0;
	nopoly4s=0;
	nopolyf3s=0;
	nopoly3s=0;
	nopolyG3s=0;

	skiablefound[Plyr->Buffer]=0;
	firstgety[Plyr->Buffer]=0;
	thiscollision[Plyr->Buffer].type=NONE;
	if (lastchillscore!=0)
	{
		scorecounter=0;
	}
	if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(PlayerNumber==1))
	{

	}
	else
	{
		plotoverlays(PlayerNumber);
	}
	lastchillscore=0;
	carson=0;
	arsecandle=0;
	noshads=0;
	if (ConsolePlayers==2)
	{
		if (currentsave.options[SPLIT_SET]==0)
		{
			gte_SetGeomOffset(60,160);
		}
		else
		{
			gte_SetGeomOffset(120,80);
		}
	}
	else
	{
		gte_SetGeomOffset(120,160);
	}
	gte_SetGeomScreen(geomscreen);
//	if ((Plyr->Track->Meshes[CP].StripNo>=101)&&(Plyr->Track->Meshes[CP].StripNo<=103)&&(currentfile[Plyr->Buffer]==32))
//	{
//		trainmove=1;
//	}
//	drawmovables(PlayerNumber);
	thiscollision[Plyr->Buffer].type=NONE;

	bufftest0 = CPoly[Plyr->Buffer];
	if (CPoly[Plyr->Buffer]==0)
	{
		bufftest=MAX_VIEW_STRIPS-1;
	}
	else
	{
		bufftest=CPoly[Plyr->Buffer]-1;
	}
	if (CPoly[Plyr->Buffer]==(MAX_VIEW_STRIPS-1))
		bufftest2=0;
	else
		bufftest2=CPoly[Plyr->Buffer]+1;


	if (ConsolePlayers==2)
	{
		if (currentsave.options[SPLIT_SET]==0)
		{
			gte_SetGeomOffset(60,160);
		}
		else
		{
			gte_SetGeomOffset(120,80);
		}
	}
	else
	{
		gte_SetGeomOffset(120,160);
	}

	for ( Cnt = 0; Cnt < Plyr->Track->NumberOfStrips; Cnt++ )
	{
		if (CP == MAX_VIEW_STRIPS)
			CP=0;
		if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(PlayerNumber==1))
		{

		}
		else
		{
			DrawObjects(CP,PlayerNumber);
			DrawTexturedTrackPolys(CP,PlayerNumber);
		}
		if ((Cnt>=0)&&(Cnt<MAX_VIEW_STRIPS))
		{
			Plyr->TaggedPolys[Plyr->NoTaggedPolys]=CP;
			Plyr->NoTaggedPolys++;
		}
		CP++;
	}
	if ((NumberOfPlayers==2)&&(ConsolePlayers==1)&&(PlayerNumber==1))
	{

	}
	else
	{
		if (ConsolePlayers==2)
		{
			if (currentsave.options[SPLIT_SET]==0)
			{
				gte_SetGeomOffset(160,60);
			}
			else
			{
				gte_SetGeomOffset(80,120);
			}
		}
		else
		{
			gte_SetGeomOffset(160,120);
		}

		RussRotMeshG3Multi(Plyr,&trackprims[otid][nopolyG3s],CPoly[0]);

		SetFogNear(z1,(d2+(howfoggy[Plyr->Buffer]*mountfog)));
		if (startski[Plyr->Buffer]==0)
		{
			startski[Plyr->Buffer]=Plyr->Pos.Y>>12;
		}
		skieddown[Plyr->Buffer]=((Plyr->Pos.Y>>12)+startski[Plyr->Buffer])/256;

		DrawMountains(PlayerNumber);
		if (maxmounty==0)
		{
			maxmounty=80;
		}
		else
		{
   			maxmounty+=80;
		}
		if (maxmounty>239)
		{
			maxmounty=239;
		}
		setXY4(&clipblag[otid],0,maxmounty,319,maxmounty,0,239,319,239);
		OTPtr=&(OrderingTable[otid][OTLENGTH-2]);
		AddPrim(OTPtr,&clipblag[otid]);

		if (ConsolePlayers==2)
		{
			if (currentsave.options[SPLIT_SET]==0)
			{
				if (TopScreenDrawn==1)
				{
					SetDrawEnv(&ChangeEnv[display_id*2],&drawenv[currentsave.options[SPLIT_SET]][(display_id*2)+2]);
					AddPrim(&OrderingTable[otid][OTLENGTH-1],&ChangeEnv[display_id*2]);
				}
				else
				{
					SetDrawEnv(&ChangeEnv[(display_id*2)+1],&drawenv[currentsave.options[SPLIT_SET]][(display_id*2)+3]);
					AddPrim(&OrderingTable[otid][OTLENGTH-1],&ChangeEnv[(display_id*2)+1]);
				}
			}
			else
			{
				if (TopScreenDrawn==1)
				{
					SetDrawEnv(&ChangeEnv[display_id*2],&drawenv[currentsave.options[SPLIT_SET]][(display_id*2)+3]);
					AddPrim(&OrderingTable[otid][OTLENGTH-1],&ChangeEnv[display_id*2]);
				}
				else
				{
					SetDrawEnv(&ChangeEnv[(display_id*2)+1],&drawenv[currentsave.options[SPLIT_SET]][(display_id*2)+2]);
					AddPrim(&OrderingTable[otid][OTLENGTH-1],&ChangeEnv[(display_id*2)+1]);
				}
			}
		}

		if ((currentfile[Plyr->Buffer]==34)&&(Player[0].Track->Meshes[CPoly[0]].StripNo>=0)&&
			(Player[0].Track->Meshes[CPoly[0]].StripNo<=110))
		{
			if (Player[0].Track->Meshes[CPoly[0]].StripNo<=50)
			{
				howfoggy[Plyr->Buffer]=howsnowy[Plyr->Buffer]=(Player[0].Track->Meshes[CPoly[0]].StripNo);
			}
			else
			{
				howfoggy[Plyr->Buffer]=howsnowy[Plyr->Buffer]=110-(Player[0].Track->Meshes[CPoly[0]].StripNo);
			}
			if (howfoggy[Plyr->Buffer]>25)
			{
				howfoggy[Plyr->Buffer]=25;
				howsnowy[Plyr->Buffer]=25;
			}
		}


	#ifdef PROFILE
		ProfileReadCount();
	#endif

		DrawSync(0);

		if (ConsolePlayers==1)
		{
	//		VSync (0);
		}
		else
		{
			if (TopScreenDrawn==1)
			{
	//			VSync (1);
			}
		}
		if (framelock!=0)
		{
			FntPrint(fntid1,"            Frame Lock Off\n");
			FntFlush(fntid1);
		}
		else
		{
			if (ConsolePlayers==1)
			{
				if (NumberOfPlayers==1)
				{
					VSync (2);
				}
			}
		}
		if (ConsolePlayers==1)
		{

#if I_AM != NOBODY
			FntPrint(fntid1,"V: %s %s f:%d",__DATE__,__TIME__,fps);
		//	FntPrint(fntid1,"Reading Card Loading Game Load\n");
			FntFlush(fntid1);
#endif
			if (ConsolePlayers==2)
			{
				if (PlayerNumber==0)
				{
					Plyr=&Player[1];
				}
				else
				{
					Plyr=&Player[0];
				}
			}


#if I_AM == JEB
			if (Plyr->Cam.Type == CAMERA_TYPE_TARGET)
			{
				FntPrint(fntid2,"Tx:%d y%d z%d h:%d",Plyr->Cam.Targ.X>>12,Plyr->Cam.Targ.Y>>12,Plyr->Cam.Targ.Z>>12,Plyr->JumpY>>12);
		//		FntPrint(fntid2,"Failed No Card Space Replace\n");
				FntFlush(fntid2);
				FntPrint(fntid3,"P x%d y%d z%d s%d t%d",Plyr->Cam.Pos.X>>12,Plyr->Cam.Pos.Y>>12,Plyr->Cam.Pos.Z>>12,
 								Plyr->Track->Meshes[Plyr->Track->CurrentStrip].StripNo,currentfile[Plyr->Buffer]);
		//		FntPrint(fntid3,"Game Save O.K. No Chill Files\n");
				FntFlush(fntid3);
			}
			if (Plyr->Cam.Type== CAMERA_TYPE_POSITIONAL)
			{
				FntPrint(fntid2,"P x:%d y:%d z:%d",Plyr->Cam.Pos.X>>12,Plyr->Cam.Pos.Y>>12,Plyr->Cam.Pos.Z>>12);
				FntFlush(fntid2);
				FntPrint(fntid3,"R x:%d y:%d z:%d",Plyr->Cam.Rot.X>>12,Plyr->Cam.Rot.Y>>12,Plyr->Cam.Rot.Z>>12);
				FntFlush(fntid3);
			}
#endif
		}

		if (ConsolePlayers==2)
		{
	//		if (TopScreenDrawn==0)
	//		{
				PutDrawEnv(&drawenv[currentsave.options[SPLIT_SET]][otid+2]);        //(display_id*2)
				PutDispEnv(&dispenv[currentsave.options[SPLIT_SET]][display_id+3]);
	//		}
	//		else
	//		{
	//			PutDrawEnv(&drawenv[currentsave.options[SPLIT_SET]][(display_id*2)+3]);
	//			PutDispEnv(&dispenv[currentsave.options[SPLIT_SET]][display_id+3]);
	//		}
		}
		else
		{
			PutDrawEnv(&drawenv[0][display_id]);
			PutDispEnv(&dispenv[0][display_id]);
		}


		OTPtr=&OrderingTable[otid][OTLENGTH-1];
		DrawOTag(OTPtr);
	//	if (ConsolePlayers==1)
	//	{
	//		DrawOTag( &OrderingTable[ otid ][ 511 ] );
	//	}
		if (setdisplay==0)
		{
//			clockon[0]=1;
//			if (ConsolePlayers==2)
//			{
//				clockon[1]=1;
//			}
			SetDispMask(1);
			setdisplay=1;
		}

#ifdef PROFILE
		ProfileStartCount();
#endif

#ifndef CD
		pollhost();
#endif

		if (ConsolePlayers==1)
		{
			display_id=(display_id+1)%2;
			otid=(otid+1)%2;
		}
		else
		{
	//		if (TopScreenDrawn==1)
	//		{
				if (PlayerNumber==1)
				{
					display_id=(display_id+1)%2;
				}
	//		}
			otid=(otid+1)%4;
		}
	}
	if ((Plyr->ConsoleRemoteGhosted==REMOTE_PLAYER)||(Plyr->ConsoleRemoteGhosted==GHOSTED_PLAYER))
	{
		thiscollision[Plyr->Buffer].type=NONE;
	}
}

void KillTrackEngine ( void )
{
	printf("Executing : KillTrackEngine()\n");
}


