// frontend.h
#define	SFX_VOLUME		0
#define	MUSIC_VOLUME    1
#define	STEREO_SET		2
#define	CONTROLLER_OPT1	3
#define	SPLIT_SET		4
#define	GHOST_SET		5
#define	YETI_FOUND		6
#define	TRACK6_FOUND	7
#define	TRACK7_FOUND	8
#define	DOLBY_SET		9
#define	PAD_TYPE1		10
#define PAD_TYPE2		11
#define CONTROLLER_OPT2	12
#define	EXTRA_OPTIONS	13
#define	MAX_RECORDS		2

typedef struct area
{
	uint16	starttrack;
	uint16	endtrack;
	VECTOR	startpos[2];
	int16	roty;
	uint16 	endstrip;
	uint16	chillpts;
	uint16	skillpts;
	uint16	maxtime;
	uint16	weather;
	uint8	tpagenos[7];
	CVECTOR backcolour;
}area;

typedef struct recstruct
{
	int32	score;
	char 	sname[4];
	int32	time;
	char	tname[4];
}recstruct;

typedef struct savegame
{
	uint8	 	options[16];
	recstruct   records[10][MAX_RECORDS];
	uint32		errorcheck;
	char		p1name[3];
	char 		p2name[3];
}savegame;

/* externs */

extern RECT	imarea[2];
extern long	starttrack;

#ifdef CD
extern CdlFILE	Texturenames[80];
#else
extern char Texturenames[80][50];
#endif

#ifdef CD
extern CdlFILE	objectnames[10][2];
#else
extern char objectnames[10][2][50];
#endif

extern	area	Mountain[10];
extern	uint8	thismount;
extern	uint8	thischallenge;
extern	uint16	fetpage1;
extern	uint16  feclut1;
extern	savegame currentsave;
extern	uint8 	 thistrack;
extern	uint8	playdemo;


/* function prototypes */

void Frontend(void);
void uvchar(char *a,POLY_FT4 *b);
