/* screen.h */

#ifndef _SCREEN_H_
#define _SCREEN_H_

#include <stdio.h>


typedef struct colour
{
	chfloat R, G, B;
}colour;

typedef struct {
	uint16	textpage;
	uint16	clutpage;
} texturedescriptor;

typedef	struct textureid
{
	unsigned int textpage;
	unsigned int clutline[5];
	long x;
	long y;
}textureid;

typedef struct tmat
{
	char ident[5];
	long textid;
	long x;
	long y;
	long w;
	long h;
}tmat;


extern  texturedescriptor textureids[32];
extern	textureid	tids[10];
extern	tmat		tmats[20];
extern	uint8 *snowtexture;
extern 	uint8 *skytexture;
extern 	uint16 textpage;
extern 	uint16 clutpage;
extern	uint16 geomx;
extern	uint16 geomy;
extern 	int32 geomscreen;
extern	uint32 fntid1;
extern	uint32 fntid2;
extern	uint32 fntid3;
extern	int32 z;
extern 	int32 d;
extern 	POLY_G4 clearsquare[4];
extern 	MATRIX MyLocalLight;
extern 	MATRIX MyColourMatrix;
extern 	MATRIX RotationMatrix[2];
extern 	SVECTOR RotationVector[2];
extern  CVECTOR PrimaryColourVector;
extern 	CVECTOR fc;
extern  CVECTOR bc;
extern 	DRAWENV drawenv[2][6];
extern 	DISPENV dispenv[2][6];

extern 	int32 geomscreen;

void LoadTextures(void	);
void InitialisePSX(void);
void InitialiseGame(void	);

#endif
