#include <sys/types.h>
#include <asm.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>

#include <stdio.h>
#include <kernel.h>
#include <libsn.h>
#include <memory.h>

typedef int SINT32;
typedef unsigned int UINT32;

typedef short int SINT16;
typedef unsigned short int UINT16;

static unsigned long EHbl;

extern void EnterCriticalSection(void);
extern void ExitCriticalSection(void);

//extern SINT32 StartRCnt(UINT32);
//extern SINT32 StopRCnt(UINT32);
//extern SINT32 SetRCnt(UINT32,UINT16,SINT32);
//extern SINT32 GetRCnt(UINT32);
//extern SINT32 ResetRCnt(UINT32);
//extern UINT32 OpenEvent(UINT32,SINT32,SINT32,void *);
//extern SINT32 EnableEvent(UINT32);

//extern void * LoadFile(char *);

UINT32 * profdat;

UINT32 profdatlen;

extern int filesize;

extern void Fatal(char *,...);

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

#define PROF_BUFF_ENTRIES (2 * 1024)

#define SAFETY (10*1024)

#define PROF_BUFF_SIZE (PROF_BUFF_ENTRIES + SAFETY)

unsigned int prof_buff[PROF_BUFF_SIZE];

int next_prof;

static void profile_int(int a);

int prof_count;

int prof_num_fns;

unsigned long mem_image[1 + (2048 * 1024 / 4)];
//UINT32 *mem_image;


///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

static unsigned long *mm;

void profiler_init(void)
{
	//mem_image=pMemBlock;

	EnterCriticalSection();
	EHbl = OpenEvent(RCntCNT2, EvSpINT, EvMdINTR,(void *)&profile_int);


	if (EHbl==-1)	Fatal("Unable to Open Root counter event\xd\n");
	if (EnableEvent(EHbl)==0) Fatal("Failure to EnableEvent\xd\n");
	if (SetRCnt(RCntCNT2, 2000, RCntMdINTR)==0) Fatal("Failure to SetRCnt\xd\n");

//	EnableEvent(EHbl);
//	SetRCnt(RCntCNT2, 2000, RCntMdINTR);



//	if (StartRCnt(RCntCNT2)==0) Fatal("Failure to Start Root Counter\xd\n");
//	StartRCnt(EHbl);
	prof_count = 0;
	ExitCriticalSection();

	memset((unsigned char *)mem_image,0,2048 * 1024);

	mm = (unsigned long *)(((char *)mem_image) - 0x00000000);

	EnterCriticalSection();
	if (StartRCnt(RCntCNT2)==0) Fatal("Failure to Start Root Counter\xd\n");
	ExitCriticalSection();
}

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

void fudge(void);

void profile_int(int a)
{
	register unsigned int tmp;

	#if 1
  	__asm__ volatile ( "mfc0 %0,$14;" : "=r"(tmp) );

	#else
  	__asm__ volatile ( ".word 0x40027000;"
  	 "nop;"
  	 "nop;"
  	 "move %0,$2":"=r"(tmp):);

	#endif

	prof_count = tmp;

	if (prof_count <= 0x1fffff)
		mem_image[(0x1fffff & prof_count) / 4]++;
}

void fudge(void)
{
	return;
}
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

void end_prof(unsigned long t)
{
	int handle;

	EnterCriticalSection();

//	StopRCnt(EHbl);
	StopRCnt(RCntCNT2);

	ExitCriticalSection();

	mem_image[(2048 * 1024)/4] = t;

	handle=PCcreat("profile.out",0);
	PCwrite(handle,(char *)mem_image,4+2048*1024);
	PCclose(handle);
}

