#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
//#include <libds.h>
#include "LibCD.h"
#include "LibEtc.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
#include "main.h"
#include "mathbits.h"
#include "screen.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "pads.h"
#include "sound.h"
#include "cd.h"
#include "frontend.h"

/* variable definitions */

uint8		param[8];				/* Parameters for CD control */
//char		cdbuffer[260100];
char		*cdbuffer;
uint8		cdloadstate;
uint32		cdfilelen;
//CdlFILE  	fipos[2][4];          /* file pointer */
//CdlFILE		tfp1[6];
unsigned long		*oldcallback;
CdlFILE		tempfp;

#define FORM1_SIZE     2048
#define Sectors(x) ((x+FORM1_SIZE-1)/FORM1_SIZE)


uint32 readcdbuf(uint32 start,char* readto,int32 num)
{
	uint32 i,j;
	j=start;
	for (i=0;i<num;i++)
	{
		*(readto+i)=cdbuffer[start+i];
		j++;
	}
	return j;
}

/*********************************************************************/
/** this routine loads a file from the cd into a buffer in main ram **/
/** buffer                                                          **/
/*********************************************************************/
void load_cd(char* filename,unsigned long* buffer)
{

CdlFILE  fp;          /* file pointer */
long   file_length;     /* length of file in bytes */
int   num_sectors;     /* whole number of secotors required */
int   mode = 0;       /* cd mode                           */
long   counter;

u_long*  addr;    /* pointer to an address in main ram */


printf("loading file %s\n",filename);

CdSyncCallback(0);
cdloadstate=0;

/* return file location and size from file name */
if (!CdSearchFile(&fp,filename))
    {
  printf("ERROR: could not find file\n");
//  exit(0);
  }

/* blocking seek to start of file */
if (!CdControlB(CdlSeekL,(unsigned char *)&fp.pos, 0))
//if (!CdControl(CdlSeekL,(unsigned char *)&fp.pos, 0))
    {
  printf("ERROR: could not do seek\n");
//  exit(0);
  }


/* calculate the number of whole sectors (2k) that need to be loaded */
/* in order to load the whole file                                   */

file_length = fp.size;
num_sectors = Sectors(file_length);

printf("File size %d bytes  sectors %d\n",file_length,num_sectors);

mode |= CdlModeSpeed;  /* double speed */


/*set the address where the file will be loaded to*/
addr=(unsigned long *)buffer;

/*execute the read */
if(!CdRead(num_sectors,addr,mode))
    {
  printf("ERROR: could not exectute read\n");
//  exit(0);
  }


printf("\n");

}
/************************************************************************/

void load_fpcd(CdlFILE* fp,unsigned long* buffer)
{

long   file_length;     /* length of file in bytes */
int   num_sectors;     /* whole number of secotors required */
int   mode = 0;       /* cd mode                           */
long   counter;

u_long*  addr;    /* pointer to an address in main ram */


//printf("loading file %s\n",filename);

CdSyncCallback(0);
cdloadstate=0;


/* return file location and size from file name */

/* blocking seek to start of file */
if (!CdControlB(CdlSeekL,&(fp->pos), 0))
//if (!CdControl(CdlSeekL,(unsigned char *)&fp.pos, 0))
    {
  printf("ERROR: could not do seek\n");
//  exit(0);
  }


/* calculate the number of whole sectors (2k) that need to be loaded */
/* in order to load the whole file                                   */

file_length = fp->size;
cdfilelen=file_length;
num_sectors = Sectors(file_length);

printf("File size %d bytes  sectors %d\n",file_length,num_sectors);

mode |= CdlModeSpeed;  /* double speed */


/*set the address where the file will be loaded to*/
addr=(unsigned long *)buffer;

/*execute the read */
if(!CdRead(num_sectors,addr,mode))
    {
  printf("ERROR: could not exectute read\n");
//  exit(0);
  }


printf("\n");

}
/************************************************************************/

void temploadtrackcontrol(uint32 no,uint32 a,uint32 b, uint32 c, uint32 d)
{
	trackcontrol[no].entry=d;  /* normal or entry right split */
	trackcontrol[no].entry+=c<<16;  /* entry left split if any */
	trackcontrol[no].exit=a; /* normal or exit right split */
	trackcontrol[no].exit+=b<<16;  /* exit left split if any */
}


void initfilesystem( void )
{
	numloadedtracks=99;
	numloadedobjects=210;
#ifdef CD
//	CdInit();
//	CdSetDebug(2);
	/* initialise file pointers */
	printf("Compile CD file positions\n");
// forest
	while (!CdSearchFile(&trackname[0],"\\DATA\\FOREST\\FORS1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[1],"\\DATA\\FOREST\\FORS2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[2],"\\DATA\\FOREST\\FORS3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[3],"\\DATA\\FOREST\\FORS4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[4],"\\DATA\\FOREST\\FORS5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[5],"\\DATA\\FOREST\\FORS6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[6],"\\DATA\\FOREST\\FORS7.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[7],"\\DATA\\FOREST\\FORS8.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[8],"\\DATA\\FOREST\\FORS9.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[9],"\\DATA\\FOREST\\FORS10.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[30],"\\DATA\\FOREST\\FORS11.SEG;1"))
    	{
  	}

// village

	while (!CdSearchFile(&trackname[32],"\\DATA\\VILLAGE\\VT1S1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[33],"\\DATA\\VILLAGE\\VT1S2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[34],"\\DATA\\VILLAGE\\VT1S3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[35],"\\DATA\\VILLAGE\\VT1S4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[36],"\\DATA\\VILLAGE\\VT1S5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[37],"\\DATA\\VILLAGE\\VT1S6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[38],"\\DATA\\VILLAGE\\VT1S7.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[39],"\\DATA\\VILLAGE\\VT1S8.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[40],"\\DATA\\VILLAGE\\VT1S9.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[41],"\\DATA\\VILLAGE\\VT1S10.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[42],"\\DATA\\VILLAGE\\VT1S11.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[43],"\\DATA\\VILLAGE\\VT1S12.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[74],"\\DATA\\VILLAGE\\VT1S13.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[75],"\\DATA\\VILLAGE\\VT1S14.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[76],"\\DATA\\VILLAGE\\VT1S15.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[78],"\\DATA\\VILLAGE\\VT1S16.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[79],"\\DATA\\VILLAGE\\VT1S17.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[80],"\\DATA\\VILLAGE\\VT1S18.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[81],"\\DATA\\VILLAGE\\VT1S19.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[82],"\\DATA\\VILLAGE\\TEXTURES\\VT1S20.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[83],"\\DATA\\VILLAGE\\TEXTURES\\VT1S21.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[84],"\\DATA\\VILLAGE\\TEXTURES\\VT1S22.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[85],"\\DATA\\VILLAGE\\TEXTURES\\VT1S23.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[86],"\\DATA\\VILLAGE\\TEXTURES\\VT1S24.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[87],"\\DATA\\VILLAGE\\TEXTURES\\VT1S25.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[88],"\\DATA\\VILLAGE\\TEXTURES\\VT1S26.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[89],"\\DATA\\VILLAGE\\TEXTURES\\VT1S27.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[90],"\\DATA\\VILLAGE\\TEXTURES\\VT1S28.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[91],"\\DATA\\VILLAGE\\TEXTURES\\VT1S29.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[92],"\\DATA\\VILLAGE\\TEXTURES\\VT1S30.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[93],"\\DATA\\VILLAGE\\TEXTURES\\VT1S31.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[94],"\\DATA\\VILLAGE\\TEXTURES\\VT1S32.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[95],"\\DATA\\VILLAGE\\TEXTURES\\VT1S33.SEG;1"))
    	{
  	}

// sports
	while (!CdSearchFile(&trackname[18],"\\DATA\\SPORTS\\ST1S1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[19],"\\DATA\\SPORTS\\ST1S2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[20],"\\DATA\\SPORTS\\ST1S3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[21],"\\DATA\\SPORTS\\ST1S4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[22],"\\DATA\\SPORTS\\ST1S5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[23],"\\DATA\\SPORTS\\ST1S6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[24],"\\DATA\\SPORTS\\ST1S7.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[25],"\\DATA\\SPORTS\\ST1S8.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[26],"\\DATA\\SPORTS\\ST1S9.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[27],"\\DATA\\SPORTS\\ST1S10.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[28],"\\DATA\\SPORTS\\ST1S11.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[29],"\\DATA\\SPORTS\\ST1S12.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[31],"\\DATA\\SPORTS\\ST1S13.SEG;1"))
    	{
  	}

// glacier
	while (!CdSearchFile(&trackname[52],"\\DATA\\GLACIER\\GT1S1.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[53],"\\DATA\\GLACIER\\GT1S2.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[54],"\\DATA\\GLACIER\\GT1S3.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[55],"\\DATA\\GLACIER\\GT1S4.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[56],"\\DATA\\GLACIER\\GT1S5.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[57],"\\DATA\\GLACIER\\GT1S6.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[58],"\\DATA\\GLACIER\\GT1S7.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[59],"\\DATA\\GLACIER\\GT1S8.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[60],"\\DATA\\GLACIER\\GT1S9.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[61],"\\DATA\\GLACIER\\GT1S10.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[62],"\\DATA\\GLACIER\\GT1S11.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[63],"\\DATA\\GLACIER\\GT1S12.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[64],"\\DATA\\GLACIER\\GT1S13.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[65],"\\DATA\\GLACIER\\GT1S14.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[66],"\\DATA\\GLACIER\\GT1S15.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[67],"\\DATA\\GLACIER\\GT1S16.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[68],"\\DATA\\GLACIER\\GT1S17.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[69],"\\DATA\\GLACIER\\GT1S18.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[70],"\\DATA\\GLACIER\\GT1S19.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[71],"\\DATA\\GLACIER\\GT1S20.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[72],"\\DATA\\GLACIER\\GT1S21.SEG;1"))
	{

	}
 	while (!CdSearchFile(&trackname[73],"\\DATA\\GLACIER\\GT1S22.SEG;1"))
	{

	}

// freeride
	while (!CdSearchFile(&trackname[10],"\\DATA\\FREERIDE\\FREE1.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[11],"\\DATA\\FREERIDE\\FREE2.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[12],"\\DATA\\FREERIDE\\FREE3.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[13],"\\DATA\\FREERIDE\\FREE4.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[14],"\\DATA\\FREERIDE\\FREE5.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[15],"\\DATA\\FREERIDE\\FREE6.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[16],"\\DATA\\FREERIDE\\FREE7.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[17],"\\DATA\\FREERIDE\\FREE8.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[77],"\\DATA\\FREERIDE\\FREE9.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[96],"\\DATA\\FREERIDE\\FREE10.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[97],"\\DATA\\FREERIDE\\FREE11.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[98],"\\DATA\\FREERIDE\\FREE12.SEG;1"))
    	{
  	}
	while (!CdSearchFile(&trackname[99],"\\DATA\\FREERIDE\\FREE13.SEG;1"))
    	{
  	}



// 78- free

// 2play1
	while (!CdSearchFile(&trackname[44],"\\DATA\\2PLAY1\\TWPY1.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[45],"\\DATA\\2PLAY1\\TWPY2.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[46],"\\DATA\\2PLAY1\\TWPY3.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[47],"\\DATA\\2PLAY1\\TWPY4.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[48],"\\DATA\\2PLAY1\\TWPY5.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[49],"\\DATA\\2PLAY1\\TWPY6.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[50],"\\DATA\\2PLAY1\\TWPY7.SEG;1"))
	{

	}
	while (!CdSearchFile(&trackname[51],"\\DATA\\2PLAY1\\TWPY8.SEG;1"))
	{

	}


/* music files */

	musiccatalog[0].numtunes=2;
	while (!CdSearchFile(&musiccatalog[0].tunes[0].vabheader,"\\MUSIC\\BONEBGM\\OZRIC.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[0].vabbody,"\\MUSIC\\BONEBGM\\OZRIC.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[0].mainsep,"\\MUSIC\\BONEBGM\\OZRIC.SEP;1"))
    	{
   	}
	while (!CdSearchFile(&musiccatalog[0].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[1].vabheader,"\\MUSIC\\BONEBGM\\GRUNDGE.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[1].vabbody,"\\MUSIC\\BONEBGM\\GRUNDGE.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[0].tunes[1].mainsep,"\\MUSIC\\BONEBGM\\GRUNDGE.SEP;1"))
    	{
   	}
	while (!CdSearchFile(&musiccatalog[0].tunes[1].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

	musiccatalog[1].numtunes=2;
	while (!CdSearchFile(&musiccatalog[1].tunes[0].vabheader,"\\MUSIC\\GOATBGM\\FLEX.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[0].vabbody,"\\MUSIC\\GOATBGM\\FLEX.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[0].mainsep,"\\MUSIC\\GOATBGM\\FLEX.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[1].vabheader,"\\MUSIC\\GOATBGM\\SABRES.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[1].vabbody,"\\MUSIC\\GOATBGM\\SABRES.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[1].mainsep,"\\MUSIC\\GOATBGM\\SABRES.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[1].tunes[1].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

	musiccatalog[2].numtunes=2;
	while (!CdSearchFile(&musiccatalog[2].tunes[0].vabheader,"\\MUSIC\\TRIXBGM\\FREE.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[0].vabbody,"\\MUSIC\\TRIXBGM\\FREE.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[0].mainsep,"\\MUSIC\\TRIXBGM\\FREE.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[1].vabheader,"\\MUSIC\\TRIXBGM\\REDEYE.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[1].vabbody,"\\MUSIC\\TRIXBGM\\REDEYE.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[1].mainsep,"\\MUSIC\\TRIXBGM\\REDEYE.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[2].tunes[1].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

	musiccatalog[3].numtunes=6;
	while (!CdSearchFile(&musiccatalog[3].tunes[0].vabheader,"\\MUSIC\\YOYOBGM\\BUZZ.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[0].vabbody,"\\MUSIC\\YOYOBGM\\BUZZ.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[0].mainsep,"\\MUSIC\\YOYOBGM\\BUZZ.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[1].vabheader,"\\MUSIC\\YOYOBGM\\DOGZ.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[1].vabbody,"\\MUSIC\\YOYOBGM\\DOGZ.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[1].mainsep,"\\MUSIC\\YOYOBGM\\DOGZ.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[1].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[2].vabheader,"\\MUSIC\\YOYOBGM\\TECH1.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[2].vabbody,"\\MUSIC\\YOYOBGM\\TECH1.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[2].mainsep,"\\MUSIC\\YOYOBGM\\TECH1.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[2].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[3].vabheader,"\\MUSIC\\YOYOBGM\\TECH2.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[3].vabbody,"\\MUSIC\\YOYOBGM\\TECH2.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[3].mainsep,"\\MUSIC\\YOYOBGM\\TECH2.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[3].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[4].vabheader,"\\MUSIC\\YOYOBGM\\TRANCE.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[4].vabbody,"\\MUSIC\\YOYOBGM\\TRANCE.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[4].mainsep,"\\MUSIC\\YOYOBGM\\TRANCE.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[4].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[5].vabheader,"\\MUSIC\\YOYOBGM\\GIRL.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[5].vabbody,"\\MUSIC\\YOYOBGM\\GIRL.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[5].mainsep,"\\MUSIC\\YOYOBGM\\GIRL.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[3].tunes[5].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

	musiccatalog[4].numtunes=1;
	while (!CdSearchFile(&musiccatalog[4].tunes[0].vabheader,"\\MUSIC\\FRONTEND\\FRONTEND.VH;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[4].tunes[0].vabbody,"\\MUSIC\\FRONTEND\\FRONTEND.VB;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[4].tunes[0].mainsep,"\\MUSIC\\FRONTEND\\FRONTEND.SEP;1"))
    	{
  	}
	while (!CdSearchFile(&musiccatalog[4].tunes[0].endsep,"\\MUSIC\\909END.SEP;1"))
    	{
  	}

/* texture pages */

// forest
	while (!CdSearchFile(&Texturenames[0],"\\DATA\\FOREST\\TEXTURES\\PAGE1F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[1],"\\DATA\\FOREST\\TEXTURES\\PAGE2F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[2],"\\DATA\\FOREST\\TEXTURES\\PAGE3F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[3],"\\DATA\\FOREST\\TEXTURES\\PAGE4F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[4],"\\DATA\\FOREST\\TEXTURES\\PAGE5F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[5],"\\DATA\\FOREST\\TEXTURES\\PAGE6F.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[6],"\\DATA\\FOREST\\TEXTURES\\PAGE7.TIM;1"))
		{
	}

// village
	while (!CdSearchFile(&Texturenames[8],"\\DATA\\VILLAGE\\TEXTURES\\PAGE1.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[9],"\\DATA\\VILLAGE\\TEXTURES\\PAGE2.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[10],"\\DATA\\VILLAGE\\TEXTURES\\PAGE3.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[11],"\\DATA\\VILLAGE\\TEXTURES\\PAGE4.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[12],"\\DATA\\VILLAGE\\TEXTURES\\PAGE5.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[13],"\\DATA\\VILLAGE\\TEXTURES\\PAGE6.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[14],"\\DATA\\VILLAGE\\TEXTURES\\PAGE7.TIM;1"))
		{
	}

//  sports
	while (!CdSearchFile(&Texturenames[16],"\\DATA\\SPORTS\\TEXTURES\\PAGE1.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[17],"\\DATA\\SPORTS\\TEXTURES\\PAGE2.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[18],"\\DATA\\SPORTS\\TEXTURES\\PAGE3.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[19],"\\DATA\\SPORTS\\TEXTURES\\PAGE4.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[20],"\\DATA\\SPORTS\\TEXTURES\\PAGE5.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[21],"\\DATA\\SPORTS\\TEXTURES\\PAGE6.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[22],"\\DATA\\SPORTS\\TEXTURES\\PAGE7.TIM;1"))
		{
	}

//  glacier
	while (!CdSearchFile(&Texturenames[24],"\\DATA\\GLACIER\\TEXTURES\\PAGE1.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[25],"\\DATA\\GLACIER\\TEXTURES\\PAGE2.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[26],"\\DATA\\GLACIER\\TEXTURES\\PAGE3.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[27],"\\DATA\\GLACIER\\TEXTURES\\PAGE4.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[28],"\\DATA\\GLACIER\\TEXTURES\\PAGE5.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[29],"\\DATA\\GLACIER\\TEXTURES\\PAGE6.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[30],"\\DATA\\GLACIER\\TEXTURES\\PAGE7.TIM;1"))
		{
	}

//  freeride

	while (!CdSearchFile(&Texturenames[32],"\\DATA\\FREERIDE\\TEXTURES\\PAGE1E.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[33],"\\DATA\\FREERIDE\\TEXTURES\\PAGE2E.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[34],"\\DATA\\FREERIDE\\TEXTURES\\PAGE3E.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[35],"\\DATA\\FREERIDE\\TEXTURES\\PAGE4E.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[36],"\\DATA\\FREERIDE\\TEXTURES\\PAGE5E.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[37],"\\DATA\\FREERIDE\\TEXTURES\\PAGE6E.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[38],"\\DATA\\FREERIDE\\TEXTURES\\PAGE7.TIM;1"))
		{
	}

//2play1
	while (!CdSearchFile(&Texturenames[56],"\\DATA\\2PLAY1\\TEXTURES\\PAGE1P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[57],"\\DATA\\2PLAY1\\TEXTURES\\PAGE2P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[58],"\\DATA\\2PLAY1\\TEXTURES\\PAGE3P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[59],"\\DATA\\2PLAY1\\TEXTURES\\PAGE4P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[60],"\\DATA\\2PLAY1\\TEXTURES\\PAGE5P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[61],"\\DATA\\2PLAY1\\TEXTURES\\PAGE6P.TIM;1"))
		{
	}
	while (!CdSearchFile(&Texturenames[62],"\\DATA\\2PLAY1\\TEXTURES\\PAGE7.TIM;1"))
		{
	}


/* object loadfiles */

	while (!CdSearchFile(&objectnames[0][0],"\\DATA\\FOREST\\FOREST.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[0][1],"\\DATA\\FOREST\\FOREST.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[1][0],"\\DATA\\VILLAGE\\VILLAGE.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[1][1],"\\DATA\\VILLAGE\\VILLAGE.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[2][0],"\\DATA\\SPORTS\\SPORT.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[2][1],"\\DATA\\SPORTS\\SPORT.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[3][0],"\\DATA\\GLACIER\\GLACIER.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[3][1],"\\DATA\\GLACIER\\GLACIER.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[4][0],"\\DATA\\FREERIDE\\FREERIDE.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[4][1],"\\DATA\\FREERIDE\\FREERIDE.CHO;1"))
		{
	}
	while (!CdSearchFile(&objectnames[7][0],"\\DATA\\2PLAY1\\2PLAY1.OBT;1"))
		{
	}
	while (!CdSearchFile(&objectnames[7][1],"\\DATA\\2PLAY1\\2PLAY1.CHO;1"))
		{
	}

	cdloadstate=0;

#else
//	PCinit();

// forest
	sprintf(&trackname[0][0],"data/forest/fors1.seg");
	sprintf(&trackname[1][0],"data/forest/fors2.seg");
	sprintf(&trackname[2][0],"data/forest/fors3.seg");
	sprintf(&trackname[3][0],"data/forest/fors4.seg");
	sprintf(&trackname[4][0],"data/forest/fors5.seg");
	sprintf(&trackname[5][0],"data/forest/fors6.seg");
	sprintf(&trackname[6][0],"data/forest/fors7.seg");
	sprintf(&trackname[7][0],"data/forest/fors8.seg");
	sprintf(&trackname[8][0],"data/forest/fors9.seg");
	sprintf(&trackname[9][0],"data/forest/fors10.seg");
	sprintf(&trackname[30][0],"data/forest/fors11.seg");

// village
	sprintf(&trackname[32][0],"data/village/vt1s1.seg");
	sprintf(&trackname[33][0],"data/village/vt1s2.seg");
	sprintf(&trackname[34][0],"data/village/vt1s3.seg");
	sprintf(&trackname[35][0],"data/village/vt1s4.seg");
	sprintf(&trackname[36][0],"data/village/vt1s5.seg");
	sprintf(&trackname[37][0],"data/village/vt1s6.seg");
	sprintf(&trackname[38][0],"data/village/vt1s7.seg");
	sprintf(&trackname[39][0],"data/village/vt1s8.seg");
	sprintf(&trackname[40][0],"data/village/vt1s9.seg");
	sprintf(&trackname[41][0],"data/village/vt1s10.seg");
	sprintf(&trackname[42][0],"data/village/vt1s11.seg");
	sprintf(&trackname[43][0],"data/village/vt1s12.seg");
	sprintf(&trackname[74][0],"data/village/vt1s13.seg");
	sprintf(&trackname[75][0],"data/village/vt1s14.seg");
	sprintf(&trackname[76][0],"data/village/vt1s15.seg");
	sprintf(&trackname[78][0],"data/village/vt1s16.seg");
	sprintf(&trackname[79][0],"data/village/vt1s17.seg");
	sprintf(&trackname[80][0],"data/village/vt1s18.seg");
	sprintf(&trackname[81][0],"data/village/vt1s19.seg");
	sprintf(&trackname[82][0],"data/village/textures/vt1s20.seg");
	sprintf(&trackname[83][0],"data/village/textures/vt1s21.seg");
	sprintf(&trackname[84][0],"data/village/textures/vt1s22.seg");
	sprintf(&trackname[85][0],"data/village/textures/vt1s23.seg");
	sprintf(&trackname[86][0],"data/village/textures/vt1s24.seg");
	sprintf(&trackname[87][0],"data/village/textures/vt1s25.seg");
	sprintf(&trackname[88][0],"data/village/textures/vt1s26.seg");
	sprintf(&trackname[89][0],"data/village/textures/vt1s27.seg");
	sprintf(&trackname[90][0],"data/village/textures/vt1s28.seg");
	sprintf(&trackname[91][0],"data/village/textures/vt1s29.seg");
	sprintf(&trackname[92][0],"data/village/textures/vt1s30.seg");
	sprintf(&trackname[93][0],"data/village/textures/vt1s31.seg");
	sprintf(&trackname[94][0],"data/village/textures/vt1s32.seg");
	sprintf(&trackname[95][0],"data/village/textures/vt1s33.seg");


// sports
	sprintf(&trackname[18][0],"data/sports/st1s1.seg");
	sprintf(&trackname[19][0],"data/sports/st1s2.seg");
	sprintf(&trackname[20][0],"data/sports/st1s3.seg");
	sprintf(&trackname[21][0],"data/sports/st1s4.seg");
	sprintf(&trackname[22][0],"data/sports/st1s5.seg");
	sprintf(&trackname[23][0],"data/sports/st1s6.seg");
	sprintf(&trackname[24][0],"data/sports/st1s7.seg");
	sprintf(&trackname[25][0],"data/sports/st1s8.seg");
	sprintf(&trackname[26][0],"data/sports/st1s9.seg");
	sprintf(&trackname[27][0],"data/sports/st1s10.seg");
	sprintf(&trackname[28][0],"data/sports/st1s11.seg");
	sprintf(&trackname[29][0],"data/sports/st1s12.seg");
	sprintf(&trackname[31][0],"data/sports/st1s13.seg");

// glacier
	sprintf(&trackname[52][0],"data/glacier/gt1s1.seg");
	sprintf(&trackname[53][0],"data/glacier/gt1s2.seg");
	sprintf(&trackname[54][0],"data/glacier/gt1s3.seg");
	sprintf(&trackname[55][0],"data/glacier/gt1s4.seg");
	sprintf(&trackname[56][0],"data/glacier/gt1s5.seg");
	sprintf(&trackname[57][0],"data/glacier/gt1s6.seg");
	sprintf(&trackname[58][0],"data/glacier/gt1s7.seg");
	sprintf(&trackname[59][0],"data/glacier/gt1s8.seg");
	sprintf(&trackname[60][0],"data/glacier/gt1s9.seg");
	sprintf(&trackname[61][0],"data/glacier/gt1s10.seg");
	sprintf(&trackname[62][0],"data/glacier/gt1s11.seg");
	sprintf(&trackname[63][0],"data/glacier/gt1s12.seg");
	sprintf(&trackname[64][0],"data/glacier/gt1s13.seg");
	sprintf(&trackname[65][0],"data/glacier/gt1s14.seg");
	sprintf(&trackname[66][0],"data/glacier/gt1s15.seg");
	sprintf(&trackname[67][0],"data/glacier/gt1s16.seg");
	sprintf(&trackname[68][0],"data/glacier/gt1s17.seg");
	sprintf(&trackname[69][0],"data/glacier/gt1s18.seg");
	sprintf(&trackname[70][0],"data/glacier/gt1s19.seg");
	sprintf(&trackname[71][0],"data/glacier/gt1s20.seg");
	sprintf(&trackname[72][0],"data/glacier/gt1s21.seg");
	sprintf(&trackname[73][0],"data/glacier/gt1s22.seg");


// freeride
	sprintf(&trackname[10][0],"data/freeride/free1.seg");
	sprintf(&trackname[11][0],"data/freeride/free2.seg");
	sprintf(&trackname[12][0],"data/freeride/free3.seg");
	sprintf(&trackname[13][0],"data/freeride/free4.seg");
	sprintf(&trackname[14][0],"data/freeride/free5.seg");
	sprintf(&trackname[15][0],"data/freeride/free6.seg");
	sprintf(&trackname[16][0],"data/freeride/free7.seg");
	sprintf(&trackname[17][0],"data/freeride/free8.seg");
	sprintf(&trackname[77][0],"data/freeride/free9.seg");
	sprintf(&trackname[96][0],"data/freeride/free10.seg");
	sprintf(&trackname[97][0],"data/freeride/free11.seg");
	sprintf(&trackname[98][0],"data/freeride/free12.seg");
	sprintf(&trackname[99][0],"data/freeride/free13.seg");



// 2play1
	sprintf(&trackname[44][0],"data/2play1/twpy1.seg");
	sprintf(&trackname[45][0],"data/2play1/twpy2.seg");
	sprintf(&trackname[46][0],"data/2play1/twpy3.seg");
	sprintf(&trackname[47][0],"data/2play1/twpy4.seg");
	sprintf(&trackname[48][0],"data/2play1/twpy5.seg");
	sprintf(&trackname[49][0],"data/2play1/twpy6.seg");
	sprintf(&trackname[50][0],"data/2play1/twpy7.seg");
	sprintf(&trackname[51][0],"data/2play1/twpy8.seg");



/* texture names */

// general
// forest
	sprintf(&Texturenames[0][0],"data/forest/textures/page1f.tim");
	sprintf(&Texturenames[1][0],"data/forest/textures/page2f.tim");
	sprintf(&Texturenames[2][0],"data/forest/textures/page3f.tim");
	sprintf(&Texturenames[3][0],"data/forest/textures/page4f.tim");
	sprintf(&Texturenames[4][0],"data/forest/textures/page5f.tim");
	sprintf(&Texturenames[5][0],"data/forest/textures/page6f.tim");
	sprintf(&Texturenames[6][0],"data/forest/textures/page7.tim");

// village

	sprintf(&Texturenames[8][0],"data/village/textures/page1.tim");
	sprintf(&Texturenames[9][0],"data/village/textures/page2.tim");
	sprintf(&Texturenames[10][0],"data/village/textures/page3.tim");
	sprintf(&Texturenames[11][0],"data/village/textures/page4.tim");
	sprintf(&Texturenames[12][0],"data/village/textures/page5.tim");
	sprintf(&Texturenames[13][0],"data/village/textures/page6.tim");
	sprintf(&Texturenames[14][0],"data/village/textures/page7.tim");

// sports
	sprintf(&Texturenames[16][0],"data/sports/textures/page1.tim");
	sprintf(&Texturenames[17][0],"data/sports/textures/page2.tim");
	sprintf(&Texturenames[18][0],"data/sports/textures/page3.tim");
	sprintf(&Texturenames[19][0],"data/sports/textures/page4.tim");
	sprintf(&Texturenames[20][0],"data/sports/textures/page5.tim");
	sprintf(&Texturenames[21][0],"data/sports/textures/page6.tim");
	sprintf(&Texturenames[22][0],"data/sports/textures/page7.tim");

// glacier
	sprintf(&Texturenames[24][0],"data/glacier/textures/page1.tim");
	sprintf(&Texturenames[25][0],"data/glacier/textures/page2.tim");
	sprintf(&Texturenames[26][0],"data/glacier/textures/page3.tim");
	sprintf(&Texturenames[27][0],"data/glacier/textures/page4.tim");
	sprintf(&Texturenames[28][0],"data/glacier/textures/page5.tim");
	sprintf(&Texturenames[29][0],"data/glacier/textures/page6.tim");
	sprintf(&Texturenames[30][0],"data/glacier/textures/page7.tim");

// freeride
	sprintf(&Texturenames[32][0],"data/freeride/textures/page1e.tim");
	sprintf(&Texturenames[33][0],"data/freeride/textures/page2e.tim");
	sprintf(&Texturenames[34][0],"data/freeride/textures/page3e.tim");
	sprintf(&Texturenames[35][0],"data/freeride/textures/page4e.tim");
	sprintf(&Texturenames[36][0],"data/freeride/textures/page5e.tim");
	sprintf(&Texturenames[37][0],"data/freeride/textures/page6e.tim");
	sprintf(&Texturenames[38][0],"data/freeride/textures/page7.tim");

// 2play1
	sprintf(&Texturenames[56][0],"data/2play1/textures/page1p.tim");
	sprintf(&Texturenames[57][0],"data/2play1/textures/page2p.tim");
	sprintf(&Texturenames[58][0],"data/2play1/textures/page3p.tim");
	sprintf(&Texturenames[59][0],"data/2play1/textures/page4p.tim");
	sprintf(&Texturenames[60][0],"data/2play1/textures/page5p.tim");
	sprintf(&Texturenames[61][0],"data/2play1/textures/page6p.tim");
	sprintf(&Texturenames[62][0],"data/2play1/textures/page7.tim");





/* object name files */
// forest
	sprintf(&objectnames[0][0][0],"data/forest/forest.obt");
	sprintf(&objectnames[0][1][0],"data/forest/forest.cho");
// village
	sprintf(&objectnames[1][0][0],"data/village/village.obt");
	sprintf(&objectnames[1][1][0],"data/village/village.cho");
// sports
	sprintf(&objectnames[2][0][0],"data/sports/sport.obt");
	sprintf(&objectnames[2][1][0],"data/sports/sport.cho");
// glacier
	sprintf(&objectnames[3][0][0],"data/glacier/glacier.obt");
	sprintf(&objectnames[3][1][0],"data/glacier/glacier.cho");
// freeride
	sprintf(&objectnames[4][0][0],"data/freeride/freeride.obt");
	sprintf(&objectnames[4][1][0],"data/freeride/freeride.cho");
// 2play1
	sprintf(&objectnames[7][0][0],"data/2play1/2play1.obt");
	sprintf(&objectnames[7][1][0],"data/2play1/2play1.cho");

#endif
// forest
	temploadtrackcontrol(0,1,0,0,0);  /* no, {r,l exit}, {r,l entry } */
	temploadtrackcontrol(1,2,0,1,0);
	temploadtrackcontrol(2,3,5,2,0);
	temploadtrackcontrol(3,4,0,2,0);
	temploadtrackcontrol(4,7,0,3,0);
	temploadtrackcontrol(5,6,0,2,0);
	temploadtrackcontrol(6,7,0,5,0);
	temploadtrackcontrol(7,8,0,4,6);
	temploadtrackcontrol(8,9,0,7,0);
	temploadtrackcontrol(9,30,0,8,0);
	temploadtrackcontrol(30,30,0,9,0);

// village

	temploadtrackcontrol(32,33,0,0,0);
	temploadtrackcontrol(33,34,0,32,0);
	temploadtrackcontrol(34,35,0,33,0);
	temploadtrackcontrol(35,36,0,34,0);
	temploadtrackcontrol(36,37,0,35,0);
	temploadtrackcontrol(37,38,0,36,0);
	temploadtrackcontrol(38,39,0,37,0);
	temploadtrackcontrol(39,40,0,38,0);
	temploadtrackcontrol(40,41,42,39,0);

	temploadtrackcontrol(41,43,0,40,0);

	temploadtrackcontrol(42,43,0,40,0);

	temploadtrackcontrol(43,74,0,41,42);

	temploadtrackcontrol(74,75,0,43,0);
	temploadtrackcontrol(75,76,0,74,0);
	temploadtrackcontrol(76,78,0,75,0);
	temploadtrackcontrol(78,79,0,76,0);
	temploadtrackcontrol(79,80,0,78,0);
	temploadtrackcontrol(80,81,82,79,0);

	temploadtrackcontrol(81,83,0,80,0);

	temploadtrackcontrol(82,84,0,80,0);
	temploadtrackcontrol(83,85,86,81,0);

	temploadtrackcontrol(84,87,0,82,0);

	temploadtrackcontrol(85,88,0,83,0);

	temploadtrackcontrol(86,89,0,83,0);

	temploadtrackcontrol(87,90,0,84,0);

	temploadtrackcontrol(88,91,0,85,0);

	temploadtrackcontrol(89,92,0,86,0);

	temploadtrackcontrol(90,92,0,87,0);

	temploadtrackcontrol(91,93,0,88,0);

	temploadtrackcontrol(92,93,0,89,90);

	temploadtrackcontrol(93,94,0,91,92);
	temploadtrackcontrol(94,95,0,93,0);
	temploadtrackcontrol(95,95,0,94,0);

// sports
	temploadtrackcontrol(18,19,0,0,0);
	temploadtrackcontrol(19,20,0,18,0);
	temploadtrackcontrol(20,21,0,19,0);
	temploadtrackcontrol(21,22,0,20,0);
	temploadtrackcontrol(22,23,0,21,0);
	temploadtrackcontrol(23,24,26,22,0);
	temploadtrackcontrol(24,25,0,23,0);
	temploadtrackcontrol(25,28,0,24,0);
	temploadtrackcontrol(26,27,0,23,0);
	temploadtrackcontrol(27,28,0,27,0);
	temploadtrackcontrol(28,29,0,25,27);
	temploadtrackcontrol(29,31,0,28,0);
	temploadtrackcontrol(31,31,0,29,0);

// glacier
	temploadtrackcontrol(52,53,0,0,0);
	temploadtrackcontrol(53,54,0,52,0);
	temploadtrackcontrol(54,55,0,53,0);
	temploadtrackcontrol(55,56,0,54,0);
	temploadtrackcontrol(56,57,0,55,0);
	temploadtrackcontrol(57,58,0,56,0);
	temploadtrackcontrol(58,59,0,57,0);
	temploadtrackcontrol(59,60,0,58,0);
	temploadtrackcontrol(60,61,0,59,0);
	temploadtrackcontrol(61,62,65,60,0);
	temploadtrackcontrol(62,63,0,61,0);
	temploadtrackcontrol(63,64,0,62,0);
	temploadtrackcontrol(64,68,0,63,0);
	temploadtrackcontrol(65,66,0,61,0);
	temploadtrackcontrol(66,67,0,65,0);
	temploadtrackcontrol(67,68,0,66,0);
	temploadtrackcontrol(68,69,0,64,68);
	temploadtrackcontrol(69,70,0,68,0);
	temploadtrackcontrol(70,71,0,69,0);
	temploadtrackcontrol(71,72,0,70,0);
	temploadtrackcontrol(72,73,0,71,0);
	temploadtrackcontrol(73,73,0,72,0);

// freeride
	temploadtrackcontrol(10,11,0,0,7);
	temploadtrackcontrol(11,12,0,10,0);
	temploadtrackcontrol(12,13,0,9,11);
	temploadtrackcontrol(13,14,0,12,0);
	temploadtrackcontrol(14,15,0,13,0);
	temploadtrackcontrol(15,16,0,14,0);
	temploadtrackcontrol(16,17,0,15,0);
	temploadtrackcontrol(17,77,0,16,0);
	temploadtrackcontrol(77,96,0,17,0);
	temploadtrackcontrol(96,97,0,77,0);
	temploadtrackcontrol(97,98,0,96,0);
	temploadtrackcontrol(98,99,0,97,0);
	temploadtrackcontrol(99,99,0,98,0);

/* 32 - 43 */

// 2play1
	temploadtrackcontrol(44,45,0,0,0);
	temploadtrackcontrol(45,46,0,44,0);
	temploadtrackcontrol(46,47,0,45,0);
	temploadtrackcontrol(47,48,0,46,0);
	temploadtrackcontrol(48,49,0,47,0);
	temploadtrackcontrol(49,50,0,48,0);
	temploadtrackcontrol(50,51,0,49,0);
	temploadtrackcontrol(51,51,0,50,0);

}

void cdsynccallback (void)
{
	cdloadstate++;
//	if (cdloadstate==4)
//	{
//		printf("callback reached %d\n",cdloadstate);
//	}
	return;
}


uint8 loadtobuffer(unsigned long* buffer,CdlFILE *fp1)
{

long   file_length;     /* length of file in bytes */
int   num_sectors;     /* whole number of secotors required */
int   mode = 0;       /* cd mode                           */
long   counter;
long fin,pcfilesize;
static u_long*  addr;    /* pointer to an address in main ram */


	switch (cdloadstate)
	{
		case (0):
		{
			oldcallback=CdSyncCallback(&cdsynccallback);
			tempfp.pos.minute=fp1->pos.minute;
			tempfp.pos.second=fp1->pos.second;
			tempfp.pos.sector=fp1->pos.sector;
			tempfp.pos.track=fp1->pos.track;
			tempfp.size=fp1->size;
			if (!CdControl(CdlSeekL,(unsigned char *)&tempfp, 0))
    		{
  				printf("ERROR: could not do seek\n");
//  				exit(0);
  			}
			cdloadstate=1;
			return 0;
			break;
		}
		case (1):
		{
//			cdloadstate=1;
			break;
		}
		case (2):
		{
//			oldcallback=CdSyncCallback(oldcallback);
//			oldcallback=CdReadCallback(&cdsynccallback);

			file_length = tempfp.size;
			num_sectors = Sectors(file_length);

//			printf("File size %d bytes  sectors %d\n",file_length,num_sectors);

			mode |= CdlModeSpeed;  /* double speed */


			/*set the address where the file will be loaded to*/
			addr=(unsigned long *)buffer;
			if (!CdControl(CdlSeekL,(unsigned char *)&(tempfp.pos), 0))
    		{
  				printf("ERROR: could not do seek\n");
//  				exit(0);
  			}
						/*execute the read */
/*			if (!CdControl(CdlSetloc,(unsigned char *)&(tempfp.pos), 0))
    		{
 				printf("ERROR: could not do setloc\n");
//  				exit(0);
 			}   */
						/*execute the read */
			if(!CdRead(num_sectors,addr,mode))
				{
  			printf("ERROR: could not exectute read\n");
//  			exit(0);
  			}

//				printf("\n");
			cdloadstate=3;
			return 0;
			break;
		}
		case (3):
		{
//			cdloadstate=3;
			break;
		}

		case (4):
		{
			oldcallback=CdSyncCallback(oldcallback);
			cdloadstate=0;
			return 1;
			break;
		}
	}
}




