// sound.c
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
//#include <libds.h>
#include "LibCD.h"
#include "LibEtc.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "gtemac.h"
#include "inline_c.h"
#include "ourtypes.h"
#include "mathbits.h"
#include "screen.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "main.h"
#include "cd.h"
#include "frontend.h"
#include "sound.h"

extern uint16 scorecounter;

short sep1;  /* SEP data id */
short sfxsep1;
short endsep[2];
short vab1;  /* VAB data id */
short mixvab;
short sfxvab;
uint8 specialsoundstate;

char seq_table[SS_SEQ_TABSIZ * 2 * 32];

char vabheader[11000];
char sequence1[40000];
char tendsep[2][3000];
//char mixvh[4200];
//char mixvb[20000];
char sfxsep[4096];
char sfxhead[8192];
long fin,arsesize;
long currentseq,nextseq,baseseq,chooseseq;
long count,waitcount;
// long playlist[24]={3,3,3,3,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,0,0,0,0}; jungle playback list
long playlist[10]={0,0,0,0,0,0,0,0,0,0};
long whichload,changesong,songloading,cdloadcycle;
uint8 musiccat;
uint32 tuneno;
uint8 lastcat=0;
uint8 musicon;

musiccatagory	musiccatalog[5];

void loadsong(uint8 songno)
{
	switch (cdloadcycle)
	{
		case (0):
		{
			printf("loading song %d\n",songno);
			songloading=1;
			cdloadcycle=1;
			break;
		}
		case (1):
		{
			if (loadtobuffer(&vabheader,&musiccatalog[musiccat].tunes[0].vabheader)==1)
			{
				cdloadcycle=2;
			}
			break;
		}
		case (2):
		{
			if (loadtobuffer(&cdbuffer,&musiccatalog[musiccat].tunes[0].vabbody)==1)
			{
				cdloadcycle=3;
			}
			break;
		}
		case (3):
		{
			if (loadtobuffer(&sequence1,&musiccatalog[musiccat].tunes[0].mainsep)==1)
			{
				cdloadcycle=4;
			}
			break;
		}
		case (4):
		{
			if (loadtobuffer(&tendsep[whichload][0],&musiccatalog[musiccat].tunes[0].endsep)==1)
			{
				cdloadcycle=5;
			}
			break;
		}
		case (5):
		{
			vab1 = SsVabOpenHead ((unsigned char*)&vabheader, 1);
			if( vab1 == -1 )
			{
	  			printf( "VAB headder open failed\n" );
	  			exit(0);
			}
        	vab1 = SsVabTransBody ((unsigned char*)&cdbuffer, vab1);
			if( vab1 == -1 )
			{
	  			printf( "VAB body open failed\n" );
	  			exit(0);
				break;
			}
			cdloadcycle=6;
			break;
		}
		case (6):
		{
			if (SsVabTransCompleted (SS_IMMEDIATE)!=0)
			{
				songloading=2;
				cdloadcycle=0;
			}
			break;
		}
	}
}

void MarkerCallBack(ac_no,tr_no,data)
{
	if (soundtrigger!=0)
	{
		SsSepPause(sep1,0);
		specialsoundstate=soundtrigger;
		SsSepPlay(sep1,soundtrigger+4,SSPLAY_PLAY,SSPLAY_INFINITY);
	}
	if (changesong==0)
	{
/*		if (nextseq==1)
		{
			if (SsIsEos(sep1,0)!=0)
			{
				currentseq=chooseseq;
					SsSepPause(sep1,0);
					SsSepPlay(sep1, currentseq, SSPLAY_PLAY, 3);
				nextseq=2;
			}
		}   */
	}
	else
	{
		if (changesong==1)
		{
//			SsSepPlay(endsep[(whichload+1)%2],0, SSPLAY_PLAY, 1);
//			SsSepPlay(0,0, SSPLAY_PLAY, 1);
			SsSepStop(sep1,baseseq);
			SsSepClose (sep1);
//			SsSepClose (endsep[(whichload+1)%2]);
    		SsVabClose (vab1);
			songloading=1;
			cdloadcycle=0;
			loadsong(whichload);
			changesong=2;
		}
	}
}


void SoundCallBack( void )
{
	novsyncs++;
//	pollhost();
	if (novsyncs==60)
	{
		novsyncs=0;
		fps=noframes;
		noframes=0;
	}
	if ((setdisplay==1)&&(gameexit!=4)&&(paused==0))
	{
		if (clockon[0]==1)
		{
#ifdef NTSC
			globaltime[0]+=167;	/* time*10000 */
#else
			globaltime[0]+=200;
#endif
		}
		if (clockon[1]==1)
		{
#ifdef NTSC
			globaltime[1]+=167;	/* time*10000 */
#else
			globaltime[1]+=200;
#endif
		}

	}
	if ((timedstart==1)&&(paused==0))
	{
#ifdef NTSC
		twoplaytime-=167;
#else
		twoplaytime-=200;
#endif
	}
	SsSeqCalledTbyT ();
#ifdef MUSIC

	if (specialsoundstate!=0)
	{
//		if (SsIsEos(sep1,specialsoundstate+4)==0)
//		{
			if (specialsoundstate!=5)
			{
				if (soundtrigger==0)
				{
					SsSepStop(sep1,specialsoundstate+4);
					SsSepReplay(sep1,0);
					specialsoundstate=5;
				}
				else
				{
	//				SsSepPlay(sep1,specialsoundstate+4,SSPLAY_PLAY,1);
				}
			}
			else
			{
				specialsoundstate=0;
			}
//		}
	}
	if (musicon==1)
	{
		switch (changesong)
		{
			case (0):
			{
//				if (nextseq==0)
//				{
//					if (soundtrigger==0)
					if (specialsoundstate==0)
					{
						if (SsIsEos(sep1,baseseq)==0)
						{
							baseseq=playlist[count];
			//					SsSetMarkCallback(1,baseseq,(SsMarkCallbackProc *)&MarkerCallBack);
							SsSepPlay (sep1, baseseq, SSPLAY_PLAY, 1);
							if (count<9)
							{
								count++;
							}
							else
							{
								count=0;
							}
						}
					}
//				}
		//			else
				if (nextseq!=0)
				{
					if (nextseq==1)
					{
						if (SsIsEos(sep1,0)!=0)
						{
							currentseq=chooseseq;
			//				if (currentseq==1)
			//				{
//								SsSepPause(sep1,0);
								SsSepPlay(sep1, currentseq, SSPLAY_PLAY, 1);
			//					SsSepPlay(endsep[0], 0, SSPLAY_PLAY,1);
			/*				}
							else
							{
								SsSepPlay(sep1, currentseq, SSPLAY_PLAY, 1);
							}	*/
							nextseq=2;
						}
					}
					else
					{
						if (nextseq==2)
						{
	//						if (SsIsEos(sep1,currentseq)==0)
							if (scorecounter==0)
							{
	//							if (currentseq==1)
	//							{
//								if (SsIsEos(sep1,0)!=0)
//								{
//									SsSepReplay(sep1,0);
//								}
									SsSepStop(sep1,currentseq);
	//								SsSepPlay(sep1, currentseq, SSPLAY_PLAY, 1);
	//							}
								nextseq=0;
							}
						}
						else
						{
							nextseq=0;
						}
					}
				}
				break;
			}

			case (1):
			{
				break;
			}

			case (2):
			{
				if (songloading==1)
				{
					if (SsIsEos(0,0)==0)
					{
		   				SsSepPlay(0, 0, SSPLAY_PLAY, 1);
					}
				}
				else
				{
					if (SsIsEos(0,0)==0)
					{
						sep1 = SsSepOpen ((unsigned long *)&sequence1, vab1, 6);
						SsSepPlay(sep1, 5, SSPLAY_PLAY, 1); /* drum roll hard coded as 5, should be generic */
						SsSepClose(0);
						endsep[whichload] = SsSepOpen ((unsigned long *)&tendsep[whichload][0], mixvab, 0 );
						SsSepSetVol (0, 0,70,70);
						SsSepSetVol (sep1, 0, 70, 70);
						SsSepSetVol (sep1, 1, 70, 70);
						SsSepSetVol (sep1, 2, 70, 70);
						SsSepSetVol (sep1, 3, 70, 70);
						SsSepSetVol (sep1, 4, 70, 70);
						SsSepSetVol (sep1, 5, 70, 70);
						songloading=0;
						changesong=3;
					}
				}
				break;
			}
			case (3):
			{
				if (SsIsEos(1,5)==0)
				{
					SsSepPlay(sep1, 0, SSPLAY_PLAY, 1);
					baseseq=0;
					changesong=0;
					whichload=(whichload+1)%2;
				}
				break;
			}
		}
	}
#endif
	return;
}

void playsoundeffect(uint8 no,uint8 repeat)
{
	if (SsIsEos(sfxsep1,no)==0)
	{
		SsSepSetVol (sfxsep1, no, (currentsave.options[SFX_VOLUME]*127)/30,(currentsave.options[SFX_VOLUME]*127)/30);
		SsSepPlay(sfxsep1, no, SSPLAY_PLAY, repeat);
	}
}

void playfesoundeffect(uint8 no,uint8 repeat)
{
	if (SsIsEos(sep1,no+1)==0)
	{
		SsSepSetVol (sep1, no+1, (currentsave.options[SFX_VOLUME]*127)/30,(currentsave.options[SFX_VOLUME]*127)/30);
		SsSepPlay(sep1, no+1, SSPLAY_PLAY, repeat);
	}
}

void InitialiseSound(uint8 where)
{
	whichload=1;
	specialsoundstate=0;
	SsInit ();
	SsSetTableSize (seq_table, 2, 32);
//	SpuInit();
//	ResetCallback();

	if ((musiccat==0)&&(tuneno==0))
	{
		musiccat=3;
		tuneno=1;
	}
	SsSetTickMode (SS_NOTICK);
//	SsSetTickMode (SS_TICK60);

//	SsSetReservedVoice(22);


#ifndef CD
/*	fin			=	PCopen( "music/mix.vh", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)&mixvh, arsesize );
	PCclose( fin );
	fin			=	PCopen( "music/mix.vb", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)&mixvb, arsesize );
	PCclose( fin );	*/

/* not to be hard coded! */
/*	fin			=	PCopen( "music/909_test.vh", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)&vabheader, arsesize );
	PCclose( fin );
	fin			=	PCopen( "music/909_test.vb", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)&cdbuffer, arsesize );
	PCclose( fin );
	fin			=	PCopen( "music/techjung.sep", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)&sequence1, arsesize );
	PCclose( fin );
	fin			=	PCopen( "music/909end.sep", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)&tendsep[0][0], arsesize );
	PCclose( fin );	*/



#else
	cdbuffer=(char *)&Ib2[0];
/*	load_cd("\\MUSIC\\MIX.VH;1",(char *)&mixvh);
	do
	{

	}
	while (CdReadSync(1,0) > 0 );
	load_cd("\\MUSIC\\MIX.VB;1",(char *)&mixvb);
	do
	{

	}    */
	while (CdReadSync(1,0) > 0 );
	load_fpcd(&musiccatalog[musiccat].tunes[tuneno].vabheader,(char *)&vabheader);
	do
	{

	}
 	while (CdReadSync(1,0) > 0 );
	load_fpcd(&musiccatalog[musiccat].tunes[tuneno].vabbody,(char *)cdbuffer);
	do
	{

	}
 	while (CdReadSync(1,0) > 0 );
	load_fpcd(&musiccatalog[musiccat].tunes[tuneno].mainsep,(char *)&sequence1);
	do
	{

	}
 	while (CdReadSync(1,0) > 0 );
	load_fpcd(&musiccatalog[musiccat].tunes[tuneno].endsep,(char *)&tendsep[0][0]);
	do
	{

	}
 	while (CdReadSync(1,0) > 0 );


#endif

//	SsSetTickMode (SS_TICK60);

/*    mixvab = SsVabOpenHead ((unsigned char*)&mixvh, 0);
	if( mixvab == -1 ) {
	  printf( "mixVAB headder open failed\n" );
	  exit(0);
	}
        mixvab = SsVabTransBody ((unsigned char*)&mixvb, mixvab);
	if( mixvab == -1 ) {
	  printf( "mixVAB body open failed\n" );
	  exit(0);
	}
	SsVabTransCompleted (SS_WAIT_COMPLETED);	*/
	cdbuffer=(char *)&Ib2[0];
	vab1 = SsVabOpenHead ((unsigned char*)&vabheader, 1);
	if( vab1 == -1 ) {
	  printf( "VAB headder open failed\n" );
	  exit(0);
	}
        vab1 = SsVabTransBody ((unsigned char*)cdbuffer, vab1);
	if( vab1 == -1 ) {
	  printf( "VAB body open failed\n" );
	  exit(0);
	}
	SsVabTransCompleted (SS_WAIT_COMPLETED);
	cdbuffer=(char *)&Ib2[0];
#ifndef CD
	fin			=	PCopen( "music/sfx/sfx.vh", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)&sfxhead, arsesize );
	PCclose( fin );
	fin			=	PCopen( "music/sfx/sfx.vb", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)cdbuffer, arsesize );
	PCclose( fin );

/* not to be hard coded! */
	fin			=	PCopen( "music/sfx/sfx.sep", 0, 0 );
	arsesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	PCread( fin, (char *)&sfxsep, arsesize );
	PCclose( fin );
#else
	load_cd("\\MUSIC\\SFX\\SFX_LO.VH;1",(char *)&sfxhead);
	do
	{

	}
	while (CdReadSync(1,0) > 0 );
	load_cd("\\MUSIC\\SFX\\SFX_LO.VB;1",(char *)cdbuffer);
	do
	{

	}
	while (CdReadSync(1,0) > 0 );
	load_cd("\\MUSIC\\SFX\\SFX.SEP;1",(char *)&sfxsep);
	do
	{

	}
 	while (CdReadSync(1,0) > 0 );
#endif
	cdbuffer=(char *)&Ib2[0];
    sfxvab = SsVabOpenHead ((unsigned char*)&sfxhead, 2);
	if( sfxvab == -1 ) {
	  printf( "sfxVAB headder open failed\n" );
	  exit(0);
	}
        sfxvab = SsVabTransBody ((unsigned char*)cdbuffer, sfxvab);
	if( sfxvab == -1 ) {
	  printf( "mixVAB body open failed\n" );
	  exit(0);
	}
	SsVabTransCompleted (SS_WAIT_COMPLETED);

	SsStart2 ();

//	endsep[0] = SsSepOpen ((unsigned long *)&tendsep[0][0], mixvab, 1 );
	sep1 = SsSepOpen ((unsigned long *)&sequence1, vab1, 7);
	sfxsep1 = SsSepOpen((unsigned long *)&sfxsep, sfxvab, 31);

	SsSetMVol (127, 127);
//	SsSepSetVol (endsep[0], 0,70,70);
//	SsSepSetVol (endsep[0], 0,120,120);
	if (musiccat==0)
	{
		SsSepSetVol(sep1, 0, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);
	}
	else
	{
		SsSepSetVol(sep1, 0, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);
	}
	SsSepSetVol (sep1, 1, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);

	SsSepSetVol (sep1, 2, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);
	SsSepSetVol (sep1, 3, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);
	SsSepSetVol (sep1, 4, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);
	SsSepSetVol (sep1, 5, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);
	SsSepSetVol (sep1, 6, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);

	SsUtSetReverbType(1);
	SsUtReverbOn();
	for(waitcount=0;waitcount<200000;waitcount++)
	{

	}
	SsUtSetReverbDepth(80,80);
	if (currentsave.options[STEREO_SET]==1)
	{
		SsSetStereo();
	}
	else
	{
		SsSetMono();
	}
//	SpuSetNoiseVoice(SPU_ON,1<<23);		/* channel 20 - white noise */
//	SsUtKeyOnV(23,vab1,15,7,41,0,64,64);	/* Key on */

	changesong=0;
	currentseq=0;
	baseseq=0;
	nextseq=0;
	count=0;
	songloading=0;
//	VSyncCallback(&SoundCallBack);
	if (where==1)
	{
		playsoundeffect(29,SSPLAY_INFINITY);
	}
	SsSetMarkCallback(sep1,0,(SsMarkCallbackProc *)&MarkerCallBack);
	musicon=1;
}

void KillSoundFE(void)
{
//	StopCallback();
	uint8	i;
	SpuCommonAttr	CommonAttrib;

	musicon=0;
	SsSetMVol (0, 0);
	SsSetMarkCallback(sep1,0,0);

//	SsSepSetVol(sep1,0,0,0);
//	SsSepStop(endsep[0],0);
	for (i=0;i<6;i++)
	{
		SsSepStop(sep1,i);
	}
	for (i=0;i<31;i++)
	{
		SsSepStop(sfxsep1,i);
	}
	SsSepClose (sep1);
    SsVabClose (vab1);
//	SsSepClose (endsep[(whichload+1)%2]);
//	SsVabClose (mixvab);
	SsSepClose (sfxsep1);
	SsVabClose (sfxvab);
    SsEnd ();
	SsInit ();
	SsSetMVol (127, 127);
	CommonAttrib.mask = (SPU_COMMON_CDVOLL | SPU_COMMON_CDVOLR | SPU_COMMON_CDREV | SPU_COMMON_CDMIX);
	CommonAttrib.cd.volume.left  = 0x7fff;
	CommonAttrib.cd.volume.right  = 0x7fff;
	CommonAttrib.cd.mix			  = SPU_ON;
	CommonAttrib.cd.reverb		  = SPU_OFF;
	SpuSetCommonAttr (&CommonAttrib);				/* Sound common attributes set */
//	SsQuit ();
}


void KillSound(void)
{
	SsSetMarkCallback(sep1,0,0);
	StopCallback();
	SsSepClose (sep1);
    SsVabClose (vab1);
	SsSepClose (endsep[(whichload+1)%2]);
	SsVabClose (mixvab);
    SsEnd ();
	SsQuit ();
}

void playauto( void )
{
	if (SsIsEos(0,currentseq)==0)
	{
		currentseq=playlist[count];
		printf("p:%d c:%d\n",currentseq,count);
		SsSepPlay (sep1, currentseq, SSPLAY_PLAY, 1);
		if (count<7)
		{
			count++;
		}
		else
		{
			count=0;
		}

	}
}

void SetNextSeq(long seq)
{
	if ((nextseq==0)&&(changesong==0))
	{
		nextseq=1;
		chooseseq=seq;
	}
}

void ChangeSong(long tuneno)
{
#ifdef CD
	if (!(CdReadSync(1,0) > 0))
	{
#endif
		if ((changesong==0)&&(nextseq==0))
		{
			musiccat=rand()%4;
			if (lastcat==musiccat)
			{
				if (musiccat>0)
				{
					musiccat--;
				}
				else
				{
					musiccat=3;
				}
			}
			lastcat=musiccat;
			changesong=1;
		}

#ifdef CD
	}
#endif

}




