// ANIMCTRL.H

#ifndef _ANIMCTRL_H_
#define _ANIMCTRL_H_

#define POSEBUFFERSIZE 60000
#define VOGUESIZE 30	// This is the maximum depth of limbs

#define AS_STATIC	0
#define AS_LERPING	1

typedef struct vogue	// A pose
{
	chfloat Tx, Ty, Tz;
	chfloat Rx[ VOGUESIZE ], Ry[ VOGUESIZE ], Rz[ VOGUESIZE ];
}vogue;

extern uint8 PoseBuffer[ POSEBUFFERSIZE ];	// .BAG storage
extern vogue Vogues[ MAX_PLAYERS ];

void Control_Anim( uint8 PNum );
void NextLerp( uint8 PNum );

// Frame/Pose setting routines
void SetPose( uint8 PNum, uint32 FrameNumber );
void SetTween( uint8 PNum, uint32 Frame1, uint32 Frame2, uint16 Lerps, int16 Tween );
void SetTweenOfTwoTweens( uint8 PNum, uint32 Src1, uint32 Dest1, uint32 Src2, uint32 Dest2, uint16 Lerps1, int16 Tween1, uint16 Lerps2, int16 Tween2, uint16 Lerps, int16 Tween );

// Lerping routines
void SetLerp( uint8 PNum, uint32 FrameNumber, uint16 Lerps );
void SetLerpToTween( uint8 PNum, uint32 Frame1, uint32 Frame2, uint16 Lerps, uint16 Twerps, int16 Tween );
void SetLerpToTweenOfTwoTweens( uint8 PNum, uint32 Src1, uint32 Dest1, uint32 Src2, uint32 Dest2, uint16 Lerps1, int16 Tween1, uint16 Lerps2, int16 Tween2, uint16 Lerps, int16 Tween );


// Status test routines
uint8 Anim_Status( uint8 PNum );
uint32 SourceLerpFrame( uint8 PNum );
uint32 DestLerpFrame( uint8 PNum );

void SetLerpRots( uint8 PNum, vec3 *Src, vec3 *Dest, uint16 Lerps, vec3 *EDest );//, vec3 *Base );
void LerpRots( uint8 PNum );//, vec3 *Dump );

extern chfloat RDRx[ MAX_PLAYERS ], RDRy[ MAX_PLAYERS ], RDRz[ MAX_PLAYERS ];
extern uint16 RLerpProgress[ MAX_PLAYERS ];
extern uint16 RLerpFrames[ MAX_PLAYERS ];
extern vec3 RSrc[ MAX_PLAYERS ], RDest[ MAX_PLAYERS ];
extern uint8 RMode[ MAX_PLAYERS ];


uint32 ConvertFrame( uint16 Character, uint32 BoneFrame );


extern uint32 ConverterTable[][5];


//#define FRAMEEQU( a, b )	ConvertFrame( Player[ a ].Character - 1, b )
#define FRAMEEQU( a, b )	b

#endif
