// GHOSTREP.H

// Header file

#ifndef _GHOSTREP_H_
#define _GHOSTREP_H_

#define RECORDBUFFERSIZE	73728

typedef struct CollisionPacket
{
	uint8	Type;

	uint8	CollisionType;
	vec3	CollidePoint;
	chfloat	CollideAngle;
}CollisionPacket;

typedef struct GhostPacket
{
	uint8 	Type;
	int8	TurnX;

	uint16	PadData;

}GhostPacket;

typedef struct XYZPacket
{
	uint8	Type;
	chfloat X, Y, Z;
}XYZPacket;

typedef struct HitTheWallPacket
{
	uint8	Type;
	chfloat X, Y, Z;
}HitTheWallPacket;


void UpdateGhostData( void );
void HandleGhosts( void );
void Init_Ghost( void );

void InsertXYZPacket( uint8 PlayerNumber );
void RetrieveXYZPacket( uint8 PlayerNumber );

void InsertCollisionPacket( uint8 PlayerNumber, uint8 CollType );
void RetrieveCollisionPacket( uint8 PlayerNumber );

uint16 RetrieveHitTheWallPacket( uint8 PlayerNumber );
void InsertHitTheWallPacket( uint8 PlayerNumber );

extern uint8 GhostData;
extern uint8 Validity[ 2 ];
extern uint8 GhostBuffer[ 2 ][ RECORDBUFFERSIZE ];

#endif
