/* camera.h */

#ifndef _CAMERA_H_
#define	_CAMERA_H_

#define CAMERA_TYPE_TARGET		0
#define CAMERA_TYPE_POSITIONAL	1

#define CAMERA_TEST_TARGET		0
#define CAMERA_TEST_POSITIONAL	1
#define CAMERA_FIRST_PERSON		2
#define CAMERA_FOLLOW			3
#define CAMERA_PARACHUTE		4

typedef struct camera
{
	/* For both types of mode */
	vec3		Pos;

	/* For ortho modes */
	vec3		Targ;
	vec3		Up;

	/* For positional modes */

	vec3		Rot;

	uint8		Type;
	uint8		Mode, SubMode, ModeAfterLerp;

	uint8 NumLerps, LerpCount;

	uint32 Spacing;
	uint32 RecCount;

	chfloat D, OldD;

	vec3 To, From;

	MATRIX		ViewMatrix;
	MATRIX		ObjectView;
	MATRIX		TransMatrix;

	vec3 *DemoVec3;
	uint8 DemoLerp;

	// Various data for the modes
	vec3		FromPos;
	chfloat		Ch1, Ch2, Ch3;
	chfloat		HeadHeight;
	chfloat		Zoom;
	chfloat		SweepAngle, XSweepAngle, SweepBonus, XSweepBonus;
	chfloat		GroundBonus;

}camera;

void InitialiseCameras( void );
void KillCameras( void );

void CameraLogic( uint8 PlayerNumber );

extern	long	cam_zrot;
extern	long	cam_zrotspeed;
extern	long	cam_zrotaccel;
extern	long	cam_zrotmaxspeed;
extern	long	cam_zrotmax;

#endif
