/* camlogic.h */

#ifndef _CAMLOGIC_H_
#define _CAMLOGIC_H_

void InitCameraModel( uint8 PlayerNumber );	// Initialises variables for camera logic routines

/* Milestone 1 camera logic routines */
void Camera_Test_Positional( uint8 PlayerNumber );
void Camera_Test_Target( uint8 PlayerNumber );

void Camera_First_Person( uint8 PlayerNumber );

void Camera_Parachute( uint8 PlayerNumber );

void Camera_Follow( uint8 PlayerNumber );
void Calculate_SweepAngles( uint8 PlayerNumber );
void SweepBonus( uint8 PlayerNumber );

void GoToSpinView( uint8 PlayerNumber );
void GoToArsView( uint8 PlayerNumber );
void GoToTwistView( uint8 PlayerNumber );
void GoToCrashView( uint8 PlayerNumber );
void GoToNormalView( uint8 PlayerNumber );
void GoToFakieView( uint8 PlayerNumber );

void GoToAvalancheView( uint8 PlayerNumber );
void ReturnFromAvalancheView( uint8 PlayerNumber );

void RotateToFakieView( uint8 PlayerNumber );

void GoToOnRailsView( uint8 PlayerNumber, uint8 WhichRails );


#define CFP_NORMAL		0	// Normal follow mode
#define CFP_TONORMAL	1	// In transition to CFP_NORMAL
#define CFP_CRASHVIEW	2	// Crash view, zooms out, more above player
#define CFP_TWISTVIEW	3	// Twist
#define CFP_ARSVIEW		4	// Ars view
#define CFP_SPINVIEW	5	// Spin view
#define CFP_TOFAKIE		6	// In transition to CFP_NORMAL ( Fakie )
#define CFP_AVALANCHE	7	// Avalanche
#define CFP_FROMAVALANCHE	8
#define CFP_LERP			9
#define CFP_ONRAILSCAM		10
#define CFP_ROTATETOFAKIE	11

#define PARA_LAUNCH	0
#define PARA_AIR	1
#define PARA_LANDED	2

extern	long	russ_cam_rot;
#endif

