// GHOSTREP.H

// Header file

#ifndef _GHOSTREP_H_
#define _GHOSTREP_H_

#define RECORDBUFFERSIZE	73728

typedef struct GhostPacket		// 0
{
	uint8 	Type;

	uint8	TurnX;
	uint16	PadData;
}GhostPacket;


typedef struct CollisionPacket	// 1
{
	uint8	Type;

	uint8	CollisionType;
	vec3	CollidePoint;
	chfloat	CollideAngle;
}CollisionPacket;

typedef struct XYZPacket		// 2
{
	uint8	Type;

	chfloat X, Y, Z;
}XYZPacket;

typedef struct HitTheWallPacket	// 3
{
	uint8	Type;

	chfloat X, Y, Z;
}HitTheWallPacket;

typedef struct PadTypePacket	// 4
{
	uint8	Type;

	uint8	PadType;
	uint8	Character, Suit, BoardNumber;
}PadTypePacket;

// Add a spin and twist packet which records the launch parameters

void UpdateGhostData( void );
void HandleGhosts( void );
void Init_Ghost( void );

void InsertXYZPacket( uint8 PlayerNumber );
void RetrieveXYZPacket( uint8 PlayerNumber );

void InsertCollisionPacket( uint8 PlayerNumber, uint8 CollType );
void RetrieveCollisionPacket( uint8 PlayerNumber );

//uint16 RetrieveHitTheWallPacket( uint8 PlayerNumber );
//void InsertHitTheWallPacket( uint8 PlayerNumber );



extern uint8 GhostData;
extern uint8 Validity[ 2 ];
extern uint8 GhostBuffer[ 2 ][ RECORDBUFFERSIZE ];

#endif
