/* mathbits.h */

#ifndef _MATHBITS_H_
#define _MATHBITS_H_


typedef struct vec3
{
	chfloat X, Y, Z;
}vec3;

typedef struct vec2
{
	chfloat X, Y;
}vec2;

typedef struct chmatrix
{
	chfloat E00, E01, E02;
	chfloat E10, E11, E12;
	chfloat E20, E21, E22;
	chfloat E30, E31, E32;
}chmatrix;
//	chfloat E[ 4 ][ 3 ];


void SetVector3(vec3 *vector,int16 x,int16 y,int16 z);

void SetVec3( vec3 *V, chfloat X, chfloat Y, chfloat Z );	// use this one

void Matrix_Init( chmatrix *A );
void Matrix_x_Matrix( chmatrix *A, chmatrix *B, chmatrix *D );
void Vec3_x_Matrix( vec3 *A, chmatrix *B, vec3 *D );

void Matrix_MakeRotX( chmatrix *A, chfloat Deg );
void Matrix_MakeRotY( chmatrix *A, chfloat Deg );
void Matrix_MakeRotZ( chmatrix *A, chfloat Deg );

void Matrix_MakeXYZTransl( chmatrix *A, chfloat X, chfloat Y, chfloat Z );
void Matrix_MakeRotXYZ( chmatrix *Mat, chfloat Rx, chfloat Ry, chfloat Rz );

chfloat Dot( vec3 *A, vec3 *B );
void Cross( vec3 *A, vec3 *B, vec3 *D );
void Normalize( vec3 *D );
chfloat Magnitude( vec3 *A );
chfloat chatan2( chfloat Dx, chfloat Dy );
chfloat chabs( chfloat Gizzard );

chfloat DistanceBetween( vec3 *A, vec3 *B );

#endif
