// SCORES.H

#ifndef _SCORES_H_
#define _SCORES_H_


#define T_NOSCORE			0
#define T_MUTE				1	// Tail grab
#define	T_METHOD			2	// Method ( heelside grabbed through legs )

#define T_TFMUTE			3	// Tails and Methods combo'ed with other moves equals better scores
#define T_TFMETHOD			4
#define T_TBMUTE			5
#define T_TBMETHOD			6

#define T_FSMUTE			7
#define T_FSMETHOD			8
#define T_BSMUTE			9
#define T_BSMETHOD			10

#define T_MC_TWIST_MUTE		11
#define T_MC_TWIST_METHOD	12

// FS is anti-clockwise

#define T_FS180				13	// Twists of multiple degrees
#define T_FS360				14
#define T_FS540				15
#define T_FS720				16
#define T_FS900				17
#define T_FS1080			18
#define T_FS1260			19
#define T_FS1440			20

#define T_BS180				21
#define T_BS360				22
#define T_BS540				23
#define T_BS720				24
#define T_BS900				25
#define T_BS1080			26
#define T_BS1260			27
#define T_BS1440			28

#define T_FSpin360			29
#define T_FSpin720			30
#define T_FSpin1080			31
#define T_FSpin1440			32

#define T_BSpin360			33
#define T_BSpin720			34
#define T_BSpin1080			35
#define T_BSpin1440			36

// To qualify for these four tricks the pose must be held for a second
#define T_FIFTYFIFTY		37	// Forward railslide
#define T_FAKIEFIFTYFIFTY	38	// Fakie version of above
#define T_RAILSLIDE			39	// Railside, with board perpendicular to rail
#define T_FAKIERAILSLIDE	40	// Fakie version of above

#define T_RAILSPIN			41	// Player constantly spins on the rail for at least 360 degrees

#define T_TREERIDE			42	// Railsliding a tree

#define T_BONK				43	// A bonk on any object
#define T_CHILLTRICK		44	// Jims leg out anim

#define T_MC_TWIST			45	// Combined Spin/Twist both of at least 360 degrees

#define MAX_SCORES			46


#define ONEPOINTZERO		0
#define ONEPOINTONE			1
#define ONEPOINTTWO			2
#define ONEPOINTTHREE		3
#define ONEPOINTFOUR		4
#define ONEPOINTFIVE		5
#define ONEPOINTSIX			6
#define ONEPOINTSEVEN		7
#define ONEPOINTEIGHT		8
#define ONEPOINTNINE		9
#define TWOPOINTZERO		10

typedef struct trickscore
{
	uint8	InUse;
	uint8	Multiply;
	uint32	Trick;
	uint32	Score;
	uint32	FinalScore;
}trickscore;

void InitScoringSystem( void );
trickscore* GetNextScore( uint8 PlayerNumber );
void DeleteScore( uint8 PlayerNumber );

void AwardTrick( uint16 PlayerNumber, uint16 DefinedScore, uint16 DefinedMultiply );

void TestScoring( uint8 PlayerNumber );


#endif