// Skeleton.h

#ifndef _SKELETON_H_
#define _SKELETON_H_

#define MAX_MODEL_POLYS 325	// Triangles and Quads
#define MAX_MODEL_VERTS	300

// Model data #defines
//#define BONE_NUM_VERTS b_skin_num_verts
//#define BONE_NUM_POLYS b_skin_num_polys
//#define BONE_POLYS b_skin_polys
//#define BONE_VERTS b_skin_verts
//#define BONE_NORMS b_skin_norms
#define BONE_ROOT b_virgin

//#define TRIX_NUM_VERTS t_skin_num_verts
//#define TRIX_NUM_POLYS t_skin_num_polys
//#define TRIX_POLYS t_skin_polys
//#define TRIX_VERTS t_skin_verts
//#define TRIX_NORMS t_skin_norms
#define TRIX_ROOT t_virgin

//#define YOYO_NUM_VERTS y_skin_num_verts
//#define YOYO_NUM_POLYS y_skin_num_polys
//#define YOYO_POLYS y_skin_polys
//#define YOYO_VERTS y_skin_verts
//#define YOYO_NORMS y_skin_norms
#define YOYO_ROOT y_virgin

//#define GOAT_NUM_VERTS g_skin_num_verts
//#define GOAT_NUM_POLYS g_skin_num_polys
//#define GOAT_POLYS g_skin_polys
//#define GOAT_VERTS g_skin_verts
//#define GOAT_NORMS g_skin_norms
#define GOAT_ROOT g_skel

#define YETI_ROOT yt_virgin

// Model polygon types
#define FLAT		1
#define GOURAUD		2
#define TEXTURED	3
#define TEXTUREDB	4

// Skeleton node types
#define CHAIN_ROOT	1
#define EFFECTOR	2
#define JOINT		3

// Model polygon format
typedef struct model_polys
{
	uint16 Type;			// Type of polygon
	uint16 NumberOfVerts;	// Maximum of 4
	uint16 VertNum[ 4 ];	// The four possible vertex indices
	CVECTOR RGB;

	uint8 U0, U1, U2, U3;
	uint8 V0, V1, V2, V3;
}model_polys;

// Skeleton node format
typedef struct node
{
	uint16 Type;
	chfloat Tx, Ty, Tz;
	chfloat Rx, Ry, Rz;

	chfloat X, Y, Z;

	int16 *Attached;
	int16 *AttachedLo;

	uint8 NumChildren;
	uint32 *Child[5];
}node;


// LOOP or BONE's Skeleton, Vertices & Polygons
extern node BONE_ROOT;
extern node GOAT_ROOT;
extern node TRIX_ROOT;
extern node YOYO_ROOT;
extern node YETI_ROOT;




// BONE - currently OK
extern int16 Verts_b_head[];
extern int16 Verts_b_chest[];
extern int16 Verts_b_llleg[];
extern int16 Verts_b_lfoot[];
extern int16 Verts_b_rfoot[];
extern int16 Verts_b_lrleg[];
extern int16 Verts_b_urleg[];
extern int16 Verts_b_peni[];
extern int16 Verts_b_urarm[];
extern int16 Verts_b_lrarm[];
extern int16 Verts_b_rhand[];
extern int16 Verts_b_ularm[];
extern int16 Verts_b_llarm[];
extern int16 Verts_b_tum[];
extern int16 Verts_b_lhand[];
extern int16 Verts_b_ulleg[];
extern int16 Verts_b_jnt184_1[];
extern int16 Verts_b_neck[];
extern int16 Verts_b_bum[];

extern int16 Verts_b_head_Lo[];
extern int16 Verts_b_chest_Lo[];
extern int16 Verts_b_llleg_Lo[];
extern int16 Verts_b_lfoot_Lo[];
extern int16 Verts_b_rfoot_Lo[];
extern int16 Verts_b_lrleg_Lo[];
extern int16 Verts_b_urleg_Lo[];
extern int16 Verts_b_peni_Lo[];
extern int16 Verts_b_urarm_Lo[];
extern int16 Verts_b_lrarm_Lo[];
extern int16 Verts_b_rhand_Lo[];
extern int16 Verts_b_ularm_Lo[];
extern int16 Verts_b_llarm_Lo[];
extern int16 Verts_b_tum_Lo[];
extern int16 Verts_b_lhand_Lo[];
extern int16 Verts_b_ulleg_Lo[];
extern int16 Verts_b_jnt184_1_Lo[];
extern int16 Verts_b_neck_Lo[];
extern int16 Verts_b_bum_Lo[];


// TRIX - currently OK
extern int16 Verts_t_head[];
extern int16 Verts_t_chest[];
extern int16 Verts_t_llleg[];
extern int16 Verts_t_lfoot[];
extern int16 Verts_t_rfoot[];
extern int16 Verts_t_lrleg[];
extern int16 Verts_t_urleg[];
extern int16 Verts_t_peni[];
extern int16 Verts_t_urarm[];
extern int16 Verts_t_lrarm[];
extern int16 Verts_t_rhand[];
extern int16 Verts_t_ularm[];
extern int16 Verts_t_llarm[];
extern int16 Verts_t_tum[];
extern int16 Verts_t_lhand[];
extern int16 Verts_t_ulleg[];
extern int16 Verts_t_jnt184_1[];
extern int16 Verts_t_bum[];
extern int16 Verts_t_neck[];
extern int16 Verts_t_peni[];

extern int16 Verts_t_head_Lo[];
extern int16 Verts_t_chest_Lo[];
extern int16 Verts_t_llleg_Lo[];
extern int16 Verts_t_lfoot_Lo[];
extern int16 Verts_t_rfoot_Lo[];
extern int16 Verts_t_lrleg_Lo[];
extern int16 Verts_t_urleg_Lo[];
extern int16 Verts_t_peni_Lo[]; 
extern int16 Verts_t_urarm_Lo[];
extern int16 Verts_t_lrarm_Lo[];
extern int16 Verts_t_rhand_Lo[];
extern int16 Verts_t_ularm_Lo[];
extern int16 Verts_t_llarm_Lo[];
extern int16 Verts_t_tum_Lo[];
extern int16 Verts_t_lhand_Lo[];
extern int16 Verts_t_ulleg_Lo[];
extern int16 Verts_t_jnt184_1_Lo[];
extern int16 Verts_t_bum_Lo[];
extern int16 Verts_t_neck_Lo[];


// YOYO - currently OK
extern int16 Verts_y_head[];
extern int16 Verts_y_chest[];
extern int16 Verts_y_llleg[];
extern int16 Verts_y_lfoot[];
extern int16 Verts_y_rfoot[];
extern int16 Verts_y_lrleg[];
extern int16 Verts_y_urleg[];
extern int16 Verts_y_peni[]; 
extern int16 Verts_y_urarm[];
extern int16 Verts_y_lrarm[];
extern int16 Verts_y_rhand[];
extern int16 Verts_y_ularm[];
extern int16 Verts_y_llarm[];
extern int16 Verts_y_tum[];
extern int16 Verts_y_lhand[]; 
extern int16 Verts_y_ulleg[];
extern int16 Verts_y_jnt184_1[];
extern int16 Verts_y_bum[];
extern int16 Verts_y_neck[];

extern int16 Verts_y_head_Lo[];
extern int16 Verts_y_chest_Lo[];
extern int16 Verts_y_llleg_Lo[];
extern int16 Verts_y_lfoot_Lo[];
extern int16 Verts_y_rfoot_Lo[];
extern int16 Verts_y_lrleg_Lo[];
extern int16 Verts_y_urleg_Lo[];
extern int16 Verts_y_urarm_Lo[];
extern int16 Verts_y_lrarm_Lo[];
extern int16 Verts_y_rhand_Lo[];
extern int16 Verts_y_ularm_Lo[];
extern int16 Verts_y_llarm_Lo[];
extern int16 Verts_y_tum_Lo[];
extern int16 Verts_y_lhand_Lo[];
extern int16 Verts_y_ulleg_Lo[];
extern int16 Verts_y_peni_Lo[]; 
extern int16 Verts_y_jnt184_1_Lo[];
extern int16 Verts_y_bum_Lo[];
extern int16 Verts_y_neck_Lo[];


// GOAT
extern int16 Verts_g_head[];
extern int16 Verts_g_chest[];
extern int16 Verts_g_llleg[];
extern int16 Verts_g_lfoot[];
extern int16 Verts_g_rfoot[];
extern int16 Verts_g_lrleg[];
extern int16 Verts_g_urleg[];
extern int16 Verts_g_peni[]; 
extern int16 Verts_g_ulleg[];
extern int16 Verts_g_tum[];
extern int16 Verts_g_lhand[];
extern int16 Verts_g_rhand[];
extern int16 Verts_g_lrarm[];
extern int16 Verts_g_llarm[];
extern int16 Verts_g_urarm[];
extern int16 Verts_g_ularm[];
extern int16 Verts_jnt184_1[];
extern int16 Verts_g_neck[];
extern int16 Verts_g_bum[];

extern int16 Verts_g_head_Lo[];
extern int16 Verts_g_chest_Lo[];
extern int16 Verts_g_llleg_Lo[];
extern int16 Verts_g_lfoot_Lo[];
extern int16 Verts_g_rfoot_Lo[];
extern int16 Verts_g_lrleg_Lo[];
extern int16 Verts_g_urleg_Lo[];
extern int16 Verts_g_peni_Lo[]; 
extern int16 Verts_g_ulleg_Lo[];
extern int16 Verts_g_tum_Lo[];
extern int16 Verts_g_lhand_Lo[];
extern int16 Verts_g_rhand_Lo[];
extern int16 Verts_g_lrarm_Lo[];
extern int16 Verts_g_llarm_Lo[];
extern int16 Verts_g_urarm_Lo[];
extern int16 Verts_g_ularm_Lo[];
extern int16 Verts_jnt184_1_Lo[];
extern int16 Verts_g_neck_Lo[];
extern int16 Verts_g_bum_Lo[]; 




// YETI
extern int16 Verts_yt_head[];
extern int16 Verts_yt_chest[];
extern int16 Verts_yt_llleg[];
extern int16 Verts_yt_lfoot[];
extern int16 Verts_yt_rfoot[];
extern int16 Verts_yt_lrleg[];
extern int16 Verts_yt_urleg[];
extern int16 Verts_yt_peni[];
extern int16 Verts_yt_urarm[];
extern int16 Verts_yt_lrarm[];
extern int16 Verts_yt_rhand[];
extern int16 Verts_yt_ularm[];
extern int16 Verts_yt_llarm[];
extern int16 Verts_yt_tum[];
extern int16 Verts_yt_lhand[];
extern int16 Verts_yt_ulleg[];
extern int16 Verts_jnt184_1_1_2[];
extern int16 Verts_jnt185_1[];

extern int16 Verts_yt_head_Lo[];
extern int16 Verts_yt_chest_Lo[];
extern int16 Verts_yt_llleg_Lo[];
extern int16 Verts_yt_lfoot_Lo[];
extern int16 Verts_yt_rfoot_Lo[];
extern int16 Verts_yt_lrleg_Lo[];
extern int16 Verts_yt_urleg_Lo[];
extern int16 Verts_yt_peni_Lo[];
extern int16 Verts_yt_urarm_Lo[];
extern int16 Verts_yt_lrarm_Lo[];
extern int16 Verts_yt_rhand_Lo[];
extern int16 Verts_yt_ularm_Lo[];
extern int16 Verts_yt_llarm_Lo[];
extern int16 Verts_yt_tum_Lo[];
extern int16 Verts_yt_lhand_Lo[];
extern int16 Verts_yt_ulleg_Lo[];
extern int16 Verts_jnt184_1_1_2_Lo[];
extern int16 Verts_jnt185_1_Lo[];









extern uint16 Ingame;




// ( 1 ) Call Initialise_Skeleton() before starting the game.  This will ensure that each character
//       player has their characters data ready.

// ( 2 ) Call Refresh_Skeleton(); once each frame.  This sets the double buffered
//       polygon list to the start of the currect buffer.

// ( 3 ) Call Draw_Character( uint8 PlayerNumber ) to do the animate and render the model.


//void TestScale( void );
void Draw_Character( uint8 PlayerNumber, uint8 Other );
void Initialise_Skeleton_Traverse( node *Node, vec3 Unt );
void Traverse_Matrix_Skeleton( uint8 PNum, node *Node, chmatrix *Rp, vec3 *Cursed );//, vec3 Unt );
void Draw_Skeleton_3d( node *Node, chfloat X, chfloat Y, chfloat Z, chfloat Rx, chfloat Ry, chfloat Rz );
void Initialise_Skeleton( void );
void LoadSkinAndTexture( uint16 i, uint16 HiLo, uint16 Suit );
void Refresh_Skeleton( void );
void Draw_Local_Model( uint8 PlayerNumber );

//void Traverse_PSX_Skeleton( uint8 PNum, node *Node, MATRIX Rp, VECTOR Cursed, VECTOR Unt );



#endif

