#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
//#include <libds.h>
#include <libcd.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"




// Skinner.exe : b_skin.c ( 205 vertices, 195 polygons )

uint32 b_skin_num_verts = 205;
uint32 b_skin_num_polys = 195;

chfloat b_skin_verts[] =
{
	CHFL( 40.724 ), CHFL( -4.34 ) , CHFL( -2.192 ),
	CHFL( 40.724 ), CHFL( -4.264 ) , CHFL( -12.776 ),
	CHFL( 43.432 ), CHFL( 6.84 ) , CHFL( -2.964 ),
	CHFL( 43.428 ), CHFL( 6.908 ) , CHFL( -11.936 ),
	CHFL( 40.732 ), CHFL( 6.756 ) , CHFL( 2.176 ),
	CHFL( 40.708 ), CHFL( 6.836 ) , CHFL( 12.956 ),
	CHFL( 43.448 ), CHFL( -4.408 ) , CHFL( 3.008 ),
	CHFL( 43.428 ), CHFL( -4.34 ) , CHFL( 12.232 ),
	CHFL( 78.96 ), CHFL( -4.12 ) , CHFL( 3.332 ),
	CHFL( 69.472 ), CHFL( -4.484 ) , CHFL( 3.576 ),
	CHFL( 69.64 ), CHFL( -2.872 ) , CHFL( 12.568 ),
	CHFL( 79.12 ), CHFL( -2.644 ) , CHFL( 11.356 ),
	CHFL( 69.308 ), CHFL( 10.02 ) , CHFL( 0.028 ),
	CHFL( 69.512 ), CHFL( 12.008 ) , CHFL( 11.22 ),
	CHFL( 96.656 ), CHFL( 4.532 ) , CHFL( 12.036 ),
	CHFL( 96.452 ), CHFL( 2.548 ) , CHFL( 0.88 ),
	CHFL( 94.248 ), CHFL( -0.464 ) , CHFL( 11.668 ),
	CHFL( 94.08 ), CHFL( -2.076 ) , CHFL( 2.676 ),
	CHFL( 78.992 ), CHFL( -3.92 ) , CHFL( -3.636 ),
	CHFL( 69.496 ), CHFL( -4.292 ) , CHFL( -3.828 ),
	CHFL( 69.608 ), CHFL( -3.012 ) , CHFL( -12.776 ),
	CHFL( 79.096 ), CHFL( -2.616 ) , CHFL( -12.588 ),
	CHFL( 69.312 ), CHFL( 10.296 ) , CHFL( -0.884 ),
	CHFL( 69.44 ), CHFL( 11.908 ) , CHFL( -11.96 ),
	CHFL( 96.604 ), CHFL( 4.508 ) , CHFL( -12.664 ),
	CHFL( 96.476 ), CHFL( 2.9 ) , CHFL( -1.628 ),
	CHFL( 94.212 ), CHFL( -0.496 ) , CHFL( -12.148 ),
	CHFL( 94.112 ), CHFL( -1.808 ) , CHFL( -3.152 ),
	CHFL( 81.372 ), CHFL( 8.656 ) , CHFL( -12.344 ),
	CHFL( 81.244 ), CHFL( 7.032 ) , CHFL( -1.204 ),
	CHFL( 81.232 ), CHFL( 6.74 ) , CHFL( 0.404 ),
	CHFL( 81.44 ), CHFL( 8.716 ) , CHFL( 11.536 ),
	CHFL( 62.696 ), CHFL( 5.928 ) , CHFL( 11.472 ),
	CHFL( 64.152 ), CHFL( -3.356 ) , CHFL( 11.492 ),
	CHFL( 64.172 ), CHFL( -3.416 ) , CHFL( 3.284 ),
	CHFL( 62.632 ), CHFL( -3.324 ) , CHFL( -11.64 ),
	CHFL( 64.224 ), CHFL( 5.968 ) , CHFL( -12.016 ),
	CHFL( 62.712 ), CHFL( 5.872 ) , CHFL( 4.08 ),
	CHFL( 64.228 ), CHFL( 5.904 ) , CHFL( -3.464 ),
	CHFL( 62.632 ), CHFL( -3.388 ) , CHFL( -3.432 ),
	CHFL( 12.856 ), CHFL( -5.432 ) , CHFL( -1.728 ),
	CHFL( 36.016 ), CHFL( -6.76 ) , CHFL( -2.196 ),
	CHFL( 36 ), CHFL( -6.684 ) , CHFL( -12.78 ),
	CHFL( 37.084 ), CHFL( 7.504 ) , CHFL( -11.888 ),
	CHFL( 37.092 ), CHFL( 7.436 ) , CHFL( -2.916 ),
	CHFL( 12.852 ), CHFL( 7.96 ) , CHFL( 13.14 ),
	CHFL( 36.028 ), CHFL( 9.168 ) , CHFL( 2.156 ),
	CHFL( 36.012 ), CHFL( 9.252 ) , CHFL( 12.94 ),
	CHFL( 37.068 ), CHFL( -4.944 ) , CHFL( 12.236 ),
	CHFL( 37.08 ), CHFL( -5.016 ) , CHFL( 3.016 ),
	CHFL( 72.48 ), CHFL( 3.832 ) , CHFL( 10.656 ),
	CHFL( 48.244 ), CHFL( 5.04 ) , CHFL( 10.376 ),
	CHFL( 72.888 ), CHFL( 11.812 ) , CHFL( 10.464 ),
	CHFL( 48.868 ), CHFL( 12.888 ) , CHFL( 10.168 ),
	CHFL( 73.496 ), CHFL( 11.976 ) , CHFL( 19.02 ),
	CHFL( 50.428 ), CHFL( 13.22 ) , CHFL( 18.752 ),
	CHFL( 73.084 ), CHFL( 3.972 ) , CHFL( 19.2 ),
	CHFL( 51.728 ), CHFL( 7.712 ) , CHFL( -4.164 ),
	CHFL( 49.784 ), CHFL( 4.968 ) , CHFL( 18.956 ),
	CHFL( 91.588 ), CHFL( 5.444 ) , CHFL( 11.248 ),
	CHFL( 74.564 ), CHFL( 4.532 ) , CHFL( 10.916 ),
	CHFL( 91.544 ), CHFL( 11.12 ) , CHFL( 11.108 ),
	CHFL( 73.604 ), CHFL( 11.216 ) , CHFL( 10.76 ),
	CHFL( 91.628 ), CHFL( 11.268 ) , CHFL( 17.56 ),
	CHFL( 73.708 ), CHFL( 11.4 ) , CHFL( 18.52 ),
	CHFL( 91.668 ), CHFL( 5.608 ) , CHFL( 17.696 ),
	CHFL( 74.664 ), CHFL( 4.688 ) , CHFL( 18.66 ),
	CHFL( 72.304 ), CHFL( -12.02 ) , CHFL( -10.32 ),
	CHFL( 48.088 ), CHFL( -10.768 ) , CHFL( -11.128 ),
	CHFL( 72.716 ), CHFL( -4.016 ) , CHFL( -10.424 ),
	CHFL( 48.712 ), CHFL( -2.92 ) , CHFL( -11.208 ),
	CHFL( 73.632 ), CHFL( -4.18 ) , CHFL( -18.98 ),
	CHFL( 50.596 ), CHFL( -2.92 ) , CHFL( -19.832 ),
	CHFL( 73.22 ), CHFL( -12.164 ) , CHFL( -18.868 ),
	CHFL( 49.952 ), CHFL( -11.172 ) , CHFL( -19.744 ),
	CHFL( 91.644 ), CHFL( -10.468 ) , CHFL( -11.548 ),
	CHFL( 74.632 ), CHFL( -11.332 ) , CHFL( -10.752 ),
	CHFL( 91.612 ), CHFL( -4.792 ) , CHFL( -11.616 ),
	CHFL( 73.684 ), CHFL( -4.644 ) , CHFL( -10.824 ),
	CHFL( 91.568 ), CHFL( -4.88 ) , CHFL( -18.108 ),
	CHFL( 73.632 ), CHFL( -4.748 ) , CHFL( -18.636 ),
	CHFL( 91.6 ), CHFL( -10.54 ) , CHFL( -18.04 ),
	CHFL( 74.576 ), CHFL( -11.464 ) , CHFL( -18.548 ),
	CHFL( 74.38 ), CHFL( 3.936 ) , CHFL( -9.288 ),
	CHFL( 74.44 ), CHFL( 9.824 ) , CHFL( 0.88 ),
	CHFL( 73.42 ), CHFL( -0.056 ) , CHFL( -8.396 ),
	CHFL( 73.488 ), CHFL( 7.056 ) , CHFL( 3.896 ),
	CHFL( 68.736 ), CHFL( 8.816 ) , CHFL( -3.724 ),
	CHFL( 68.712 ), CHFL( 7.452 ) , CHFL( -6.088 ),
	CHFL( 71.864 ), CHFL( 8.324 ) , CHFL( -5.08 ),
	CHFL( 66.276 ), CHFL( 5.232 ) , CHFL( -7.256 ),
	CHFL( 66.316 ), CHFL( 8.732 ) , CHFL( -1.204 ),
	CHFL( 66.72 ), CHFL( 5.236 ) , CHFL( 4.22 ),
	CHFL( 66.656 ), CHFL( -1.208 ) , CHFL( -6.924 ),
	CHFL( 62.492 ), CHFL( 2.032 ) , CHFL( -6.604 ),
	CHFL( 62.54 ), CHFL( 6.588 ) , CHFL( 1.272 ),
	CHFL( 64.248 ), CHFL( -3.416 ) , CHFL( 6.524 ),
	CHFL( 64.204 ), CHFL( -7.484 ) , CHFL( -0.512 ),
	CHFL( 73.6 ), CHFL( -6.704 ) , CHFL( -4.224 ),
	CHFL( 73.668 ), CHFL( 0.12 ) , CHFL( 7.572 ),
	CHFL( 68.816 ), CHFL( -7.088 ) , CHFL( -3.524 ),
	CHFL( 68.876 ), CHFL( -0.648 ) , CHFL( 7.6 ),
	CHFL( 37.564 ), CHFL( -13.64 ) , CHFL( 0.144 ),
	CHFL( 56.548 ), CHFL( -11.68 ) , CHFL( -4.516 ),
	CHFL( 56.488 ), CHFL( -2.608 ) , CHFL( 11.928 ),
	CHFL( 37.528 ), CHFL( -7.652 ) , CHFL( 10.996 ),
	CHFL( 56.288 ), CHFL( 2.392 ) , CHFL( 15.56 ),
	CHFL( 51.684 ), CHFL( 14 ) , CHFL( 7.232 ),
	CHFL( 61.272 ), CHFL( -3.828 ) , CHFL( 6.772 ),
	CHFL( 56.784 ), CHFL( 9.232 ) , CHFL( 14.868 ),
	CHFL( 56.804 ), CHFL( 6.368 ) , CHFL( 1.664 ),
	CHFL( 23.36 ), CHFL( 9.344 ) , CHFL( 7.16 ),
	CHFL( 56.408 ), CHFL( -12.08 ) , CHFL( -10.616 ),
	CHFL( 51.776 ), CHFL( 0.972 ) , CHFL( -16.388 ),
	CHFL( 61.3 ), CHFL( -7.9 ) , CHFL( -0.612 ),
	CHFL( 56.912 ), CHFL( -7.58 ) , CHFL( -15.628 ),
	CHFL( 56.828 ), CHFL( 1.808 ) , CHFL( -6.6 ),
	CHFL( 23.36 ), CHFL( 3.712 ) , CHFL( -12.136 ),
	CHFL( 92.004 ), CHFL( -10.684 ) , CHFL( -17.52 ),
	CHFL( 92.084 ), CHFL( 5.404 ) , CHFL( 17.32 ),
	CHFL( 91.784 ), CHFL( 11.38 ) , CHFL( 17.18 ),
	CHFL( 91.74 ), CHFL( -4.764 ) , CHFL( -17.596 ),
	CHFL( 41.46 ), CHFL( -0.38 ) , CHFL( 17.26 ),
	CHFL( 41.536 ), CHFL( -14.852 ) , CHFL( -9.028 ),
	CHFL( 22.672 ), CHFL( -6.604 ) , CHFL( 12.992 ),
	CHFL( 22.672 ), CHFL( -12.664 ) , CHFL( -7.792 ),
	CHFL( 39.112 ), CHFL( 2.268 ) , CHFL( -16.996 ),
	CHFL( 39.028 ), CHFL( 14.872 ) , CHFL( 5.864 ),
	CHFL( 91.696 ), CHFL( 11.224 ) , CHFL( 11.204 ),
	CHFL( 91.776 ), CHFL( -4.66 ) , CHFL( -11.868 ),
	CHFL( 92.048 ), CHFL( -10.624 ) , CHFL( -11.792 ),
	CHFL( 92.024 ), CHFL( 5.288 ) , CHFL( 11.324 ),
	CHFL( 13.628 ), CHFL( -7.72 ) , CHFL( 2.168 ),
	CHFL( 13.632 ), CHFL( 10.24 ) , CHFL( -12.684 ),
	CHFL( 13.16 ), CHFL( -15.792 ) , CHFL( -8.472 ),
	CHFL( 13.132 ), CHFL( -8.64 ) , CHFL( 16.048 ),
	CHFL( 78.712 ), CHFL( 7.536 ) , CHFL( 0.64 ),
	CHFL( 79.668 ), CHFL( 4.924 ) , CHFL( 2.832 ),
	CHFL( 78.664 ), CHFL( 2.832 ) , CHFL( -7.492 ),
	CHFL( 79.616 ), CHFL( -0.36 ) , CHFL( -6.304 ),
	CHFL( 79.644 ), CHFL( 5.572 ) , CHFL( -3.616 ),
	CHFL( 79.172 ), CHFL( -0.236 ) , CHFL( 5.996 ),
	CHFL( 79.12 ), CHFL( -5.568 ) , CHFL( -3.212 ),
	CHFL( 80.984 ), CHFL( 2.252 ) , CHFL( -1.664 ),
	CHFL( 80.696 ), CHFL( -2.24 ) , CHFL( 0.932 ),
	CHFL( 110.912 ), CHFL( -4.912 ) , CHFL( -12.052 ),
	CHFL( 111.124 ), CHFL( -10.56 ) , CHFL( -17.14 ),
	CHFL( 111.156 ), CHFL( -10.488 ) , CHFL( -11.976 ),
	CHFL( 110.884 ), CHFL( -5.004 ) , CHFL( -17.228 ),
	CHFL( 101.116 ), CHFL( -4.324 ) , CHFL( -19.18 ),
	CHFL( 101.732 ), CHFL( -14.424 ) , CHFL( -19.028 ),
	CHFL( 101.152 ), CHFL( -4.204 ) , CHFL( -11.996 ),
	CHFL( 101.788 ), CHFL( -14.324 ) , CHFL( -11.88 ),
	CHFL( 101.156 ), CHFL( 11.924 ) , CHFL( 18.448 ),
	CHFL( 101.064 ), CHFL( 11.736 ) , CHFL( 11.084 ),
	CHFL( 101.828 ), CHFL( 1.808 ) , CHFL( 18.672 ),
	CHFL( 101.764 ), CHFL( 1.644 ) , CHFL( 11.336 ),
	CHFL( 110.872 ), CHFL( 11.252 ) , CHFL( 16.352 ),
	CHFL( 111.184 ), CHFL( 5.684 ) , CHFL( 16.476 ),
	CHFL( 110.824 ), CHFL( 11.096 ) , CHFL( 10.996 ),
	CHFL( 111.112 ), CHFL( 5.568 ) , CHFL( 11.16 ),
	CHFL( 70.12 ), CHFL( 4.62 ) , CHFL( -9.08 ),
	CHFL( 70.176 ), CHFL( 10.004 ) , CHFL( 0.228 ),
	CHFL( 74.46 ), CHFL( 7.82 ) , CHFL( -4.748 ),
	CHFL( 15.08 ), CHFL( -5.86 ) , CHFL( -12.916 ),
	CHFL( 15.104 ), CHFL( 8.38 ) , CHFL( 2.056 ),
	CHFL( 67.124 ), CHFL( -6.78 ) , CHFL( 1.916 ),
	CHFL( 67.14 ), CHFL( -5.204 ) , CHFL( 4.636 ),
	CHFL( 77.964 ), CHFL( -4.924 ) , CHFL( 4.2 ),
	CHFL( 74.612 ), CHFL( -5.832 ) , CHFL( 5.436 ),
	CHFL( 77.952 ), CHFL( -6.332 ) , CHFL( 1.764 ),
	CHFL( 74.592 ), CHFL( -7.832 ) , CHFL( 1.972 ),
	CHFL( 68.856 ), CHFL( 8.892 ) , CHFL( -5.344 ),
	CHFL( 62.544 ), CHFL( 7.924 ) , CHFL( -4.748 ),
	CHFL( 69.204 ), CHFL( 10.008 ) , CHFL( -5.992 ),
	CHFL( 23.32 ), CHFL( 8.756 ) , CHFL( -2.804 ),
	CHFL( 39.064 ), CHFL( 8.908 ) , CHFL( -5 ),
	CHFL( 76.772 ), CHFL( 5.44 ) , CHFL( 17.332 ),
	CHFL( 76.36 ), CHFL( 5.344 ) , CHFL( 11.52 ),
	CHFL( 77.008 ), CHFL( 10.084 ) , CHFL( 17.224 ),
	CHFL( 76.596 ), CHFL( 9.972 ) , CHFL( 11.408 ),
	CHFL( 76.86 ), CHFL( -10.644 ) , CHFL( -17.144 ),
	CHFL( 77.1 ), CHFL( -6.008 ) , CHFL( -17.212 ),
	CHFL( 76.48 ), CHFL( -5.896 ) , CHFL( -11.412 ),
	CHFL( 76.244 ), CHFL( -10.52 ) , CHFL( -11.352 ),
	CHFL( 93.428 ), CHFL( -6.384 ) , CHFL( -13.12 ),
	CHFL( 93.404 ), CHFL( -6.432 ) , CHFL( -16.516 ),
	CHFL( 93.44 ), CHFL( -8.88 ) , CHFL( -13.088 ),
	CHFL( 93.416 ), CHFL( -8.936 ) , CHFL( -16.484 ),
	CHFL( 93.436 ), CHFL( 9.652 ) , CHFL( 15.988 ),
	CHFL( 93.392 ), CHFL( 9.576 ) , CHFL( 12.632 ),
	CHFL( 93.408 ), CHFL( 7.064 ) , CHFL( 12.696 ),
	CHFL( 93.452 ), CHFL( 7.148 ) , CHFL( 16.048 ),
	CHFL( 70.86 ), CHFL( -5.804 ) , CHFL( 5.204 ),
	CHFL( 70.844 ), CHFL( -7.592 ) , CHFL( 2.108 ),
	CHFL( 18.928 ), CHFL( 9.94 ) , CHFL( -1.572 ),
	CHFL( 18.928 ), CHFL( 9.948 ) , CHFL( 1.076 ),
	CHFL( 58.72 ), CHFL( -8.328 ) , CHFL( 2.196 ),
	CHFL( 57.86 ), CHFL( 10.444 ) , CHFL( 1.544 ),
	CHFL( 58.696 ), CHFL( -8.252 ) , CHFL( 12.392 ),
	CHFL( 57.832 ), CHFL( 10.536 ) , CHFL( 13.568 ),
	CHFL( 57.864 ), CHFL( -7.996 ) , CHFL( -1.328 ),
	CHFL( 58.684 ), CHFL( 10.78 ) , CHFL( -2.776 ),
	CHFL( 57.86 ), CHFL( -7.904 ) , CHFL( -13.5 ),
	CHFL( 58.68 ), CHFL( 10.852 ) , CHFL( -12.768 ),
};


chfloat b_skin_norms[] =
{
	CHFL( 0.132 ), CHFL( -0.991 ) , CHFL( -0.008 ),
	CHFL( 0.132 ), CHFL( -0.991 ) , CHFL( -0.008 ),
	CHFL( -0.067 ), CHFL( 0.721 ) , CHFL( 0.69 ),
	CHFL( -0.076 ), CHFL( 0.724 ) , CHFL( -0.685 ),
	CHFL( 0.131 ), CHFL( 0.991 ) , CHFL( -0.007 ),
	CHFL( 0.131 ), CHFL( 0.991 ) , CHFL( -0.007 ),
	CHFL( -0.072 ), CHFL( -0.723 ) , CHFL( -0.687 ),
	CHFL( -0.065 ), CHFL( -0.719 ) , CHFL( 0.692 ),
	CHFL( 0.148 ), CHFL( -0.989 ) , CHFL( -0.008 ),
	CHFL( -0.404 ), CHFL( -0.144 ) , CHFL( -0.903 ),
	CHFL( -0.665 ), CHFL( 0.329 ) , CHFL( -0.671 ),
	CHFL( 0.142 ), CHFL( -0.603 ) , CHFL( 0.785 ),
	CHFL( -0.723 ), CHFL( -0.177 ) , CHFL( -0.668 ),
	CHFL( -1 ), CHFL( -0.007 ) , CHFL( 0.02 ),
	CHFL( 0.601 ), CHFL( -0.319 ) , CHFL( 0.733 ),
	CHFL( 0.604 ), CHFL( -0.499 ) , CHFL( -0.621 ),
	CHFL( 0.469 ), CHFL( -0.67 ) , CHFL( 0.576 ),
	CHFL( 0.48 ), CHFL( -0.807 ) , CHFL( -0.344 ),
	CHFL( 0.048 ), CHFL( -0.65 ) , CHFL( 0.758 ),
	CHFL( -0.038 ), CHFL( 0.174 ) , CHFL( 0.984 ),
	CHFL( -0.14 ), CHFL( 0.161 ) , CHFL( -0.977 ),
	CHFL( -0.002 ), CHFL( -0.558 ) , CHFL( -0.83 ),
	CHFL( -0.719 ), CHFL( -0.151 ) , CHFL( 0.679 ),
	CHFL( -0.704 ), CHFL( 0.021 ) , CHFL( -0.71 ),
	CHFL( 0.618 ), CHFL( -0.31 ) , CHFL( -0.722 ),
	CHFL( 0.612 ), CHFL( -0.469 ) , CHFL( 0.637 ),
	CHFL( 0.488 ), CHFL( -0.67 ) , CHFL( -0.559 ),
	CHFL( 0.488 ), CHFL( -0.79 ) , CHFL( 0.371 ),
	CHFL( -0.001 ), CHFL( 0.012 ) , CHFL( -1 ),
	CHFL( -0.02 ), CHFL( -0.222 ) , CHFL( 0.975 ),
	CHFL( -0.027 ), CHFL( -0.265 ) , CHFL( -0.964 ),
	CHFL( 0.01 ), CHFL( 0.008 ) , CHFL( 1 ),
	CHFL( 0.411 ), CHFL( -0.004 ) , CHFL( 0.912 ),
	CHFL( 0.804 ), CHFL( -0.353 ) , CHFL( 0.478 ),
	CHFL( 0.505 ), CHFL( -0.22 ) , CHFL( -0.835 ),
	CHFL( 0.273 ), CHFL( -0.662 ) , CHFL( -0.698 ),
	CHFL( 0.604 ), CHFL( 0.382 ) , CHFL( -0.7 ),
	CHFL( 0.836 ), CHFL( -0.022 ) , CHFL( -0.548 ),
	CHFL( 0.611 ), CHFL( 0.442 ) , CHFL( 0.657 ),
	CHFL( 0.384 ), CHFL( -0.6 ) , CHFL( 0.702 ),
	CHFL( -0.683 ), CHFL( -0.306 ) , CHFL( 0.663 ),
	CHFL( 0.211 ), CHFL( -0.977 ) , CHFL( 0.002 ),
	CHFL( 0.211 ), CHFL( -0.977 ) , CHFL( 0.002 ),
	CHFL( 0.078 ), CHFL( 0.721 ) , CHFL( -0.689 ),
	CHFL( 0.089 ), CHFL( 0.716 ) , CHFL( 0.693 ),
	CHFL( -0.743 ), CHFL( 0.517 ) , CHFL( -0.426 ),
	CHFL( 0.212 ), CHFL( 0.977 ) , CHFL( 0.002 ),
	CHFL( 0.212 ), CHFL( 0.977 ) , CHFL( 0.002 ),
	CHFL( -0.198 ), CHFL( -0.648 ) , CHFL( 0.735 ),
	CHFL( -0.132 ), CHFL( -0.779 ) , CHFL( -0.613 ),
	CHFL( 0.196 ), CHFL( -0.697 ) , CHFL( -0.69 ),
	CHFL( -0.981 ), CHFL( 0.082 ) , CHFL( 0.176 ),
	CHFL( 0.261 ), CHFL( 0.641 ) , CHFL( -0.722 ),
	CHFL( -0.561 ), CHFL( 0.642 ) , CHFL( -0.523 ),
	CHFL( 0.339 ), CHFL( 0.683 ) , CHFL( 0.647 ),
	CHFL( -0.51 ), CHFL( 0.598 ) , CHFL( 0.618 ),
	CHFL( 0.273 ), CHFL( -0.683 ) , CHFL( 0.677 ),
	CHFL( 0.431 ), CHFL( 0.791 ) , CHFL( -0.434 ),
	CHFL( -0.643 ), CHFL( 0.069 ) , CHFL( 0.763 ),
	CHFL( 0.479 ), CHFL( -0.628 ) , CHFL( -0.613 ),
	CHFL( 0.052 ), CHFL( -0.721 ) , CHFL( -0.691 ),
	CHFL( 0.463 ), CHFL( 0.608 ) , CHFL( -0.645 ),
	CHFL( 0.018 ), CHFL( 0.691 ) , CHFL( -0.723 ),
	CHFL( 0.488 ), CHFL( 0.637 ) , CHFL( 0.597 ),
	CHFL( 0.043 ), CHFL( 0.724 ) , CHFL( 0.688 ),
	CHFL( 0.504 ), CHFL( -0.597 ) , CHFL( 0.623 ),
	CHFL( 0.054 ), CHFL( -0.998 ) , CHFL( 0.022 ),
	CHFL( 0.189 ), CHFL( -0.671 ) , CHFL( 0.717 ),
	CHFL( -0.974 ), CHFL( 0.074 ) , CHFL( -0.214 ),
	CHFL( 0.254 ), CHFL( 0.667 ) , CHFL( 0.7 ),
	CHFL( -0.581 ), CHFL( 0.66 ) , CHFL( 0.476 ),
	CHFL( 0.35 ), CHFL( 0.657 ) , CHFL( -0.667 ),
	CHFL( -0.483 ), CHFL( 0.575 ) , CHFL( -0.66 ),
	CHFL( 0.283 ), CHFL( -0.706 ) , CHFL( -0.649 ),
	CHFL( -0.611 ), CHFL( 0.039 ) , CHFL( -0.791 ),
	CHFL( 0.493 ), CHFL( -0.604 ) , CHFL( 0.626 ),
	CHFL( 0.069 ), CHFL( -0.695 ) , CHFL( 0.716 ),
	CHFL( 0.477 ), CHFL( 0.63 ) , CHFL( 0.613 ),
	CHFL( 0.037 ), CHFL( 0.717 ) , CHFL( 0.696 ),
	CHFL( 0.474 ), CHFL( 0.615 ) , CHFL( -0.63 ),
	CHFL( 0.026 ), CHFL( 0.699 ) , CHFL( -0.715 ),
	CHFL( 0.491 ), CHFL( -0.62 ) , CHFL( -0.611 ),
	CHFL( 0.03 ), CHFL( -0.01 ) , CHFL( -1 ),
	CHFL( 0.218 ), CHFL( 0.271 ) , CHFL( -0.938 ),
	CHFL( 0.24 ), CHFL( 0.944 ) , CHFL( 0.228 ),
	CHFL( 0.086 ), CHFL( -0.397 ) , CHFL( -0.914 ),
	CHFL( 0.114 ), CHFL( 0.595 ) , CHFL( 0.796 ),
	CHFL( -0.279 ), CHFL( 0.96 ) , CHFL( 0.023 ),
	CHFL( -0.29 ), CHFL( 0.46 ) , CHFL( -0.839 ),
	CHFL( 0.148 ), CHFL( 0.855 ) , CHFL( -0.498 ),
	CHFL( -0.252 ), CHFL( 0.339 ) , CHFL( -0.907 ),
	CHFL( -0.247 ), CHFL( 0.956 ) , CHFL( 0.16 ),
	CHFL( -0.279 ), CHFL( 0.665 ) , CHFL( 0.693 ),
	CHFL( -0.288 ), CHFL( -0.268 ) , CHFL( -0.919 ),
	CHFL( -0.524 ), CHFL( -0.3 ) , CHFL( -0.797 ),
	CHFL( -0.522 ), CHFL( 0.538 ) , CHFL( 0.662 ),
	CHFL( -0.13 ), CHFL( -0.373 ) , CHFL( 0.919 ),
	CHFL( -0.13 ), CHFL( -0.982 ) , CHFL( -0.139 ),
	CHFL( 0.129 ), CHFL( -0.828 ) , CHFL( -0.546 ),
	CHFL( 0.146 ), CHFL( 0.062 ) , CHFL( 0.987 ),
	CHFL( -0.161 ), CHFL( -0.87 ) , CHFL( -0.467 ),
	CHFL( -0.15 ), CHFL( -0.028 ) , CHFL( 0.988 ),
	CHFL( 0.032 ), CHFL( -0.962 ) , CHFL( 0.27 ),
	CHFL( 0.404 ), CHFL( -0.88 ) , CHFL( 0.248 ),
	CHFL( 0.398 ), CHFL( -0.682 ) , CHFL( 0.613 ),
	CHFL( 0.075 ), CHFL( -0.799 ) , CHFL( 0.596 ),
	CHFL( 0.055 ), CHFL( -0.039 ) , CHFL( 0.998 ),
	CHFL( 0.272 ), CHFL( 0.949 ) , CHFL( 0.157 ),
	CHFL( 0.651 ), CHFL( -0.283 ) , CHFL( 0.704 ),
	CHFL( 0.948 ), CHFL( 0.176 ) , CHFL( 0.265 ),
	CHFL( 0.545 ), CHFL( 0.83 ) , CHFL( -0.121 ),
	CHFL( -0.384 ), CHFL( 0.821 ) , CHFL( 0.422 ),
	CHFL( 0.089 ), CHFL( -0.855 ) , CHFL( -0.511 ),
	CHFL( 0.299 ), CHFL( 0.342 ) , CHFL( -0.891 ),
	CHFL( 0.66 ), CHFL( -0.74 ) , CHFL( -0.127 ),
	CHFL( 0.95 ), CHFL( -0.116 ) , CHFL( -0.288 ),
	CHFL( 0.551 ), CHFL( 0.539 ) , CHFL( -0.637 ),
	CHFL( -0.095 ), CHFL( 0.132 ) , CHFL( -0.987 ),
	CHFL( -0.356 ), CHFL( -0.656 ) , CHFL( -0.666 ),
	CHFL( -0.332 ), CHFL( -0.635 ) , CHFL( 0.698 ),
	CHFL( -0.133 ), CHFL( 0.717 ) , CHFL( 0.684 ),
	CHFL( -0.15 ), CHFL( 0.689 ) , CHFL( -0.709 ),
	CHFL( -0.013 ), CHFL( -0.085 ) , CHFL( 0.996 ),
	CHFL( -0.049 ), CHFL( -0.862 ) , CHFL( -0.505 ),
	CHFL( 0.054 ), CHFL( -0.482 ) , CHFL( 0.875 ),
	CHFL( -0.001 ), CHFL( -0.947 ) , CHFL( -0.321 ),
	CHFL( -0.056 ), CHFL( 0.332 ) , CHFL( -0.942 ),
	CHFL( -0.116 ), CHFL( 0.948 ) , CHFL( 0.297 ),
	CHFL( -0.046 ), CHFL( 0.688 ) , CHFL( -0.724 ),
	CHFL( 0.013 ), CHFL( 0.013 ) , CHFL( 1 ),
	CHFL( 0.013 ), CHFL( 0.013 ) , CHFL( 1 ),
	CHFL( -0.254 ), CHFL( -0.678 ) , CHFL( -0.69 ),
	CHFL( -0.549 ), CHFL( -0.813 ) , CHFL( -0.192 ),
	CHFL( -0.725 ), CHFL( 0.474 ) , CHFL( -0.501 ),
	CHFL( -0.642 ), CHFL( -0.503 ) , CHFL( -0.579 ),
	CHFL( -0.483 ), CHFL( 0.021 ) , CHFL( 0.876 ),
	CHFL( 0.666 ), CHFL( 0.729 ) , CHFL( 0.157 ),
	CHFL( 0.729 ), CHFL( 0.451 ) , CHFL( 0.515 ),
	CHFL( 0.647 ), CHFL( 0.225 ) , CHFL( -0.728 ),
	CHFL( 0.71 ), CHFL( -0.236 ) , CHFL( -0.663 ),
	CHFL( 0.749 ), CHFL( 0.573 ) , CHFL( -0.334 ),
	CHFL( 0.709 ), CHFL( -0.05 ) , CHFL( 0.703 ),
	CHFL( 0.695 ), CHFL( -0.647 ) , CHFL( -0.313 ),
	CHFL( 0.992 ), CHFL( 0.11 ) , CHFL( -0.068 ),
	CHFL( 0.93 ), CHFL( -0.32 ) , CHFL( 0.179 ),
	CHFL( 0.717 ), CHFL( 0.697 ) , CHFL( -0.016 ),
	CHFL( 0.767 ), CHFL( -0.431 ) , CHFL( -0.475 ),
	CHFL( 0.722 ), CHFL( -0.453 ) , CHFL( 0.523 ),
	CHFL( 0.66 ), CHFL( 0.539 ) , CHFL( -0.523 ),
	CHFL( 0.02 ), CHFL( 0.701 ) , CHFL( -0.713 ),
	CHFL( 0.021 ), CHFL( -0.697 ) , CHFL( -0.717 ),
	CHFL( 0.012 ), CHFL( 1 ) , CHFL( -0.017 ),
	CHFL( 0.015 ), CHFL( -0.671 ) , CHFL( 0.741 ),
	CHFL( 0.032 ), CHFL( 0.73 ) , CHFL( 0.683 ),
	CHFL( -0.003 ), CHFL( 0.688 ) , CHFL( -0.726 ),
	CHFL( 0.043 ), CHFL( -0.669 ) , CHFL( 0.742 ),
	CHFL( 0.007 ), CHFL( -0.698 ) , CHFL( -0.716 ),
	CHFL( 0.665 ), CHFL( 0.566 ) , CHFL( 0.487 ),
	CHFL( 0.779 ), CHFL( -0.406 ) , CHFL( 0.477 ),
	CHFL( 0.585 ), CHFL( 0.569 ) , CHFL( -0.578 ),
	CHFL( 0.717 ), CHFL( -0.466 ) , CHFL( -0.519 ),
	CHFL( -0.157 ), CHFL( 0.32 ) , CHFL( -0.934 ),
	CHFL( -0.152 ), CHFL( 0.97 ) , CHFL( 0.188 ),
	CHFL( 0.293 ), CHFL( 0.827 ) , CHFL( -0.48 ),
	CHFL( -0.382 ), CHFL( -0.304 ) , CHFL( -0.873 ),
	CHFL( -0.668 ), CHFL( 0.626 ) , CHFL( -0.402 ),
	CHFL( -0.154 ), CHFL( -0.923 ) , CHFL( 0.352 ),
	CHFL( -0.151 ), CHFL( -0.765 ) , CHFL( 0.626 ),
	CHFL( 0.636 ), CHFL( -0.541 ) , CHFL( 0.55 ),
	CHFL( 0.178 ), CHFL( -0.64 ) , CHFL( 0.748 ),
	CHFL( 0.633 ), CHFL( -0.751 ) , CHFL( 0.189 ),
	CHFL( 0.174 ), CHFL( -0.968 ) , CHFL( 0.18 ),
	CHFL( -0.524 ), CHFL( 0.74 ) , CHFL( -0.422 ),
	CHFL( -0.522 ), CHFL( 0.74 ) , CHFL( -0.424 ),
	CHFL( 0.339 ), CHFL( 0.802 ) , CHFL( 0.491 ),
	CHFL( -0.504 ), CHFL( 0.695 ) , CHFL( -0.512 ),
	CHFL( -0.012 ), CHFL( 0.899 ) , CHFL( -0.439 ),
	CHFL( 0.818 ), CHFL( -0.445 ) , CHFL( 0.366 ),
	CHFL( 0.736 ), CHFL( -0.471 ) , CHFL( -0.487 ),
	CHFL( 0.859 ), CHFL( 0.376 ) , CHFL( 0.348 ),
	CHFL( 0.779 ), CHFL( 0.371 ) , CHFL( -0.506 ),
	CHFL( 0.821 ), CHFL( -0.463 ) , CHFL( -0.335 ),
	CHFL( 0.862 ), CHFL( 0.369 ) , CHFL( -0.347 ),
	CHFL( 0.774 ), CHFL( 0.383 ) , CHFL( 0.504 ),
	CHFL( 0.733 ), CHFL( -0.445 ) , CHFL( 0.514 ),
	CHFL( 0.906 ), CHFL( 0.306 ) , CHFL( 0.293 ),
	CHFL( 0.905 ), CHFL( 0.297 ) , CHFL( -0.306 ),
	CHFL( 0.909 ), CHFL( -0.288 ) , CHFL( 0.3 ),
	CHFL( 0.908 ), CHFL( -0.294 ) , CHFL( -0.298 ),
	CHFL( 0.91 ), CHFL( 0.308 ) , CHFL( 0.276 ),
	CHFL( 0.9 ), CHFL( 0.295 ) , CHFL( -0.322 ),
	CHFL( 0.903 ), CHFL( -0.3 ) , CHFL( -0.307 ),
	CHFL( 0.914 ), CHFL( -0.283 ) , CHFL( 0.291 ),
	CHFL( -0.069 ), CHFL( -0.687 ) , CHFL( 0.723 ),
	CHFL( -0.073 ), CHFL( -0.969 ) , CHFL( 0.236 ),
	CHFL( -0.401 ), CHFL( 0.449 ) , CHFL( 0.798 ),
	CHFL( 0.054 ), CHFL( -0.673 ) , CHFL( 0.738 ),
	CHFL( 0.263 ), CHFL( -0.646 ) , CHFL( -0.717 ),
	CHFL( 0.283 ), CHFL( 0.626 ) , CHFL( -0.727 ),
	CHFL( 0.246 ), CHFL( -0.653 ) , CHFL( 0.717 ),
	CHFL( 0.277 ), CHFL( 0.615 ) , CHFL( 0.738 ),
	CHFL( 0.273 ), CHFL( -0.609 ) , CHFL( 0.745 ),
	CHFL( 0.231 ), CHFL( 0.66 ) , CHFL( 0.714 ),
	CHFL( 0.256 ), CHFL( -0.619 ) , CHFL( -0.743 ),
	CHFL( 0.225 ), CHFL( 0.654 ) , CHFL( -0.722 ),
};


model_polys b_skin_polys[] =
{
	{
		GOURAUD,
		4,
		204, 3, 2, 202,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		31, 13, 10, 11,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		12, 30, 8, 9,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		23, 28, 21, 20,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		30, 15, 17, 8,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		22, 19, 18, 29,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		18, 27, 25, 29,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		28, 24, 26, 21,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		202, 2, 0, 201,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		22, 23, 20, 19,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		197, 6, 4, 198,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		19, 20, 36, 38,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		199, 7, 6, 197,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		18, 19, 38, 39,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		21, 18, 39, 35,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		203, 35, 39, 201,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		20, 21, 35, 36,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		13, 12, 9, 10,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		201, 39, 38, 202,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		201, 0, 1, 203,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		204, 36, 35, 203,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		200, 32, 37, 198,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		202, 38, 36, 204,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		15, 14, 16, 17,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		26, 27, 18, 21,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		17, 16, 11, 8,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		24, 25, 27, 26,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		200, 5, 7, 199,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		11, 16, 14, 31,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		203, 1, 3, 204,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		65, 59, 191, 192,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		118, 121, 149, 150,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		63, 65, 192, 189,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		111, 165, 135, 0,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		59, 61, 190, 191,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		135, 124, 111, 0,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		122, 106, 107, 127,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		77, 79, 80, 78,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		112, 113, 115, 0,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		61, 63, 189, 190,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		194, 171, 169, 193,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		75, 81, 188, 187,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		67, 73, 181, 184,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		81, 79, 186, 188,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		111, 124, 122, 127,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		77, 75, 187, 185,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		94, 95, 173, 0,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		0, 2, 44, 41,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		79, 77, 185, 186,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		2, 3, 43, 44,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		117, 126, 123, 125,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		86, 137, 136, 84,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		123, 126, 113, 112,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		184, 181, 182, 183,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		124, 125, 102, 105,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		3, 1, 42, 43,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		57, 113, 126, 176,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		176, 126, 117, 175,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		1, 0, 41, 42,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		148, 145, 147, 146,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		116, 113, 57, 0,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		153, 155, 158, 157,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		49, 48, 196, 132,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		151, 152, 147, 145,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		85, 139, 142, 98,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		125, 123, 102, 0,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		173, 172, 88, 90,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		150, 149, 148, 146,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		69, 67, 184, 183,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		159, 157, 158, 160,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		90, 88, 89, 161,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		121, 129, 151, 149,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		52, 54, 179, 180,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		144, 142, 139, 143,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		71, 69, 183, 182,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		75, 77, 78, 76,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		56, 50, 178, 177,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		190, 189, 192, 191,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		88, 172, 87, 174,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		132, 196, 135, 0,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		154, 153, 157, 159,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		106, 104, 108, 109,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		81, 75, 76, 82,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		101, 193, 169, 99,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		152, 150, 146, 147,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		124, 105, 122, 0,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		79, 81, 82, 80,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		103, 112, 115, 114,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		102, 123, 112, 103,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		44, 43, 133, 195,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		144, 143, 137, 141,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		50, 52, 180, 178,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		122, 105, 104, 106,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		98, 142, 170, 171,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		89, 162, 84, 163,
		{ 0, 0, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		173, 95, 92, 91,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		94, 173, 90, 93,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		87, 91, 162, 89,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		170, 142, 144, 0,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		47, 45, 196, 48,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		41, 44, 195, 40,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		47, 46, 165, 45,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		168, 144, 141, 0,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		46, 49, 132, 165,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		42, 164, 133, 43,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		96, 167, 193, 101,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		134, 164, 117, 0,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		125, 124, 135, 134,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		109, 107, 106, 0,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		57, 107, 110, 0,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		130, 118, 150, 152,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		173, 91, 87, 172,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		88, 174, 89, 0,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		166, 97, 100, 194,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		54, 52, 53, 55,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		116, 94, 97, 114,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		129, 130, 152, 151,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		52, 50, 51, 53,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		140, 136, 137, 143,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		42, 41, 40, 164,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		195, 133, 134, 0,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		50, 56, 58, 51,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		143, 139, 138, 140,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		56, 54, 55, 58,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		177, 178, 180, 179,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		96, 97, 166, 167,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		128, 120, 153, 154,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		113, 116, 114, 115,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		175, 111, 127, 176,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		45, 165, 111, 175,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		40, 45, 175, 0,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		54, 56, 177, 179,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		73, 71, 182, 181,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		65, 63, 64, 66,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		59, 65, 66, 60,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		195, 196, 45, 40,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		193, 167, 166, 194,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		61, 59, 60, 62,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		63, 61, 62, 64,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		40, 175, 117, 164,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		116, 110, 95, 94,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		155, 156, 160, 158,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		196, 195, 134, 135,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		163, 83, 161, 89,
		{ 0, 0, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		71, 73, 74, 72,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		165, 132, 135, 0,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		92, 101, 99, 86,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		69, 71, 72, 70,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		95, 96, 101, 92,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		85, 83, 138, 139,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		119, 131, 156, 155,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		73, 67, 68, 74,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		83, 163, 140, 138,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		67, 69, 70, 68,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		51, 58, 55, 53,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		105, 102, 103, 104,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		174, 87, 89, 0,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		74, 68, 70, 72,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		133, 164, 134, 0,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		168, 170, 144, 0,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		149, 151, 145, 148,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		169, 171, 170, 168,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		94, 93, 100, 97,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		91, 92, 162, 0,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		176, 127, 107, 57,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		93, 85, 98, 100,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		117, 125, 134, 0,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		163, 84, 136, 140,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		110, 108, 96, 95,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		107, 109, 108, 110,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		141, 99, 169, 168,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		185, 187, 188, 186,
		{ 255, 182, 0, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		156, 154, 159, 160,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		86, 99, 141, 137,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		108, 114, 97, 96,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		110, 116, 57, 0,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		194, 100, 98, 171,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		93, 161, 83, 85,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		131, 128, 154, 156,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		120, 119, 155, 153,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		104, 103, 114, 108,
		{ 9, 9, 4, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		93, 90, 161, 0,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		162, 92, 86, 84,
		{ 205, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		6, 7, 48, 49,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		7, 5, 47, 48,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		4, 6, 49, 46,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		5, 4, 46, 47,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		198, 4, 5, 200,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		198, 37, 34, 197,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		197, 34, 33, 199,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		199, 33, 32, 200,
		{ 0, 9, 63, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		9, 8, 32, 33,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		8, 11, 37, 32,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		11, 10, 34, 37,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		10, 9, 33, 34,
		{ 0, 58, 44, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
};
