
#include "ourtypes.h"
#include "skeleton.h"

#define NULL 0


node LeftFoot =
{
	CHFL(-0.5), CHFL( 0.2 ), CHFL( 0.0 ),
	CHFL(0.0), CHFL(0.0), CHFL(0.0),
	1,
	NULL
};


node LeftShin =
{
	CHFL( -0.5), CHFL( 1.0 ), CHFL( 0.0 ),
	CHFL(0.0), CHFL(0.0), CHFL(0.0),
	1,
	&LeftFoot
};


node Left =
{
	CHFL( -1.0), CHFL( 1.0 ), CHFL( 0.0 ),
	CHFL(0.0), CHFL(0.0), CHFL(0.0),
	1,
	&LeftShin
};

node Right =
{
	CHFL( 1.0), CHFL( 1.0 ), CHFL( 0.0 ),
	CHFL(0.0), CHFL(0.0), CHFL(0.0),
	1,
	NULL
};


node TOP =
{
	CHFL(0.0), CHFL(0.0), CHFL(0.0),
	CHFL(0.0), CHFL(0.0), CHFL(0.0),
	2,
	&Left,
	&Right
};


// Here is the basic frame


node eff104_3 =
{
	CHFL( 1.200000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	NULL
};

node jnt70_5_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 7.221000 ), CHFL( -97.171997 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff104_3	// Effector
};

node chn101_1 =
{
	CHFL( -0.010000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 92.679001 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt70_5_1	// Joint
};

node eff103_1 =
{
	CHFL( 1.667000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&chn101_1,	// Chain Root
	NULL
};

node jnt69_5_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 1.718000 ), CHFL( -98.426003 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff103_1	// Effector
};

node rarm4_1 =
{
	CHFL( -0.038000 ), CHFL( -0.047000 ), CHFL( -0.008000 ),	// Tx, Ty, Tz
	CHFL( -0.057000 ), CHFL( 0.398000 ), CHFL( 102.613998 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt69_5_1	// Joint
};

node eff102_3 =
{
	CHFL( 1.830000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&rarm4_1,	// Chain Root
	NULL
};

node jnt88_2_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( -5.861000 ), CHFL( -96.582001 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff102_3	// Effector
};

node chn100_1 =
{
	CHFL( -0.017000 ), CHFL( 0.010000 ), CHFL( 0.002000 ),	// Tx, Ty, Tz
	CHFL( 90.147003 ), CHFL( -86.196999 ), CHFL( -245.852005 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt88_2_1	// Joint
};

node eff101_1 =
{
	CHFL( 0.692000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&chn100_1,	// Chain Root
	NULL
};

node jnt86_2_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( -2.098000 ), CHFL( 157.494995 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff101_1	// Effector
};

node chn99_1 =
{
	CHFL( -1.426000 ), CHFL( 1.065000 ), CHFL( 0.013000 ),	// Tx, Ty, Tz
	CHFL( -13.527000 ), CHFL( 3.422000 ), CHFL( -90.385002 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt86_2_1	// Joint
};

node eff102_1_1 =
{
	CHFL( 1.219000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	NULL
};

node jnt102_2_1 =
{
	CHFL( 0.262000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( -1.665000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff102_1_1	// Effector
};

node jnt102_1_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.087000 ), CHFL( 0.964000 ), CHFL( 94.121002 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt102_2_1	// Joint
};

node chn102_1 =
{
	CHFL( 0.123000 ), CHFL( -0.017000 ), CHFL( -0.039000 ),	// Tx, Ty, Tz
	CHFL( 215.488998 ), CHFL( 85.777000 ), CHFL( 125.303001 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt102_1_1	// Joint
};

node eff100_1 =
{
	CHFL( 1.200000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	NULL
};

node jnt70_4_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( -3.572000 ), CHFL( -96.811996 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff100_1	// Effector
};

node chn98_1 =
{
	CHFL( -0.010000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 92.679001 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt70_4_1	// Joint
};

node eff99_1 =
{
	CHFL( 1.667000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&chn98_1,	// Chain Root
	NULL
};

node jnt69_4_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( -5.873000 ), CHFL( -102.837997 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff99_1	// Effector
};

node rarm3_1 =
{
	CHFL( -0.024000 ), CHFL( 0.023000 ), CHFL( -0.007000 ),	// Tx, Ty, Tz
	CHFL( 0.214000 ), CHFL( -0.056000 ), CHFL( 104.751999 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt69_4_1	// Joint
};

node eff98_1 =
{
	CHFL( 1.830000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&rarm3_1,	// Chain Root
	NULL
};

node jnt68_4_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 6.409000 ), CHFL( -96.570999 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff98_1	// Effector
};

node relbow3_1 =
{
	CHFL( -0.046000 ), CHFL( 0.019000 ), CHFL( 0.004000 ),	// Tx, Ty, Tz
	CHFL( 89.852997 ), CHFL( -86.196999 ), CHFL( -116.364998 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt68_4_1	// Joint
};

node eff97_1 =
{
	CHFL( 0.695000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&relbow3_1,	// Chain Root
	NULL
};

node jnt87_2_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( -1.774000 ), CHFL( 25.087000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff97_1	// Effector
};

node chn97_1 =
{
	CHFL( -1.421000 ), CHFL( -1.188000 ), CHFL( -0.124000 ),	// Tx, Ty, Tz
	CHFL( -13.527000 ), CHFL( 3.422000 ), CHFL( -90.385002 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt87_2_1	// Joint
};

node eff109 =
{
	CHFL( 1.544000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	4,	// NumberOfChildren
	&chn97_1,	// Chain Root
	&chn102_1,	// Chain Root
	&chn99_1,	// Chain Root
	NULL
};

node jnt109_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( -2.044000 ), CHFL( 89.924004 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff109	// Effector
};

node chn109 =
{
	CHFL( 0.025000 ), CHFL( 0.083000 ), CHFL( 0.024000 ),	// Tx, Ty, Tz
	CHFL( -3.123000 ), CHFL( 86.537003 ), CHFL( -92.473999 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt109_1	// Joint
};

node eff110 =
{
	CHFL( 1.328000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&chn109,	// Chain Root
	NULL
};

node jnt110_2 =
{
	CHFL( 1.155000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff110	// Effector
};

node jnt110_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.008000 ), CHFL( -0.160000 ), CHFL( 90.362000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt110_2	// Joint
};

node chn110 =
{
	CHFL( -0.893000 ), CHFL( -0.011000 ), CHFL( 0.014000 ),	// Tx, Ty, Tz
	CHFL( -0.058000 ), CHFL( -176.554993 ), CHFL( 91.587997 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt110_1	// Joint
};

node eff94_1 =
{
	CHFL( 2.997000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	NULL
};

node jnt85_2_1 =
{
	CHFL( -0.001000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( -14.891000 ), CHFL( -3.896000 ), CHFL( 190.710999 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff94_1	// Effector
};

node chn94_1 =
{
	CHFL( 0.178000 ), CHFL( -0.027000 ), CHFL( 0.003000 ),	// Tx, Ty, Tz
	CHFL( 6.247000 ), CHFL( 1.448000 ), CHFL( 82.699997 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt85_2_1	// Joint
};

node eff93_1 =
{
	CHFL( 5.250000 ), CHFL( 0.001000 ), CHFL( -0.001000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&chn94_1,	// Chain Root
	NULL
};

node jnt84_4_1 =
{
	CHFL( 4.291000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.697000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff93_1	// Effector
};

node jnt84_3_1 =
{
	CHFL( 0.001000 ), CHFL( 0.000000 ), CHFL( 0.002000 ),	// Tx, Ty, Tz
	CHFL( -0.284000 ), CHFL( 3.597000 ), CHFL( -89.698997 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt84_4_1	// Joint
};

node chn93_1 =
{
	CHFL( -0.304000 ), CHFL( 0.019000 ), CHFL( 0.880000 ),	// Tx, Ty, Tz
	CHFL( -363.197998 ), CHFL( -0.159000 ), CHFL( -268.631989 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt84_3_1	// Joint
};

node eff92_1 =
{
	CHFL( 2.997000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	NULL
};

node jnt58_3_1 =
{
	CHFL( -0.001000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( -2.927000 ), CHFL( -168.574005 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff92_1	// Effector
};

node chn92_1 =
{
	CHFL( 0.178000 ), CHFL( -0.027000 ), CHFL( -0.003000 ),	// Tx, Ty, Tz
	CHFL( -6.247000 ), CHFL( -1.448000 ), CHFL( 82.699997 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt58_3_1	// Joint
};

node eff91_1 =
{
	CHFL( 5.250000 ), CHFL( 0.001000 ), CHFL( 0.001000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&chn92_1,	// Chain Root
	NULL
};

node jnt101_2_1 =
{
	CHFL( 4.291000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.810000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff91_1	// Effector
};

node jnt65_3_1 =
{
	CHFL( 0.001000 ), CHFL( 0.000000 ), CHFL( -0.002000 ),	// Tx, Ty, Tz
	CHFL( 0.284000 ), CHFL( -2.981000 ), CHFL( -89.748001 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt101_2_1	// Joint
};

node chn91_1 =
{
	CHFL( -0.302000 ), CHFL( -0.080000 ), CHFL( -0.830000 ),	// Tx, Ty, Tz
	CHFL( 3.097000 ), CHFL( 0.159000 ), CHFL( 91.362000 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt65_3_1	// Joint
};

node eff104_1_1 =
{
	CHFL( 0.911000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	4,	// NumberOfChildren
	&chn91_1,	// Chain Root
	&chn93_1,	// Chain Root
	&chn110,	// Chain Root
	NULL
};

node jnt104_1_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( -1.478000 ), CHFL( -86.505997 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff104_1_1	// Effector
};

node chn104_1 =
{
	CHFL( -0.008000 ), CHFL( -0.009000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( -180.000000 ), CHFL( 180.000000 ), CHFL( -27.205999 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt104_1_1	// Joint
};

node eff105_1 =
{
	CHFL( 0.691000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Rx, Ry, Rz
	2,	// NumberOfChildren
	&chn104_1,	// Chain Root
	NULL
};

node jnt105_1_1 =
{
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHFL( 0.000000 ), CHFL( 3.763000 ), CHFL( -157.863998 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&eff105_1	// Effector
};

node bones =
{
	CHFL( 0.086000 ), CHFL( 6.443000 ), CHFL( -0.748000 ),	// Tx, Ty, Tz
	CHFL( 79.899002 ), CHFL( 90.000000 ), CHFL( 79.898003 ),	// Rx, Ry, Rz
	1,	// NumberOfChildren
	&jnt105_1_1	// Joint
};






