#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
#include <LibCD.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"


node g_rfoot =
{
	JOINT,
	CHFL( 34.919998 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_rfoot,	// vertex attachment
	&Verts_g_rfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node g_lrleg =
{
	JOINT,
	CHFL( 29.224001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_lrleg,	// vertex attachment
	&Verts_g_lrleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_rfoot,	// Joint
};

node g_urleg =
{
	JOINT,
	CHFL( 13.076000 ), CHFL( 1.364000 ), CHFL( -7.376000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_urleg,	// vertex attachment
	&Verts_g_urleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_lrleg,	// Joint
};

node g_lfoot =
{
	JOINT,
	CHFL( 34.919998 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_lfoot,	// vertex attachment
	&Verts_g_lfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node g_llleg =
{
	JOINT,
	CHFL( 29.224001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_llleg,	// vertex attachment
	&Verts_g_llleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_lfoot,	// Joint
};

node g_ulleg =
{
	JOINT,
	CHFL( 13.076000 ), CHFL( 1.364000 ), CHFL( 7.604000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_ulleg,	// vertex attachment
	&Verts_g_ulleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_llleg,	// Joint
};

node g_peni =
{
	JOINT,
	CHFL( 12.375999 ), CHFL( 0.192000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_peni,	// vertex attachment
	&Verts_g_peni_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node g_head =
{
	JOINT,
	CHFL( 3.516000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_head,	// vertex attachment
	&Verts_g_head_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node jnt184_1 =
{
	JOINT,
	CHFL( 26.572001 ), CHFL( 0.028000 ), CHFL( 0.080000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_jnt184_1,	// vertex attachment
	&Verts_jnt184_1_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_head,	// Joint
};

node g_lhand =
{
	JOINT,
	CHFL( 18.520000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_lhand,	// vertex attachment
	&Verts_g_lhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node g_llarm =
{
	JOINT,
	CHFL( 20.572001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_llarm,	// vertex attachment
	&Verts_g_llarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_lhand,	// Joint
};

node g_ularm =
{
	JOINT,
	CHFL( 19.216000 ), CHFL( 8.568000 ), CHFL( 14.696000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_ularm,	// vertex attachment
	&Verts_g_ularm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_llarm,	// Joint
};

node g_rhand =
{
	JOINT,
	CHFL( 18.520000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_rhand,	// vertex attachment
	&Verts_g_rhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node g_lrarm =
{
	JOINT,
	CHFL( 20.572001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_lrarm,	// vertex attachment
	&Verts_g_lrarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_rhand,	// Joint
};

node g_urarm =
{
	JOINT,
	CHFL( 19.292000 ), CHFL( -7.964000 ), CHFL( -15.176000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_urarm,	// vertex attachment
	&Verts_g_urarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_lrarm,	// Joint
};

node g_chest =
{
	JOINT,
	CHFL( 21.468000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_chest,	// vertex attachment
	&Verts_g_chest_Lo,	// vertex attachment
	3,	// NumberOfChildren
	&g_urarm,	// Joint
	&g_ularm,	// Joint
	&jnt184_1,	// Joint
};

node g_tum =
{
	JOINT,
	CHFL( 12.016000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_tum,	// vertex attachment
	&Verts_g_tum_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&g_chest,	// Joint
};

node g_bum =
{
	JOINT,
	CHFL( 0.008000 ), CHFL( 0.768000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_g_bum,	// vertex attachment
	&Verts_g_bum_Lo,	// vertex attachment
	4,	// NumberOfChildren
	&g_tum,	// Joint
	&g_peni,	// Joint
	&g_ulleg,	// Joint
	&g_urleg,	// Joint
};

node g_skel =
{
	CHAIN_ROOT,
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	NULL,	// No verts attached (Chain Root or Effector)
	NULL,	// No verts attached (Chain Root or Effector)
	1,	// NumberOfChildren
	&g_bum,	// Chain Root
};

