#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
#include <LibCD.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"


node b_rfoot =
{
	JOINT,
	CHFL( 34.292000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 174.631592 ), CHANG( 3.602855 ), CHANG( 78.525215 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_rfoot,	// vertex attachment
	&Verts_b_rfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node b_lrleg =
{
	JOINT,
	CHFL( 29.528000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( -5.884000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_lrleg,	// vertex attachment
	&Verts_b_lrleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_rfoot,	// Joint
};

node b_urleg =
{
	JOINT,
	CHFL( 11.024000 ), CHFL( 1.244000 ), CHFL( -7.376000 ),	// Tx, Ty, Tz
	CHANG( 183.936005 ), CHANG( 0.170000 ), CHANG( 88.793877 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_urleg,	// vertex attachment
	&Verts_b_urleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_lrleg,	// Joint
};

node b_lfoot =
{
	JOINT,
	CHFL( 34.292000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 174.631592 ), CHANG( 3.602855 ), CHANG( 78.525215 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_lfoot,	// vertex attachment
	&Verts_b_lfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node b_llleg =
{
	JOINT,
	CHFL( 29.528000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( -5.884000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_llleg,	// vertex attachment
	&Verts_b_llleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_lfoot,	// Joint
};

node b_ulleg =
{
	JOINT,
	CHFL( 11.024000 ), CHFL( 1.244000 ), CHFL( 7.616000 ),	// Tx, Ty, Tz
	CHANG( 183.936005 ), CHANG( 0.170000 ), CHANG( 88.793877 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_ulleg,	// vertex attachment
	&Verts_b_ulleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_llleg,	// Joint
};

node b_peni =
{
	JOINT,
	CHFL( 12.375999 ), CHFL( 0.192000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 90.197823 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_peni,	// vertex attachment
	&Verts_b_peni_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node b_head =
{
	JOINT,
	CHFL( 3.516000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( -1.294000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_head,	// vertex attachment
	&Verts_b_head_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node b_jnt184_1 =
{
	JOINT,
	CHFL( 26.572001 ), CHFL( 0.028000 ), CHFL( 0.080000 ),	// Tx, Ty, Tz
	CHANG( -28.662712 ), CHANG( 3.756374 ), CHANG( 7.209027 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_jnt184_1,	// vertex attachment
	&Verts_b_jnt184_1_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_head,	// Joint
};

node b_lhand =
{
	JOINT,
	CHFL( 18.520000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( -1.239000 ), CHANG( -2.291000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_lhand,	// vertex attachment
	&Verts_b_lhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node b_llarm =
{
	JOINT,
	CHFL( 20.572001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 1.611000 ), CHANG( -3.394005 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_llarm,	// vertex attachment
	&Verts_b_llarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_lhand,	// Joint
};

node b_ularm =
{
	JOINT,
	CHFL( 19.216000 ), CHFL( 8.568000 ), CHFL( 14.696000 ),	// Tx, Ty, Tz
	CHANG( 29.875530 ), CHANG( -6.059562 ), CHANG( 186.038620 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_ularm,	// vertex attachment
	&Verts_b_ularm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_llarm,	// Joint
};

node b_rhand =
{
	JOINT,
	CHFL( 18.520000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( -0.757000 ), CHANG( -2.248001 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_rhand,	// vertex attachment
	&Verts_b_rhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node b_lrarm =
{
	JOINT,
	CHFL( 20.572001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( -2.441000 ), CHANG( -3.236999 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_lrarm,	// vertex attachment
	&Verts_b_lrarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_rhand,	// Joint
};

node b_urarm =
{
	JOINT,
	CHFL( 19.292000 ), CHFL( -7.964000 ), CHFL( -15.176000 ),	// Tx, Ty, Tz
	CHANG( 29.701597 ), CHANG( -0.623021 ), CHANG( 189.029480 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_urarm,	// vertex attachment
	&Verts_b_urarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_lrarm,	// Joint
};

node b_chest =
{
	JOINT,
	CHFL( 21.468000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 12.655000 ), CHANG( -0.668000 ), CHANG( -2.942001 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_chest,	// vertex attachment
	&Verts_b_chest_Lo,	// vertex attachment
	3,	// NumberOfChildren
	&b_urarm,	// Joint
	&b_ularm,	// Joint
	&b_jnt184_1,	// Joint
};

node b_tum =
{
	JOINT,
	CHFL( 12.016000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 16.254000 ), CHANG( 0.000000 ), CHANG( 269.485291 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_tum,	// vertex attachment
	&Verts_b_tum_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&b_chest,	// Joint
};

node b_bum =
{
	JOINT,
	CHFL( 0.008000 ), CHFL( 0.768000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 178.264008 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_b_bum,	// vertex attachment
	&Verts_b_bum_Lo,	// vertex attachment
	4,	// NumberOfChildren
	&b_tum,	// Joint
	&b_peni,	// Joint
	&b_ulleg,	// Joint
	&b_urleg,	// Joint
};

node b_virgin =
{
	CHAIN_ROOT,
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	NULL,	// No verts attached (Chain Root or Effector)
	NULL,	// No verts attached (Chain Root or Effector)
	1,	// NumberOfChildren
	&b_bum,	// Chain Root
};

