/* mathbits.c */

#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
//#include "main.h"
#include "sine.h"
#include "mathbits.h"

void SetVector3(vec3 *vector,int16 x,int16 y,int16 z)
{
	vector->X=x<<12;
	vector->Y=y<<12;
	vector->Z=z<<12;
}

void SetVec3( vec3 *V, chfloat X, chfloat Y, chfloat Z )
{
	V->X = X;
	V->Y = Y;
	V->Z = Z;
}

void Matrix_Init( chmatrix *A )
{
	A->E00 = CHFL( 1.0 );
	A->E01 = CHFL( 0.0 );
	A->E02 = CHFL( 0.0 );

	A->E10 = CHFL( 0.0 );
	A->E11 = CHFL( 1.0 );
	A->E12 = CHFL( 0.0 );

	A->E20 = CHFL( 0.0 );
	A->E21 = CHFL( 0.0 );
	A->E22 = CHFL( 1.0 );

	A->E30 = CHFL( 0.0 );
	A->E31 = CHFL( 0.0 );
	A->E32 = CHFL( 0.0 );
}

/*void Matrix_Transvestite( chmatrix *D )
{
	static chmatrix Mat;





}*/


void Matrix_x_Matrix( chmatrix *A, chmatrix *B, chmatrix *D )
{
	D->E00	=	CHSHIFTR( ( A->E00 * B->E00 ) ) +
		 		CHSHIFTR( ( A->E01 * B->E10 ) ) +
			 	CHSHIFTR( ( A->E02 * B->E20 ) );

	D->E01	=	CHSHIFTR( ( A->E00 * B->E01 ) ) +
			 	CHSHIFTR( ( A->E01 * B->E11 ) ) +
			 	CHSHIFTR( ( A->E02 * B->E21 ) );

	D->E02	= 	CHSHIFTR( ( A->E00 * B->E02 ) ) +
			 	CHSHIFTR( ( A->E01 * B->E12 ) ) +
			 	CHSHIFTR( ( A->E02 * B->E22 ) );

	D->E10	= 	CHSHIFTR( ( A->E10 * B->E00 ) ) +
			 	CHSHIFTR( ( A->E11 * B->E10 ) ) +
			 	CHSHIFTR( ( A->E12 * B->E20 ) );

	D->E11	= 	CHSHIFTR( ( A->E10 * B->E01 ) ) +
			 	CHSHIFTR( ( A->E11 * B->E11 ) ) +
			 	CHSHIFTR( ( A->E12 * B->E21 ) );

	D->E12	=	CHSHIFTR( ( A->E10 * B->E02 ) ) +
			 	CHSHIFTR( ( A->E11 * B->E12 ) ) +
			 	CHSHIFTR( ( A->E12 * B->E22 ) );

	D->E20	=	CHSHIFTR( ( A->E20 * B->E00 ) ) +
			 	CHSHIFTR( ( A->E21 * B->E10 ) ) +
			 	CHSHIFTR( ( A->E22 * B->E20 ) );

	D->E21	=	CHSHIFTR( ( A->E20 * B->E01 ) ) +
			 	CHSHIFTR( ( A->E21 * B->E11 ) ) +
			 	CHSHIFTR( ( A->E22 * B->E21 ) );

	D->E22	=	CHSHIFTR( ( A->E20 * B->E02 ) ) +
			 	CHSHIFTR( ( A->E21 * B->E12 ) ) +
			 	CHSHIFTR( ( A->E22 * B->E22 ) );

	D->E30	=	CHSHIFTR( ( A->E30 * B->E00 ) ) +
				CHSHIFTR( ( A->E31 * B->E10 ) ) +
				CHSHIFTR( ( A->E32 * B->E20 ) ) +
				B->E30;

	D->E31	=	CHSHIFTR( ( A->E30 * B->E01 ) ) +
				CHSHIFTR( ( A->E31 * B->E11 ) ) +
				CHSHIFTR( ( A->E32 * B->E21 ) ) +
				B->E31;

	D->E32	=	CHSHIFTR( ( A->E30 * B->E02 ) ) +
				CHSHIFTR( ( A->E31 * B->E12 ) ) +
				CHSHIFTR( ( A->E32 * B->E22 ) ) +
				B->E32;
}

void Vec3_x_Matrix( vec3 *A, chmatrix *B, vec3 *D )
{
	D->X	=	CHSHIFTR( ( A->X * B->E00 ) ) +
				CHSHIFTR( ( A->Y * B->E10 ) ) +
				CHSHIFTR( ( A->Z * B->E20 ) ) +
				B->E30;

	D->Y	=	CHSHIFTR( ( A->X * B->E01 ) ) +
				CHSHIFTR( ( A->Y * B->E11 ) ) +
				CHSHIFTR( ( A->Z * B->E21 ) ) +
				B->E31;

	D->Z	=	CHSHIFTR( ( A->X * B->E02 ) ) +
				CHSHIFTR( ( A->Y * B->E12 ) ) +
				CHSHIFTR( ( A->Z * B->E22 ) ) +
				B->E32;
}


/*




lw t0,0(a0)
lw t3,0(a1)

;t3 = 	E00

lw t1,4(a0)
mult t3,t1
lw t2,8(a0)

; x = t0, y = t1, z = t2

lw t4,12(a1)
mflo t5
lw t3,24(a1)

; t4 = E10
; t3 = E20

nop
mult t1,t4
sra t5,t5,12
nop
mflo t6
nop
nop
mult t2,t3
sra t6.t6,12
nop
mflo t7
addu v0,t5,t6
lw t6,36(a1)
sra t7,t7,12
addu v0,v0,t7
addu v0,v0,t6
sw v0,0(a2)


; x = t0, y = t1, z = t2

lw t3,4(a1)		;t3 = E01

mult t0,t3
lw t4,16(a1)	;t4 = E11
lw t5,28(a1)	;t5 = E21
mflo v0

lw t6,40(a1)	;56 = E31
nop

mult t1,t4
sra v0,v0,12
addu v0,v0,t6
mflo v1

nop
nop
mult t2,t5
sra v1,v1,12
addu v0,v0,v1

mflo v1

nop
nop
sra v1,v1,12
addu v0,v0,v1

sw v0,4(a2)






*/

void Matrix_MakeRotX( chmatrix *A, chfloat Deg )
{
   A->E11 =  Cosine( Deg );
   A->E22 =  Cosine( Deg );
   A->E12 = Sine( Deg );
   A->E21 =  -Sine( Deg );
}

void Matrix_MakeRotY( chmatrix *A, chfloat Deg )
{
   A->E00 =  Cosine( Deg );
   A->E20 = -Sine( Deg );
   A->E02 =  Sine( Deg );
   A->E22 =  Cosine( Deg );
}

void Matrix_MakeRotZ( chmatrix *A, chfloat Deg )
{
   A->E00 =  Cosine( Deg );
   A->E11 =  Cosine( Deg );
   A->E10 =  -Sine( Deg );
   A->E01 = Sine( Deg );
}

/*
void Matrix_MakeRotX( chmatrix *A, chfloat Deg )
{
   A->E[1][1] =  Cosine( Deg );
   A->E[2][2] =  Cosine( Deg );
   A->E[2][1] = -Sine( Deg );
   A->E[1][2] =  Sine( Deg );
}

void Matrix_MakeRotY( chmatrix *A, chfloat Deg )
{
   A->E[0][0] =  Cosine( Deg );
   A->E[0][2] = -Sine( Deg );
   A->E[2][0] =  Sine( Deg );
   A->E[2][2] =  Cosine( Deg );
}

void Matrix_MakeRotZ( chmatrix *A, chfloat Deg )
{
   A->E[ 0 ][ 0 ] =  Cosine( Deg );
   A->E[ 1 ][ 1 ] =  Cosine( Deg );
   A->E[ 0 ][ 1 ] =  Sine( Deg );
   A->E[ 1 ][ 0 ] = -Sine( Deg );
}
*/

void Matrix_MakeXYZTransl( chmatrix *A, chfloat X, chfloat Y, chfloat Z )
{
   A->E30 = X;
   A->E31 = Y;
   A->E32 = Z;
}

void Matrix_MakeRotXYZ( chmatrix *Mat, chfloat Rx, chfloat Ry, chfloat Rz )
{
	chfloat CX = Cosine( Rx );
	chfloat CY = Cosine( Ry );
	chfloat CZ = Cosine( Rz );
	chfloat SX = Sine( Rx );
	chfloat SY = Sine( Ry );
	chfloat SZ = Sine( Rz );

	Mat->E00 = CHSHIFTR( CZ * CY );
	Mat->E01 = CHSHIFTR( SZ * CY );
	Mat->E02 = -SY;
	Mat->E10 = CHSHIFTR(CHSHIFTR(CZ*SY)*SX)-CHSHIFTR(SZ*CX);
	Mat->E11 = CHSHIFTR(CHSHIFTR(SZ*SY)*SX)+CHSHIFTR(CZ*CX);
	Mat->E12 = CHSHIFTR( CY*SX );
	Mat->E20 = CHSHIFTR(CHSHIFTR(CZ*SY)*CX)+CHSHIFTR(SZ*SX);
	Mat->E21 = CHSHIFTR(CHSHIFTR(SZ*SY)*CX)-CHSHIFTR(CZ*SX);
	Mat->E22 = CHSHIFTR( CY*CX );
	Mat->E30 = 0;
	Mat->E31 = 0;
	Mat->E32 = 0;
}


/*
void AstMatrix4x3::MakeXTranslation( AstFixedpoint_t amount )
{
   data[3][0] = amount;
   data[3][1] = 0;
   data[3][2] = 0;
}
void AstMatrix4x3::MakeYTranslation( AstFixedpoint_t amount )
{
   data[3][0] = 0;
   data[3][1] = amount;
   data[3][2] = 0;
}
void AstMatrix4x3::MakeZTranslation( AstFixedpoint_t amount )
{
   data[3][0] = 0;
   data[3][1] = 0;
   data[3][2] = amount;
}

*/

PSX_Matrix_Init(MATRIX *m)
{
	uint8	Count1,Count2;

	for (Count1=0;Count1<3;Count1++)
	{
		for (Count2=0;Count2<3;Count2++)
		{
			if (Count1==Count2)
			{
				m->m[Count1][Count2]=0x1000;
			}
			else
			{
				m->m[Count1][Count2]=0;
			}
		}
		m->t[Count1]=0;
	}

}

int32 PSX_Dot ( VECTOR *A, VECTOR *B)
{
	return	(( A->vx * B->vx ) +
					( A->vy * B->vy ) +
					( A->vz * B->vz ));
}


chfloat Dot( vec3 *A, vec3 *B )
{
	return	( A->X * B->X ) +
					( A->Y * B->Y ) +
					( A->Z * B->Z );
}

void Cross( vec3 *A, vec3 *B, vec3 *D )
{
	D->X = ( A->Y * B->Z ) - ( A->Z * B->Y );
	D->Y = ( A->Z * B->X ) - ( A->X * B->Z );
	D->Z = ( A->X * B->Y ) - ( A->Y * B->X );
}


chfloat Magnitude( vec3 *A )
{
	chfloat f;
/*	VECTOR	outputvector,squaredvector;

	squaredvector.vx=A->X>>12;
	squaredvector.vy=A->Y>>12;
	squaredvector.vz=A->Z>>12;
	Square0(&squaredvector,&outputvector);
	printf("ivx %d, ivy %d, ivz %d\n",squaredvector.vx,squaredvector.vy,squaredvector.vz);
	printf("ovx %d, ovy %d, ovz %d\n",outputvector.vx,outputvector.vy,outputvector.vz);
	f = outputvector.vx+outputvector.vy+outputvector.vz;

	return SquareRoot0( f<<12 )<<12;   */
	long	d[3],i,j,t;

	d[0]	=	abs(A->X);
	d[1]	=	abs(A->Y);
	d[2]	=	abs(A->Z);

	/* shitsort */
	for ( i=0;i<3;i++ )
	{
		for ( j=1;j<3;j++ )
		{
			if ( d[j]>d[j-1] )
			{
				t		=	d[j];
				d[j]	=	d[j-1];
				d[j-1]	=	t;
			}
		}
	}

	t	=	d[0] + (( d[1] * 11 ) >> 5 ) + ( d[2] >> 2 );

	return(t);


}


void Normalize( vec3 *D )
{
	chfloat M = Magnitude( D );

	D->X = D->X / M;
	D->Y = D->Y / M;
	D->Z = D->Z / M;
}

chfloat chatan2( chfloat Dx, chfloat Dy )
{
	return ratan2( Dx, Dy );
}

chfloat chabs( chfloat Gizzard )
{
	if( Gizzard > 0 ) return Gizzard;
	return -Gizzard;
}


chfloat DistanceBetween( vec3 *A, vec3 *B )
{
	chfloat h, b, c;

	b = chabs( CHSHIFTR( A->Z ) - CHSHIFTR( B->Z ) );
	c = chabs( CHSHIFTR( A->X ) - CHSHIFTR( B->X ) );
	h = SquareRoot0( ( b * b ) + ( c * c ) );

	b = chabs( CHSHIFTR( A->Y ) - CHSHIFTR( B->Y ) );
	return CHFL( SquareRoot0( ( b * b ) + ( h * h ) ) );
} 



