/* players.c */

#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
#include "mathbits.h"
#include "main.h"
#include "camera.h"
#include "camlogic.h"
#include "tracks.h"
#include "players.h"


uint8	NumberOfPlayers;	/* Total number of players */
uint8	ConsolePlayers;		/* This is the number of split screens you should have */
uint8	RemotePlayers;
uint8	GameMode;
player Player[ MAX_PLAYERS ];


void KillPlayers( void )
{
	printf("Executing : KillPlayers()\n");
}

void InitialisePlayers(void)
{
	uint8	i;
	uint8	Count1,Count2,Count3;

	printf("Executing : InitialisePlayers()\n");

//	NumberOfPlayers = 1;
//	ConsolePlayers = 1;
//	RemotePlayers = 0;

	for ( i = 0; i < MAX_PLAYERS ; i++ )
	{
		/* name */
		/* colour scheme */
//		sprintf( Player[ i ].Name,"Player %d", i + 1 );
		Player[ i ].PlayerNumber = i;

		Player[ i ].Transport = SNOWBOARD;	// Set which transport logic to use
//		Player[ i ].Transport = TESTCAM;

		InitBoardModel( i );					// Initialise the transport logic

//		Player[ i ].ConsoleRemoteGhosted = CONSOLE_PLAYER;
		Player[ i ].PadNumber=i%2;

		Player[ i ].Cam.Mode = CAMERA_FOLLOW;
//		Player[ i ].Cam.Mode = CAMERA_TEST_POSITIONAL;
		InitCameraModel( i );

		// Make the Target Camera at least point somewhere by default
		SetVec3( &Player[ i ].Cam.Up, CHFL( 0.0 ), CHFL( 1.0 ), CHFL( 0.0 ) );
		SetVec3( &Player[ i ].Cam.Targ, CHFL( 0.0 ), CHFL( 0.0 ), CHFL( 0.0 ) );


		// JEB's player initialising
		for (Count1=0;Count1<3;Count1++)
		{
			for (Count2=0;Count2<3;Count2++)
			{
				if (Count1==Count2)
				{
					Player[ i ].Cam.ViewMatrix.m[Count1][Count2]=0x1000;
				}
				else
				{
					Player[ i ].Cam.ViewMatrix.m[Count1][Count2]=0;
				}
			}
			Player[ i ].Cam.ViewMatrix.t[Count1]=0;
		}

		Player[ i ].Track = &Tb[ i % 2 ];
		Player[ i ].Buffer = i % 2;

	}

}




