#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
//#include <libds.h>
#include <libcd.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"




// Skinner.exe : t_skin.c ( 249 vertices, 256 polygons )

uint32 t_skin_num_verts = 249;
uint32 t_skin_num_polys = 256;

chfloat t_skin_verts[] =
{
	CHFL( 69.688 ), CHFL( -2.992 ) , CHFL( 16.584 ),
	CHFL( 48.532 ), CHFL( -3.764 ) , CHFL( 17.42 ),
	CHFL( 69.656 ), CHFL( -3.868 ) , CHFL( 12.436 ),
	CHFL( 46.292 ), CHFL( -4.264 ) , CHFL( 12.732 ),
	CHFL( 70.8 ), CHFL( -0.204 ) , CHFL( 10.3 ),
	CHFL( 46.404 ), CHFL( 1.004 ) , CHFL( 9.684 ),
	CHFL( 70.88 ), CHFL( 2.952 ) , CHFL( 13.124 ),
	CHFL( 48.712 ), CHFL( 4.756 ) , CHFL( 12.496 ),
	CHFL( 69.784 ), CHFL( 1.24 ) , CHFL( 17.008 ),
	CHFL( 47.616 ), CHFL( 1.864 ) , CHFL( 17.28 ),
	CHFL( 85.612 ), CHFL( -2.648 ) , CHFL( 16.012 ),
	CHFL( 73.132 ), CHFL( -3.056 ) , CHFL( 16.596 ),
	CHFL( 85.628 ), CHFL( -3.312 ) , CHFL( 12.884 ),
	CHFL( 73.152 ), CHFL( -3.932 ) , CHFL( 12.448 ),
	CHFL( 85.68 ), CHFL( -0.528 ) , CHFL( 11.272 ),
	CHFL( 72.048 ), CHFL( -0.224 ) , CHFL( 10.304 ),
	CHFL( 85.7 ), CHFL( 1.852 ) , CHFL( 13.404 ),
	CHFL( 72.072 ), CHFL( 2.936 ) , CHFL( 13.132 ),
	CHFL( 85.656 ), CHFL( 0.544 ) , CHFL( 16.332 ),
	CHFL( 73.188 ), CHFL( 1.18 ) , CHFL( 17.024 ),
	CHFL( 69.692 ), CHFL( -3.768 ) , CHFL( -13.452 ),
	CHFL( 48.54 ), CHFL( -4.916 ) , CHFL( -13.28 ),
	CHFL( 69.648 ), CHFL( -0.624 ) , CHFL( -10.612 ),
	CHFL( 46.284 ), CHFL( -1.112 ) , CHFL( -10.504 ),
	CHFL( 70.792 ), CHFL( 3.068 ) , CHFL( -12.704 ),
	CHFL( 46.396 ), CHFL( 4.164 ) , CHFL( -13.528 ),
	CHFL( 70.888 ), CHFL( 2.212 ) , CHFL( -16.852 ),
	CHFL( 48.724 ), CHFL( 3.624 ) , CHFL( -18.176 ),
	CHFL( 69.8 ), CHFL( -2.012 ) , CHFL( -17.324 ),
	CHFL( 47.636 ), CHFL( -1.972 ) , CHFL( -18.08 ),
	CHFL( 85.632 ), CHFL( -2.972 ) , CHFL( -13.4 ),
	CHFL( 73.156 ), CHFL( -3.788 ) , CHFL( -13.392 ),
	CHFL( 85.62 ), CHFL( -0.6 ) , CHFL( -11.256 ),
	CHFL( 73.136 ), CHFL( -0.644 ) , CHFL( -10.552 ),
	CHFL( 85.652 ), CHFL( 2.192 ) , CHFL( -12.856 ),
	CHFL( 72.012 ), CHFL( 3.064 ) , CHFL( -12.688 ),
	CHFL( 85.688 ), CHFL( 1.544 ) , CHFL( -15.984 ),
	CHFL( 72.06 ), CHFL( 2.204 ) , CHFL( -16.836 ),
	CHFL( 85.676 ), CHFL( -1.648 ) , CHFL( -16.32 ),
	CHFL( 73.216 ), CHFL( -2.032 ) , CHFL( -17.268 ),
	CHFL( 85.844 ), CHFL( 4.288 ) , CHFL( -7.12 ),
	CHFL( 50.256 ), CHFL( 3.44 ) , CHFL( -11.004 ),
	CHFL( 50.696 ), CHFL( -2.14 ) , CHFL( -9.168 ),
	CHFL( 50.676 ), CHFL( -1.82 ) , CHFL( -4.492 ),
	CHFL( 50.228 ), CHFL( 3.96 ) , CHFL( -3.44 ),
	CHFL( 49.968 ), CHFL( 7.212 ) , CHFL( -7.464 ),
	CHFL( 80.812 ), CHFL( 5.972 ) , CHFL( -13.1 ),
	CHFL( 80.496 ), CHFL( 12.252 ) , CHFL( -7.688 ),
	CHFL( 80.764 ), CHFL( 6.772 ) , CHFL( -1.464 ),
	CHFL( 81.248 ), CHFL( -2.92 ) , CHFL( -3.328 ),
	CHFL( 81.28 ), CHFL( -3.4 ) , CHFL( -10.308 ),
	CHFL( 33.388 ), CHFL( 3.196 ) , CHFL( -12.964 ),
	CHFL( 24.32 ), CHFL( -3.852 ) , CHFL( -1.172 ),
	CHFL( 33.176 ), CHFL( -5.684 ) , CHFL( -10.128 ),
	CHFL( 20.736 ), CHFL( -5.64 ) , CHFL( -10.42 ),
	CHFL( 33.196 ), CHFL( -5.18 ) , CHFL( -2.764 ),
	CHFL( 20.756 ), CHFL( -5.128 ) , CHFL( -3.012 ),
	CHFL( 33.424 ), CHFL( 4.008 ) , CHFL( -1.128 ),
	CHFL( 18.168 ), CHFL( 4.452 ) , CHFL( -1.444 ),
	CHFL( 33.544 ), CHFL( 9.176 ) , CHFL( -7.552 ),
	CHFL( 19.324 ), CHFL( 9.196 ) , CHFL( -7.42 ),
	CHFL( 49.272 ), CHFL( 3.408 ) , CHFL( -11.004 ),
	CHFL( 49.372 ), CHFL( 7.188 ) , CHFL( -7.464 ),
	CHFL( 49.296 ), CHFL( 3.928 ) , CHFL( -3.44 ),
	CHFL( 49.152 ), CHFL( -1.868 ) , CHFL( -4.492 ),
	CHFL( 49.136 ), CHFL( -2.192 ) , CHFL( -9.168 ),
	CHFL( 85.844 ), CHFL( 4.296 ) , CHFL( 7.8 ),
	CHFL( 50.256 ), CHFL( 3.448 ) , CHFL( 3.912 ),
	CHFL( 50.696 ), CHFL( -2.132 ) , CHFL( 5.748 ),
	CHFL( 50.676 ), CHFL( -1.812 ) , CHFL( 10.424 ),
	CHFL( 50.228 ), CHFL( 3.968 ) , CHFL( 11.476 ),
	CHFL( 49.968 ), CHFL( 7.22 ) , CHFL( 7.452 ),
	CHFL( 80.812 ), CHFL( 5.98 ) , CHFL( 1.816 ),
	CHFL( 80.496 ), CHFL( 12.26 ) , CHFL( 7.228 ),
	CHFL( 80.764 ), CHFL( 6.78 ) , CHFL( 13.452 ),
	CHFL( 81.248 ), CHFL( -2.892 ) , CHFL( 11.884 ),
	CHFL( 81.276 ), CHFL( -3.384 ) , CHFL( 4.696 ),
	CHFL( 33.388 ), CHFL( 3.188 ) , CHFL( 1.7 ),
	CHFL( 18.128 ), CHFL( 3.64 ) , CHFL( 2.188 ),
	CHFL( 33.172 ), CHFL( -5.692 ) , CHFL( 4.58 ),
	CHFL( 20.736 ), CHFL( -5.592 ) , CHFL( 5.068 ),
	CHFL( 33.196 ), CHFL( -5.184 ) , CHFL( 11.952 ),
	CHFL( 20.76 ), CHFL( -5.08 ) , CHFL( 12.512 ),
	CHFL( 33.424 ), CHFL( 4 ) , CHFL( 13.544 ),
	CHFL( 24.32 ), CHFL( -3.852 ) , CHFL( 1.368 ),
	CHFL( 33.544 ), CHFL( 9.184 ) , CHFL( 7.364 ),
	CHFL( 19.324 ), CHFL( 9.208 ) , CHFL( 7.512 ),
	CHFL( 49.272 ), CHFL( 3.416 ) , CHFL( 3.912 ),
	CHFL( 49.372 ), CHFL( 7.196 ) , CHFL( 7.452 ),
	CHFL( 49.296 ), CHFL( 3.936 ) , CHFL( 11.476 ),
	CHFL( 49.152 ), CHFL( -1.86 ) , CHFL( 10.424 ),
	CHFL( 49.136 ), CHFL( -2.184 ) , CHFL( 5.748 ),
	CHFL( 70.812 ), CHFL( 8.7 ) , CHFL( -0.788 ),
	CHFL( 70.82 ), CHFL( 3.964 ) , CHFL( 7.808 ),
	CHFL( 68.76 ), CHFL( 6.052 ) , CHFL( -3.42 ),
	CHFL( 68.768 ), CHFL( 0.332 ) , CHFL( 6.968 ),
	CHFL( 66.004 ), CHFL( 8.012 ) , CHFL( 5.732 ),
	CHFL( 65.992 ), CHFL( 9.116 ) , CHFL( 3.736 ),
	CHFL( 68.656 ), CHFL( 7.652 ) , CHFL( 4.192 ),
	CHFL( 63.664 ), CHFL( 8.356 ) , CHFL( 0.996 ),
	CHFL( 63.672 ), CHFL( 5.288 ) , CHFL( 6.564 ),
	CHFL( 60.436 ), CHFL( 7.208 ) , CHFL( 5.656 ),
	CHFL( 60.432 ), CHFL( 8.616 ) , CHFL( 3.108 ),
	CHFL( 62.048 ), CHFL( 8.488 ) , CHFL( 2.052 ),
	CHFL( 62.052 ), CHFL( 6.248 ) , CHFL( 6.112 ),
	CHFL( 63.616 ), CHFL( -0.624 ) , CHFL( 5.816 ),
	CHFL( 63.608 ), CHFL( 4.564 ) , CHFL( -3.6 ),
	CHFL( 60.22 ), CHFL( 5.068 ) , CHFL( -1.036 ),
	CHFL( 60.224 ), CHFL( 1.812 ) , CHFL( 4.876 ),
	CHFL( 61.28 ), CHFL( -4.1 ) , CHFL( 1.208 ),
	CHFL( 61.276 ), CHFL( -1.192 ) , CHFL( -4.072 ),
	CHFL( 67.792 ), CHFL( -3.304 ) , CHFL( -7.804 ),
	CHFL( 67.796 ), CHFL( -8.372 ) , CHFL( 1.396 ),
	CHFL( 65.04 ), CHFL( -1.256 ) , CHFL( -6.8 ),
	CHFL( 65.044 ), CHFL( -6.436 ) , CHFL( 2.6 ),
	CHFL( 66.468 ), CHFL( 9.84 ) , CHFL( 4.936 ),
	CHFL( 66.48 ), CHFL( 9.412 ) , CHFL( 5.704 ),
	CHFL( 35.12 ), CHFL( -8.496 ) , CHFL( -5.388 ),
	CHFL( 52.856 ), CHFL( -7.068 ) , CHFL( -8.148 ),
	CHFL( 52.856 ), CHFL( -7.068 ) , CHFL( 8.076 ),
	CHFL( 35.12 ), CHFL( -8.496 ) , CHFL( 5.316 ),
	CHFL( 53.288 ), CHFL( -5.936 ) , CHFL( 11.332 ),
	CHFL( 49.604 ), CHFL( 6.484 ) , CHFL( 10.672 ),
	CHFL( 57.808 ), CHFL( -3.144 ) , CHFL( 2.98 ),
	CHFL( 54.828 ), CHFL( -0.236 ) , CHFL( 10.876 ),
	CHFL( 54.588 ), CHFL( 3.568 ) , CHFL( 3.336 ),
	CHFL( 86.108 ), CHFL( -1.556 ) , CHFL( 3.74 ),
	CHFL( 79.912 ), CHFL( -2.496 ) , CHFL( 4.52 ),
	CHFL( 80.068 ), CHFL( -1.548 ) , CHFL( 11.328 ),
	CHFL( 86.36 ), CHFL( -0.244 ) , CHFL( 11.556 ),
	CHFL( 24.46 ), CHFL( 6.232 ) , CHFL( 7.336 ),
	CHFL( 80.456 ), CHFL( 11.152 ) , CHFL( 2.604 ),
	CHFL( 80.612 ), CHFL( 12.1 ) , CHFL( 9.428 ),
	CHFL( 104.636 ), CHFL( 4.064 ) , CHFL( 10.488 ),
	CHFL( 104.46 ), CHFL( 2.98 ) , CHFL( 2.692 ),
	CHFL( 102.252 ), CHFL( -0.14 ) , CHFL( 11.12 ),
	CHFL( 102.072 ), CHFL( -1.224 ) , CHFL( 3.32 ),
	CHFL( 53.348 ), CHFL( -5.84 ) , CHFL( -11.372 ),
	CHFL( 49.604 ), CHFL( 6.756 ) , CHFL( -9.592 ),
	CHFL( 57.808 ), CHFL( -3.144 ) , CHFL( -3.052 ),
	CHFL( 54.808 ), CHFL( -0.264 ) , CHFL( -10.932 ),
	CHFL( 54.588 ), CHFL( 3.568 ) , CHFL( -3.412 ),
	CHFL( 86.292 ), CHFL( -0.432 ) , CHFL( -2.98 ),
	CHFL( 80.076 ), CHFL( -1.488 ) , CHFL( -3.024 ),
	CHFL( 79.92 ), CHFL( -2.44 ) , CHFL( -9.88 ),
	CHFL( 86.116 ), CHFL( -1.496 ) , CHFL( -10.624 ),
	CHFL( 24.46 ), CHFL( 6.232 ) , CHFL( -7.372 ),
	CHFL( 80.624 ), CHFL( 12.164 ) , CHFL( -4.896 ),
	CHFL( 80.46 ), CHFL( 11.18 ) , CHFL( -11.968 ),
	CHFL( 104.4 ), CHFL( 2.832 ) , CHFL( -11.712 ),
	CHFL( 104.576 ), CHFL( 3.9 ) , CHFL( -4.032 ),
	CHFL( 102.08 ), CHFL( -1.164 ) , CHFL( -11.036 ),
	CHFL( 102.256 ), CHFL( -0.1 ) , CHFL( -3.396 ),
	CHFL( 86.148 ), CHFL( -3.696 ) , CHFL( -14.672 ),
	CHFL( 86.32 ), CHFL( -1.916 ) , CHFL( 17.344 ),
	CHFL( 85.984 ), CHFL( 2.696 ) , CHFL( 14.576 ),
	CHFL( 86.024 ), CHFL( 1.012 ) , CHFL( -17.3 ),
	CHFL( 36.188 ), CHFL( -3.956 ) , CHFL( 11.48 ),
	CHFL( 36.172 ), CHFL( -3.932 ) , CHFL( -11.296 ),
	CHFL( 25.436 ), CHFL( -5.72 ) , CHFL( 7.688 ),
	CHFL( 25.436 ), CHFL( -5.72 ) , CHFL( -7.664 ),
	CHFL( 40.908 ), CHFL( 12.532 ) , CHFL( -10.552 ),
	CHFL( 40.896 ), CHFL( 12.552 ) , CHFL( 10.68 ),
	CHFL( 34.552 ), CHFL( 8.268 ) , CHFL( -9.528 ),
	CHFL( 34.464 ), CHFL( 8.388 ) , CHFL( 8.208 ),
	CHFL( 86.02 ), CHFL( 0.384 ) , CHFL( 10.888 ),
	CHFL( 86.04 ), CHFL( 2.916 ) , CHFL( -13.608 ),
	CHFL( 86.352 ), CHFL( -1.94 ) , CHFL( -11.588 ),
	CHFL( 86.448 ), CHFL( -3.768 ) , CHFL( 14.072 ),
	CHFL( 24.296 ), CHFL( 1.344 ) , CHFL( -8.468 ),
	CHFL( 24.296 ), CHFL( 1.344 ) , CHFL( 8.472 ),
	CHFL( 13.296 ), CHFL( -9.216 ) , CHFL( -7.548 ),
	CHFL( 13.272 ), CHFL( -9.22 ) , CHFL( 7.596 ),
	CHFL( 90.968 ), CHFL( 7.468 ) , CHFL( -12.096 ),
	CHFL( 91.144 ), CHFL( 8.54 ) , CHFL( -4.36 ),
	CHFL( 90.996 ), CHFL( 7.524 ) , CHFL( 2.372 ),
	CHFL( 91.176 ), CHFL( 8.612 ) , CHFL( 10.216 ),
	CHFL( 75.2 ), CHFL( 2.672 ) , CHFL( 5.62 ),
	CHFL( 75.072 ), CHFL( -0.388 ) , CHFL( 4.704 ),
	CHFL( 75.196 ), CHFL( 6.28 ) , CHFL( -0.936 ),
	CHFL( 75.064 ), CHFL( 3.864 ) , CHFL( -3.016 ),
	CHFL( 76.072 ), CHFL( 4.776 ) , CHFL( 2.54 ),
	CHFL( 73.588 ), CHFL( -5.988 ) , CHFL( 0.908 ),
	CHFL( 73.584 ), CHFL( -2.42 ) , CHFL( -5.568 ),
	CHFL( 76.244 ), CHFL( 1.6 ) , CHFL( 0.82 ),
	CHFL( 75.124 ), CHFL( -2.7 ) , CHFL( -1.552 ),
	CHFL( 101.712 ), CHFL( 2.372 ) , CHFL( -13.608 ),
	CHFL( 100.736 ), CHFL( -3.936 ) , CHFL( -14.544 ),
	CHFL( 102.084 ), CHFL( -2.272 ) , CHFL( -11.884 ),
	CHFL( 100.548 ), CHFL( 0.648 ) , CHFL( -16.928 ),
	CHFL( 93.364 ), CHFL( 2.04 ) , CHFL( -19.548 ),
	CHFL( 93.648 ), CHFL( -6.06 ) , CHFL( -15.168 ),
	CHFL( 93.408 ), CHFL( 4.616 ) , CHFL( -14.688 ),
	CHFL( 93.876 ), CHFL( -3.532 ) , CHFL( -10.948 ),
	CHFL( 93.28 ), CHFL( 5.192 ) , CHFL( 14.728 ),
	CHFL( 93.328 ), CHFL( 2.204 ) , CHFL( 9.872 ),
	CHFL( 93.888 ), CHFL( -2.648 ) , CHFL( 19.528 ),
	CHFL( 94.028 ), CHFL( -5.084 ) , CHFL( 15.008 ),
	CHFL( 100.472 ), CHFL( 2.252 ) , CHFL( 14.516 ),
	CHFL( 100.948 ), CHFL( -2.096 ) , CHFL( 17.28 ),
	CHFL( 101.66 ), CHFL( 0.172 ) , CHFL( 11.156 ),
	CHFL( 102.22 ), CHFL( -3.612 ) , CHFL( 14.276 ),
	CHFL( 67.088 ), CHFL( 9.116 ) , CHFL( -0.076 ),
	CHFL( 67.096 ), CHFL( 4.784 ) , CHFL( 7.788 ),
	CHFL( 70.936 ), CHFL( 7.244 ) , CHFL( 4.012 ),
	CHFL( 66.54 ), CHFL( 9.116 ) , CHFL( 1.832 ),
	CHFL( 66.548 ), CHFL( 6.396 ) , CHFL( 6.76 ),
	CHFL( 63.472 ), CHFL( -4.324 ) , CHFL( -3.86 ),
	CHFL( 63.472 ), CHFL( -5.592 ) , CHFL( -1.56 ),
	CHFL( 88.7 ), CHFL( 0.256 ) , CHFL( -14.548 ),
	CHFL( 88.704 ), CHFL( -0.036 ) , CHFL( 13.828 ),
	CHFL( 18.256 ), CHFL( -9.416 ) , CHFL( 0.096 ),
	CHFL( 24.508 ), CHFL( 7.328 ) , CHFL( -0.008 ),
	CHFL( 72.14 ), CHFL( -5.804 ) , CHFL( 4.792 ),
	CHFL( 72.632 ), CHFL( -4.78 ) , CHFL( 4.48 ),
	CHFL( 72.904 ), CHFL( -6.152 ) , CHFL( 1.9 ),
	CHFL( 72.204 ), CHFL( -6.404 ) , CHFL( 3.376 ),
	CHFL( 75.064 ), CHFL( 3.864 ) , CHFL( -3.016 ),
	CHFL( 73.584 ), CHFL( -2.42 ) , CHFL( -5.568 ),
	CHFL( 67.792 ), CHFL( -3.304 ) , CHFL( -7.804 ),
	CHFL( 68.76 ), CHFL( 6.052 ) , CHFL( -3.42 ),
	CHFL( 72.66 ), CHFL( 1.132 ) , CHFL( -6.368 ),
	CHFL( 72.216 ), CHFL( -0.76 ) , CHFL( -7.132 ),
	CHFL( 72.092 ), CHFL( -0.508 ) , CHFL( -6.78 ),
	CHFL( 72.872 ), CHFL( -0.828 ) , CHFL( -3.776 ),
	CHFL( 75.576 ), CHFL( -5.468 ) , CHFL( 2.652 ),
	CHFL( 75.456 ), CHFL( -3.764 ) , CHFL( 3.1 ),
	CHFL( 74.836 ), CHFL( -5.128 ) , CHFL( 5.552 ),
	CHFL( 75.104 ), CHFL( -3.332 ) , CHFL( 5.032 ),
	CHFL( 75.168 ), CHFL( 1.748 ) , CHFL( -7.092 ),
	CHFL( 75.468 ), CHFL( 1.344 ) , CHFL( -5.06 ),
	CHFL( 74.84 ), CHFL( -0.132 ) , CHFL( -7.596 ),
	CHFL( 75.592 ), CHFL( -0.436 ) , CHFL( -4.58 ),
	CHFL( 80.588 ), CHFL( -6.18 ) , CHFL( 0.984 ),
	CHFL( 79.9 ), CHFL( -3.444 ) , CHFL( 0.96 ),
	CHFL( 79.96 ), CHFL( -6.88 ) , CHFL( 5.036 ),
	CHFL( 79.084 ), CHFL( -3.62 ) , CHFL( 4.624 ),
	CHFL( 79.64 ), CHFL( 1.864 ) , CHFL( -6.776 ),
	CHFL( 80.312 ), CHFL( 1.916 ) , CHFL( -2.956 ),
	CHFL( 80.408 ), CHFL( -1.644 ) , CHFL( -7.156 ),
	CHFL( 81.02 ), CHFL( -0.924 ) , CHFL( -2.964 ),
	CHFL( 84.256 ), CHFL( 2.188 ) , CHFL( -8.564 ),
	CHFL( 84.78 ), CHFL( 3.068 ) , CHFL( -4.644 ),
	CHFL( 84.876 ), CHFL( -1.524 ) , CHFL( -7.868 ),
	CHFL( 85.248 ), CHFL( -0.404 ) , CHFL( -3.824 ),
	CHFL( 84.848 ), CHFL( -6.164 ) , CHFL( 1.772 ),
	CHFL( 84.084 ), CHFL( -2.784 ) , CHFL( 2.128 ),
	CHFL( 84.52 ), CHFL( -7.308 ) , CHFL( 5.744 ),
	CHFL( 83.52 ), CHFL( -3.908 ) , CHFL( 6.348 ),
};


chfloat t_skin_norms[] =
{
	CHFL( 0.01 ), CHFL( -0.666 ) , CHFL( 0.746 ),
	CHFL( -0.392 ), CHFL( -0.54 ) , CHFL( 0.745 ),
	CHFL( 0.001 ), CHFL( -0.907 ) , CHFL( -0.421 ),
	CHFL( -0.771 ), CHFL( -0.635 ) , CHFL( -0.056 ),
	CHFL( 0.021 ), CHFL( 0.086 ) , CHFL( -0.996 ),
	CHFL( -0.752 ), CHFL( 0.291 ) , CHFL( -0.592 ),
	CHFL( 0.043 ), CHFL( 0.978 ) , CHFL( -0.205 ),
	CHFL( -0.362 ), CHFL( 0.926 ) , CHFL( -0.103 ),
	CHFL( 0.023 ), CHFL( 0.5 ) , CHFL( 0.866 ),
	CHFL( -0.73 ), CHFL( 0.353 ) , CHFL( 0.585 ),
	CHFL( 0.446 ), CHFL( -0.59 ) , CHFL( 0.673 ),
	CHFL( 0.021 ), CHFL( -0.668 ) , CHFL( 0.744 ),
	CHFL( 0.449 ), CHFL( -0.812 ) , CHFL( -0.372 ),
	CHFL( 0.022 ), CHFL( -0.913 ) , CHFL( -0.408 ),
	CHFL( 0.379 ), CHFL( 0.113 ) , CHFL( -0.919 ),
	CHFL( 0.04 ), CHFL( 0.104 ) , CHFL( -0.994 ),
	CHFL( 0.327 ), CHFL( 0.924 ) , CHFL( -0.197 ),
	CHFL( 0.05 ), CHFL( 0.976 ) , CHFL( -0.21 ),
	CHFL( 0.374 ), CHFL( 0.48 ) , CHFL( 0.794 ),
	CHFL( 0.038 ), CHFL( 0.502 ) , CHFL( 0.864 ),
	CHFL( 0.013 ), CHFL( -0.979 ) , CHFL( 0.201 ),
	CHFL( -0.39 ), CHFL( -0.916 ) , CHFL( 0.092 ),
	CHFL( -0.002 ), CHFL( -0.092 ) , CHFL( 0.996 ),
	CHFL( -0.772 ), CHFL( -0.271 ) , CHFL( 0.574 ),
	CHFL( 0.015 ), CHFL( 0.905 ) , CHFL( 0.426 ),
	CHFL( -0.753 ), CHFL( 0.656 ) , CHFL( 0.043 ),
	CHFL( 0.042 ), CHFL( 0.668 ) , CHFL( -0.743 ),
	CHFL( -0.361 ), CHFL( 0.554 ) , CHFL( -0.75 ),
	CHFL( 0.029 ), CHFL( -0.497 ) , CHFL( -0.867 ),
	CHFL( -0.727 ), CHFL( -0.33 ) , CHFL( -0.602 ),
	CHFL( 0.453 ), CHFL( -0.874 ) , CHFL( 0.174 ),
	CHFL( 0.027 ), CHFL( -0.979 ) , CHFL( 0.204 ),
	CHFL( 0.446 ), CHFL( -0.082 ) , CHFL( 0.891 ),
	CHFL( 0.019 ), CHFL( -0.105 ) , CHFL( 0.994 ),
	CHFL( 0.37 ), CHFL( 0.855 ) , CHFL( 0.365 ),
	CHFL( 0.031 ), CHFL( 0.912 ) , CHFL( 0.409 ),
	CHFL( 0.325 ), CHFL( 0.638 ) , CHFL( -0.699 ),
	CHFL( 0.048 ), CHFL( 0.673 ) , CHFL( -0.739 ),
	CHFL( 0.381 ), CHFL( -0.442 ) , CHFL( -0.812 ),
	CHFL( 0.045 ), CHFL( -0.495 ) , CHFL( -0.868 ),
	CHFL( 0.999 ), CHFL( 0.054 ) , CHFL( 0.001 ),
	CHFL( -0.049 ), CHFL( 0.211 ) , CHFL( -0.976 ),
	CHFL( -0.013 ), CHFL( -0.827 ) , CHFL( -0.561 ),
	CHFL( -0.014 ), CHFL( -0.747 ) , CHFL( 0.665 ),
	CHFL( -0.053 ), CHFL( 0.337 ) , CHFL( 0.94 ),
	CHFL( -0.097 ), CHFL( 0.993 ) , CHFL( -0.069 ),
	CHFL( 0.41 ), CHFL( 0.206 ) , CHFL( -0.888 ),
	CHFL( 0.461 ), CHFL( 0.885 ) , CHFL( -0.059 ),
	CHFL( 0.405 ), CHFL( 0.311 ) , CHFL( 0.86 ),
	CHFL( 0.507 ), CHFL( -0.614 ) , CHFL( 0.605 ),
	CHFL( 0.517 ), CHFL( -0.681 ) , CHFL( -0.519 ),
	CHFL( -0.216 ), CHFL( 0.233 ) , CHFL( -0.948 ),
	CHFL( -0.199 ), CHFL( 0.09 ) , CHFL( -0.976 ),
	CHFL( -0.088 ), CHFL( -0.762 ) , CHFL( -0.642 ),
	CHFL( -0.787 ), CHFL( 0.414 ) , CHFL( -0.457 ),
	CHFL( 0.103 ), CHFL( -0.739 ) , CHFL( 0.666 ),
	CHFL( -0.408 ), CHFL( -0.911 ) , CHFL( 0.063 ),
	CHFL( 0.064 ), CHFL( 0.351 ) , CHFL( 0.934 ),
	CHFL( -0.954 ), CHFL( 0.031 ) , CHFL( 0.298 ),
	CHFL( -0.107 ), CHFL( 0.978 ) , CHFL( -0.18 ),
	CHFL( -0.578 ), CHFL( 0.218 ) , CHFL( -0.786 ),
	CHFL( 0.055 ), CHFL( 0.214 ) , CHFL( -0.975 ),
	CHFL( 0.043 ), CHFL( 0.996 ) , CHFL( -0.072 ),
	CHFL( 0.063 ), CHFL( 0.348 ) , CHFL( 0.936 ),
	CHFL( 0.124 ), CHFL( -0.738 ) , CHFL( 0.663 ),
	CHFL( 0.118 ), CHFL( -0.822 ) , CHFL( -0.557 ),
	CHFL( 0.998 ), CHFL( 0.058 ) , CHFL( 0 ),
	CHFL( -0.049 ), CHFL( 0.21 ) , CHFL( -0.977 ),
	CHFL( -0.013 ), CHFL( -0.828 ) , CHFL( -0.56 ),
	CHFL( -0.016 ), CHFL( -0.744 ) , CHFL( 0.668 ),
	CHFL( -0.054 ), CHFL( 0.342 ) , CHFL( 0.938 ),
	CHFL( -0.097 ), CHFL( 0.993 ) , CHFL( -0.069 ),
	CHFL( 0.411 ), CHFL( 0.202 ) , CHFL( -0.889 ),
	CHFL( 0.461 ), CHFL( 0.885 ) , CHFL( -0.059 ),
	CHFL( 0.404 ), CHFL( 0.322 ) , CHFL( 0.856 ),
	CHFL( 0.511 ), CHFL( -0.606 ) , CHFL( 0.61 ),
	CHFL( 0.516 ), CHFL( -0.683 ) , CHFL( -0.517 ),
	CHFL( 0.053 ), CHFL( 0.219 ) , CHFL( -0.974 ),
	CHFL( -0.965 ), CHFL( 0.008 ) , CHFL( -0.263 ),
	CHFL( 0.096 ), CHFL( -0.824 ) , CHFL( -0.559 ),
	CHFL( -0.469 ), CHFL( -0.686 ) , CHFL( 0.556 ),
	CHFL( -0.087 ), CHFL( -0.668 ) , CHFL( 0.739 ),
	CHFL( -0.734 ), CHFL( 0.469 ) , CHFL( 0.491 ),
	CHFL( -0.22 ), CHFL( 0.346 ) , CHFL( 0.912 ),
	CHFL( -0.215 ), CHFL( 0.153 ) , CHFL( 0.965 ),
	CHFL( -0.122 ), CHFL( 0.992 ) , CHFL( 0.041 ),
	CHFL( -0.573 ), CHFL( 0.213 ) , CHFL( 0.792 ),
	CHFL( 0.061 ), CHFL( 0.216 ) , CHFL( -0.974 ),
	CHFL( 0.043 ), CHFL( 0.997 ) , CHFL( -0.065 ),
	CHFL( 0.057 ), CHFL( 0.345 ) , CHFL( 0.937 ),
	CHFL( 0.12 ), CHFL( -0.738 ) , CHFL( 0.664 ),
	CHFL( 0.123 ), CHFL( -0.822 ) , CHFL( -0.556 ),
	CHFL( 0.239 ), CHFL( 0.928 ) , CHFL( -0.285 ),
	CHFL( 0.252 ), CHFL( 0.252 ) , CHFL( 0.934 ),
	CHFL( 0.029 ), CHFL( 0.592 ) , CHFL( -0.805 ),
	CHFL( 0.066 ), CHFL( -0.404 ) , CHFL( 0.912 ),
	CHFL( -0.088 ), CHFL( 0.518 ) , CHFL( 0.851 ),
	CHFL( -0.093 ), CHFL( 0.996 ) , CHFL( -0.016 ),
	CHFL( 0.516 ), CHFL( 0.752 ) , CHFL( 0.41 ),
	CHFL( -0.257 ), CHFL( 0.886 ) , CHFL( -0.385 ),
	CHFL( -0.258 ), CHFL( 0.149 ) , CHFL( 0.955 ),
	CHFL( -0.503 ), CHFL( 0.369 ) , CHFL( 0.782 ),
	CHFL( -0.504 ), CHFL( 0.857 ) , CHFL( -0.105 ),
	CHFL( -0.255 ), CHFL( 0.835 ) , CHFL( -0.488 ),
	CHFL( -0.253 ), CHFL( 0.034 ) , CHFL( 0.967 ),
	CHFL( -0.296 ), CHFL( -0.308 ) , CHFL( 0.904 ),
	CHFL( -0.297 ), CHFL( 0.6 ) , CHFL( -0.743 ),
	CHFL( -0.488 ), CHFL( 0.647 ) , CHFL( -0.586 ),
	CHFL( -0.534 ), CHFL( -0.016 ) , CHFL( 0.845 ),
	CHFL( -0.492 ), CHFL( -0.824 ) , CHFL( 0.28 ),
	CHFL( -0.467 ), CHFL( -0.377 ) , CHFL( -0.8 ),
	CHFL( -0.173 ), CHFL( -0.537 ) , CHFL( -0.826 ),
	CHFL( -0.07 ), CHFL( -0.984 ) , CHFL( 0.166 ),
	CHFL( -0.434 ), CHFL( 0.119 ) , CHFL( -0.893 ),
	CHFL( -0.432 ), CHFL( -0.692 ) , CHFL( 0.578 ),
	CHFL( -0.931 ), CHFL( 0.317 ) , CHFL( 0.182 ),
	CHFL( -0.931 ), CHFL( 0.317 ) , CHFL( 0.182 ),
	CHFL( -0.087 ), CHFL( -0.948 ) , CHFL( -0.307 ),
	CHFL( 0.434 ), CHFL( -0.865 ) , CHFL( -0.253 ),
	CHFL( 0.433 ), CHFL( -0.867 ) , CHFL( 0.246 ),
	CHFL( -0.087 ), CHFL( -0.951 ) , CHFL( 0.296 ),
	CHFL( 0.273 ), CHFL( -0.35 ) , CHFL( 0.896 ),
	CHFL( 0.413 ), CHFL( 0.545 ) , CHFL( 0.73 ),
	CHFL( 0.699 ), CHFL( -0.6 ) , CHFL( 0.389 ),
	CHFL( 0.739 ), CHFL( 0.084 ) , CHFL( 0.669 ),
	CHFL( 0.44 ), CHFL( 0.731 ) , CHFL( 0.522 ),
	CHFL( -0.051 ), CHFL( -0.13 ) , CHFL( -0.99 ),
	CHFL( -0.742 ), CHFL( -0.056 ) , CHFL( -0.668 ),
	CHFL( -0.712 ), CHFL( 0.133 ) , CHFL( 0.689 ),
	CHFL( 0.002 ), CHFL( -0.313 ) , CHFL( 0.95 ),
	CHFL( -0.324 ), CHFL( 0.748 ) , CHFL( 0.579 ),
	CHFL( -0.742 ), CHFL( -0.056 ) , CHFL( -0.668 ),
	CHFL( -0.712 ), CHFL( 0.133 ) , CHFL( 0.689 ),
	CHFL( 0.633 ), CHFL( -0.249 ) , CHFL( 0.733 ),
	CHFL( 0.872 ), CHFL( -0.488 ) , CHFL( 0.048 ),
	CHFL( 0.455 ), CHFL( -0.666 ) , CHFL( 0.591 ),
	CHFL( 0.513 ), CHFL( -0.851 ) , CHFL( 0.115 ),
	CHFL( 0.227 ), CHFL( -0.314 ) , CHFL( -0.922 ),
	CHFL( 0.406 ), CHFL( 0.561 ) , CHFL( -0.721 ),
	CHFL( 0.725 ), CHFL( -0.422 ) , CHFL( -0.544 ),
	CHFL( 0.704 ), CHFL( 0.109 ) , CHFL( -0.702 ),
	CHFL( 0.44 ), CHFL( 0.841 ) , CHFL( -0.314 ),
	CHFL( 0.016 ), CHFL( -0.316 ) , CHFL( 0.949 ),
	CHFL( -0.703 ), CHFL( 0.13 ) , CHFL( 0.699 ),
	CHFL( -0.74 ), CHFL( -0.066 ) , CHFL( -0.669 ),
	CHFL( -0.033 ), CHFL( -0.571 ) , CHFL( -0.82 ),
	CHFL( -0.361 ), CHFL( 0.723 ) , CHFL( -0.59 ),
	CHFL( -0.703 ), CHFL( 0.13 ) , CHFL( 0.699 ),
	CHFL( -0.74 ), CHFL( -0.066 ) , CHFL( -0.669 ),
	CHFL( 0.595 ), CHFL( -0.455 ) , CHFL( -0.662 ),
	CHFL( 0.63 ), CHFL( -0.251 ) , CHFL( 0.735 ),
	CHFL( 0.43 ), CHFL( -0.811 ) , CHFL( -0.397 ),
	CHFL( 0.456 ), CHFL( -0.67 ) , CHFL( 0.586 ),
	CHFL( -0.3 ), CHFL( -0.921 ) , CHFL( -0.249 ),
	CHFL( -0.285 ), CHFL( -0.254 ) , CHFL( 0.924 ),
	CHFL( -0.323 ), CHFL( 0.917 ) , CHFL( 0.234 ),
	CHFL( -0.322 ), CHFL( 0.266 ) , CHFL( -0.909 ),
	CHFL( -0.135 ), CHFL( -0.27 ) , CHFL( 0.953 ),
	CHFL( -0.116 ), CHFL( -0.272 ) , CHFL( -0.955 ),
	CHFL( -0.294 ), CHFL( -0.581 ) , CHFL( 0.759 ),
	CHFL( -0.382 ), CHFL( -0.584 ) , CHFL( -0.716 ),
	CHFL( 0.007 ), CHFL( 0.863 ) , CHFL( -0.505 ),
	CHFL( -0.068 ), CHFL( 0.87 ) , CHFL( 0.489 ),
	CHFL( -0.281 ), CHFL( 0.782 ) , CHFL( -0.556 ),
	CHFL( -0.295 ), CHFL( 0.795 ) , CHFL( 0.53 ),
	CHFL( -0.272 ), CHFL( 0.817 ) , CHFL( -0.509 ),
	CHFL( -0.26 ), CHFL( 0.856 ) , CHFL( -0.447 ),
	CHFL( -0.134 ), CHFL( -0.287 ) , CHFL( 0.948 ),
	CHFL( -0.131 ), CHFL( -0.965 ) , CHFL( -0.229 ),
	CHFL( -0.422 ), CHFL( -0.08 ) , CHFL( -0.903 ),
	CHFL( -0.403 ), CHFL( -0.045 ) , CHFL( 0.914 ),
	CHFL( 0.03 ), CHFL( -0.216 ) , CHFL( -0.976 ),
	CHFL( 0.048 ), CHFL( -0.222 ) , CHFL( 0.974 ),
	CHFL( -0.049 ), CHFL( -0.144 ) , CHFL( -0.988 ),
	CHFL( 0.006 ), CHFL( 0.143 ) , CHFL( 0.99 ),
	CHFL( -0.051 ), CHFL( -0.13 ) , CHFL( -0.99 ),
	CHFL( -0.007 ), CHFL( 0.143 ) , CHFL( 0.99 ),
	CHFL( 0.715 ), CHFL( 0.093 ) , CHFL( 0.693 ),
	CHFL( 0.759 ), CHFL( -0.313 ) , CHFL( 0.571 ),
	CHFL( 0.704 ), CHFL( 0.647 ) , CHFL( -0.293 ),
	CHFL( 0.83 ), CHFL( 0.253 ) , CHFL( -0.498 ),
	CHFL( 0.853 ), CHFL( 0.457 ) , CHFL( 0.253 ),
	CHFL( 0.708 ), CHFL( -0.705 ) , CHFL( -0.041 ),
	CHFL( 0.727 ), CHFL( -0.547 ) , CHFL( -0.415 ),
	CHFL( 0.995 ), CHFL( -0.09 ) , CHFL( -0.049 ),
	CHFL( 0.919 ), CHFL( -0.346 ) , CHFL( -0.191 ),
	CHFL( 0.75 ), CHFL( 0.44 ) , CHFL( -0.494 ),
	CHFL( 0.651 ), CHFL( -0.674 ) , CHFL( -0.35 ),
	CHFL( 0.694 ), CHFL( -0.336 ) , CHFL( 0.637 ),
	CHFL( 0.651 ), CHFL( 0.123 ) , CHFL( -0.749 ),
	CHFL( 0.024 ), CHFL( 0.273 ) , CHFL( -0.962 ),
	CHFL( -0.003 ), CHFL( -0.962 ) , CHFL( -0.273 ),
	CHFL( 0.025 ), CHFL( 0.876 ) , CHFL( -0.482 ),
	CHFL( 0.005 ), CHFL( -0.302 ) , CHFL( 0.953 ),
	CHFL( 0.023 ), CHFL( 0.968 ) , CHFL( 0.248 ),
	CHFL( 0.014 ), CHFL( 0.86 ) , CHFL( -0.51 ),
	CHFL( 0.012 ), CHFL( -0.252 ) , CHFL( 0.968 ),
	CHFL( 0.006 ), CHFL( -0.975 ) , CHFL( -0.223 ),
	CHFL( 0.648 ), CHFL( 0.72 ) , CHFL( 0.247 ),
	CHFL( 0.673 ), CHFL( -0.024 ) , CHFL( 0.74 ),
	CHFL( 0.738 ), CHFL( 0.657 ) , CHFL( -0.154 ),
	CHFL( 0.699 ), CHFL( -0.712 ) , CHFL( -0.064 ),
	CHFL( -0.018 ), CHFL( 0.975 ) , CHFL( -0.222 ),
	CHFL( -0.018 ), CHFL( 0.335 ) , CHFL( 0.942 ),
	CHFL( 0.336 ), CHFL( 0.825 ) , CHFL( 0.454 ),
	CHFL( 0.12 ), CHFL( 0.992 ) , CHFL( 0.035 ),
	CHFL( 0.123 ), CHFL( 0.562 ) , CHFL( 0.818 ),
	CHFL( -0.547 ), CHFL( -0.647 ) , CHFL( -0.532 ),
	CHFL( -0.547 ), CHFL( -0.795 ) , CHFL( -0.262 ),
	CHFL( 0.997 ), CHFL( 0.056 ) , CHFL( -0.055 ),
	CHFL( 0.997 ), CHFL( 0.074 ) , CHFL( -0.011 ),
	CHFL( -0.542 ), CHFL( -0.84 ) , CHFL( 0.011 ),
	CHFL( -0.416 ), CHFL( 0.909 ) , CHFL( -0.001 ),
	CHFL( 0.007 ), CHFL( -0.481 ) , CHFL( 0.877 ),
	CHFL( 0.171 ), CHFL( 0.248 ) , CHFL( 0.954 ),
	CHFL( 0.036 ), CHFL( -0.984 ) , CHFL( 0.175 ),
	CHFL( 0.465 ), CHFL( 0.023 ) , CHFL( -0.885 ),
	CHFL( 0.511 ), CHFL( 0.361 ) , CHFL( -0.78 ),
	CHFL( 0.322 ), CHFL( 0.458 ) , CHFL( -0.829 ),
	CHFL( -0.07 ), CHFL( 0.429 ) , CHFL( -0.901 ),
	CHFL( 0.147 ), CHFL( 0.374 ) , CHFL( -0.916 ),
	CHFL( 0.096 ), CHFL( 0.683 ) , CHFL( -0.724 ),
	CHFL( -0.159 ), CHFL( 0.987 ) , CHFL( -0.031 ),
	CHFL( 0.023 ), CHFL( 0.019 ) , CHFL( -1 ),
	CHFL( -0.295 ), CHFL( 0.385 ) , CHFL( -0.875 ),
	CHFL( -0.363 ), CHFL( -0.586 ) , CHFL( -0.725 ),
	CHFL( -0.354 ), CHFL( 0.706 ) , CHFL( -0.614 ),
	CHFL( -0.03 ), CHFL( -0.999 ) , CHFL( 0.034 ),
	CHFL( -0.27 ), CHFL( 0.835 ) , CHFL( 0.479 ),
	CHFL( -0.313 ), CHFL( 0.843 ) , CHFL( -0.438 ),
	CHFL( -0.366 ), CHFL( 0.658 ) , CHFL( 0.658 ),
	CHFL( -0.115 ), CHFL( 0.248 ) , CHFL( -0.962 ),
	CHFL( -0.434 ), CHFL( -0.58 ) , CHFL( 0.69 ),
	CHFL( -0.144 ), CHFL( -0.625 ) , CHFL( -0.767 ),
	CHFL( -0.096 ), CHFL( 0.757 ) , CHFL( -0.647 ),
	CHFL( -0.133 ), CHFL( -0.977 ) , CHFL( -0.164 ),
	CHFL( -0.081 ), CHFL( 0.714 ) , CHFL( 0.696 ),
	CHFL( -0.156 ), CHFL( 0.714 ) , CHFL( -0.682 ),
	CHFL( -0.131 ), CHFL( 0.75 ) , CHFL( 0.648 ),
	CHFL( -0.084 ), CHFL( 0.039 ) , CHFL( -0.996 ),
	CHFL( -0.064 ), CHFL( -0.622 ) , CHFL( 0.781 ),
	CHFL( 0.983 ), CHFL( 0.12 ) , CHFL( -0.14 ),
	CHFL( 0.579 ), CHFL( 0.707 ) , CHFL( 0.405 ),
	CHFL( 0.983 ), CHFL( 0.12 ) , CHFL( -0.14 ),
	CHFL( 0.818 ), CHFL( 0.192 ) , CHFL( 0.541 ),
	CHFL( 0.694 ), CHFL( -0.383 ) , CHFL( -0.61 ),
	CHFL( 0.804 ), CHFL( 0.226 ) , CHFL( -0.55 ),
	CHFL( -0.007 ), CHFL( -0.974 ) , CHFL( -0.225 ),
	CHFL( -0.246 ), CHFL( 0.605 ) , CHFL( 0.757 ),
};


model_polys t_skin_polys[] =
{
	{
		GOURAUD,
		4,
		147, 143, 142, 174,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		26, 28, 29, 27,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		6, 7, 9, 8,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		2, 3, 5, 4,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		204, 93, 177, 181,
		{ 247, 110, 63, 0 },
		126, 180, 153, 127,
		83, 77, 2, 1,
	},
	{
		GOURAUD,
		4,
		2, 0, 1, 3,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		20, 22, 23, 21,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		22, 24, 25, 23,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		157, 121, 122, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		34, 35, 33, 32,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		14, 12, 13, 15,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		213, 215, 225, 227,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		247, 245, 246, 248,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		24, 26, 27, 25,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		6, 4, 5, 7,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		215, 216, 226, 225,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		163, 161, 138, 158,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		226, 228, 236, 234,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		228, 227, 235, 236,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		218, 219, 224, 222,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		10, 18, 19, 11,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		38, 30, 31, 39,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		34, 36, 37, 35,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		16, 14, 15, 17,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		234, 236, 248, 246,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		12, 10, 11, 13,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		18, 16, 17, 19,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		236, 235, 247, 248,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		235, 233, 245, 247,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		233, 234, 246, 245,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		74, 70, 69, 75,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		223, 221, 229, 231,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		221, 222, 230, 229,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		219, 220, 223, 224,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		46, 50, 42, 41,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		216, 214, 228, 226,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		214, 213, 227, 228,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		220, 217, 221, 223,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		112, 111, 183, 182,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		227, 225, 233, 235,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		225, 226, 234, 233,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		217, 218, 222, 221,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		108, 109, 114, 105,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		0, 8, 9, 1,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		28, 20, 21, 29,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		111, 94, 220, 219,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		92, 204, 181, 179,
		{ 247, 110, 63, 0 },
		74, 126, 127, 100,
		77, 83, 1, 2,
	},
	{
		GOURAUD,
		4,
		222, 224, 232, 230,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		224, 223, 231, 232,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		94, 180, 217, 220,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		230, 232, 240, 238,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		232, 231, 239, 240,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		231, 229, 237, 239,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		229, 230, 238, 237,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		238, 240, 244, 242,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		36, 38, 39, 37,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		30, 32, 33, 31,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		240, 239, 243, 244,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		239, 237, 241, 243,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		237, 238, 242, 241,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		50, 46, 40, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		53, 51, 61, 65,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		96, 206, 203, 98,
		{ 247, 110, 63, 0 },
		144, 160, 177, 126,
		137, 138, 130, 110,
	},
	{
		GOURAUD,
		3,
		49, 50, 40, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		55, 53, 65, 64,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		175, 134, 136, 126,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		48, 49, 40, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		57, 55, 64, 63,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		107, 106, 113, 110,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		47, 48, 40, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		59, 57, 63, 62,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		142, 152, 150, 174,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		46, 47, 40, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		51, 59, 62, 61,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		173, 149, 151, 145,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		210, 14, 16, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		59, 51, 52, 60,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		19, 17, 6, 8,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		10, 12, 210, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		57, 59, 60, 58,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		11, 19, 8, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		51, 53, 54, 52,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		210, 18, 10, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		13, 11, 0, 2,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		53, 55, 56, 54,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		12, 14, 210, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		15, 13, 2, 4,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		55, 57, 58, 56,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		16, 18, 210, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		17, 15, 4, 6,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		9, 7, 5, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		73, 72, 67, 71,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		1, 9, 3, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		76, 75, 69, 68,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		74, 73, 71, 70,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		3, 9, 5, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		48, 47, 45, 44,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		46, 41, 45, 47,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		29, 21, 23, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		50, 49, 43, 42,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		76, 72, 66, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		79, 77, 87, 91,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		118, 137, 140, 139,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		75, 76, 66, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		81, 79, 91, 90,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		121, 119, 123, 124,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		74, 75, 66, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		83, 81, 90, 89,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		116, 96, 98, 0,
		{ 247, 110, 63, 0 },
		130, 135, 127, 0,
		19, 20, 15, 0,
	},
	{
		GOURAUD,
		3,
		73, 74, 66, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		85, 83, 89, 88,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		115, 116, 98, 0,
		{ 247, 110, 63, 0 },
		119, 137, 126, 0,
		120, 120, 109, 0,
	},
	{
		GOURAUD,
		3,
		72, 73, 66, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		77, 85, 88, 87,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		97, 115, 98, 0,
		{ 247, 110, 63, 0 },
		119, 124, 127, 0,
		20, 19, 15, 0,
	},
	{
		GOURAUD,
		3,
		32, 30, 209, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		85, 77, 78, 86,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		37, 39, 28, 26,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		209, 38, 36, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		83, 85, 86, 84,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		35, 37, 26, 24,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		77, 79, 80, 78,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		209, 34, 32, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		33, 35, 24, 22,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		79, 81, 82, 80,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		36, 34, 209, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		31, 33, 22, 20,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		81, 83, 84, 82,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		30, 38, 209, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		39, 31, 20, 28,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		29, 25, 27, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		72, 76, 68, 67,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		95, 112, 215, 213,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		29, 23, 25, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		182, 178, 214, 216,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		112, 182, 216, 215,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		183, 111, 219, 218,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		178, 95, 213, 214,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		180, 183, 218, 217,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		48, 44, 43, 49,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		117, 158, 137, 118,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		157, 120, 119, 121,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		138, 137, 158, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		134, 133, 135, 136,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		80, 172, 159, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		193, 191, 187, 188,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		151, 152, 142, 145,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		191, 190, 189, 187,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		190, 192, 186, 189,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		192, 193, 188, 186,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		196, 197, 201, 199,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		197, 195, 200, 201,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		195, 194, 198, 200,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		194, 196, 199, 198,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		136, 135, 129, 126,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		164, 163, 212, 0,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		212, 130, 164, 0,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		80, 170, 78, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		146, 163, 158, 169,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		200, 198, 199, 201,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		163, 164, 162, 161,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		202, 205, 97, 98,
		{ 247, 110, 63, 0 },
		76, 94, 112, 126,
		130, 142, 137, 110,
	},
	{
		TEXTURED,
		3,
		100, 105, 203, 0,
		{ 247, 110, 63, 0 },
		150, 165, 159, 0,
		23, 22, 17, 0,
	},
	{
		GOURAUD,
		4,
		138, 122, 125, 141,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		212, 146, 60, 211,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		106, 99, 202, 0,
		{ 247, 110, 63, 0 },
		90, 105, 96, 0,
		22, 23, 17, 0,
	},
	{
		GOURAUD,
		4,
		110, 113, 111, 207,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		137, 138, 140, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		101, 104, 100, 96,
		{ 247, 110, 63, 0 },
		148, 160, 173, 139,
		193, 176, 160, 137,
	},
	{
		TEXTURED,
		4,
		97, 99, 103, 102,
		{ 247, 110, 63, 0 },
		115, 77, 103, 108,
		136, 157, 174, 194,
	},
	{
		TEXTURED,
		4,
		96, 97, 102, 101,
		{ 247, 110, 63, 0 },
		140, 115, 108, 148,
		135, 136, 194, 193,
	},
	{
		GOURAUD,
		3,
		163, 146, 212, 0,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		189, 186, 188, 187,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		103, 99, 106, 107,
		{ 247, 110, 63, 0 },
		111, 105, 90, 104,
		27, 23, 22, 29,
	},
	{
		TEXTURED,
		4,
		108, 105, 100, 104,
		{ 247, 110, 63, 0 },
		151, 165, 150, 144,
		29, 22, 23, 27,
	},
	{
		TEXTURED,
		4,
		108, 101, 102, 107,
		{ 247, 110, 63, 0 },
		151, 137, 117, 104,
		29, 30, 30, 29,
	},
	{
		TEXTURED,
		3,
		104, 101, 108, 0,
		{ 247, 110, 63, 0 },
		144, 137, 151, 0,
		27, 30, 29, 0,
	},
	{
		TEXTURED,
		3,
		107, 102, 103, 0,
		{ 247, 110, 63, 0 },
		104, 117, 111, 0,
		29, 30, 27, 0,
	},
	{
		GOURAUD,
		3,
		159, 120, 157, 0,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		130, 170, 157, 164,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		203, 105, 95, 93,
		{ 247, 110, 63, 0 },
		177, 240, 242, 180,
		130, 181, 100, 77,
	},
	{
		TEXTURED,
		4,
		97, 96, 116, 115,
		{ 247, 110, 63, 0 },
		115, 140, 132, 122,
		136, 135, 121, 121,
	},
	{
		GOURAUD,
		4,
		155, 154, 196, 194,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		168, 165, 195, 197,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		106, 202, 92, 94,
		{ 247, 110, 63, 0 },
		12, 76, 72, 15,
		178, 130, 76, 98,
	},
	{
		GOURAUD,
		3,
		78, 170, 86, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		84, 86, 211, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		123, 139, 110, 109,
		{ 247, 110, 63, 0 },
		148, 106, 106, 148,
		32, 32, 26, 26,
	},
	{
		GOURAUD,
		4,
		132, 131, 127, 128,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		147, 148, 144, 143,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		125, 123, 109, 108,
		{ 247, 110, 63, 0 },
		151, 148, 148, 151,
		38, 32, 26, 29,
	},
	{
		TEXTURED,
		4,
		141, 107, 110, 139,
		{ 247, 110, 63, 0 },
		104, 104, 106, 106,
		38, 29, 26, 32,
	},
	{
		GOURAUD,
		4,
		166, 167, 193, 192,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		181, 177, 178, 184,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		184, 180, 179, 181,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		60, 169, 58, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		120, 117, 118, 119,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		109, 110, 207, 208,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		86, 170, 130, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		96, 100, 203, 206,
		{ 247, 110, 63, 0 },
		135, 150, 159, 147,
		20, 23, 17, 18,
	},
	{
		GOURAUD,
		4,
		54, 82, 84, 52,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		119, 118, 139, 123,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		160, 158, 117, 0,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		207, 111, 112, 208,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		176, 132, 128, 129,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		149, 150, 152, 151,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		105, 114, 112, 95,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		106, 94, 111, 113,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		60, 146, 169, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		154, 168, 197, 196,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		94, 92, 179, 180,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		243, 241, 242, 244,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		185, 183, 180, 184,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		185, 184, 178, 182,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		211, 52, 84, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		160, 169, 158, 0,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		129, 135, 133, 176,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		159, 160, 117, 120,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		204, 92, 202, 98,
		{ 247, 110, 63, 0 },
		126, 72, 76, 126,
		84, 77, 130, 110,
	},
	{
		GOURAUD,
		3,
		124, 122, 121, 0,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		161, 162, 122, 138,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		211, 60, 52, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		211, 86, 130, 212,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		183, 185, 182, 0,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		131, 175, 126, 127,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		54, 171, 172, 82,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		54, 56, 171, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		160, 159, 172, 171,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		82, 172, 80, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		170, 159, 157, 0,
		{ 247, 110, 63, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		202, 99, 97, 205,
		{ 247, 110, 63, 0 },
		96, 105, 119, 108,
		17, 23, 20, 18,
	},
	{
		TEXTURED,
		4,
		141, 125, 108, 107,
		{ 247, 110, 63, 0 },
		104, 151, 151, 104,
		38, 38, 29, 29,
	},
	{
		GOURAUD,
		4,
		164, 157, 122, 162,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		167, 153, 191, 193,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		98, 203, 93, 204,
		{ 247, 110, 63, 0 },
		126, 177, 180, 126,
		110, 130, 77, 84,
	},
	{
		GOURAUD,
		4,
		122, 124, 123, 125,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		208, 112, 114, 109,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		153, 156, 190, 191,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		165, 155, 194, 195,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		138, 141, 139, 140,
		{ 255, 152, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		56, 58, 169, 160,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		156, 166, 192, 190,
		{ 210, 0, 0, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		56, 160, 171, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		80, 159, 170, 0,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		148, 173, 145, 144,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		95, 178, 177, 93,
		{ 255, 193, 47, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		44, 45, 62, 63,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		45, 41, 61, 62,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		41, 42, 65, 61,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		42, 43, 64, 65,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		43, 44, 63, 64,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		70, 71, 88, 89,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		71, 67, 87, 88,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		67, 68, 91, 87,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		68, 69, 90, 91,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		69, 70, 89, 90,
		{ 31, 27, 26, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
};
