#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
#include <LibCD.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"


node t_rfoot =
{
	JOINT,
	CHFL( 32.380001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_rfoot,	// vertex attachment
	&Verts_t_rfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node t_lrleg =
{
	JOINT,
	CHFL( 35.480000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( -5.884000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_lrleg,	// vertex attachment
	&Verts_t_lrleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_rfoot,	// Joint
};

node t_urleg =
{
	JOINT,
	CHFL( 11.160000 ), CHFL( -3.172000 ), CHFL( -7.376000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_urleg,	// vertex attachment
	&Verts_t_urleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_lrleg,	// Joint
};

node t_lfoot =
{
	JOINT,
	CHFL( 32.380001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_lfoot,	// vertex attachment
	&Verts_t_lfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node t_llleg =
{
	JOINT,
	CHFL( 35.480000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( -5.884000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_llleg,	// vertex attachment
	&Verts_t_llleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_lfoot,	// Joint
};

node t_ulleg =
{
	JOINT,
	CHFL( 11.160000 ), CHFL( -3.172000 ), CHFL( 7.616000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_ulleg,	// vertex attachment
	&Verts_t_ulleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_llleg,	// Joint
};

node t_peni =
{
	JOINT,
	CHFL( 12.375999 ), CHFL( 0.192000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_peni,	// vertex attachment
	&Verts_t_peni_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node t_head =
{
	JOINT,
	CHFL( 3.516000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_head,	// vertex attachment
	&Verts_t_head_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node t_jnt184_1 =
{
	JOINT,
	CHFL( 26.572001 ), CHFL( 0.028000 ), CHFL( 0.080000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_jnt184_1,	// vertex attachment
	&Verts_t_jnt184_1_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_head,	// Joint
};

node t_lhand =
{
	JOINT,
	CHFL( 14.852000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_lhand,	// vertex attachment
	&Verts_t_lhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node t_llarm =
{
	JOINT,
	CHFL( 20.572001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_llarm,	// vertex attachment
	&Verts_t_llarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_lhand,	// Joint
};

node t_ularm =
{
	JOINT,
	CHFL( 19.223999 ), CHFL( 7.332000 ), CHFL( 12.460000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_ularm,	// vertex attachment
	&Verts_t_ularm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_llarm,	// Joint
};

node t_rhand =
{
	JOINT,
	CHFL( 14.592000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_rhand,	// vertex attachment
	&Verts_t_rhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node t_lrarm =
{
	JOINT,
	CHFL( 20.572001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_lrarm,	// vertex attachment
	&Verts_t_lrarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_rhand,	// Joint
};

node t_urarm =
{
	JOINT,
	CHFL( 19.284000 ), CHFL( -6.592000 ), CHFL( -12.692000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_urarm,	// vertex attachment
	&Verts_t_urarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_lrarm,	// Joint
};

node t_chest =
{
	JOINT,
	CHFL( 21.468000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_chest,	// vertex attachment
	&Verts_t_chest_Lo,	// vertex attachment
	3,	// NumberOfChildren
	&t_urarm,	// Joint
	&t_ularm,	// Joint
	&t_jnt184_1,	// Joint
};

node t_tum =
{
	JOINT,
	CHFL( 12.016000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_tum,	// vertex attachment
	&Verts_t_tum_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&t_chest,	// Joint
};

node t_bum =
{
	JOINT,
	CHFL( 0.008000 ), CHFL( 0.768000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_t_bum,	// vertex attachment
	&Verts_t_bum_Lo,	// vertex attachment
	4,	// NumberOfChildren
	&t_tum,	// Joint
	&t_peni,	// Joint
	&t_ulleg,	// Joint
	&t_urleg,	// Joint
};

node t_virgin =
{
	CHAIN_ROOT,
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	NULL,	// No verts attached (Chain Root or Effector)
	NULL,	// No verts attached (Chain Root or Effector)
	1,	// NumberOfChildren
	&t_bum,	// Chain Root
};

