#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
//#include <libds.h>
#include <libcd.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"




// Skinner.exe : y_skin.c ( 243 vertices, 242 polygons )

uint32 y_skin_num_verts = 243;
uint32 y_skin_num_polys = 242;

chfloat y_skin_verts[] =
{
	CHFL( 68.696 ), CHFL( 0.172 ) , CHFL( 12.316 ),
	CHFL( 66.252 ), CHFL( -3.064 ) , CHFL( 13.52 ),
	CHFL( 48.472 ), CHFL( -4.328 ) , CHFL( 14.604 ),
	CHFL( 66.048 ), CHFL( -1.82 ) , CHFL( 9.696 ),
	CHFL( 46.016 ), CHFL( -2.516 ) , CHFL( 10.612 ),
	CHFL( 66.112 ), CHFL( 2.232 ) , CHFL( 9.688 ),
	CHFL( 46.108 ), CHFL( 3.264 ) , CHFL( 10.596 ),
	CHFL( 66.352 ), CHFL( 3.492 ) , CHFL( 13.504 ),
	CHFL( 48.62 ), CHFL( 5.024 ) , CHFL( 14.58 ),
	CHFL( 66.436 ), CHFL( 0.216 ) , CHFL( 15.876 ),
	CHFL( 48.692 ), CHFL( 0.352 ) , CHFL( 17.136 ),
	CHFL( 81.3 ), CHFL( -2.56 ) , CHFL( 12.772 ),
	CHFL( 66.532 ), CHFL( -3.136 ) , CHFL( 13.484 ),
	CHFL( 81.176 ), CHFL( -1.632 ) , CHFL( 9.884 ),
	CHFL( 66.364 ), CHFL( -1.904 ) , CHFL( 9.656 ),
	CHFL( 81.036 ), CHFL( 1.42 ) , CHFL( 9.872 ),
	CHFL( 66.176 ), CHFL( 2.14 ) , CHFL( 9.64 ),
	CHFL( 81.072 ), CHFL( 2.38 ) , CHFL( 12.752 ),
	CHFL( 66.228 ), CHFL( 3.412 ) , CHFL( 13.46 ),
	CHFL( 81.24 ), CHFL( -0.08 ) , CHFL( 14.544 ),
	CHFL( 66.448 ), CHFL( 0.152 ) , CHFL( 15.836 ),
	CHFL( 68.704 ), CHFL( -0.584 ) , CHFL( -12.48 ),
	CHFL( 66.276 ), CHFL( -3.064 ) , CHFL( -13.696 ),
	CHFL( 48.504 ), CHFL( -4.328 ) , CHFL( -14.848 ),
	CHFL( 66.06 ), CHFL( -1.82 ) , CHFL( -9.872 ),
	CHFL( 46.028 ), CHFL( -2.516 ) , CHFL( -10.868 ),
	CHFL( 66.12 ), CHFL( 2.232 ) , CHFL( -9.86 ),
	CHFL( 46.12 ), CHFL( 3.264 ) , CHFL( -10.852 ),
	CHFL( 66.376 ), CHFL( 3.492 ) , CHFL( -13.676 ),
	CHFL( 48.648 ), CHFL( 5.024 ) , CHFL( -14.828 ),
	CHFL( 66.472 ), CHFL( 0.216 ) , CHFL( -16.048 ),
	CHFL( 48.732 ), CHFL( 0.352 ) , CHFL( -17.38 ),
	CHFL( 81.316 ), CHFL( -2.556 ) , CHFL( -12.904 ),
	CHFL( 66.548 ), CHFL( -3.136 ) , CHFL( -13.66 ),
	CHFL( 81.18 ), CHFL( -1.628 ) , CHFL( -10.016 ),
	CHFL( 66.368 ), CHFL( -1.904 ) , CHFL( -9.828 ),
	CHFL( 81.04 ), CHFL( 1.424 ) , CHFL( -10.004 ),
	CHFL( 66.18 ), CHFL( 2.144 ) , CHFL( -9.812 ),
	CHFL( 81.088 ), CHFL( 2.384 ) , CHFL( -12.884 ),
	CHFL( 66.244 ), CHFL( 3.416 ) , CHFL( -13.632 ),
	CHFL( 81.256 ), CHFL( -0.076 ) , CHFL( -14.676 ),
	CHFL( 66.472 ), CHFL( 0.152 ) , CHFL( -16.008 ),
	CHFL( 47.02 ), CHFL( 0.948 ) , CHFL( -2.64 ),
	CHFL( 47.436 ), CHFL( 6.36 ) , CHFL( -4.016 ),
	CHFL( 47.436 ), CHFL( 6.36 ) , CHFL( -8.468 ),
	CHFL( 47.02 ), CHFL( 0.948 ) , CHFL( -9.844 ),
	CHFL( 46.76 ), CHFL( -2.396 ) , CHFL( -6.24 ),
	CHFL( 75.952 ), CHFL( -1.556 ) , CHFL( -0.7 ),
	CHFL( 75.68 ), CHFL( -7.16 ) , CHFL( -6.24 ),
	CHFL( 75.952 ), CHFL( -1.556 ) , CHFL( -11.78 ),
	CHFL( 76.396 ), CHFL( 7.508 ) , CHFL( -9.664 ),
	CHFL( 76.396 ), CHFL( 7.508 ) , CHFL( -2.816 ),
	CHFL( 51.316 ), CHFL( -0.908 ) , CHFL( -6.528 ),
	CHFL( 21.776 ), CHFL( 0.596 ) , CHFL( -1.156 ),
	CHFL( 18.112 ), CHFL( 9.184 ) , CHFL( -3.1 ),
	CHFL( 18.112 ), CHFL( 9.184 ) , CHFL( -10.156 ),
	CHFL( 19.528 ), CHFL( 0.368 ) , CHFL( -12.26 ),
	CHFL( 20.024 ), CHFL( -4.524 ) , CHFL( -6.24 ),
	CHFL( 47.108 ), CHFL( 0.764 ) , CHFL( -2.64 ),
	CHFL( 47.444 ), CHFL( -2.576 ) , CHFL( -6.24 ),
	CHFL( 47.108 ), CHFL( 0.764 ) , CHFL( -9.844 ),
	CHFL( 46.56 ), CHFL( 6.164 ) , CHFL( -8.468 ),
	CHFL( 46.56 ), CHFL( 6.164 ) , CHFL( -4.016 ),
	CHFL( 47.02 ), CHFL( 0.904 ) , CHFL( 9.948 ),
	CHFL( 47.392 ), CHFL( 6.32 ) , CHFL( 8.572 ),
	CHFL( 47.392 ), CHFL( 6.32 ) , CHFL( 4.12 ),
	CHFL( 47.02 ), CHFL( 0.904 ) , CHFL( 2.744 ),
	CHFL( 46.788 ), CHFL( -2.444 ) , CHFL( 6.348 ),
	CHFL( 75.972 ), CHFL( -1.364 ) , CHFL( 11.888 ),
	CHFL( 75.744 ), CHFL( -6.968 ) , CHFL( 6.348 ),
	CHFL( 75.972 ), CHFL( -1.364 ) , CHFL( 0.808 ),
	CHFL( 76.34 ), CHFL( 7.704 ) , CHFL( 2.924 ),
	CHFL( 76.34 ), CHFL( 7.704 ) , CHFL( 9.772 ),
	CHFL( 51.34 ), CHFL( -1.004 ) , CHFL( 6.552 ),
	CHFL( 19.52 ), CHFL( 0.404 ) , CHFL( 12.428 ),
	CHFL( 18.12 ), CHFL( 9.18 ) , CHFL( 10.292 ),
	CHFL( 18.12 ), CHFL( 9.18 ) , CHFL( 3.204 ),
	CHFL( 21.776 ), CHFL( 0.588 ) , CHFL( 1.26 ),
	CHFL( 20.016 ), CHFL( -4.528 ) , CHFL( 6.348 ),
	CHFL( 47.104 ), CHFL( 0.728 ) , CHFL( 9.948 ),
	CHFL( 47.44 ), CHFL( -2.608 ) , CHFL( 6.348 ),
	CHFL( 47.104 ), CHFL( 0.728 ) , CHFL( 2.744 ),
	CHFL( 46.564 ), CHFL( 6.128 ) , CHFL( 4.12 ),
	CHFL( 46.564 ), CHFL( 6.128 ) , CHFL( 8.572 ),
	CHFL( 67.96 ), CHFL( -5.82 ) , CHFL( 4.736 ),
	CHFL( 67.96 ), CHFL( -5.82 ) , CHFL( -4.584 ),
	CHFL( 65.992 ), CHFL( -2.42 ) , CHFL( 5.712 ),
	CHFL( 65.996 ), CHFL( -2.42 ) , CHFL( -5.556 ),
	CHFL( 63.4 ), CHFL( -8.26 ) , CHFL( -1.004 ),
	CHFL( 63.388 ), CHFL( -8.26 ) , CHFL( 1.16 ),
	CHFL( 65.916 ), CHFL( -7.24 ) , CHFL( 0.112 ),
	CHFL( 61.168 ), CHFL( -6.388 ) , CHFL( 3.096 ),
	CHFL( 61.172 ), CHFL( -6.384 ) , CHFL( -2.944 ),
	CHFL( 58.104 ), CHFL( -7.584 ) , CHFL( -1.308 ),
	CHFL( 58.104 ), CHFL( -7.584 ) , CHFL( 1.46 ),
	CHFL( 59.636 ), CHFL( -6.984 ) , CHFL( 2.28 ),
	CHFL( 59.64 ), CHFL( -6.984 ) , CHFL( -2.128 ),
	CHFL( 61.096 ), CHFL( -1.124 ) , CHFL( -5.032 ),
	CHFL( 61.092 ), CHFL( -1.124 ) , CHFL( 5.184 ),
	CHFL( 57.88 ), CHFL( -2.732 ) , CHFL( 3.284 ),
	CHFL( 57.884 ), CHFL( -2.732 ) , CHFL( -3.132 ),
	CHFL( 58.852 ), CHFL( 3.876 ) , CHFL( -2.788 ),
	CHFL( 58.848 ), CHFL( 3.872 ) , CHFL( 2.94 ),
	CHFL( 65.024 ), CHFL( 7.372 ) , CHFL( 5.076 ),
	CHFL( 65.024 ), CHFL( 7.372 ) , CHFL( -4.904 ),
	CHFL( 63.848 ), CHFL( -9.412 ) , CHFL( 0.496 ),
	CHFL( 63.856 ), CHFL( -9.408 ) , CHFL( -0.34 ),
	CHFL( 34.452 ), CHFL( -7.816 ) , CHFL( -6.396 ),
	CHFL( 50.212 ), CHFL( -6.732 ) , CHFL( -7.26 ),
	CHFL( 50.212 ), CHFL( -6.732 ) , CHFL( 7.104 ),
	CHFL( 34.292 ), CHFL( -7.808 ) , CHFL( 6.276 ),
	CHFL( 49.812 ), CHFL( -5.644 ) , CHFL( 10.724 ),
	CHFL( 47.424 ), CHFL( 6.804 ) , CHFL( 10.1 ),
	CHFL( 53.344 ), CHFL( -3.256 ) , CHFL( 2.788 ),
	CHFL( 51.672 ), CHFL( -0.352 ) , CHFL( 10.292 ),
	CHFL( 50.764 ), CHFL( 3.328 ) , CHFL( 3.132 ),
	CHFL( 81.224 ), CHFL( -2.016 ) , CHFL( 2.46 ),
	CHFL( 75.388 ), CHFL( -3.324 ) , CHFL( 2.936 ),
	CHFL( 75.388 ), CHFL( -3.324 ) , CHFL( 9.468 ),
	CHFL( 81.284 ), CHFL( -1.8 ) , CHFL( 10.908 ),
	CHFL( 25.416 ), CHFL( 8.24 ) , CHFL( 6.928 ),
	CHFL( 75.188 ), CHFL( 9.78 ) , CHFL( 2.928 ),
	CHFL( 75.188 ), CHFL( 9.78 ) , CHFL( 9.476 ),
	CHFL( 98.396 ), CHFL( 3.336 ) , CHFL( 9.94 ),
	CHFL( 98.4 ), CHFL( 3.34 ) , CHFL( 2.46 ),
	CHFL( 96.356 ), CHFL( -0.816 ) , CHFL( 9.932 ),
	CHFL( 96.356 ), CHFL( -0.816 ) , CHFL( 2.452 ),
	CHFL( 49.876 ), CHFL( -5.556 ) , CHFL( -10.844 ),
	CHFL( 47.444 ), CHFL( 7.064 ) , CHFL( -9.152 ),
	CHFL( 53.344 ), CHFL( -3.256 ) , CHFL( -2.94 ),
	CHFL( 51.648 ), CHFL( -0.376 ) , CHFL( -10.428 ),
	CHFL( 50.764 ), CHFL( 3.328 ) , CHFL( -3.284 ),
	CHFL( 81.396 ), CHFL( -2.26 ) , CHFL( -2.74 ),
	CHFL( 75.56 ), CHFL( -3.572 ) , CHFL( -2.816 ),
	CHFL( 75.56 ), CHFL( -3.572 ) , CHFL( -9.396 ),
	CHFL( 81.396 ), CHFL( -2.26 ) , CHFL( -10.708 ),
	CHFL( 25.416 ), CHFL( 8.24 ) , CHFL( -7.044 ),
	CHFL( 75.352 ), CHFL( 9.528 ) , CHFL( -2.784 ),
	CHFL( 75.352 ), CHFL( 9.528 ) , CHFL( -9.568 ),
	CHFL( 98.512 ), CHFL( 2.908 ) , CHFL( -9.904 ),
	CHFL( 98.512 ), CHFL( 2.908 ) , CHFL( -2.508 ),
	CHFL( 96.524 ), CHFL( -1.056 ) , CHFL( -9.84 ),
	CHFL( 96.524 ), CHFL( -1.056 ) , CHFL( -2.736 ),
	CHFL( 38.18 ), CHFL( -5.468 ) , CHFL( 10.868 ),
	CHFL( 38.168 ), CHFL( -5.444 ) , CHFL( -10.772 ),
	CHFL( 19.004 ), CHFL( -6.608 ) , CHFL( 7.764 ),
	CHFL( 19.004 ), CHFL( -6.608 ) , CHFL( -6.82 ),
	CHFL( 39.22 ), CHFL( 13.34 ) , CHFL( -10.068 ),
	CHFL( 39.212 ), CHFL( 13.36 ) , CHFL( 10.108 ),
	CHFL( 35.076 ), CHFL( 9.636 ) , CHFL( -9.092 ),
	CHFL( 35.004 ), CHFL( 9.756 ) , CHFL( 7.76 ),
	CHFL( 25.596 ), CHFL( 2.616 ) , CHFL( -8.088 ),
	CHFL( 25.596 ), CHFL( 2.616 ) , CHFL( 8.008 ),
	CHFL( 3.388 ), CHFL( -0.496 ) , CHFL( -6.916 ),
	CHFL( 3.384 ), CHFL( -0.472 ) , CHFL( 6.892 ),
	CHFL( 85.524 ), CHFL( 6.608 ) , CHFL( -10.828 ),
	CHFL( 85.524 ), CHFL( 6.608 ) , CHFL( -2.656 ),
	CHFL( 85.388 ), CHFL( 6.948 ) , CHFL( 2.46 ),
	CHFL( 85.388 ), CHFL( 6.948 ) , CHFL( 10.912 ),
	CHFL( 72.116 ), CHFL( -3.716 ) , CHFL( -3.36 ),
	CHFL( 71.976 ), CHFL( -0.756 ) , CHFL( -4 ),
	CHFL( 72.112 ), CHFL( -3.716 ) , CHFL( 3.748 ),
	CHFL( 71.976 ), CHFL( -0.756 ) , CHFL( 4.376 ),
	CHFL( 72.948 ), CHFL( -4.056 ) , CHFL( 0.168 ),
	CHFL( 70.536 ), CHFL( 5.64 ) , CHFL( -3.408 ),
	CHFL( 70.536 ), CHFL( 5.64 ) , CHFL( 3.616 ),
	CHFL( 73.092 ), CHFL( -0.62 ) , CHFL( 0.144 ),
	CHFL( 72.008 ), CHFL( 4.04 ) , CHFL( 0.148 ),
	CHFL( 96.088 ), CHFL( 2.976 ) , CHFL( -10.3 ),
	CHFL( 95.548 ), CHFL( -1.804 ) , CHFL( -14.1 ),
	CHFL( 96.78 ), CHFL( -1.624 ) , CHFL( -11.104 ),
	CHFL( 95.024 ), CHFL( 3.076 ) , CHFL( -13.864 ),
	CHFL( 88.064 ), CHFL( 4.984 ) , CHFL( -15.452 ),
	CHFL( 88.956 ), CHFL( -3.716 ) , CHFL( -15.728 ),
	CHFL( 88.032 ), CHFL( 4.92 ) , CHFL( -10.228 ),
	CHFL( 89.104 ), CHFL( -3.652 ) , CHFL( -11.052 ),
	CHFL( 87.904 ), CHFL( 4.988 ) , CHFL( 15.44 ),
	CHFL( 88.056 ), CHFL( 4.8 ) , CHFL( 10.028 ),
	CHFL( 89.052 ), CHFL( -3.684 ) , CHFL( 15.748 ),
	CHFL( 89.26 ), CHFL( -3.572 ) , CHFL( 10.876 ),
	CHFL( 94.904 ), CHFL( 3.116 ) , CHFL( 14.004 ),
	CHFL( 95.668 ), CHFL( -1.736 ) , CHFL( 14.26 ),
	CHFL( 96.104 ), CHFL( 3.044 ) , CHFL( 10.272 ),
	CHFL( 96.92 ), CHFL( -1.504 ) , CHFL( 11.092 ),
	CHFL( 64.424 ), CHFL( -6.508 ) , CHFL( 4.336 ),
	CHFL( 64.428 ), CHFL( -6.508 ) , CHFL( -4.196 ),
	CHFL( 68.08 ), CHFL( -6.808 ) , CHFL( 0.076 ),
	CHFL( 63.908 ), CHFL( -7.384 ) , CHFL( 2.748 ),
	CHFL( 63.912 ), CHFL( -7.384 ) , CHFL( -2.6 ),
	CHFL( 59.644 ), CHFL( 7.852 ) , CHFL( 2.74 ),
	CHFL( 59.644 ), CHFL( 7.852 ) , CHFL( -2.712 ),
	CHFL( 68.86 ), CHFL( 8.332 ) , CHFL( 1.024 ),
	CHFL( 68.436 ), CHFL( 5.968 ) , CHFL( 1.5 ),
	CHFL( 68.86 ), CHFL( 8.332 ) , CHFL( -1.208 ),
	CHFL( 68.436 ), CHFL( 5.968 ) , CHFL( -1.672 ),
	CHFL( 72.488 ), CHFL( 5.908 ) , CHFL( -1.672 ),
	CHFL( 71.832 ), CHFL( 8.216 ) , CHFL( -1.208 ),
	CHFL( 72.488 ), CHFL( 5.908 ) , CHFL( 1.5 ),
	CHFL( 71.832 ), CHFL( 8.216 ) , CHFL( 1.024 ),
	CHFL( 77.984 ), CHFL( 5.156 ) , CHFL( -3.8 ),
	CHFL( 75.748 ), CHFL( 8.852 ) , CHFL( -2.928 ),
	CHFL( 77.984 ), CHFL( 5.156 ) , CHFL( 3.844 ),
	CHFL( 75.748 ), CHFL( 8.852 ) , CHFL( 2.452 ),
	CHFL( 83.98 ), CHFL( 0.42 ) , CHFL( -12.132 ),
	CHFL( 84.012 ), CHFL( 0.952 ) , CHFL( 12.124 ),
	CHFL( 15.172 ), CHFL( -8.248 ) , CHFL( 0.052 ),
	CHFL( 25.416 ), CHFL( 8.2 ) , CHFL( -0.048 ),
	CHFL( 37.144 ), CHFL( -15.12 ) , CHFL( 5.012 ),
	CHFL( 37.144 ), CHFL( -15.12 ) , CHFL( -5.16 ),
	CHFL( 49.828 ), CHFL( -14.224 ) , CHFL( -5.852 ),
	CHFL( 49.828 ), CHFL( -14.224 ) , CHFL( 5.676 ),
	CHFL( 79.4 ), CHFL( 9.252 ) , CHFL( -2.868 ),
	CHFL( 85.932 ), CHFL( 5.9 ) , CHFL( -1.616 ),
	CHFL( 85.932 ), CHFL( 5.9 ) , CHFL( 1.416 ),
	CHFL( 79.4 ), CHFL( 9.252 ) , CHFL( 2.512 ),
	CHFL( 61.088 ), CHFL( -1.124 ) , CHFL( 7.304 ),
	CHFL( 62.256 ), CHFL( 6.556 ) , CHFL( 6.628 ),
	CHFL( 57.876 ), CHFL( -2.732 ) , CHFL( 7.604 ),
	CHFL( 58.912 ), CHFL( 6.436 ) , CHFL( 6.548 ),
	CHFL( 62.26 ), CHFL( 6.556 ) , CHFL( -6.448 ),
	CHFL( 61.096 ), CHFL( -1.12 ) , CHFL( -7.14 ),
	CHFL( 58.916 ), CHFL( 6.436 ) , CHFL( -6.408 ),
	CHFL( 57.884 ), CHFL( -2.732 ) , CHFL( -7.472 ),
	CHFL( 66.48 ), CHFL( 5.416 ) , CHFL( -5.416 ),
	CHFL( 66.476 ), CHFL( 5.416 ) , CHFL( 5.6 ),
	CHFL( 81.284 ), CHFL( 2.356 ) , CHFL( 13.8 ),
	CHFL( 82.028 ), CHFL( -2.236 ) , CHFL( 14.056 ),
	CHFL( 81.404 ), CHFL( 2.172 ) , CHFL( 9.496 ),
	CHFL( 82.2 ), CHFL( -2.116 ) , CHFL( 10.292 ),
	CHFL( 81.372 ), CHFL( 2.18 ) , CHFL( -9.84 ),
	CHFL( 82.04 ), CHFL( -2.16 ) , CHFL( -10.616 ),
	CHFL( 81.4 ), CHFL( 2.388 ) , CHFL( -13.956 ),
	CHFL( 81.904 ), CHFL( -2.232 ) , CHFL( -14.192 ),
	CHFL( 32.032 ), CHFL( -0.672 ) , CHFL( -1.02 ),
	CHFL( 31.024 ), CHFL( 9.288 ) , CHFL( -2.692 ),
	CHFL( 32.464 ), CHFL( -4.94 ) , CHFL( -6.24 ),
	CHFL( 32.028 ), CHFL( -0.692 ) , CHFL( 0.928 ),
	CHFL( 31.02 ), CHFL( 9.272 ) , CHFL( 2.6 ),
	CHFL( 31.056 ), CHFL( 9.268 ) , CHFL( 10.264 ),
	CHFL( 32.072 ), CHFL( -0.904 ) , CHFL( 12.056 ),
	CHFL( 32.444 ), CHFL( -4.96 ) , CHFL( 6.348 ),
	CHFL( 31.008 ), CHFL( 9.288 ) , CHFL( -10.136 ),
	CHFL( 32.044 ), CHFL( -0.904 ) , CHFL( -11.912 ),
};


chfloat y_skin_norms[] =
{
	CHFL( 0.998 ), CHFL( -0.016 ) , CHFL( -0.057 ),
	CHFL( 0.525 ), CHFL( -0.817 ) , CHFL( 0.238 ),
	CHFL( -0.377 ), CHFL( -0.809 ) , CHFL( 0.451 ),
	CHFL( 0.45 ), CHFL( -0.503 ) , CHFL( -0.738 ),
	CHFL( -0.906 ), CHFL( -0.093 ) , CHFL( 0.413 ),
	CHFL( 0.462 ), CHFL( 0.487 ) , CHFL( -0.741 ),
	CHFL( -0.811 ), CHFL( 0.528 ) , CHFL( -0.251 ),
	CHFL( 0.544 ), CHFL( 0.805 ) , CHFL( 0.235 ),
	CHFL( -0.361 ), CHFL( 0.819 ) , CHFL( 0.446 ),
	CHFL( 0.537 ), CHFL( -0.006 ) , CHFL( 0.843 ),
	CHFL( -0.647 ), CHFL( 0.012 ) , CHFL( 0.762 ),
	CHFL( 0.487 ), CHFL( -0.826 ) , CHFL( 0.282 ),
	CHFL( 0.052 ), CHFL( -0.948 ) , CHFL( 0.313 ),
	CHFL( 0.445 ), CHFL( -0.496 ) , CHFL( -0.746 ),
	CHFL( 0.023 ), CHFL( -0.59 ) , CHFL( -0.807 ),
	CHFL( 0.323 ), CHFL( 0.576 ) , CHFL( -0.751 ),
	CHFL( 0.041 ), CHFL( 0.582 ) , CHFL( -0.812 ),
	CHFL( 0.283 ), CHFL( 0.917 ) , CHFL( 0.28 ),
	CHFL( 0.08 ), CHFL( 0.95 ) , CHFL( 0.301 ),
	CHFL( 0.39 ), CHFL( 0.047 ) , CHFL( 0.92 ),
	CHFL( 0.087 ), CHFL( 0.007 ) , CHFL( 0.996 ),
	CHFL( 0.995 ), CHFL( -0.083 ) , CHFL( 0.061 ),
	CHFL( 0.465 ), CHFL( -0.851 ) , CHFL( -0.242 ),
	CHFL( -0.376 ), CHFL( -0.809 ) , CHFL( -0.453 ),
	CHFL( 0.409 ), CHFL( -0.53 ) , CHFL( 0.743 ),
	CHFL( -0.904 ), CHFL( -0.093 ) , CHFL( -0.416 ),
	CHFL( 0.485 ), CHFL( 0.463 ) , CHFL( 0.742 ),
	CHFL( -0.812 ), CHFL( 0.528 ) , CHFL( 0.247 ),
	CHFL( 0.589 ), CHFL( 0.776 ) , CHFL( -0.228 ),
	CHFL( -0.359 ), CHFL( 0.819 ) , CHFL( -0.448 ),
	CHFL( 0.536 ), CHFL( -0.028 ) , CHFL( -0.844 ),
	CHFL( -0.644 ), CHFL( 0.012 ) , CHFL( -0.765 ),
	CHFL( 0.458 ), CHFL( -0.844 ) , CHFL( -0.28 ),
	CHFL( 0.053 ), CHFL( -0.948 ) , CHFL( -0.313 ),
	CHFL( 0.418 ), CHFL( -0.512 ) , CHFL( 0.751 ),
	CHFL( 0.021 ), CHFL( -0.59 ) , CHFL( 0.807 ),
	CHFL( 0.356 ), CHFL( 0.559 ) , CHFL( 0.749 ),
	CHFL( 0.039 ), CHFL( 0.582 ) , CHFL( 0.812 ),
	CHFL( 0.355 ), CHFL( 0.895 ) , CHFL( -0.27 ),
	CHFL( 0.081 ), CHFL( 0.95 ) , CHFL( -0.3 ),
	CHFL( 0.417 ), CHFL( 0.034 ) , CHFL( -0.908 ),
	CHFL( 0.09 ), CHFL( 0.007 ) , CHFL( -0.996 ),
	CHFL( -0.091 ), CHFL( -0.27 ) , CHFL( 0.959 ),
	CHFL( -0.055 ), CHFL( 0.785 ) , CHFL( 0.617 ),
	CHFL( -0.055 ), CHFL( 0.785 ) , CHFL( -0.617 ),
	CHFL( -0.091 ), CHFL( -0.27 ) , CHFL( -0.959 ),
	CHFL( -0.157 ), CHFL( -0.988 ) , CHFL( 0 ),
	CHFL( -0.091 ), CHFL( -0.27 ) , CHFL( 0.959 ),
	CHFL( -0.157 ), CHFL( -0.988 ) , CHFL( 0 ),
	CHFL( -0.091 ), CHFL( -0.27 ) , CHFL( -0.959 ),
	CHFL( -0.055 ), CHFL( 0.785 ) , CHFL( -0.617 ),
	CHFL( -0.055 ), CHFL( 0.785 ) , CHFL( 0.617 ),
	CHFL( 0.993 ), CHFL( -0.116 ) , CHFL( -0.022 ),
	CHFL( 0.722 ), CHFL( -0.386 ) , CHFL( 0.574 ),
	CHFL( -0.059 ), CHFL( 0.956 ) , CHFL( 0.288 ),
	CHFL( -0.289 ), CHFL( 0.401 ) , CHFL( -0.869 ),
	CHFL( -0.431 ), CHFL( -0.269 ) , CHFL( -0.861 ),
	CHFL( -0.815 ), CHFL( -0.569 ) , CHFL( -0.107 ),
	CHFL( 0.382 ), CHFL( -0.29 ) , CHFL( 0.878 ),
	CHFL( 0.287 ), CHFL( -0.958 ) , CHFL( 0.006 ),
	CHFL( 0.353 ), CHFL( -0.301 ) , CHFL( -0.886 ),
	CHFL( 0.571 ), CHFL( 0.628 ) , CHFL( -0.529 ),
	CHFL( 0.582 ), CHFL( 0.627 ) , CHFL( 0.518 ),
	CHFL( -0.089 ), CHFL( -0.271 ) , CHFL( 0.959 ),
	CHFL( -0.061 ), CHFL( 0.785 ) , CHFL( 0.617 ),
	CHFL( -0.061 ), CHFL( 0.785 ) , CHFL( -0.617 ),
	CHFL( -0.089 ), CHFL( -0.271 ) , CHFL( -0.959 ),
	CHFL( -0.149 ), CHFL( -0.989 ) , CHFL( 0 ),
	CHFL( -0.089 ), CHFL( -0.271 ) , CHFL( 0.959 ),
	CHFL( -0.149 ), CHFL( -0.989 ) , CHFL( 0 ),
	CHFL( -0.089 ), CHFL( -0.271 ) , CHFL( -0.959 ),
	CHFL( -0.061 ), CHFL( 0.785 ) , CHFL( -0.617 ),
	CHFL( -0.061 ), CHFL( 0.785 ) , CHFL( 0.617 ),
	CHFL( 0.993 ), CHFL( -0.121 ) , CHFL( 0.016 ),
	CHFL( -0.953 ), CHFL( -0.233 ) , CHFL( 0.194 ),
	CHFL( -0.356 ), CHFL( 0.53 ) , CHFL( 0.77 ),
	CHFL( -0.063 ), CHFL( 0.955 ) , CHFL( -0.289 ),
	CHFL( 0.718 ), CHFL( -0.391 ) , CHFL( -0.576 ),
	CHFL( -0.814 ), CHFL( -0.569 ) , CHFL( 0.119 ),
	CHFL( 0.356 ), CHFL( -0.302 ) , CHFL( 0.884 ),
	CHFL( 0.28 ), CHFL( -0.96 ) , CHFL( -0.005 ),
	CHFL( 0.377 ), CHFL( -0.294 ) , CHFL( -0.878 ),
	CHFL( 0.583 ), CHFL( 0.625 ) , CHFL( -0.518 ),
	CHFL( 0.574 ), CHFL( 0.627 ) , CHFL( 0.526 ),
	CHFL( 0.242 ), CHFL( -0.674 ) , CHFL( 0.697 ),
	CHFL( 0.255 ), CHFL( -0.67 ) , CHFL( -0.697 ),
	CHFL( 0.117 ), CHFL( -0.319 ) , CHFL( 0.941 ),
	CHFL( 0.132 ), CHFL( -0.317 ) , CHFL( -0.939 ),
	CHFL( -0.084 ), CHFL( -0.864 ) , CHFL( -0.496 ),
	CHFL( -0.089 ), CHFL( -0.865 ) , CHFL( 0.494 ),
	CHFL( 0.52 ), CHFL( -0.854 ) , CHFL( 0.003 ),
	CHFL( -0.254 ), CHFL( -0.592 ) , CHFL( 0.765 ),
	CHFL( -0.255 ), CHFL( -0.592 ) , CHFL( -0.764 ),
	CHFL( -0.5 ), CHFL( -0.703 ) , CHFL( -0.506 ),
	CHFL( -0.501 ), CHFL( -0.703 ) , CHFL( 0.505 ),
	CHFL( -0.252 ), CHFL( -0.497 ) , CHFL( 0.83 ),
	CHFL( -0.251 ), CHFL( -0.498 ) , CHFL( -0.83 ),
	CHFL( -0.156 ), CHFL( -0.715 ) , CHFL( -0.682 ),
	CHFL( -0.155 ), CHFL( -0.715 ) , CHFL( 0.681 ),
	CHFL( -0.992 ), CHFL( 0.123 ) , CHFL( -0.032 ),
	CHFL( -0.355 ), CHFL( -0.482 ) , CHFL( -0.801 ),
	CHFL( -0.865 ), CHFL( 0.448 ) , CHFL( -0.225 ),
	CHFL( -0.834 ), CHFL( 0.43 ) , CHFL( -0.346 ),
	CHFL( 0.147 ), CHFL( 0.95 ) , CHFL( 0.276 ),
	CHFL( 0.149 ), CHFL( 0.948 ) , CHFL( -0.28 ),
	CHFL( -0.929 ), CHFL( -0.37 ) , CHFL( -0.006 ),
	CHFL( -0.929 ), CHFL( -0.37 ) , CHFL( -0.006 ),
	CHFL( -0.274 ), CHFL( -0.834 ) , CHFL( -0.479 ),
	CHFL( 0.69 ), CHFL( -0.572 ) , CHFL( -0.442 ),
	CHFL( 0.691 ), CHFL( -0.576 ) , CHFL( 0.436 ),
	CHFL( -0.267 ), CHFL( -0.846 ) , CHFL( 0.461 ),
	CHFL( 0.32 ), CHFL( -0.379 ) , CHFL( 0.868 ),
	CHFL( 0.497 ), CHFL( 0.481 ) , CHFL( 0.722 ),
	CHFL( 0.966 ), CHFL( 0.169 ) , CHFL( -0.196 ),
	CHFL( 0.794 ), CHFL( 0.066 ) , CHFL( 0.605 ),
	CHFL( 0.587 ), CHFL( 0.757 ) , CHFL( -0.288 ),
	CHFL( -0.029 ), CHFL( 0.005 ) , CHFL( -1 ),
	CHFL( -0.727 ), CHFL( -0.003 ) , CHFL( -0.686 ),
	CHFL( -0.766 ), CHFL( 0.01 ) , CHFL( 0.643 ),
	CHFL( -0.016 ), CHFL( -0.448 ) , CHFL( 0.894 ),
	CHFL( -0.507 ), CHFL( 0.568 ) , CHFL( 0.648 ),
	CHFL( -0.727 ), CHFL( -0.003 ) , CHFL( -0.686 ),
	CHFL( -0.766 ), CHFL( 0.01 ) , CHFL( 0.643 ),
	CHFL( 0.658 ), CHFL( -0.323 ) , CHFL( 0.681 ),
	CHFL( 0.897 ), CHFL( -0.441 ) , CHFL( 0 ),
	CHFL( 0.502 ), CHFL( -0.713 ) , CHFL( 0.49 ),
	CHFL( 0.559 ), CHFL( -0.829 ) , CHFL( 0.008 ),
	CHFL( 0.272 ), CHFL( -0.343 ) , CHFL( -0.899 ),
	CHFL( 0.493 ), CHFL( 0.504 ) , CHFL( -0.71 ),
	CHFL( 0.851 ), CHFL( 0.149 ) , CHFL( -0.503 ),
	CHFL( 0.766 ), CHFL( 0.094 ) , CHFL( -0.636 ),
	CHFL( 0.559 ), CHFL( 0.721 ) , CHFL( -0.41 ),
	CHFL( 0.026 ), CHFL( -0.454 ) , CHFL( 0.89 ),
	CHFL( -0.712 ), CHFL( -0.013 ) , CHFL( 0.702 ),
	CHFL( -0.761 ), CHFL( 0 ) , CHFL( -0.649 ),
	CHFL( -0.008 ), CHFL( -0.459 ) , CHFL( -0.889 ),
	CHFL( -0.532 ), CHFL( 0.543 ) , CHFL( -0.649 ),
	CHFL( -0.712 ), CHFL( -0.013 ) , CHFL( 0.702 ),
	CHFL( -0.761 ), CHFL( 0 ) , CHFL( -0.649 ),
	CHFL( 0.651 ), CHFL( -0.335 ) , CHFL( -0.681 ),
	CHFL( 0.626 ), CHFL( -0.331 ) , CHFL( 0.706 ),
	CHFL( 0.5 ), CHFL( -0.72 ) , CHFL( -0.482 ),
	CHFL( 0.478 ), CHFL( -0.726 ) , CHFL( 0.495 ),
	CHFL( -0.087 ), CHFL( -0.286 ) , CHFL( 0.954 ),
	CHFL( -0.082 ), CHFL( -0.293 ) , CHFL( -0.953 ),
	CHFL( -0.126 ), CHFL( -0.659 ) , CHFL( 0.741 ),
	CHFL( -0.217 ), CHFL( -0.723 ) , CHFL( -0.656 ),
	CHFL( -0.021 ), CHFL( 0.845 ) , CHFL( -0.534 ),
	CHFL( -0.115 ), CHFL( 0.845 ) , CHFL( 0.523 ),
	CHFL( -0.308 ), CHFL( 0.782 ) , CHFL( -0.541 ),
	CHFL( -0.334 ), CHFL( 0.788 ) , CHFL( 0.518 ),
	CHFL( -0.493 ), CHFL( 0.08 ) , CHFL( -0.866 ),
	CHFL( -0.549 ), CHFL( 0.196 ) , CHFL( 0.812 ),
	CHFL( -0.811 ), CHFL( 0.28 ) , CHFL( -0.514 ),
	CHFL( -0.812 ), CHFL( 0.297 ) , CHFL( 0.503 ),
	CHFL( -0.049 ), CHFL( -0.014 ) , CHFL( -0.999 ),
	CHFL( -0.01 ), CHFL( -0.012 ) , CHFL( 1 ),
	CHFL( -0.029 ), CHFL( 0.005 ) , CHFL( -1 ),
	CHFL( -0.054 ), CHFL( -0.001 ) , CHFL( 0.999 ),
	CHFL( 0.717 ), CHFL( -0.412 ) , CHFL( -0.562 ),
	CHFL( 0.725 ), CHFL( 0.039 ) , CHFL( -0.687 ),
	CHFL( 0.706 ), CHFL( -0.422 ) , CHFL( 0.568 ),
	CHFL( 0.716 ), CHFL( 0.04 ) , CHFL( 0.697 ),
	CHFL( 0.855 ), CHFL( -0.518 ) , CHFL( -0.001 ),
	CHFL( 0.648 ), CHFL( 0.619 ) , CHFL( -0.444 ),
	CHFL( 0.643 ), CHFL( 0.623 ) , CHFL( 0.445 ),
	CHFL( 0.994 ), CHFL( 0.107 ) , CHFL( -0.001 ),
	CHFL( 0.917 ), CHFL( 0.4 ) , CHFL( 0 ),
	CHFL( 0.709 ), CHFL( 0.675 ) , CHFL( -0.203 ),
	CHFL( 0.687 ), CHFL( -0.359 ) , CHFL( -0.632 ),
	CHFL( 0.73 ), CHFL( -0.561 ) , CHFL( 0.391 ),
	CHFL( 0.624 ), CHFL( 0.524 ) , CHFL( -0.579 ),
	CHFL( -0.038 ), CHFL( 0.714 ) , CHFL( -0.699 ),
	CHFL( 0.029 ), CHFL( -0.693 ) , CHFL( -0.721 ),
	CHFL( 0.039 ), CHFL( -0.118 ) , CHFL( 0.992 ),
	CHFL( 0.049 ), CHFL( -0.737 ) , CHFL( 0.674 ),
	CHFL( -0.057 ), CHFL( 0.719 ) , CHFL( 0.693 ),
	CHFL( -0.066 ), CHFL( 0.998 ) , CHFL( -0.02 ),
	CHFL( 0.017 ), CHFL( -0.697 ) , CHFL( 0.717 ),
	CHFL( 0.066 ), CHFL( -0.734 ) , CHFL( -0.676 ),
	CHFL( 0.604 ), CHFL( 0.546 ) , CHFL( 0.581 ),
	CHFL( 0.686 ), CHFL( -0.341 ) , CHFL( 0.643 ),
	CHFL( 0.69 ), CHFL( 0.695 ) , CHFL( 0.202 ),
	CHFL( 0.743 ), CHFL( -0.54 ) , CHFL( -0.395 ),
	CHFL( -0.014 ), CHFL( -0.747 ) , CHFL( 0.665 ),
	CHFL( -0.014 ), CHFL( -0.748 ) , CHFL( -0.664 ),
	CHFL( 0.341 ), CHFL( -0.94 ) , CHFL( 0 ),
	CHFL( 0.125 ), CHFL( -0.885 ) , CHFL( 0.448 ),
	CHFL( 0.127 ), CHFL( -0.886 ) , CHFL( -0.445 ),
	CHFL( -0.638 ), CHFL( 0.766 ) , CHFL( 0.078 ),
	CHFL( -0.636 ), CHFL( 0.767 ) , CHFL( -0.081 ),
	CHFL( 0.272 ), CHFL( 0.916 ) , CHFL( 0.295 ),
	CHFL( 0.195 ), CHFL( 0.772 ) , CHFL( 0.606 ),
	CHFL( 0.271 ), CHFL( 0.915 ) , CHFL( -0.298 ),
	CHFL( 0.194 ), CHFL( 0.768 ) , CHFL( -0.61 ),
	CHFL( -0.197 ), CHFL( -0.667 ) , CHFL( -0.718 ),
	CHFL( -0.167 ), CHFL( 0.746 ) , CHFL( -0.645 ),
	CHFL( -0.199 ), CHFL( -0.649 ) , CHFL( 0.735 ),
	CHFL( -0.161 ), CHFL( 0.76 ) , CHFL( 0.63 ),
	CHFL( -0.095 ), CHFL( -0.685 ) , CHFL( -0.722 ),
	CHFL( -0.163 ), CHFL( 0.742 ) , CHFL( -0.65 ),
	CHFL( -0.097 ), CHFL( -0.652 ) , CHFL( 0.752 ),
	CHFL( -0.154 ), CHFL( 0.771 ) , CHFL( 0.618 ),
	CHFL( 0.996 ), CHFL( 0.089 ) , CHFL( 0.017 ),
	CHFL( 0.989 ), CHFL( 0.148 ) , CHFL( -0.001 ),
	CHFL( 0.635 ), CHFL( -0.772 ) , CHFL( -0.002 ),
	CHFL( -0.491 ), CHFL( 0.871 ) , CHFL( -0.002 ),
	CHFL( -0.444 ), CHFL( -0.756 ) , CHFL( 0.48 ),
	CHFL( -0.445 ), CHFL( -0.753 ) , CHFL( -0.485 ),
	CHFL( 0.547 ), CHFL( -0.654 ) , CHFL( -0.522 ),
	CHFL( 0.547 ), CHFL( -0.655 ) , CHFL( 0.521 ),
	CHFL( 0.224 ), CHFL( 0.88 ) , CHFL( -0.418 ),
	CHFL( 0.402 ), CHFL( 0.673 ) , CHFL( -0.621 ),
	CHFL( 0.388 ), CHFL( 0.707 ) , CHFL( 0.591 ),
	CHFL( 0.216 ), CHFL( 0.892 ) , CHFL( 0.398 ),
	CHFL( 0.103 ), CHFL( -0.995 ) , CHFL( 0 ),
	CHFL( 0.163 ), CHFL( 0.435 ) , CHFL( 0.885 ),
	CHFL( -0.992 ), CHFL( 0.123 ) , CHFL( -0.032 ),
	CHFL( -0.746 ), CHFL( 0.498 ) , CHFL( 0.442 ),
	CHFL( 0.168 ), CHFL( 0.433 ) , CHFL( -0.886 ),
	CHFL( 0.103 ), CHFL( -0.995 ) , CHFL( 0 ),
	CHFL( -0.742 ), CHFL( 0.499 ) , CHFL( -0.447 ),
	CHFL( -0.992 ), CHFL( 0.123 ) , CHFL( 0.031 ),
	CHFL( 0.325 ), CHFL( 0.192 ) , CHFL( -0.926 ),
	CHFL( 0.317 ), CHFL( 0.196 ) , CHFL( 0.928 ),
	CHFL( -0.803 ), CHFL( 0.388 ) , CHFL( 0.452 ),
	CHFL( -0.697 ), CHFL( -0.564 ) , CHFL( 0.443 ),
	CHFL( -0.87 ), CHFL( 0.49 ) , CHFL( -0.052 ),
	CHFL( -0.551 ), CHFL( -0.641 ) , CHFL( -0.535 ),
	CHFL( -0.862 ), CHFL( 0.506 ) , CHFL( 0.023 ),
	CHFL( -0.576 ), CHFL( -0.626 ) , CHFL( 0.525 ),
	CHFL( -0.785 ), CHFL( 0.405 ) , CHFL( -0.468 ),
	CHFL( -0.699 ), CHFL( -0.542 ) , CHFL( -0.466 ),
	CHFL( 0.047 ), CHFL( -0.314 ) , CHFL( 0.948 ),
	CHFL( 0.091 ), CHFL( 0.768 ) , CHFL( 0.633 ),
	CHFL( 0.056 ), CHFL( -0.998 ) , CHFL( 0.034 ),
	CHFL( 0.045 ), CHFL( -0.32 ) , CHFL( -0.946 ),
	CHFL( 0.09 ), CHFL( 0.768 ) , CHFL( -0.634 ),
	CHFL( 0.112 ), CHFL( 0.771 ) , CHFL( 0.627 ),
	CHFL( 0.075 ), CHFL( -0.34 ) , CHFL( 0.938 ),
	CHFL( 0.055 ), CHFL( -0.998 ) , CHFL( -0.029 ),
	CHFL( 0.11 ), CHFL( 0.771 ) , CHFL( -0.628 ),
	CHFL( 0.075 ), CHFL( -0.34 ) , CHFL( -0.937 ),
};


model_polys y_skin_polys[] =
{
	{
		GOURAUD,
		3,
		0, 1, 3, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		86, 162, 165, 224,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		87, 223, 164, 160,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		173, 175, 230, 232,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		0, 3, 5, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		17, 18, 20, 19,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		38, 40, 41, 39,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		172, 173, 232, 231,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		0, 5, 7, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		5, 3, 4, 6,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		26, 27, 25, 24,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		174, 172, 231, 229,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		0, 7, 9, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		220, 219, 223, 87,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		215, 86, 224, 216,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		175, 174, 229, 230,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		0, 9, 1, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		28, 30, 31, 29,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		9, 7, 8, 10,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		179, 178, 226, 228,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		215, 98, 86, 0,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		97, 220, 87, 0,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		218, 216, 103, 189,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		221, 190, 104, 219,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		3, 1, 2, 4,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		22, 24, 25, 23,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		13, 11, 12, 14,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		34, 36, 37, 35,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		32, 34, 35, 33,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		15, 13, 14, 16,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		24, 22, 21, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		101, 190, 221, 0,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		102, 218, 189, 0,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		4, 10, 6, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		26, 24, 21, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		238, 75, 74, 239,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		240, 78, 77, 236,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		2, 10, 4, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		28, 26, 21, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		40, 32, 33, 41,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		22, 23, 31, 30,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		10, 8, 6, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		30, 28, 21, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		200, 202, 214, 211,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		202, 201, 213, 214,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		177, 179, 228, 227,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		22, 30, 21, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		233, 53, 57, 235,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		165, 164, 191, 193,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		176, 177, 227, 225,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		201, 199, 212, 213,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		199, 200, 211, 212,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		70, 69, 67, 66,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		48, 47, 42, 46,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		103, 165, 193, 194,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		104, 103, 194, 192,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		26, 28, 29, 27,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		1, 9, 10, 2,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		194, 193, 196, 195,
		{ 0, 26, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		11, 19, 20, 12,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		239, 79, 83, 238,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		241, 55, 54, 234,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		88, 188, 185, 90,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		240, 80, 79, 239,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		107, 108, 209, 208,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		157, 124, 126, 116,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		236, 81, 80, 240,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		237, 76, 75, 238,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		217, 215, 216, 218,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		237, 82, 81, 236,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		109, 110, 207, 210,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		132, 142, 140, 156,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		238, 83, 82, 237,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		71, 70, 66, 65,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		155, 139, 141, 135,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		204, 15, 17, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		72, 64, 63, 68,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		58, 59, 52, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		11, 13, 204, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		108, 109, 210, 209,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		62, 58, 52, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		239, 74, 78, 240,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		204, 19, 11, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		61, 62, 52, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		110, 107, 208, 207,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		13, 15, 204, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		60, 61, 52, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		235, 57, 56, 242,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		17, 19, 204, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		59, 60, 52, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		150, 149, 206, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		49, 48, 46, 45,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		206, 120, 150, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		47, 51, 43, 42,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		51, 50, 44, 43,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		205, 53, 77, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		50, 49, 45, 44,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		72, 71, 65, 64,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		205, 57, 53, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		69, 68, 63, 67,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		234, 62, 61, 241,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		143, 111, 112, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		108, 127, 130, 129,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		241, 61, 60, 242,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		205, 78, 120, 206,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		111, 109, 113, 114,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		242, 60, 59, 235,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		222, 221, 219, 220,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		106, 88, 90, 0,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		233, 58, 62, 234,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		242, 56, 55, 241,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		105, 106, 90, 0,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		235, 59, 58, 233,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		54, 153, 154, 76,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		89, 105, 90, 0,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		34, 32, 203, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		54, 55, 153, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		79, 80, 73, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		203, 40, 38, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		234, 54, 53, 233,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		83, 79, 73, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		84, 186, 163, 161,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		203, 36, 34, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		82, 83, 73, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		76, 154, 75, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		38, 36, 203, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		81, 82, 73, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		137, 133, 132, 156,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		32, 40, 203, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		80, 81, 73, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		55, 56, 151, 146,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		186, 85, 159, 163,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		236, 77, 76, 237,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		55, 146, 153, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		164, 104, 192, 191,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		87, 160, 159, 85,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		75, 145, 152, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		97, 100, 222, 220,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		138, 155, 135, 134,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		149, 147, 128, 144,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		107, 144, 127, 108,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		143, 110, 109, 111,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		128, 127, 144, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		124, 123, 125, 126,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		75, 154, 145, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		175, 173, 169, 170,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		141, 142, 132, 135,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		173, 172, 171, 169,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		172, 174, 168, 171,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		174, 175, 170, 168,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		178, 179, 183, 181,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		179, 177, 182, 183,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		177, 176, 180, 182,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		176, 178, 181, 180,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		126, 125, 119, 116,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		196, 198, 202, 200,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		198, 197, 201, 202,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		75, 152, 74, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		136, 149, 144, 151,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		182, 180, 181, 183,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		149, 150, 148, 147,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		184, 187, 89, 90,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		92, 97, 185, 0,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		128, 112, 115, 131,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		206, 136, 57, 205,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		98, 91, 184, 0,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		99, 98, 215, 217,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		127, 128, 130, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		93, 96, 92, 88,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		89, 91, 95, 94,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		88, 89, 94, 93,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		149, 136, 206, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		171, 168, 170, 169,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		95, 91, 98, 99,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		100, 97, 92, 96,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		100, 93, 94, 99,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		96, 93, 100, 0,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		99, 94, 95, 0,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		145, 110, 143, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		120, 152, 143, 150,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		185, 97, 87, 85,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		89, 88, 106, 105,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		17, 15, 16, 18,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		7, 5, 6, 8,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		98, 184, 84, 86,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		74, 152, 78, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		77, 78, 205, 0,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		113, 129, 102, 101,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		122, 121, 117, 118,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		137, 138, 134, 133,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		115, 113, 101, 100,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		131, 99, 102, 129,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		36, 38, 39, 37,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		163, 159, 160, 166,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		166, 162, 161, 163,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		57, 151, 56, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		207, 208, 209, 210,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		101, 102, 189, 190,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		78, 152, 120, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		88, 92, 185, 188,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		54, 76, 77, 53,
		{ 13, 11, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		109, 108, 129, 113,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		146, 144, 107, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		189, 103, 104, 190,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		158, 122, 118, 119,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		139, 140, 142, 141,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		219, 104, 164, 223,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		216, 224, 165, 103,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		57, 136, 151, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		128, 131, 129, 130,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		86, 84, 161, 162,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		100, 101, 221, 222,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		167, 165, 162, 166,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		167, 166, 160, 164,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		197, 195, 199, 201,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		146, 151, 144, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		119, 125, 123, 158,
		{ 11, 11, 14, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		145, 146, 107, 110,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		186, 84, 184, 90,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		114, 112, 111, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		147, 148, 112, 128,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		195, 196, 200, 199,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		193, 191, 198, 196,
		{ 0, 26, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		165, 167, 164, 0,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		121, 157, 116, 117,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		213, 212, 211, 214,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		191, 192, 197, 198,
		{ 0, 26, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		146, 145, 154, 153,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		192, 194, 195, 197,
		{ 0, 26, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		152, 145, 143, 0,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		184, 91, 89, 187,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		131, 115, 100, 99,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		150, 143, 112, 148,
		{ 0, 17, 87, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		102, 99, 217, 218,
		{ 0, 0, 11, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		90, 185, 85, 186,
		{ 206, 110, 67, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		112, 114, 113, 115,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		229, 231, 232, 230,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		227, 228, 226, 225,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		4,
		178, 176, 225, 226,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		31, 27, 29, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		31, 25, 27, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
	{
		GOURAUD,
		3,
		31, 23, 25, 0,
		{ 178, 178, 178, 0 },
		0, 0, 0, 0,
		0, 0, 0, 0,
	},
};
