#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
#include <LibCD.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"


node y_rfoot =
{
	JOINT,
	CHFL( 32.380001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_rfoot,	// vertex attachment
	&Verts_y_rfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node y_lrleg =
{
	JOINT,
	CHFL( 35.480000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_lrleg,	// vertex attachment
	&Verts_y_lrleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_rfoot,	// Joint
};

node y_urleg =
{
	JOINT,
	CHFL( 11.160000 ), CHFL( -3.172000 ), CHFL( -7.376000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_urleg,	// vertex attachment
	&Verts_y_urleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_lrleg,	// Joint
};

node y_lfoot =
{
	JOINT,
	CHFL( 32.380001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_lfoot,	// vertex attachment
	&Verts_y_lfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node y_llleg =
{
	JOINT,
	CHFL( 35.480000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_llleg,	// vertex attachment
	&Verts_y_llleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_lfoot,	// Joint
};

node y_ulleg =
{
	JOINT,
	CHFL( 11.160000 ), CHFL( -3.172000 ), CHFL( 7.616000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_ulleg,	// vertex attachment
	&Verts_y_ulleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_llleg,	// Joint
};

node y_peni =
{
	JOINT,
	CHFL( 12.375999 ), CHFL( 0.192000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_peni,	// vertex attachment
	&Verts_y_peni_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node y_head =
{
	JOINT,
	CHFL( 3.516000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_head,	// vertex attachment
	&Verts_y_head_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node y_jnt184_1 =
{
	JOINT,
	CHFL( 26.572001 ), CHFL( 0.028000 ), CHFL( 0.080000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_jnt184_1,	// vertex attachment
	&Verts_y_jnt184_1_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_head,	// Joint
};

node y_lhand =
{
	JOINT,
	CHFL( 14.852000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_lhand,	// vertex attachment
	&Verts_y_lhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node y_llarm =
{
	JOINT,
	CHFL( 20.572001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_llarm,	// vertex attachment
	&Verts_y_llarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_lhand,	// Joint
};

node y_ularm =
{
	JOINT,
	CHFL( 19.223999 ), CHFL( 7.332000 ), CHFL( 12.460000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_ularm,	// vertex attachment
	&Verts_y_ularm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_llarm,	// Joint
};

node y_rhand =
{
	JOINT,
	CHFL( 14.592000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_rhand,	// vertex attachment
	&Verts_y_rhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node y_lrarm =
{
	JOINT,
	CHFL( 20.572001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_lrarm,	// vertex attachment
	&Verts_y_lrarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_rhand,	// Joint
};

node y_urarm =
{
	JOINT,
	CHFL( 19.284000 ), CHFL( -6.592000 ), CHFL( -12.692000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_urarm,	// vertex attachment
	&Verts_y_urarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_lrarm,	// Joint
};

node y_chest =
{
	JOINT,
	CHFL( 21.468000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_chest,	// vertex attachment
	&Verts_y_chest_Lo,	// vertex attachment
	3,	// NumberOfChildren
	&y_urarm,	// Joint
	&y_ularm,	// Joint
	&y_jnt184_1,	// Joint
};

node y_tum =
{
	JOINT,
	CHFL( 12.016000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_tum,	// vertex attachment
	&Verts_y_tum_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&y_chest,	// Joint
};

node y_bum =
{
	JOINT,
	CHFL( 0.008000 ), CHFL( 0.768000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_y_bum,	// vertex attachment
	&Verts_y_bum_Lo,	// vertex attachment
	4,	// NumberOfChildren
	&y_tum,	// Joint
	&y_peni,	// Joint
	&y_ulleg,	// Joint
	&y_urleg,	// Joint
};

node y_virgin =
{
	CHAIN_ROOT,
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	NULL,	// No verts attached (Chain Root or Effector)
	NULL,	// No verts attached (Chain Root or Effector)
	1,	// NumberOfChildren
	&y_bum,	// Chain Root
};

