#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
//#include <libds.h>
#include <libcd.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"




// Skinner.exe : b_skin.c ( 220 vertices, 254 polygons )

uint32 b_skin_num_verts = 220;
uint32 b_skin_num_polys = 254;

chfloat b_skin_verts[] =
{
	CHFL( 41.028 ), CHFL( 7.704 ) , CHFL( -13.964 ),
	CHFL( 41.028 ), CHFL( 8.556 ) , CHFL( -1.616 ),
	CHFL( 43.824 ), CHFL( -3.376 ) , CHFL( -12.584 ),
	CHFL( 43.836 ), CHFL( -2.624 ) , CHFL( -1.652 ),
	CHFL( 41.048 ), CHFL( 7.712 ) , CHFL( 1.136 ),
	CHFL( 40.996 ), CHFL( 8.552 ) , CHFL( 13.396 ),
	CHFL( 43.844 ), CHFL( -3.356 ) , CHFL( 2.716 ),
	CHFL( 43.8 ), CHFL( -2.608 ) , CHFL( 13.576 ),
	CHFL( 79.96 ), CHFL( -2.332 ) , CHFL( 2.392 ),
	CHFL( 70.476 ), CHFL( -2.904 ) , CHFL( 2.316 ),
	CHFL( 70.448 ), CHFL( -3.568 ) , CHFL( 11 ),
	CHFL( 79.936 ), CHFL( -2.972 ) , CHFL( 11.308 ),
	CHFL( 70.052 ), CHFL( 12.02 ) , CHFL( 2.512 ),
	CHFL( 70.012 ), CHFL( 11.136 ) , CHFL( 13.848 ),
	CHFL( 97.296 ), CHFL( 4.156 ) , CHFL( 13.396 ),
	CHFL( 97.336 ), CHFL( 5.036 ) , CHFL( 2.1 ),
	CHFL( 95.008 ), CHFL( -0.624 ) , CHFL( 11.732 ),
	CHFL( 95.04 ), CHFL( 0.068 ) , CHFL( 2.62 ),
	CHFL( 79.924 ), CHFL( -3.048 ) , CHFL( -3.204 ),
	CHFL( 70.436 ), CHFL( -3.596 ) , CHFL( -3.308 ),
	CHFL( 70.524 ), CHFL( -2.748 ) , CHFL( -12.308 ),
	CHFL( 79.956 ), CHFL( -2.36 ) , CHFL( -12.224 ),
	CHFL( 70.008 ), CHFL( 11.156 ) , CHFL( -1.372 ),
	CHFL( 70.052 ), CHFL( 12.004 ) , CHFL( -12.536 ),
	CHFL( 97.34 ), CHFL( 5.04 ) , CHFL( -12.904 ),
	CHFL( 97.3 ), CHFL( 4.192 ) , CHFL( -1.784 ),
	CHFL( 95.04 ), CHFL( 0.044 ) , CHFL( -12.032 ),
	CHFL( 95.004 ), CHFL( -0.648 ) , CHFL( -2.964 ),
	CHFL( 82.036 ), CHFL( 8.94 ) , CHFL( -12.768 ),
	CHFL( 81.996 ), CHFL( 8.084 ) , CHFL( -1.544 ),
	CHFL( 82.04 ), CHFL( 8.952 ) , CHFL( 2.336 ),
	CHFL( 82 ), CHFL( 8.072 ) , CHFL( 13.608 ),
	CHFL( 62.996 ), CHFL( 7.688 ) , CHFL( 11.52 ),
	CHFL( 64.52 ), CHFL( -1.568 ) , CHFL( 12.112 ),
	CHFL( 64.552 ), CHFL( -2.108 ) , CHFL( 4.268 ),
	CHFL( 62.924 ), CHFL( 7.664 ) , CHFL( -3.692 ),
	CHFL( 64.452 ), CHFL( -1.596 ) , CHFL( -3.008 ),
	CHFL( 63.028 ), CHFL( 7.144 ) , CHFL( 3.648 ),
	CHFL( 64.632 ), CHFL( -2.148 ) , CHFL( -11.136 ),
	CHFL( 62.956 ), CHFL( 7.1 ) , CHFL( -11.884 ),
	CHFL( 17.308 ), CHFL( 7.744 ) , CHFL( -14.712 ),
	CHFL( 36.168 ), CHFL( 9.96 ) , CHFL( -14.084 ),
	CHFL( 36.244 ), CHFL( 10.808 ) , CHFL( -1.776 ),
	CHFL( 37.696 ), CHFL( -3.38 ) , CHFL( -1.656 ),
	CHFL( 37.62 ), CHFL( -4.128 ) , CHFL( -12.52 ),
	CHFL( 17.352 ), CHFL( 8.704 ) , CHFL( 14.372 ),
	CHFL( 36.184 ), CHFL( 9.952 ) , CHFL( 1.004 ),
	CHFL( 36.22 ), CHFL( 10.796 ) , CHFL( 13.26 ),
	CHFL( 37.672 ), CHFL( -3.368 ) , CHFL( 13.632 ),
	CHFL( 37.64 ), CHFL( -4.116 ) , CHFL( 2.776 ),
	CHFL( 51.324 ), CHFL( 8.164 ) , CHFL( -4.112 ),
	CHFL( 32.736 ), CHFL( -8.536 ) , CHFL( -0.924 ),
	CHFL( 53.696 ), CHFL( -9.008 ) , CHFL( -1.776 ),
	CHFL( 53.66 ), CHFL( -3.008 ) , CHFL( 9.096 ),
	CHFL( 32.704 ), CHFL( -3.468 ) , CHFL( 8.264 ),
	CHFL( 56 ), CHFL( 2.792 ) , CHFL( 15.616 ),
	CHFL( 51.28 ), CHFL( 14.792 ) , CHFL( 7.908 ),
	CHFL( 57.42 ), CHFL( 7.608 ) , CHFL( 13.364 ),
	CHFL( 22.944 ), CHFL( 10.312 ) , CHFL( 8.848 ),
	CHFL( 56.068 ), CHFL( -11.344 ) , CHFL( -10.048 ),
	CHFL( 51.372 ), CHFL( 1.668 ) , CHFL( -15.896 ),
	CHFL( 57.532 ), CHFL( -6.936 ) , CHFL( -13.02 ),
	CHFL( 22.944 ), CHFL( 3.94 ) , CHFL( -12.98 ),
	CHFL( 41.376 ), CHFL( 2.16 ) , CHFL( 15.152 ),
	CHFL( 41.38 ), CHFL( -11.3 ) , CHFL( -9.284 ),
	CHFL( 22.132 ), CHFL( -2.772 ) , CHFL( 13.164 ),
	CHFL( 22.132 ), CHFL( -9.384 ) , CHFL( -9.516 ),
	CHFL( 38.708 ), CHFL( 3.16 ) , CHFL( -16.144 ),
	CHFL( 38.624 ), CHFL( 15.736 ) , CHFL( 6.668 ),
	CHFL( 14.384 ), CHFL( -7.428 ) , CHFL( 3.28 ),
	CHFL( 14.304 ), CHFL( -6.736 ) , CHFL( -1.592 ),
	CHFL( 12.02 ), CHFL( -12.876 ) , CHFL( -10.744 ),
	CHFL( 11.996 ), CHFL( -5.004 ) , CHFL( 16.252 ),
	CHFL( 15.328 ), CHFL( 9.368 ) , CHFL( -2.592 ),
	CHFL( 15.296 ), CHFL( 8.652 ) , CHFL( 2.112 ),
	CHFL( 22.924 ), CHFL( 8.76 ) , CHFL( -2.452 ),
	CHFL( 38.66 ), CHFL( 9.468 ) , CHFL( -4.752 ),
	CHFL( 16.712 ), CHFL( -7.212 ) , CHFL( -13.588 ),
	CHFL( 16.752 ), CHFL( -6.256 ) , CHFL( 15.384 ),
	CHFL( 59.148 ), CHFL( -7.28 ) , CHFL( 1.08 ),
	CHFL( 58.152 ), CHFL( 11.452 ) , CHFL( -0.144 ),
	CHFL( 59.092 ), CHFL( -6.3 ) , CHFL( 15.308 ),
	CHFL( 58.092 ), CHFL( 12.424 ) , CHFL( 13.996 ),
	CHFL( 58.152 ), CHFL( 11.448 ) , CHFL( -14.952 ),
	CHFL( 59.148 ), CHFL( -7.252 ) , CHFL( -13.528 ),
	CHFL( 58.096 ), CHFL( 12.428 ) , CHFL( -0.72 ),
	CHFL( 59.088 ), CHFL( -6.276 ) , CHFL( 0.664 ),
	CHFL( 72.144 ), CHFL( 5.18 ) , CHFL( 15.712 ),
	CHFL( 48.976 ), CHFL( 3.74 ) , CHFL( 16.744 ),
	CHFL( 71.984 ), CHFL( 6.676 ) , CHFL( 10.292 ),
	CHFL( 48.06 ), CHFL( 5.632 ) , CHFL( 11.064 ),
	CHFL( 73.48 ), CHFL( 11.82 ) , CHFL( 10.324 ),
	CHFL( 47.412 ), CHFL( 14.652 ) , CHFL( 10.788 ),
	CHFL( 73.796 ), CHFL( 13.54 ) , CHFL( 15.46 ),
	CHFL( 49.268 ), CHFL( 16.128 ) , CHFL( 16.46 ),
	CHFL( 72.52 ), CHFL( 9.464 ) , CHFL( 19.176 ),
	CHFL( 48.392 ), CHFL( 10.02 ) , CHFL( 19.804 ),
	CHFL( 91.468 ), CHFL( 6.108 ) , CHFL( 15.108 ),
	CHFL( 77.552 ), CHFL( 5.156 ) , CHFL( 15.604 ),
	CHFL( 91.404 ), CHFL( 7.24 ) , CHFL( 11.588 ),
	CHFL( 77.456 ), CHFL( 6.64 ) , CHFL( 10.18 ),
	CHFL( 91.372 ), CHFL( 11.172 ) , CHFL( 11.496 ),
	CHFL( 75.712 ), CHFL( 11.844 ) , CHFL( 10.288 ),
	CHFL( 91.42 ), CHFL( 12.468 ) , CHFL( 14.956 ),
	CHFL( 75.78 ), CHFL( 13.58 ) , CHFL( 15.432 ),
	CHFL( 91.48 ), CHFL( 9.344 ) , CHFL( 17.368 ),
	CHFL( 77.664 ), CHFL( 9.456 ) , CHFL( 19.072 ),
	CHFL( 72.224 ), CHFL( -11.428 ) , CHFL( -16.084 ),
	CHFL( 48.964 ), CHFL( -12.76 ) , CHFL( -17.228 ),
	CHFL( 71.932 ), CHFL( -9.712 ) , CHFL( -10.188 ),
	CHFL( 48.048 ), CHFL( -10.792 ) , CHFL( -11.452 ),
	CHFL( 73.428 ), CHFL( -4.572 ) , CHFL( -10.396 ),
	CHFL( 47.4 ), CHFL( -1.768 ) , CHFL( -11.54 ),
	CHFL( 73.876 ), CHFL( -3.064 ) , CHFL( -16.124 ),
	CHFL( 49.372 ), CHFL( -0.364 ) , CHFL( -17.42 ),
	CHFL( 72.656 ), CHFL( -7.276 ) , CHFL( -19.512 ),
	CHFL( 48.468 ), CHFL( -6.604 ) , CHFL( -20.452 ),
	CHFL( 91.528 ), CHFL( -10.504 ) , CHFL( -15.384 ),
	CHFL( 77.616 ), CHFL( -11.456 ) , CHFL( -16.004 ),
	CHFL( 91.448 ), CHFL( -9.24 ) , CHFL( -11.988 ),
	CHFL( 77.484 ), CHFL( -9.764 ) , CHFL( -10.316 ),
	CHFL( 91.424 ), CHFL( -5.308 ) , CHFL( -12.044 ),
	CHFL( 75.748 ), CHFL( -4.564 ) , CHFL( -10.636 ),
	CHFL( 91.492 ), CHFL( -4.14 ) , CHFL( -15.476 ),
	CHFL( 75.86 ), CHFL( -3.028 ) , CHFL( -16.16 ),
	CHFL( 91.56 ), CHFL( -7.356 ) , CHFL( -17.78 ),
	CHFL( 77.752 ), CHFL( -7.284 ) , CHFL( -19.364 ),
	CHFL( 110.828 ), CHFL( -4.704 ) , CHFL( -12.42 ),
	CHFL( 109.908 ), CHFL( -10.912 ) , CHFL( -17.188 ),
	CHFL( 111.428 ), CHFL( -10.668 ) , CHFL( -12.376 ),
	CHFL( 109.54 ), CHFL( -4.6 ) , CHFL( -17.004 ),
	CHFL( 100.756 ), CHFL( -1.744 ) , CHFL( -19.368 ),
	CHFL( 101.348 ), CHFL( -12.996 ) , CHFL( -19.5 ),
	CHFL( 100.596 ), CHFL( -1.688 ) , CHFL( -12.556 ),
	CHFL( 101.432 ), CHFL( -12.78 ) , CHFL( -12.432 ),
	CHFL( 100.708 ), CHFL( 15.016 ) , CHFL( 18.812 ),
	CHFL( 100.428 ), CHFL( 14.648 ) , CHFL( 11.74 ),
	CHFL( 101.62 ), CHFL( 3.796 ) , CHFL( 19.348 ),
	CHFL( 101.444 ), CHFL( 3.804 ) , CHFL( 12.028 ),
	CHFL( 109.432 ), CHFL( 12.088 ) , CHFL( 16.316 ),
	CHFL( 110.108 ), CHFL( 5.812 ) , CHFL( 16.72 ),
	CHFL( 110.652 ), CHFL( 11.84 ) , CHFL( 11.432 ),
	CHFL( 111.428 ), CHFL( 5.936 ) , CHFL( 11.616 ),
	CHFL( 95.132 ), CHFL( -7.104 ) , CHFL( -14.952 ),
	CHFL( 95.144 ), CHFL( 9.496 ) , CHFL( 14.36 ),
	CHFL( 91.888 ), CHFL( 12.332 ) , CHFL( 17.212 ),
	CHFL( 92.548 ), CHFL( 6.388 ) , CHFL( 17.608 ),
	CHFL( 91.664 ), CHFL( 12 ) , CHFL( 11.644 ),
	CHFL( 92.424 ), CHFL( 6.428 ) , CHFL( 11.816 ),
	CHFL( 91.84 ), CHFL( -4.496 ) , CHFL( -12.204 ),
	CHFL( 92.428 ), CHFL( -10.124 ) , CHFL( -12.156 ),
	CHFL( 91.98 ), CHFL( -4.34 ) , CHFL( -17.524 ),
	CHFL( 92.332 ), CHFL( -10.316 ) , CHFL( -17.708 ),
	CHFL( 16.88 ), CHFL( 12.656 ) , CHFL( 0.052 ),
	CHFL( 63.316 ), CHFL( -0.68 ) , CHFL( 4.688 ),
	CHFL( 63.32 ), CHFL( -0.68 ) , CHFL( -4.56 ),
	CHFL( 62.044 ), CHFL( 5.14 ) , CHFL( -4.544 ),
	CHFL( 62.1 ), CHFL( 5.1 ) , CHFL( 4.48 ),
	CHFL( 57.48 ), CHFL( 2.448 ) , CHFL( -6.248 ),
	CHFL( 58.392 ), CHFL( -5.996 ) , CHFL( -2.856 ),
	CHFL( 57.448 ), CHFL( 6.928 ) , CHFL( 1.876 ),
	CHFL( 58.352 ), CHFL( -0.56 ) , CHFL( 7 ),
	CHFL( 63.964 ), CHFL( -3.916 ) , CHFL( 0.208 ),
	CHFL( 58.572 ), CHFL( -4.34 ) , CHFL( 3 ),
	CHFL( 73.828 ), CHFL( 8.748 ) , CHFL( -5.988 ),
	CHFL( 73.828 ), CHFL( 8.748 ) , CHFL( 5.76 ),
	CHFL( 72.944 ), CHFL( 4.828 ) , CHFL( -7.22 ),
	CHFL( 72.944 ), CHFL( 4.828 ) , CHFL( 6.984 ),
	CHFL( 68.12 ), CHFL( 10.08 ) , CHFL( 1.244 ),
	CHFL( 68.112 ), CHFL( 10.084 ) , CHFL( -1.392 ),
	CHFL( 71.252 ), CHFL( 10.392 ) , CHFL( 0.028 ),
	CHFL( 65.744 ), CHFL( 9.828 ) , CHFL( -3.62 ),
	CHFL( 65.748 ), CHFL( 9.828 ) , CHFL( 3.184 ),
	CHFL( 66.728 ), CHFL( 2.952 ) , CHFL( 6.32 ),
	CHFL( 66.716 ), CHFL( 2.972 ) , CHFL( -6.796 ),
	CHFL( 62.044 ), CHFL( 5.14 ) , CHFL( -4.544 ),
	CHFL( 62.1 ), CHFL( 5.1 ) , CHFL( 4.48 ),
	CHFL( 73.268 ), CHFL( -3.012 ) , CHFL( -6.512 ),
	CHFL( 73.248 ), CHFL( -3.044 ) , CHFL( 6.276 ),
	CHFL( 68.44 ), CHFL( -3.488 ) , CHFL( -5.572 ),
	CHFL( 68.492 ), CHFL( -3.584 ) , CHFL( 5.364 ),
	CHFL( 78.14 ), CHFL( 6.972 ) , CHFL( 4.428 ),
	CHFL( 78.924 ), CHFL( 3.636 ) , CHFL( 4.932 ),
	CHFL( 78.14 ), CHFL( 6.972 ) , CHFL( -4.68 ),
	CHFL( 78.968 ), CHFL( 3.636 ) , CHFL( -5.248 ),
	CHFL( 79.088 ), CHFL( 7.42 ) , CHFL( 0.004 ),
	CHFL( 78.452 ), CHFL( -2.436 ) , CHFL( 4.604 ),
	CHFL( 78.444 ), CHFL( -2.424 ) , CHFL( -4.992 ),
	CHFL( 80.496 ), CHFL( 3.596 ) , CHFL( 0.036 ),
	CHFL( 80.308 ), CHFL( -1.6 ) , CHFL( 0.032 ),
	CHFL( 69.556 ), CHFL( 9.156 ) , CHFL( -5.488 ),
	CHFL( 69.56 ), CHFL( 9.152 ) , CHFL( 5.268 ),
	CHFL( 73.86 ), CHFL( 9.836 ) , CHFL( 0.028 ),
	CHFL( 77.644 ), CHFL( -5.608 ) , CHFL( 1.268 ),
	CHFL( 74.328 ), CHFL( -6.54 ) , CHFL( 1.868 ),
	CHFL( 77.644 ), CHFL( -5.608 ) , CHFL( -1.456 ),
	CHFL( 74.328 ), CHFL( -6.54 ) , CHFL( -2.04 ),
	CHFL( 68.232 ), CHFL( 10.956 ) , CHFL( -0.024 ),
	CHFL( 61.944 ), CHFL( 9.704 ) , CHFL( -0.072 ),
	CHFL( 68.556 ), CHFL( 12.256 ) , CHFL( -0.024 ),
	CHFL( 68.92 ), CHFL( -6.424 ) , CHFL( 1.66 ),
	CHFL( 68.92 ), CHFL( -6.424 ) , CHFL( -1.82 ),
	CHFL( 59.7 ), CHFL( 10.664 ) , CHFL( 10.54 ),
	CHFL( 60.74 ), CHFL( -7.68 ) , CHFL( -10.924 ),
	CHFL( 68.404 ), CHFL( 15.612 ) , CHFL( -85.896 ),
	CHFL( 97.196 ), CHFL( 8.248 ) , CHFL( -86.48 ),
	CHFL( 97.284 ), CHFL( -2.696 ) , CHFL( 55.884 ),
	CHFL( 68.464 ), CHFL( 4.672 ) , CHFL( 56.468 ),
	CHFL( 68.984 ), CHFL( 17.656 ) , CHFL( -65.8 ),
	CHFL( 98.416 ), CHFL( 10.128 ) , CHFL( -66.396 ),
	CHFL( 98.416 ), CHFL( 2.272 ) , CHFL( 36.032 ),
	CHFL( 68.984 ), CHFL( 9.8 ) , CHFL( 36.628 ),
	CHFL( 98.376 ), CHFL( 7.556 ) , CHFL( -32.296 ),
	CHFL( 68.948 ), CHFL( 15.084 ) , CHFL( -31.7 ),
	CHFL( 68.972 ), CHFL( 16.156 ) , CHFL( -46.044 ),
	CHFL( 98.4 ), CHFL( 8.628 ) , CHFL( -46.64 ),
	CHFL( 98.4 ), CHFL( 3.788 ) , CHFL( 16.504 ),
	CHFL( 68.972 ), CHFL( 11.316 ) , CHFL( 17.1 ),
	CHFL( 98.392 ), CHFL( 4.968 ) , CHFL( 1.208 ),
	CHFL( 68.964 ), CHFL( 12.496 ) , CHFL( 1.804 ),
};


chfloat b_skin_norms[] =
{
	CHFL( 0.04 ), CHFL( 0.614 ) , CHFL( -0.789 ),
	CHFL( 0.125 ), CHFL( 0.703 ) , CHFL( 0.7 ),
	CHFL( -0.022 ), CHFL( -0.764 ) , CHFL( -0.644 ),
	CHFL( -0.076 ), CHFL( -0.67 ) , CHFL( 0.739 ),
	CHFL( 0.128 ), CHFL( 0.601 ) , CHFL( -0.789 ),
	CHFL( 0.042 ), CHFL( 0.717 ) , CHFL( 0.695 ),
	CHFL( -0.07 ), CHFL( -0.764 ) , CHFL( -0.641 ),
	CHFL( -0.02 ), CHFL( -0.668 ) , CHFL( 0.744 ),
	CHFL( 0.087 ), CHFL( -0.707 ) , CHFL( -0.702 ),
	CHFL( -0.305 ), CHFL( 0.267 ) , CHFL( 0.914 ),
	CHFL( -0.34 ), CHFL( -0.015 ) , CHFL( 0.94 ),
	CHFL( 0.041 ), CHFL( -0.99 ) , CHFL( 0.137 ),
	CHFL( -0.706 ), CHFL( -0.016 ) , CHFL( -0.708 ),
	CHFL( -0.716 ), CHFL( -0.156 ) , CHFL( 0.681 ),
	CHFL( 0.611 ), CHFL( -0.455 ) , CHFL( 0.648 ),
	CHFL( 0.626 ), CHFL( -0.317 ) , CHFL( -0.712 ),
	CHFL( 0.489 ), CHFL( -0.771 ) , CHFL( 0.407 ),
	CHFL( 0.505 ), CHFL( -0.686 ) , CHFL( -0.524 ),
	CHFL( 0.106 ), CHFL( -0.987 ) , CHFL( 0.125 ),
	CHFL( -0.37 ), CHFL( -0.019 ) , CHFL( 0.929 ),
	CHFL( -0.449 ), CHFL( 0.185 ) , CHFL( 0.874 ),
	CHFL( 0.107 ), CHFL( -0.688 ) , CHFL( -0.718 ),
	CHFL( -0.5 ), CHFL( 0.523 ) , CHFL( 0.691 ),
	CHFL( -0.505 ), CHFL( 0.601 ) , CHFL( -0.619 ),
	CHFL( 0.737 ), CHFL( 0.293 ) , CHFL( -0.609 ),
	CHFL( 0.722 ), CHFL( 0.234 ) , CHFL( 0.651 ),
	CHFL( 0.497 ), CHFL( -0.699 ) , CHFL( -0.515 ),
	CHFL( 0.504 ), CHFL( -0.754 ) , CHFL( 0.421 ),
	CHFL( 0.183 ), CHFL( 0.689 ) , CHFL( -0.701 ),
	CHFL( 0.175 ), CHFL( 0.598 ) , CHFL( 0.783 ),
	CHFL( -0.003 ), CHFL( -0.015 ) , CHFL( -1 ),
	CHFL( -0.022 ), CHFL( -0.216 ) , CHFL( 0.976 ),
	CHFL( 0.799 ), CHFL( -0.082 ) , CHFL( 0.596 ),
	CHFL( 0.612 ), CHFL( -0.139 ) , CHFL( 0.778 ),
	CHFL( 0.886 ), CHFL( -0.243 ) , CHFL( -0.394 ),
	CHFL( 0.864 ), CHFL( -0.015 ) , CHFL( 0.503 ),
	CHFL( 0.595 ), CHFL( -0.136 ) , CHFL( 0.792 ),
	CHFL( 0.45 ), CHFL( -0.079 ) , CHFL( -0.89 ),
	CHFL( 0.863 ), CHFL( -0.3 ) , CHFL( -0.406 ),
	CHFL( 0.441 ), CHFL( -0.072 ) , CHFL( -0.895 ),
	CHFL( -0.417 ), CHFL( 0.539 ) , CHFL( -0.732 ),
	CHFL( 0.189 ), CHFL( 0.598 ) , CHFL( -0.779 ),
	CHFL( 0.107 ), CHFL( 0.723 ) , CHFL( 0.683 ),
	CHFL( 0.076 ), CHFL( -0.673 ) , CHFL( 0.736 ),
	CHFL( 0.111 ), CHFL( -0.757 ) , CHFL( -0.644 ),
	CHFL( -0.728 ), CHFL( 0.657 ) , CHFL( 0.197 ),
	CHFL( 0.102 ), CHFL( 0.624 ) , CHFL( -0.774 ),
	CHFL( 0.195 ), CHFL( 0.699 ) , CHFL( 0.688 ),
	CHFL( 0.117 ), CHFL( -0.661 ) , CHFL( 0.741 ),
	CHFL( 0.077 ), CHFL( -0.766 ) , CHFL( -0.638 ),
	CHFL( 0.381 ), CHFL( 0.81 ) , CHFL( -0.445 ),
	CHFL( -0.039 ), CHFL( -0.941 ) , CHFL( 0.337 ),
	CHFL( 0.366 ), CHFL( -0.864 ) , CHFL( 0.345 ),
	CHFL( 0.368 ), CHFL( -0.749 ) , CHFL( 0.551 ),
	CHFL( 0.029 ), CHFL( -0.868 ) , CHFL( 0.496 ),
	CHFL( 0.191 ), CHFL( -0.076 ) , CHFL( 0.979 ),
	CHFL( 0.25 ), CHFL( 0.939 ) , CHFL( 0.236 ),
	CHFL( 0.854 ), CHFL( 0.28 ) , CHFL( 0.439 ),
	CHFL( -0.436 ), CHFL( 0.647 ) , CHFL( 0.626 ),
	CHFL( 0.173 ), CHFL( -0.871 ) , CHFL( -0.46 ),
	CHFL( 0.241 ), CHFL( 0.309 ) , CHFL( -0.92 ),
	CHFL( 0.852 ), CHFL( -0.223 ) , CHFL( -0.475 ),
	CHFL( -0.167 ), CHFL( 0.046 ) , CHFL( -0.985 ),
	CHFL( -0.012 ), CHFL( -0.039 ) , CHFL( 0.999 ),
	CHFL( -0.074 ), CHFL( -0.814 ) , CHFL( -0.577 ),
	CHFL( 0.139 ), CHFL( -0.558 ) , CHFL( 0.818 ),
	CHFL( 0.064 ), CHFL( -0.955 ) , CHFL( -0.29 ),
	CHFL( -0.035 ), CHFL( 0.332 ) , CHFL( -0.943 ),
	CHFL( -0.095 ), CHFL( 0.94 ) , CHFL( 0.328 ),
	CHFL( -0.573 ), CHFL( -0.654 ) , CHFL( -0.494 ),
	CHFL( -0.566 ), CHFL( -0.567 ) , CHFL( 0.598 ),
	CHFL( -0.601 ), CHFL( -0.348 ) , CHFL( -0.72 ),
	CHFL( -0.538 ), CHFL( 0.096 ) , CHFL( 0.837 ),
	CHFL( -0.846 ), CHFL( 0.482 ) , CHFL( -0.229 ),
	CHFL( -0.797 ), CHFL( 0.327 ) , CHFL( -0.507 ),
	CHFL( -0.261 ), CHFL( 0.558 ) , CHFL( -0.788 ),
	CHFL( 0.025 ), CHFL( 0.891 ) , CHFL( -0.453 ),
	CHFL( -0.471 ), CHFL( -0.55 ) , CHFL( -0.689 ),
	CHFL( -0.466 ), CHFL( -0.461 ) , CHFL( 0.755 ),
	CHFL( 0.342 ), CHFL( -0.686 ) , CHFL( -0.642 ),
	CHFL( 0.35 ), CHFL( 0.596 ) , CHFL( -0.723 ),
	CHFL( 0.315 ), CHFL( -0.586 ) , CHFL( 0.746 ),
	CHFL( 0.323 ), CHFL( 0.686 ) , CHFL( 0.651 ),
	CHFL( 0.328 ), CHFL( 0.586 ) , CHFL( -0.741 ),
	CHFL( 0.315 ), CHFL( -0.686 ) , CHFL( -0.656 ),
	CHFL( 0.342 ), CHFL( 0.688 ) , CHFL( 0.64 ),
	CHFL( 0.331 ), CHFL( -0.59 ) , CHFL( 0.736 ),
	CHFL( 0.037 ), CHFL( -0.952 ) , CHFL( 0.304 ),
	CHFL( -0.238 ), CHFL( -0.907 ) , CHFL( 0.347 ),
	CHFL( 0 ), CHFL( -0.599 ) , CHFL( -0.801 ),
	CHFL( -0.802 ), CHFL( -0.295 ) , CHFL( -0.519 ),
	CHFL( 0.024 ), CHFL( 0.592 ) , CHFL( -0.806 ),
	CHFL( -0.385 ), CHFL( 0.377 ) , CHFL( -0.843 ),
	CHFL( 0.054 ), CHFL( 0.965 ) , CHFL( 0.257 ),
	CHFL( -0.433 ), CHFL( 0.829 ) , CHFL( 0.354 ),
	CHFL( 0.051 ), CHFL( 0.021 ) , CHFL( 0.998 ),
	CHFL( -0.719 ), CHFL( 0.009 ) , CHFL( 0.695 ),
	CHFL( 0.417 ), CHFL( -0.861 ) , CHFL( 0.291 ),
	CHFL( 0.044 ), CHFL( -0.95 ) , CHFL( 0.309 ),
	CHFL( 0.433 ), CHFL( -0.53 ) , CHFL( -0.729 ),
	CHFL( 0.038 ), CHFL( -0.596 ) , CHFL( -0.802 ),
	CHFL( 0.405 ), CHFL( 0.528 ) , CHFL( -0.746 ),
	CHFL( 0.034 ), CHFL( 0.587 ) , CHFL( -0.809 ),
	CHFL( 0.382 ), CHFL( 0.891 ) , CHFL( 0.245 ),
	CHFL( 0.041 ), CHFL( 0.966 ) , CHFL( 0.255 ),
	CHFL( 0.4 ), CHFL( 0.032 ) , CHFL( 0.916 ),
	CHFL( 0.061 ), CHFL( 0.029 ) , CHFL( 0.998 ),
	CHFL( 0.033 ), CHFL( -0.948 ) , CHFL( -0.318 ),
	CHFL( -0.463 ), CHFL( -0.813 ) , CHFL( -0.353 ),
	CHFL( -0.01 ), CHFL( -0.443 ) , CHFL( 0.897 ),
	CHFL( -0.713 ), CHFL( -0.462 ) , CHFL( 0.527 ),
	CHFL( 0.029 ), CHFL( 0.622 ) , CHFL( 0.782 ),
	CHFL( -0.402 ), CHFL( 0.389 ) , CHFL( 0.829 ),
	CHFL( 0.061 ), CHFL( 0.876 ) , CHFL( -0.478 ),
	CHFL( -0.55 ), CHFL( 0.802 ) , CHFL( -0.232 ),
	CHFL( 0.027 ), CHFL( -0.012 ) , CHFL( -1 ),
	CHFL( -0.454 ), CHFL( -0.014 ) , CHFL( -0.891 ),
	CHFL( 0.418 ), CHFL( -0.869 ) , CHFL( -0.265 ),
	CHFL( 0.046 ), CHFL( -0.955 ) , CHFL( -0.292 ),
	CHFL( 0.448 ), CHFL( -0.498 ) , CHFL( 0.742 ),
	CHFL( 0.066 ), CHFL( -0.57 ) , CHFL( 0.819 ),
	CHFL( 0.422 ), CHFL( 0.552 ) , CHFL( 0.719 ),
	CHFL( 0.068 ), CHFL( 0.623 ) , CHFL( 0.779 ),
	CHFL( 0.385 ), CHFL( 0.877 ) , CHFL( -0.285 ),
	CHFL( 0.05 ), CHFL( 0.949 ) , CHFL( -0.311 ),
	CHFL( 0.39 ), CHFL( -0.003 ) , CHFL( -0.921 ),
	CHFL( 0.061 ), CHFL( -0.009 ) , CHFL( -0.998 ),
	CHFL( 0.706 ), CHFL( 0.591 ) , CHFL( 0.39 ),
	CHFL( 0.688 ), CHFL( -0.415 ) , CHFL( -0.596 ),
	CHFL( 0.714 ), CHFL( -0.544 ) , CHFL( 0.442 ),
	CHFL( 0.673 ), CHFL( 0.473 ) , CHFL( -0.568 ),
	CHFL( 0.023 ), CHFL( 0.703 ) , CHFL( -0.711 ),
	CHFL( 0 ), CHFL( -0.706 ) , CHFL( -0.708 ),
	CHFL( 0.011 ), CHFL( 0.7 ) , CHFL( 0.714 ),
	CHFL( -0.012 ), CHFL( -0.684 ) , CHFL( 0.73 ),
	CHFL( 0.038 ), CHFL( 0.735 ) , CHFL( 0.677 ),
	CHFL( -0.007 ), CHFL( 0.668 ) , CHFL( -0.744 ),
	CHFL( 0.018 ), CHFL( -0.683 ) , CHFL( 0.73 ),
	CHFL( -0.027 ), CHFL( -0.708 ) , CHFL( -0.705 ),
	CHFL( 0.682 ), CHFL( 0.515 ) , CHFL( 0.519 ),
	CHFL( 0.716 ), CHFL( -0.376 ) , CHFL( 0.588 ),
	CHFL( 0.678 ), CHFL( 0.59 ) , CHFL( -0.438 ),
	CHFL( 0.704 ), CHFL( -0.542 ) , CHFL( -0.459 ),
	CHFL( 1 ), CHFL( 0.023 ) , CHFL( -0.005 ),
	CHFL( 1 ), CHFL( 0.025 ) , CHFL( -0.002 ),
	CHFL( -0.745 ), CHFL( 0.445 ) , CHFL( 0.496 ),
	CHFL( -0.706 ), CHFL( -0.508 ) , CHFL( 0.494 ),
	CHFL( -0.698 ), CHFL( 0.449 ) , CHFL( -0.558 ),
	CHFL( -0.649 ), CHFL( -0.574 ) , CHFL( -0.5 ),
	CHFL( -0.685 ), CHFL( 0.485 ) , CHFL( 0.544 ),
	CHFL( -0.649 ), CHFL( -0.537 ) , CHFL( 0.539 ),
	CHFL( -0.749 ), CHFL( 0.443 ) , CHFL( -0.493 ),
	CHFL( -0.725 ), CHFL( -0.507 ) , CHFL( -0.466 ),
	CHFL( 0.127 ), CHFL( 0.973 ) , CHFL( -0.193 ),
	CHFL( -0.131 ), CHFL( -0.37 ) , CHFL( 0.92 ),
	CHFL( -0.099 ), CHFL( -0.624 ) , CHFL( -0.775 ),
	CHFL( -0.09 ), CHFL( 0.264 ) , CHFL( -0.96 ),
	CHFL( -0.115 ), CHFL( 0.597 ) , CHFL( 0.794 ),
	CHFL( 0.629 ), CHFL( 0.555 ) , CHFL( -0.544 ),
	CHFL( 0.758 ), CHFL( -0.615 ) , CHFL( -0.217 ),
	CHFL( 0.634 ), CHFL( 0.773 ) , CHFL( -0.038 ),
	CHFL( 0.698 ), CHFL( -0.317 ) , CHFL( 0.642 ),
	CHFL( -0.176 ), CHFL( -0.977 ) , CHFL( 0.118 ),
	CHFL( 0.47 ), CHFL( -0.806 ) , CHFL( 0.36 ),
	CHFL( 0.228 ), CHFL( 0.708 ) , CHFL( -0.668 ),
	CHFL( 0.226 ), CHFL( 0.7 ) , CHFL( 0.677 ),
	CHFL( 0.113 ), CHFL( 0.076 ) , CHFL( -0.991 ),
	CHFL( 0.109 ), CHFL( 0.071 ) , CHFL( 0.992 ),
	CHFL( -0.254 ), CHFL( 0.863 ) , CHFL( 0.436 ),
	CHFL( -0.236 ), CHFL( 0.877 ) , CHFL( -0.419 ),
	CHFL( 0.188 ), CHFL( 0.982 ) , CHFL( 0.008 ),
	CHFL( -0.237 ), CHFL( 0.778 ) , CHFL( -0.582 ),
	CHFL( -0.239 ), CHFL( 0.771 ) , CHFL( 0.59 ),
	CHFL( -0.278 ), CHFL( 0.173 ) , CHFL( 0.945 ),
	CHFL( -0.291 ), CHFL( 0.165 ) , CHFL( -0.942 ),
	CHFL( -0.846 ), CHFL( 0.27 ) , CHFL( -0.46 ),
	CHFL( -0.827 ), CHFL( 0.284 ) , CHFL( 0.485 ),
	CHFL( 0.122 ), CHFL( -0.477 ) , CHFL( -0.871 ),
	CHFL( 0.127 ), CHFL( -0.471 ) , CHFL( 0.873 ),
	CHFL( -0.288 ), CHFL( -0.507 ) , CHFL( -0.812 ),
	CHFL( -0.261 ), CHFL( -0.491 ) , CHFL( 0.831 ),
	CHFL( 0.657 ), CHFL( 0.544 ) , CHFL( 0.522 ),
	CHFL( 0.714 ), CHFL( 0.105 ) , CHFL( 0.692 ),
	CHFL( 0.657 ), CHFL( 0.554 ) , CHFL( -0.512 ),
	CHFL( 0.718 ), CHFL( 0.112 ) , CHFL( -0.688 ),
	CHFL( 0.745 ), CHFL( 0.667 ) , CHFL( 0.008 ),
	CHFL( 0.684 ), CHFL( -0.383 ) , CHFL( 0.62 ),
	CHFL( 0.688 ), CHFL( -0.389 ) , CHFL( -0.613 ),
	CHFL( 0.992 ), CHFL( 0.126 ) , CHFL( 0.013 ),
	CHFL( 0.937 ), CHFL( -0.349 ) , CHFL( 0.009 ),
	CHFL( -0.095 ), CHFL( 0.752 ) , CHFL( -0.652 ),
	CHFL( -0.119 ), CHFL( 0.744 ) , CHFL( 0.657 ),
	CHFL( 0.277 ), CHFL( 0.961 ) , CHFL( 0.005 ),
	CHFL( 0.617 ), CHFL( -0.748 ) , CHFL( 0.243 ),
	CHFL( 0.138 ), CHFL( -0.933 ) , CHFL( 0.333 ),
	CHFL( 0.617 ), CHFL( -0.751 ) , CHFL( -0.237 ),
	CHFL( 0.132 ), CHFL( -0.934 ) , CHFL( -0.331 ),
	CHFL( -0.481 ), CHFL( 0.877 ) , CHFL( 0.011 ),
	CHFL( -0.57 ), CHFL( 0.822 ) , CHFL( 0.013 ),
	CHFL( -0.297 ), CHFL( 0.954 ) , CHFL( 0.022 ),
	CHFL( -0.268 ), CHFL( -0.918 ) , CHFL( 0.293 ),
	CHFL( -0.278 ), CHFL( -0.917 ) , CHFL( -0.287 ),
	CHFL( -0.024 ), CHFL( -0.011 ) , CHFL( -1 ),
	CHFL( -0.049 ), CHFL( 0.031 ) , CHFL( 0.998 ),
	CHFL( 0.244 ), CHFL( 0.964 ) , CHFL( -0.105 ),
	CHFL( 0.244 ), CHFL( 0.964 ) , CHFL( -0.105 ),
	CHFL( 0.245 ), CHFL( 0.937 ) , CHFL( 0.249 ),
	CHFL( 0.245 ), CHFL( 0.937 ) , CHFL( 0.249 ),
	CHFL( 0.247 ), CHFL( 0.969 ) , CHFL( -0.016 ),
	CHFL( 0.247 ), CHFL( 0.969 ) , CHFL( -0.016 ),
	CHFL( 0.248 ), CHFL( 0.955 ) , CHFL( 0.162 ),
	CHFL( 0.248 ), CHFL( 0.955 ) , CHFL( 0.162 ),
	CHFL( 0.249 ), CHFL( 0.966 ) , CHFL( 0.074 ),
	CHFL( 0.249 ), CHFL( 0.966 ) , CHFL( 0.074 ),
	CHFL( 0.249 ), CHFL( 0.966 ) , CHFL( 0.073 ),
	CHFL( 0.249 ), CHFL( 0.966 ) , CHFL( 0.073 ),
	CHFL( 0.249 ), CHFL( 0.966 ) , CHFL( 0.075 ),
	CHFL( 0.249 ), CHFL( 0.966 ) , CHFL( 0.075 ),
	CHFL( 0.249 ), CHFL( 0.966 ) , CHFL( 0.074 ),
	CHFL( 0.249 ), CHFL( 0.966 ) , CHFL( 0.074 ),
};


model_polys b_skin_polys[] =
{
	{
		GOURAUD,
		4,
		86, 3, 2, 84,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		31, 13, 10, 11,
		{ 205, 110, 67, 0 },
		45, 128, 127, 71,
		255, 254, 228, 227,
	},
	{
		TEXTURED,
		4,
		12, 30, 8, 9,
		{ 205, 110, 67, 0 },
		128, 59, 74, 127,
		254, 255, 227, 228,
	},
	{
		TEXTURED,
		4,
		23, 28, 21, 20,
		{ 205, 110, 67, 0 },
		128, 45, 71, 127,
		254, 255, 227, 228,
	},
	{
		TEXTURED,
		4,
		30, 15, 17, 8,
		{ 205, 110, 67, 0 },
		59, 0, 3, 74,
		255, 255, 233, 227,
	},
	{
		TEXTURED,
		4,
		22, 19, 18, 29,
		{ 205, 110, 67, 0 },
		128, 127, 71, 45,
		254, 228, 227, 255,
	},
	{
		TEXTURED,
		4,
		18, 27, 25, 29,
		{ 205, 110, 67, 0 },
		71, 24, 0, 45,
		227, 227, 255, 255,
	},
	{
		TEXTURED,
		4,
		28, 24, 26, 21,
		{ 205, 110, 67, 0 },
		45, 0, 24, 71,
		255, 255, 227, 227,
	},
	{
		GOURAUD,
		4,
		84, 2, 0, 83,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		22, 23, 20, 19,
		{ 205, 110, 67, 0 },
		115, 115, 126, 128,
		221, 248, 248, 221,
	},
	{
		GOURAUD,
		4,
		79, 6, 4, 80,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		19, 20, 36, 38,
		{ 205, 110, 67, 0 },
		127, 126, 113, 113,
		220, 248, 248, 221,
	},
	{
		GOURAUD,
		4,
		81, 7, 6, 79,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		18, 19, 38, 39,
		{ 205, 110, 67, 0 },
		71, 127, 127, 95,
		227, 228, 199, 203,
	},
	{
		TEXTURED,
		4,
		21, 18, 39, 35,
		{ 205, 110, 67, 0 },
		62, 71, 96, 85,
		216, 227, 202, 193,
	},
	{
		GOURAUD,
		4,
		85, 35, 39, 83,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		20, 21, 35, 36,
		{ 205, 110, 67, 0 },
		127, 71, 95, 127,
		228, 227, 203, 199,
	},
	{
		TEXTURED,
		4,
		13, 12, 9, 10,
		{ 205, 110, 67, 0 },
		115, 115, 126, 128,
		221, 248, 248, 221,
	},
	{
		GOURAUD,
		4,
		83, 39, 38, 84,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		83, 0, 1, 85,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		86, 36, 35, 85,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		82, 32, 37, 80,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		84, 38, 36, 86,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		15, 14, 16, 17,
		{ 205, 110, 67, 0 },
		2, 0, 0, 2,
		255, 255, 235, 235,
	},
	{
		TEXTURED,
		4,
		26, 27, 18, 21,
		{ 205, 110, 67, 0 },
		24, 24, 62, 71,
		227, 216, 216, 227,
	},
	{
		TEXTURED,
		4,
		17, 16, 11, 8,
		{ 205, 110, 67, 0 },
		24, 24, 62, 71,
		227, 216, 216, 227,
	},
	{
		TEXTURED,
		4,
		24, 25, 27, 26,
		{ 205, 110, 67, 0 },
		2, 0, 0, 2,
		255, 255, 235, 235,
	},
	{
		GOURAUD,
		4,
		82, 5, 7, 81,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		11, 16, 14, 31,
		{ 205, 110, 67, 0 },
		71, 24, 0, 45,
		227, 227, 255, 255,
	},
	{
		GOURAUD,
		4,
		85, 1, 3, 86,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		10, 9, 33, 34,
		{ 205, 110, 67, 0 },
		127, 126, 113, 113,
		220, 248, 248, 221,
	},
	{
		TEXTURED,
		4,
		11, 10, 34, 37,
		{ 205, 110, 67, 0 },
		71, 127, 127, 95,
		227, 228, 199, 203,
	},
	{
		TEXTURED,
		4,
		8, 11, 37, 32,
		{ 205, 110, 67, 0 },
		62, 71, 96, 85,
		216, 227, 202, 193,
	},
	{
		TEXTURED,
		3,
		58, 74, 72, 0,
		{ 205, 110, 67, 0 },
		95, 88, 100, 0,
		168, 187, 185, 0,
	},
	{
		TEXTURED,
		4,
		9, 8, 32, 33,
		{ 205, 110, 67, 0 },
		127, 74, 87, 127,
		228, 227, 199, 199,
	},
	{
		TEXTURED,
		3,
		72, 65, 58, 0,
		{ 205, 110, 67, 0 },
		100, 102, 95, 0,
		185, 166, 168, 0,
	},
	{
		TEXTURED,
		3,
		63, 55, 56, 0,
		{ 205, 110, 67, 0 },
		121, 120, 105, 0,
		101, 92, 100, 0,
	},
	{
		GOURAUD,
		4,
		81, 33, 32, 82,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		59, 60, 61, 0,
		{ 205, 110, 67, 0 },
		33, 17, 35, 0,
		101, 110, 95, 0,
	},
	{
		GOURAUD,
		4,
		79, 34, 33, 81,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		158, 50, 160, 0,
		{ 205, 110, 67, 0 },
		40, 62, 85, 0,
		87, 88, 87, 0,
	},
	{
		GOURAUD,
		4,
		80, 37, 34, 79,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		80, 4, 5, 82,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		4, 46, 47, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		58, 65, 63, 68,
		{ 205, 110, 67, 0 },
		74, 84, 83, 77,
		108, 107, 99, 96,
	},
	{
		GOURAUD,
		3,
		4, 6, 49, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		159, 158, 156, 155,
		{ 205, 110, 67, 0 },
		19, 40, 44, 15,
		88, 87, 78, 72,
	},
	{
		GOURAUD,
		3,
		2, 44, 41, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		7, 5, 47, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		2, 3, 43, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		62, 67, 64, 66,
		{ 205, 110, 67, 0 },
		29, 25, 34, 41,
		177, 168, 171, 179,
	},
	{
		GOURAUD,
		4,
		120, 122, 111, 109,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		64, 67, 60, 0,
		{ 205, 110, 67, 0 },
		29, 15, 15, 0,
		94, 109, 95, 0,
	},
	{
		GOURAUD,
		3,
		7, 48, 49, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		65, 66, 51, 54,
		{ 205, 110, 67, 0 },
		54, 56, 80, 83,
		204, 192, 189, 194,
	},
	{
		GOURAUD,
		3,
		1, 42, 43, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		3,
		60, 67, 76, 0,
		{ 205, 110, 67, 0 },
		15, 5, 5, 0,
		103, 97, 107, 0,
	},
	{
		TEXTURED,
		4,
		76, 67, 62, 75,
		{ 205, 110, 67, 0 },
		24, 33, 36, 30,
		174, 172, 189, 189,
	},
	{
		GOURAUD,
		3,
		1, 0, 41, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		111, 122, 124, 113,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		163, 159, 155, 162,
		{ 205, 110, 67, 0 },
		0, 19, 15, 0,
		88, 88, 72, 73,
	},
	{
		GOURAUD,
		4,
		124, 126, 115, 113,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		49, 48, 78, 69,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		126, 118, 107, 115,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		120, 109, 107, 118,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		66, 64, 51, 0,
		{ 205, 110, 67, 0 },
		54, 67, 80, 0,
		204, 190, 189, 0,
	},
	{
		GOURAUD,
		4,
		102, 100, 89, 91,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		89, 87, 88, 0,
		{ 205, 110, 67, 0 },
		122, 110, 111, 0,
		181, 180, 146, 0,
	},
	{
		GOURAUD,
		4,
		100, 98, 87, 89,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		98, 106, 95, 87,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		104, 102, 91, 93,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		106, 104, 93, 95,
		{ 121, 142, 158, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		56, 68, 63, 0,
		{ 205, 110, 67, 0 },
		114, 110, 124, 0,
		95, 105, 103, 0,
	},
	{
		TEXTURED,
		4,
		97, 105, 106, 98,
		{ 205, 110, 67, 0 },
		92, 121, 104, 115,
		10, 10, 6, 8,
	},
	{
		GOURAUD,
		3,
		74, 69, 72, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		4,
		134, 132, 128, 129,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		162, 154, 161, 163,
		{ 205, 110, 67, 0 },
		125, 106, 116, 126,
		69, 73, 88, 88,
	},
	{
		TEXTURED,
		3,
		95, 96, 88, 0,
		{ 205, 110, 67, 0 },
		116, 125, 119, 0,
		178, 179, 140, 0,
	},
	{
		TEXTURED,
		3,
		111, 113, 114, 0,
		{ 205, 110, 67, 0 },
		5, 15, 15, 0,
		178, 179, 142, 0,
	},
	{
		TEXTURED,
		3,
		60, 59, 64, 0,
		{ 205, 110, 67, 0 },
		15, 30, 18, 0,
		100, 96, 105, 0,
	},
	{
		TEXTURED,
		3,
		99, 101, 144, 0,
		{ 205, 110, 67, 0 },
		172, 204, 189, 0,
		119, 119, 126, 0,
	},
	{
		TEXTURED,
		3,
		143, 125, 123, 0,
		{ 205, 110, 67, 0 },
		189, 188, 214, 0,
		125, 119, 119, 0,
	},
	{
		TEXTURED,
		4,
		121, 123, 124, 122,
		{ 205, 110, 67, 0 },
		101, 103, 114, 97,
		7, 8, 20, 17,
	},
	{
		TEXTURED,
		3,
		103, 105, 144, 0,
		{ 205, 110, 67, 0 },
		214, 188, 189, 0,
		119, 119, 126, 0,
	},
	{
		TEXTURED,
		3,
		117, 125, 143, 0,
		{ 205, 110, 67, 0 },
		162, 188, 189, 0,
		119, 119, 125, 0,
	},
	{
		TEXTURED,
		3,
		65, 54, 63, 0,
		{ 205, 110, 67, 0 },
		54, 80, 67, 0,
		204, 189, 190, 0,
	},
	{
		TEXTURED,
		3,
		143, 121, 119, 0,
		{ 205, 110, 67, 0 },
		189, 204, 172, 0,
		125, 119, 119, 0,
	},
	{
		GOURAUD,
		4,
		147, 148, 146, 145,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		51, 64, 59, 52,
		{ 205, 110, 67, 0 },
		83, 104, 104, 82,
		187, 163, 98, 112,
	},
	{
		GOURAUD,
		4,
		44, 43, 70, 77,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		132, 131, 130, 128,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		141, 139, 140, 142,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		63, 54, 53, 55,
		{ 205, 110, 67, 0 },
		22, 43, 44, 22,
		166, 187, 112, 97,
	},
	{
		GOURAUD,
		4,
		135, 136, 147, 145,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		135, 137, 140, 139,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		136, 135, 139, 141,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		144, 105, 97, 0,
		{ 205, 110, 67, 0 },
		189, 188, 162, 0,
		126, 119, 119, 0,
	},
	{
		GOURAUD,
		4,
		136, 138, 148, 147,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		138, 136, 141, 142,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		47, 45, 78, 48,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		41, 44, 77, 40,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		47, 46, 74, 45,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		137, 138, 142, 140,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		46, 49, 69, 74,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		42, 73, 70, 43,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		97, 99, 144, 0,
		{ 205, 110, 67, 0 },
		162, 172, 189, 0,
		119, 119, 126, 0,
	},
	{
		TEXTURED,
		3,
		71, 73, 62, 0,
		{ 205, 110, 67, 0 },
		41, 26, 29, 0,
		187, 194, 177, 0,
	},
	{
		TEXTURED,
		4,
		66, 65, 72, 71,
		{ 205, 110, 67, 0 },
		52, 72, 86, 89,
		187, 199, 199, 192,
	},
	{
		TEXTURED,
		3,
		57, 56, 55, 0,
		{ 205, 110, 67, 0 },
		106, 105, 120, 0,
		93, 100, 92, 0,
	},
	{
		TEXTURED,
		3,
		60, 50, 158, 0,
		{ 205, 110, 67, 0 },
		6, 28, 10, 0,
		105, 96, 93, 0,
	},
	{
		TEXTURED,
		3,
		90, 96, 94, 0,
		{ 205, 110, 67, 0 },
		119, 115, 121, 0,
		168, 149, 145, 0,
	},
	{
		TEXTURED,
		3,
		107, 108, 116, 0,
		{ 205, 110, 67, 0 },
		8, 5, 19, 0,
		148, 172, 159, 0,
	},
	{
		TEXTURED,
		4,
		125, 117, 118, 126,
		{ 205, 110, 67, 0 },
		121, 92, 115, 104,
		10, 10, 8, 6,
	},
	{
		TEXTURED,
		3,
		91, 92, 94, 0,
		{ 205, 110, 67, 0 },
		124, 113, 113, 0,
		176, 179, 141, 0,
	},
	{
		TEXTURED,
		3,
		88, 96, 90, 0,
		{ 205, 110, 67, 0 },
		111, 115, 119, 0,
		165, 149, 168, 0,
	},
	{
		GOURAUD,
		4,
		133, 134, 129, 127,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		62, 66, 71, 0,
		{ 205, 110, 67, 0 },
		29, 41, 41, 0,
		177, 179, 187, 0,
	},
	{
		TEXTURED,
		4,
		40, 75, 62, 73,
		{ 205, 110, 67, 0 },
		40, 35, 43, 49,
		200, 197, 184, 190,
	},
	{
		TEXTURED,
		3,
		119, 117, 143, 0,
		{ 205, 110, 67, 0 },
		172, 162, 189, 0,
		119, 119, 125, 0,
	},
	{
		GOURAUD,
		4,
		42, 41, 40, 73,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		103, 101, 102, 104,
		{ 205, 110, 67, 0 },
		103, 101, 97, 114,
		8, 7, 17, 20,
	},
	{
		TEXTURED,
		3,
		144, 101, 103, 0,
		{ 205, 110, 67, 0 },
		189, 204, 214, 0,
		126, 119, 119, 0,
	},
	{
		TEXTURED,
		3,
		76, 68, 56, 0,
		{ 205, 110, 67, 0 },
		105, 99, 91, 0,
		93, 102, 92, 0,
	},
	{
		GOURAUD,
		4,
		131, 133, 127, 130,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		3,
		123, 121, 143, 0,
		{ 205, 110, 67, 0 },
		214, 204, 189, 0,
		119, 119, 125, 0,
	},
	{
		GOURAUD,
		4,
		130, 127, 129, 128,
		{ 11, 11, 13, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		149, 151, 152, 150,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		75, 58, 68, 76,
		{ 205, 110, 67, 0 },
		90, 99, 100, 94,
		189, 181, 174, 172,
	},
	{
		TEXTURED,
		4,
		45, 74, 58, 75,
		{ 205, 110, 67, 0 },
		77, 85, 79, 70,
		196, 188, 183, 187,
	},
	{
		TEXTURED,
		3,
		40, 45, 75, 0,
		{ 205, 110, 67, 0 },
		54, 64, 61, 0,
		200, 199, 185, 0,
	},
	{
		TEXTURED,
		4,
		101, 99, 100, 102,
		{ 205, 110, 67, 0 },
		101, 110, 111, 97,
		7, 17, 13, 17,
	},
	{
		TEXTURED,
		4,
		117, 119, 120, 118,
		{ 205, 110, 67, 0 },
		92, 110, 111, 115,
		10, 17, 13, 8,
	},
	{
		GOURAUD,
		3,
		70, 73, 71, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		119, 121, 122, 120,
		{ 205, 110, 67, 0 },
		110, 101, 97, 111,
		17, 7, 17, 13,
	},
	{
		GOURAUD,
		4,
		77, 78, 45, 40,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		99, 97, 98, 100,
		{ 205, 110, 67, 0 },
		110, 92, 115, 111,
		17, 10, 8, 13,
	},
	{
		TEXTURED,
		4,
		54, 51, 52, 53,
		{ 205, 110, 67, 0 },
		43, 83, 82, 44,
		187, 187, 112, 112,
	},
	{
		TEXTURED,
		3,
		107, 109, 110, 0,
		{ 205, 110, 67, 0 },
		15, 17, 5, 0,
		162, 178, 181, 0,
	},
	{
		GOURAUD,
		3,
		77, 70, 153, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		3,
		116, 108, 110, 0,
		{ 205, 110, 67, 0 },
		119, 115, 111, 0,
		154, 161, 147, 0,
	},
	{
		TEXTURED,
		3,
		110, 112, 114, 0,
		{ 205, 110, 67, 0 },
		119, 111, 115, 0,
		154, 147, 145, 0,
	},
	{
		GOURAUD,
		4,
		132, 134, 150, 152,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		78, 77, 153, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		4,
		103, 104, 106, 105,
		{ 205, 110, 67, 0 },
		103, 114, 104, 121,
		8, 20, 6, 10,
	},
	{
		TEXTURED,
		4,
		123, 125, 126, 124,
		{ 205, 110, 67, 0 },
		103, 121, 104, 114,
		8, 10, 6, 20,
	},
	{
		GOURAUD,
		4,
		131, 132, 152, 151,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		3,
		69, 78, 153, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		3,
		90, 92, 202, 0,
		{ 205, 110, 67, 0 },
		15, 5, 5, 0,
		180, 180, 142, 0,
	},
	{
		TEXTURED,
		3,
		112, 110, 203, 0,
		{ 205, 110, 67, 0 },
		120, 122, 110, 0,
		179, 144, 145, 0,
	},
	{
		GOURAUD,
		4,
		133, 131, 151, 149,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		157, 154, 180, 173,
		{ 205, 110, 67, 0 },
		80, 106, 117, 101,
		78, 73, 53, 56,
	},
	{
		GOURAUD,
		4,
		137, 135, 145, 146,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		GOURAUD,
		4,
		134, 133, 149, 150,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		154, 162, 200, 180,
		{ 205, 110, 67, 0 },
		106, 125, 126, 117,
		73, 69, 53, 53,
	},
	{
		TEXTURED,
		3,
		113, 115, 116, 0,
		{ 205, 110, 67, 0 },
		15, 15, 6, 0,
		107, 136, 103, 0,
	},
	{
		TEXTURED,
		3,
		95, 93, 94, 0,
		{ 205, 110, 67, 0 },
		127, 118, 116, 0,
		185, 185, 121, 0,
	},
	{
		GOURAUD,
		4,
		138, 137, 146, 148,
		{ 226, 221, 223, 0 },
		0, 0, 0, 0,
		255, 255, 255, 255,
	},
	{
		TEXTURED,
		4,
		161, 154, 157, 160,
		{ 205, 110, 67, 0 },
		116, 106, 80, 85,
		88, 73, 78, 88,
	},
	{
		TEXTURED,
		3,
		61, 60, 158, 0,
		{ 205, 110, 67, 0 },
		43, 15, 12, 0,
		90, 104, 91, 0,
	},
	{
		TEXTURED,
		3,
		50, 56, 160, 0,
		{ 205, 110, 67, 0 },
		108, 125, 106, 0,
		104, 103, 93, 0,
	},
	{
		TEXTURED,
		3,
		160, 56, 57, 0,
		{ 205, 110, 67, 0 },
		81, 113, 116, 0,
		91, 105, 92, 0,
	},
	{
		TEXTURED,
		4,
		158, 160, 157, 156,
		{ 205, 110, 67, 0 },
		40, 85, 80, 44,
		87, 87, 78, 78,
	},
	{
		TEXTURED,
		3,
		159, 61, 158, 0,
		{ 205, 110, 67, 0 },
		26, 17, 17, 0,
		94, 100, 94, 0,
	},
	{
		TEXTURED,
		3,
		57, 161, 160, 0,
		{ 205, 110, 67, 0 },
		113, 111, 100, 0,
		105, 93, 95, 0,
	},
	{
		TEXTURED,
		4,
		55, 53, 161, 57,
		{ 205, 110, 67, 0 },
		23, 44, 47, 23,
		95, 112, 90, 90,
	},
	{
		TEXTURED,
		4,
		52, 59, 61, 159,
		{ 205, 110, 67, 0 },
		83, 102, 103, 79,
		112, 95, 90, 90,
	},
	{
		TEXTURED,
		3,
		53, 163, 161, 0,
		{ 205, 110, 67, 0 },
		38, 47, 62, 0,
		106, 105, 90, 0,
	},
	{
		TEXTURED,
		3,
		163, 52, 159, 0,
		{ 205, 110, 67, 0 },
		84, 78, 79, 0,
		101, 98, 104, 0,
	},
	{
		TEXTURED,
		3,
		53, 52, 163, 0,
		{ 205, 110, 67, 0 },
		62, 47, 78, 0,
		90, 105, 105, 0,
	},
	{
		TEXTURED,
		4,
		164, 192, 185, 183,
		{ 205, 110, 67, 0 },
		64, 43, 46, 64,
		31, 31, 8, 6,
	},
	{
		TEXTURED,
		3,
		174, 171, 190, 0,
		{ 205, 110, 67, 0 },
		25, 52, 45, 0,
		57, 61, 48, 0,
	},
	{
		TEXTURED,
		3,
		199, 168, 170, 0,
		{ 205, 110, 67, 0 },
		63, 69, 64, 0,
		51, 53, 41, 0,
	},
	{
		TEXTURED,
		3,
		193, 195, 189, 0,
		{ 205, 110, 67, 0 },
		88, 88, 72, 0,
		7, 1, 2, 0,
	},
	{
		TEXTURED,
		4,
		194, 196, 195, 193,
		{ 205, 110, 67, 0 },
		96, 102, 88, 88,
		2, 4, 7, 1,
	},
	{
		TEXTURED,
		4,
		173, 180, 178, 167,
		{ 205, 110, 67, 0 },
		101, 117, 123, 99,
		56, 53, 30, 32,
	},
	{
		TEXTURED,
		4,
		166, 184, 187, 177,
		{ 205, 110, 67, 0 },
		27, 23, 6, 6,
		32, 9, 10, 31,
	},
	{
		TEXTURED,
		3,
		172, 173, 191, 0,
		{ 205, 110, 67, 0 },
		75, 101, 82, 0,
		61, 56, 48, 0,
	},
	{
		TEXTURED,
		4,
		188, 184, 183, 185,
		{ 205, 110, 67, 0 },
		54, 65, 48, 45,
		2, 7, 6, 3,
	},
	{
		TEXTURED,
		4,
		174, 166, 177, 179,
		{ 205, 110, 67, 0 },
		25, 27, 6, 5,
		57, 32, 31, 53,
	},
	{
		TEXTURED,
		4,
		185, 181, 182, 188,
		{ 205, 110, 67, 0 },
		45, 48, 65, 54,
		3, 6, 7, 2,
	},
	{
		TEXTURED,
		3,
		175, 176, 198, 0,
		{ 205, 110, 67, 0 },
		44, 80, 63, 0,
		78, 78, 77, 0,
	},
	{
		TEXTURED,
		4,
		167, 182, 181, 165,
		{ 205, 110, 67, 0 },
		99, 100, 83, 84,
		32, 9, 8, 30,
	},
	{
		TEXTURED,
		4,
		201, 196, 194, 200,
		{ 205, 110, 67, 0 },
		97, 96, 102, 114,
		5, 2, 4, 5,
	},
	{
		TEXTURED,
		3,
		169, 199, 170, 0,
		{ 205, 110, 67, 0 },
		58, 63, 64, 0,
		53, 51, 41, 0,
	},
	{
		TEXTURED,
		4,
		198, 172, 168, 197,
		{ 205, 110, 67, 0 },
		63, 75, 69, 63,
		77, 61, 53, 53,
	},
	{
		TEXTURED,
		4,
		192, 165, 181, 185,
		{ 205, 110, 67, 0 },
		64, 84, 83, 64,
		31, 30, 8, 6,
	},
	{
		TEXTURED,
		4,
		198, 197, 169, 171,
		{ 205, 110, 67, 0 },
		63, 63, 58, 52,
		77, 53, 53, 61,
	},
	{
		TEXTURED,
		3,
		193, 189, 186, 0,
		{ 205, 110, 67, 0 },
		88, 72, 76, 0,
		7, 2, 8, 0,
	},
	{
		TEXTURED,
		3,
		195, 187, 189, 0,
		{ 205, 110, 67, 0 },
		88, 76, 72, 0,
		7, 8, 2, 0,
	},
	{
		TEXTURED,
		4,
		168, 172, 191, 170,
		{ 205, 110, 67, 0 },
		69, 75, 82, 64,
		53, 61, 48, 41,
	},
	{
		TEXTURED,
		4,
		175, 198, 171, 174,
		{ 205, 110, 67, 0 },
		44, 63, 52, 25,
		78, 77, 61, 57,
	},
	{
		TEXTURED,
		4,
		198, 176, 173, 172,
		{ 205, 110, 67, 0 },
		63, 80, 101, 75,
		77, 78, 56, 61,
	},
	{
		TEXTURED,
		4,
		170, 191, 165, 192,
		{ 205, 110, 67, 0 },
		64, 82, 84, 64,
		41, 48, 30, 31,
	},
	{
		TEXTURED,
		4,
		177, 187, 195, 196,
		{ 205, 110, 67, 0 },
		1, 2, 6, 6,
		31, 10, 10, 31,
	},
	{
		TEXTURED,
		4,
		192, 164, 190, 170,
		{ 205, 110, 67, 0 },
		64, 43, 45, 64,
		31, 31, 48, 41,
	},
	{
		TEXTURED,
		4,
		189, 188, 182, 186,
		{ 205, 110, 67, 0 },
		72, 54, 65, 76,
		2, 2, 7, 8,
	},
	{
		TEXTURED,
		4,
		191, 173, 167, 165,
		{ 205, 110, 67, 0 },
		82, 101, 99, 84,
		48, 56, 32, 30,
	},
	{
		TEXTURED,
		4,
		180, 200, 194, 178,
		{ 205, 110, 67, 0 },
		117, 126, 130, 123,
		53, 53, 31, 30,
	},
	{
		TEXTURED,
		4,
		186, 178, 194, 193,
		{ 205, 110, 67, 0 },
		121, 123, 130, 128,
		11, 30, 31, 11,
	},
	{
		TEXTURED,
		4,
		167, 178, 186, 182,
		{ 205, 110, 67, 0 },
		99, 123, 121, 100,
		32, 30, 11, 9,
	},
	{
		TEXTURED,
		4,
		169, 197, 168, 199,
		{ 205, 110, 67, 0 },
		69, 63, 58, 63,
		53, 51, 53, 53,
	},
	{
		TEXTURED,
		4,
		166, 164, 183, 184,
		{ 205, 110, 67, 0 },
		43, 27, 23, 46,
		31, 32, 9, 8,
	},
	{
		TEXTURED,
		4,
		201, 179, 177, 196,
		{ 205, 110, 67, 0 },
		5, 0, 1, 6,
		53, 54, 31, 31,
	},
	{
		TEXTURED,
		4,
		189, 187, 184, 188,
		{ 205, 110, 67, 0 },
		72, 76, 65, 54,
		2, 8, 7, 2,
	},
	{
		TEXTURED,
		4,
		174, 190, 164, 166,
		{ 205, 110, 67, 0 },
		25, 45, 43, 27,
		57, 48, 31, 32,
	},
	{
		TEXTURED,
		4,
		171, 169, 170, 190,
		{ 205, 110, 67, 0 },
		52, 58, 64, 45,
		61, 53, 41, 48,
	},
	{
		TEXTURED,
		3,
		200, 162, 201, 0,
		{ 205, 110, 67, 0 },
		8, 2, 4, 0,
		59, 58, 69, 0,
	},
	{
		TEXTURED,
		4,
		162, 155, 179, 201,
		{ 205, 110, 67, 0 },
		0, 15, 5, 0,
		73, 72, 53, 54,
	},
	{
		TEXTURED,
		4,
		155, 156, 174, 179,
		{ 205, 110, 67, 0 },
		15, 44, 25, 5,
		72, 78, 57, 53,
	},
	{
		GOURAUD,
		3,
		69, 153, 72, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		153, 70, 71, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		72, 153, 71, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		3,
		94, 96, 95, 0,
		{ 205, 110, 67, 0 },
		107, 110, 105, 0,
		92, 103, 100, 0,
	},
	{
		TEXTURED,
		3,
		94, 93, 91, 0,
		{ 205, 110, 67, 0 },
		87, 99, 96, 0,
		91, 92, 100, 0,
	},
	{
		TEXTURED,
		3,
		114, 112, 111, 0,
		{ 205, 110, 67, 0 },
		31, 19, 24, 0,
		94, 94, 104, 0,
	},
	{
		TEXTURED,
		3,
		88, 87, 95, 0,
		{ 205, 110, 67, 0 },
		2, 15, 5, 0,
		92, 94, 103, 0,
	},
	{
		TEXTURED,
		3,
		88, 90, 89, 0,
		{ 205, 110, 67, 0 },
		116, 113, 112, 0,
		137, 126, 108, 0,
	},
	{
		GOURAUD,
		3,
		47, 5, 4, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		41, 42, 1, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		49, 46, 4, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		43, 3, 1, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		47, 48, 7, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		41, 0, 2, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		43, 44, 2, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		GOURAUD,
		3,
		49, 6, 7, 0,
		{ 0, 37, 18, 0 },
		0, 0, 0, 0,
		255, 255, 255, 0,
	},
	{
		TEXTURED,
		3,
		109, 111, 203, 0,
		{ 205, 110, 67, 0 },
		10, 4, 6, 0,
		94, 93, 103, 0,
	},
	{
		TEXTURED,
		3,
		116, 115, 107, 0,
		{ 205, 110, 67, 0 },
		3, 11, 5, 0,
		167, 169, 176, 0,
	},
	{
		TEXTURED,
		3,
		91, 89, 202, 0,
		{ 205, 110, 67, 0 },
		96, 110, 107, 0,
		93, 94, 108, 0,
	},
	{
		TEXTURED,
		3,
		56, 50, 76, 0,
		{ 205, 110, 67, 0 },
		5, 16, 5, 0,
		136, 139, 148, 0,
	},
	{
		TEXTURED,
		3,
		76, 50, 60, 0,
		{ 205, 110, 67, 0 },
		9, 17, 9, 0,
		117, 125, 132, 0,
	},
	{
		TEXTURED,
		3,
		116, 114, 113, 0,
		{ 205, 110, 67, 0 },
		15, 16, 6, 0,
		145, 167, 163, 0,
	},
	{
		TEXTURED,
		3,
		110, 108, 107, 0,
		{ 205, 110, 67, 0 },
		124, 123, 114, 0,
		174, 179, 177, 0,
	},
	{
		TEXTURED,
		3,
		114, 116, 110, 0,
		{ 205, 110, 67, 0 },
		14, 5, 10, 0,
		152, 162, 177, 0,
	},
	{
		TEXTURED,
		3,
		94, 92, 90, 0,
		{ 205, 110, 67, 0 },
		116, 122, 109, 0,
		161, 171, 176, 0,
	},
	{
		TEXTURED,
		3,
		202, 92, 91, 0,
		{ 205, 110, 67, 0 },
		112, 116, 112, 0,
		114, 122, 133, 0,
	},
	{
		TEXTURED,
		3,
		202, 89, 90, 0,
		{ 205, 110, 67, 0 },
		123, 119, 112, 0,
		163, 147, 163, 0,
	},
	{
		TEXTURED,
		3,
		203, 111, 112, 0,
		{ 205, 110, 67, 0 },
		26, 15, 20, 0,
		95, 94, 104, 0,
	},
	{
		TEXTURED,
		3,
		203, 110, 109, 0,
		{ 205, 110, 67, 0 },
		9, 5, 5, 0,
		120, 139, 145, 0,
	},
	{
		TEXTURED,
		4,
		23, 22, 29, 28,
		{ 205, 110, 67, 0 },
		5, 6, 16, 15,
		168, 158, 158, 169,
	},
	{
		TEXTURED,
		4,
		28, 29, 25, 24,
		{ 205, 110, 67, 0 },
		9, 16, 11, 4,
		133, 140, 149, 141,
	},
	{
		TEXTURED,
		4,
		210, 206, 207, 211,
		{ 255, 255, 255, 0 },
		52, 53, 5, 5,
		35, 1, 1, 36,
	},
	{
		TEXTURED,
		4,
		208, 204, 205, 209,
		{ 255, 255, 255, 0 },
		5, 5, 53, 53,
		217, 253, 253, 217,
	},
	{
		TEXTURED,
		4,
		214, 208, 209, 215,
		{ 255, 255, 255, 0 },
		5, 5, 53, 54,
		185, 217, 217, 185,
	},
	{
		TEXTURED,
		4,
		216, 210, 211, 217,
		{ 255, 255, 255, 0 },
		52, 52, 5, 5,
		69, 35, 36, 69,
	},
	{
		TEXTURED,
		4,
		219, 213, 212, 218,
		{ 255, 255, 255, 0 },
		5, 5, 53, 53,
		97, 157, 156, 97,
	},
	{
		TEXTURED,
		4,
		218, 216, 217, 219,
		{ 255, 255, 255, 0 },
		53, 52, 5, 5,
		97, 69, 69, 97,
	},
	{
		TEXTURED,
		4,
		215, 212, 213, 214,
		{ 255, 255, 255, 0 },
		54, 53, 5, 5,
		185, 156, 157, 185,
	},
	{
		TEXTURED,
		4,
		211, 207, 206, 210,
		{ 255, 255, 255, 0 },
		52, 53, 5, 5,
		35, 1, 1, 36,
	},
	{
		TEXTURED,
		4,
		209, 205, 204, 208,
		{ 255, 255, 255, 0 },
		5, 5, 53, 53,
		217, 253, 253, 217,
	},
	{
		TEXTURED,
		4,
		215, 209, 208, 214,
		{ 255, 255, 255, 0 },
		5, 5, 53, 54,
		185, 217, 217, 185,
	},
	{
		TEXTURED,
		4,
		217, 211, 210, 216,
		{ 255, 255, 255, 0 },
		52, 52, 5, 5,
		69, 35, 36, 69,
	},
	{
		TEXTURED,
		5,
		218, 212, 213, 219,
		{ 255, 255, 255, 0 },
		5, 5, 53, 53,
		97, 157, 156, 97,
	},
	{
		TEXTURED,
		4,
		219, 217, 216, 218,
		{ 255, 255, 255, 0 },
		53, 52, 5, 5,
		97, 69, 69, 97,
	},
	{
		TEXTURED,
		4,
		214, 213, 212, 215,
		{ 255, 255, 255, 0 },
		54, 53, 5, 5,
		185, 156, 157, 185,
	},
};
