#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
#include <LibCD.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>

#include "ourtypes.h"
#include "mathbits.h"

#include "skeleton.h"


node yt_rfoot =
{
	JOINT,
	CHFL( 39.916000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_rfoot,	// vertex attachment
	&Verts_yt_rfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node yt_lrleg =
{
	JOINT,
	CHFL( 34.372002 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_lrleg,	// vertex attachment
	&Verts_yt_lrleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_rfoot,	// Joint
};

node yt_urleg =
{
	JOINT,
	CHFL( 12.832001 ), CHFL( 1.448000 ), CHFL( -8.584000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_urleg,	// vertex attachment
	&Verts_yt_urleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_lrleg,	// Joint
};

node yt_lfoot =
{
	JOINT,
	CHFL( 39.916000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_lfoot,	// vertex attachment
	&Verts_yt_lfoot_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node yt_llleg =
{
	JOINT,
	CHFL( 34.372002 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_llleg,	// vertex attachment
	&Verts_yt_llleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_lfoot,	// Joint
};

node yt_ulleg =
{
	JOINT,
	CHFL( 12.832001 ), CHFL( 1.448000 ), CHFL( 8.868000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_ulleg,	// vertex attachment
	&Verts_yt_ulleg_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_llleg,	// Joint
};

node yt_peni =
{
	JOINT,
	CHFL( 14.400001 ), CHFL( 0.224000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_peni,	// vertex attachment
	&Verts_yt_peni_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node yt_head =
{
	JOINT,
	CHFL( 4.092000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_head,	// vertex attachment
	&Verts_yt_head_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node jnt184_1_1_2 =
{
	JOINT,
	CHFL( 30.931999 ), CHFL( 0.032000 ), CHFL( 0.096000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_jnt184_1_1_2,	// vertex attachment
	&Verts_jnt184_1_1_2_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_head,	// Joint
};

node yt_lhand =
{
	JOINT,
	CHFL( 21.556000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_lhand,	// vertex attachment
	&Verts_yt_lhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node yt_llarm =
{
	JOINT,
	CHFL( 23.944000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_llarm,	// vertex attachment
	&Verts_yt_llarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_lhand,	// Joint
};

node yt_ularm =
{
	JOINT,
	CHFL( 22.368000 ), CHFL( 9.972000 ), CHFL( 17.104000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_ularm,	// vertex attachment
	&Verts_yt_ularm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_llarm,	// Joint
};

node yt_rhand =
{
	JOINT,
	CHFL( 21.556000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_rhand,	// vertex attachment
	&Verts_yt_rhand_Lo,	// vertex attachment
	0,	// NumberOfChildren
};

node yt_lrarm =
{
	JOINT,
	CHFL( 23.944000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_lrarm,	// vertex attachment
	&Verts_yt_lrarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_rhand,	// Joint
};

node yt_urarm =
{
	JOINT,
	CHFL( 22.459999 ), CHFL( -9.268000 ), CHFL( -17.667999 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_urarm,	// vertex attachment
	&Verts_yt_urarm_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_lrarm,	// Joint
};

node yt_chest =
{
	JOINT,
	CHFL( 24.988001 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_chest,	// vertex attachment
	&Verts_yt_chest_Lo,	// vertex attachment
	3,	// NumberOfChildren
	&yt_urarm,	// Joint
	&yt_ularm,	// Joint
	&jnt184_1_1_2,	// Joint
};

node yt_tum =
{
	JOINT,
	CHFL( 13.984000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_yt_tum,	// vertex attachment
	&Verts_yt_tum_Lo,	// vertex attachment
	1,	// NumberOfChildren
	&yt_chest,	// Joint
};

node jnt185_1 =
{
	JOINT,
	CHFL( 0.008000 ), CHFL( 0.896000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	&Verts_jnt185_1,	// vertex attachment
	&Verts_jnt185_1_Lo,	// vertex attachment
	4,	// NumberOfChildren
	&yt_tum,	// Joint
	&yt_peni,	// Joint
	&yt_ulleg,	// Joint
	&yt_urleg,	// Joint
};

node yt_virgin =
{
	CHAIN_ROOT,
	CHFL( 0.000000 ), CHFL( 0.000000 ), CHFL( 0.000000 ),	// Tx, Ty, Tz
	CHANG( 0.000000 ), CHANG( 0.000000 ), CHANG( 0.000000 ),	// Rx, Ry, Rz
	0, 0, 0,	// Dynamic field
	NULL,	// No verts attached (Chain Root or Effector)
	NULL,	// No verts attached (Chain Root or Effector)
	1,	// NumberOfChildren
	&jnt185_1,	// Chain Root
};

