/* mathbits.h */

#ifndef _MATHBITS_H_
#define _MATHBITS_H_


typedef struct vec3
{
	chfloat X, Y, Z;
}vec3;

typedef struct vec2
{
	chfloat X, Y;
}vec2;

typedef struct chfloat
{
	chfloat E[ 4 ][ 3 ];
}chmatrix;


void SetVector3(vec3 *vector,int16 x,int16 y,int16 z);
void Matrix_Init( chmatrix *A );
void Matrix_x_Matrix( chmatrix *A, chmatrix *B, chmatrix *D );
void Vec3_x_Matrix( vec3 *A, chmatrix *B, vec3 *D );

void Matrix_MakeRotX( chmatrix *A, chfloat Deg );
void Matrix_MakeRotY( chmatrix *A, chfloat Deg );
void Matrix_MakeRotZ( chmatrix *A, chfloat Deg );

void Matrix_MakeXYZTransl( chmatrix *A, chfloat X, chfloat Y, chfloat Z );

chfloat Dot( vec3 *A, vec3 *B );
void Cross( vec3 *A, vec3 *B, vec3 *D );
void Normalize( vec3 *D );
chfloat Magnitude( vec3 *A );

#endif
