/* pads.h */

#ifndef _PADS_H_
#define _PADS_H_

/* All PAD_ #define's are Chill mandatory */

#define	PAD_UP		PADLup
#define	PAD_DOWN	PADLdown
#define PAD_LEFT	PADLleft
#define	PAD_RIGHT	PADLright

#define	PAD_B1		PADRleft
#define	PAD_B2		PADRdown
#define	PAD_B3		PADRright
#define	PAD_B4		PADRup	/* See note 1 */

#define PAD_STOP	PADselect
#define PAD_START	PADstart

#define	PAD_TOPLEFT		PADL1
#define	PAD_TOPRIGHT	PADR1

#define	PAD_BOTTOMLEFT	PADL2			/* See note 1 */
#define	PAD_BOTTOMRIGHT	PADR2			/* See note 1 */


/* M2 Specific routines */

//void InitialiseM2Pads( void );
//void KillM2Pads( void );
//void Pad_Update( void );


/* Chill mandatory routines */

void 	Pad_Update( void );
/* Return current state of pad ( 0 is the first pad )*/
uint32	Pad_State( uint8 PadNumber );
/* Return current debounced state of pad */
uint32	Pad_Debounced( uint8 PadNumber );

#endif


/*
Note 1	:	These pad buttons will not appear on the M2 version
					and have been put in just for compatability with
					the other versions during development.
*/


