/* players.h */

#ifndef _PLAYERS_H_
#define _PLAYERS_H_

#include "ourtypes.h"
#include "mathbits.h"
#include "camera.h"

/* ConsoleRemoteGhost field possibilities */

#define CONSOLE_PLAYER 0
#define REMOTE_PLAYER 1
#define GHOSTED_PLAYER 2

/* Transport field possibilities */

#define	TESTCAM		0
#define	SNOWBOARD	1
#define	SKIS			2
#define	BIGFEET		3
#define	MOOSE			4
#define SLIDEY		5
#define PARACHUTE 128

typedef struct player
{
	char		Name[ 8 ];
	uint8		ColourScheme;

	uint8		Transport;
	uint8		PlayerNumber;

	vec3		Pos;
	vec3		Rot;

	vec3		Inert;
	vec3		Vel;

	uint8		ConsoleRemoteGhosted;
	uint8		PadNumber;
	camera		Cam;

	uint32		Credibility;
	uint8		Lives, Score, Etc;
	uint16		NoTaggedPolys;
	uint16		TaggedPolys[500];
}	player;



extern uint8	NumberOfPlayers;	/* Total number of players */
extern uint8	ConsolePlayers;		/* This is the number of split screens you should have */
extern uint8	RemotePlayers;
extern uint8	GameMode;
extern player Player[ 8 ];

void InitialisePlayers( void );
void KillPlayers( void );

#endif



