/* camera.c */

/* Machine dependant - you may not be using the chill Matrix routines for your version */

#include <stdio.h>

#include "ourtypes.h"
#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "main.h"
#include "mathbits.h"
#include "pads.h"
#include "camlogic.h"
#include "players.h"
#include "camera.h"


void InitialiseCameras( void )
{
	printf("Executing : InitialiseCameras()\n");
}

void KillCameras( void )
{
	printf("Executing : KillCameras()\n");
}


void CameraLogic( uint8 PlayerNumber )
{
	player *Plyr = &Player[ PlayerNumber ];
	static int32 DotP;
	static VECTOR X,Y,Z,T;


	/* Call the appropriate camera movement code */
	switch( Plyr->Cam.Mode )
	{
		case CAMERA_TEST_TARGET:
			Camera_Test_Target( PlayerNumber );
			break;

		case CAMERA_TEST_POSITIONAL:
			Camera_Test_Positional( PlayerNumber );
			break;

		/* Some example types of modes */
		case CAMERA_FOLLOW:
			Camera_Follow( PlayerNumber );
			break;

		case CAMERA_ACTION:
			/* Camera_Action( PlayerNumber ); */
			break;
	}


	switch( Plyr->Cam.Type )
	{
		case CAMERA_TYPE_TARGET:
			{

//				PSX_Matrix_Init (&Plyr->Cam.ViewMatrix);
//				PSX_Matrix_Init (&Tm);
//				PSX_Matrix_Init (&Rm);

				Z.vx = (Plyr->Cam.Targ.X - Plyr->Cam.Pos.X)>>12;
				Z.vy = (Plyr->Cam.Targ.Y - Plyr->Cam.Pos.Y)>>12;
				Z.vz = (Plyr->Cam.Targ.Z - Plyr->Cam.Pos.Z)>>12;
				VectorNormal( &Z, &T );
				Z.vx=T.vx;
				Z.vy=T.vy;
				Z.vz=T.vz;

				DotP = PSX_Dot( &Plyr->Cam.Up, &Z )>>12;

				Y.vx = Plyr->Cam.Up.X - ( (DotP * Z.vx)>>12 );
				Y.vy = Plyr->Cam.Up.Y - ( (DotP * Z.vy)>>12 );
				Y.vz = Plyr->Cam.Up.Z - ( (DotP * Z.vz)>>12 );
				VectorNormal( &Y, &T );
				T.vx=T.vx;
				T.vy=T.vy;
				T.vz=T.vz;

				OuterProduct0(&Z, &T, &X);

				Plyr->Cam.ViewMatrix.m[ 0 ][ 0 ]=X.vx>>12;
				Plyr->Cam.ViewMatrix.m[ 0 ][ 1 ]=X.vy>>12;
				Plyr->Cam.ViewMatrix.m[ 0 ][ 2 ]=X.vz>>12;
				Plyr->Cam.ViewMatrix.m[ 1 ][ 0 ]=-Y.vx;
				Plyr->Cam.ViewMatrix.m[ 1 ][ 1 ]=-Y.vy;
				Plyr->Cam.ViewMatrix.m[ 1 ][ 2 ]=-Y.vz;
				Plyr->Cam.ViewMatrix.m[ 2 ][ 0 ]=Z.vx;
				Plyr->Cam.ViewMatrix.m[ 2 ][ 1 ]=Z.vy;
				Plyr->Cam.ViewMatrix.m[ 2 ][ 2 ]=Z.vz;

				RotMatrixZ(-0x400,&(Plyr->Cam.ViewMatrix));

/*
 				static chmatrix Tm, Rm;
				static chfloat DotP;
				static vec3 X, Y, Z;

				Matrix_Init( &Plyr->Cam.ViewMatrix );
				Matrix_Init( &Tm );
				Matrix_Init( &Rm );

				Z.X = Plyr->Cam.Targ.X - Plyr->Cam.Pos.X;
				Z.Y = Plyr->Cam.Targ.Y - Plyr->Cam.Pos.Y;
				Z.Z = Plyr->Cam.Targ.Z - Plyr->Cam.Pos.Z;
				Normalize( &Z );

				DotP = Dot( &Plyr->Cam.Up, &Z );
				Y.X = Plyr->Cam.Up.X - ( DotP * Z.X );
				Y.Y = Plyr->Cam.Up.Y - ( DotP * Z.Y );
				Y.Z = Plyr->Cam.Up.Z - ( DotP * Z.Z );
				Normalize( &Y );

				Cross( &Z, &Y, &X );

				Rm.E[ 0 ][ 0 ] = X.X;
				Rm.E[ 0 ][ 1 ] = X.Y;
				Rm.E[ 0 ][ 2 ] = X.Z;
				Rm.E[ 1 ][ 0 ] = Y.X;
				Rm.E[ 1 ][ 1 ] = Y.Y;
				Rm.E[ 1 ][ 2 ] = Y.Z;
				Rm.E[ 2 ][ 0 ] = Z.X;
				Rm.E[ 2 ][ 1 ] = Z.Y;
				Rm.E[ 2 ][ 2 ] = Z.Z;

				Matrix_MakeXYZTransl( &Tm, -Plyr->Cam.Pos.X, -Plyr->Cam.Pos.Y, -Plyr->Cam.Pos.Z );
				Matrix_x_Matrix( &Tm, &Rm, &Plyr->Cam.ViewMatrix );
				*/
			}
			break;

		case CAMERA_FOLLOW:
		case CAMERA_TYPE_POSITIONAL:
			{
/*				static chmatrix Mat1, Mat2, XMat, YMat, ZMat;

				Matrix_Init( &Plyr->Cam.ViewMatrix );
				Matrix_Init( &XMat );
				Matrix_Init( &YMat );
				Matrix_Init( &ZMat );

				Matrix_MakeXYZTransl( &Plyr->Cam.ViewMatrix, -Plyr->Cam.Pos.X, -Plyr->Cam.Pos.Y, -Plyr->Cam.Pos.Z );

				Matrix_MakeRotX( &XMat, -Plyr->Cam.Rot.X );
				Matrix_MakeRotY( &YMat, -Plyr->Cam.Rot.Y );
				Matrix_MakeRotZ( &ZMat, -Plyr->Cam.Rot.Z );

				Matrix_x_Matrix( &Plyr->Cam.ViewMatrix, &YMat, &Mat1 );
				Matrix_x_Matrix( &Mat1, &XMat, &Mat2 );
				Matrix_x_Matrix( &Mat2, &ZMat, &Plyr->Cam.ViewMatrix );  */
				RotationVector[rotid].vx=Plyr->Cam.Rot.Y>>12;
				RotationVector[rotid].vy=(Plyr->Cam.Rot.X>>12)+2048;
				RotationVector[rotid].vz=(Plyr->Cam.Rot.Z>>12)+3072;
				RotMatrix(&RotationVector[rotid],&(Plyr->Cam.ViewMatrix));


			}
			break;
	}
}


