/* logic.c */
#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
#include "main.h"
#include "mathbits.h"
#include "camera.h"
#include "pads.h"
#include "players.h"
#include "logic.h"

//#include "m2debug.h"

#include "sine.h"

void BoardModel( uint8 PlayerNumber )
{
	player *Plyr = &Player[ PlayerNumber ];

	switch( Plyr->Transport )
	{
		case TESTCAM:
			/* TESTCAM mode has no actual logic to move the board */
			break;


		case SLIDEY:
			Slidey( Plyr->PlayerNumber );
			break;

	}
}

void Slidey( uint8 PlayerNumber )
{
	player *Plyr = &Player[ PlayerNumber ];
	uint32	Pad = Pad_State( Plyr->PadNumber );


	if( ( Pad & ( PAD_LEFT + PAD_RIGHT ) ) == 0 )
	{
		Plyr->Vel.Y = 0.0;
	}
	else
	{
		if( Pad & PAD_RIGHT )
		{
			if( Plyr->Vel.Y < 0.0 ) Plyr->Vel.Y = 0.0;
			Plyr->Vel.Y+=4096/720;
		}

		if( Pad & PAD_LEFT )
		{
			if( Plyr->Vel.Y > 0.0 ) Plyr->Vel.Y = 0.0;
			Plyr->Vel.Y-=4096/720;
		}
	}



	if( Pad & PAD_B1 )	/* Accelerate */
	{
		Plyr->Vel.Z+=4.0;
	}

	if( Pad & PAD_B2 && Plyr->Vel.Z > 0.0 )	/* Decelerate */
	{
		Plyr->Vel.Z-=6.0;
		if( Plyr->Vel.Z < 0.0 )
			Plyr->Vel.Z = 0.0;
	}



	if( Pad_State( 0 ) == PAD_UP + PAD_B3 )
	{
		Plyr->Rot.X -= ( 4096 / 60 );
	}

	if( Pad_State( 0 ) == PAD_DOWN + PAD_B3 )
	{
		Plyr->Rot.X += ( 4096 / 60 );
	}





	Plyr->Rot.Y += Plyr->Vel.Y;

	{
		char String[ 30 ];
		chfloat Vx, Vz;

		Vx = ( ( Plyr->Vel.X * Cosine( Plyr->Rot.Y ) ) - ( Plyr->Vel.Z * Sine( Plyr->Rot.Y ) ) );
		Vz = ( ( Plyr->Vel.Z * Cosine( Plyr->Rot.Y ) ) + ( Plyr->Vel.X * Sine( Plyr->Rot.Y ) ) );

/*		sprintf( String, "Vx%f", -Vx );
		SetDebugTextString( 2, &String[ 0 ] );
		sprintf( String, "Vz%f", Vz );
		SetDebugTextString( 3, &String[ 0 ] );
*/
/*		sprintf( String, "BT = %ld", BT );
		SetDebugTextString( 3, &String[ 0 ] );
		sprintf( String, "BB = %ld", BB );
		SetDebugTextString( 4, &String[ 0 ] );
*/
	/* Do the funkey velocity */
	Plyr->Pos.X += -Vx;
	Plyr->Pos.Z += Vz;


/*	Plyr->Pos.Z += Plyr->Vel.Z;*/
	}

	Plyr->Pos.Y = 0;/*GetPlayersY( 0 );*/

	/* Temporary place to put first person camera view mode */
	Plyr->Cam.Pos.X = Plyr->Pos.X;
	Plyr->Cam.Pos.Y = Plyr->Pos.Y + 64.0;
	Plyr->Cam.Pos.Z = Plyr->Pos.Z;

	Plyr->Cam.Rot.X = Plyr->Rot.X;
	Plyr->Cam.Rot.Y = Plyr->Rot.Y;
	Plyr->Cam.Rot.Z = Plyr->Rot.Z;

//	SetDebugTextDecimal( 0, Player->Cam.Rot.Y );
}



