/* players.c */

#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
#include "mathbits.h"
#include "main.h"
#include "camera.h"
#include "players.h"


uint8	NumberOfPlayers;	/* Total number of players */
uint8	ConsolePlayers;		/* This is the number of split screens you should have */
uint8	RemotePlayers;
uint8	GameMode;
player Player[ 8 ];


void KillPlayers( void )
{
	printf("Executing : KillPlayers()\n");
}

void InitialisePlayers(void)
{
	uint8	i;
	uint8	Count1,Count2,Count3;

	printf("Executing : InitialisePlayers()\n");

	NumberOfPlayers = 1;
	ConsolePlayers = 1;
	RemotePlayers = 0;

	for (i=0;i<8;i++)
	{
		/* name */
		/* colour scheme */
		sprintf( Player[ i ].Name,"Player%d", i + 1 );
		Player[ i ].PlayerNumber = i;

		Player[ i ].Transport=TESTCAM;

		Player[ i ].ConsoleRemoteGhosted=CONSOLE_PLAYER;
		Player[ i ].PadNumber=i%2;
		Player[ i ].Cam.Mode = CAMERA_TEST_POSITIONAL;

		SetVector3(&Player[ i ].Cam.Pos,150,-71,-140 );           /*  192,-47,-225*/
		SetVector3(&Player[ i ].Cam.Targ,870,-550,-2100);         /*  217,-137,-525*/
		SetVector3(&Player[ i ].Cam.Up,0,1,0);
		SetVector3(&Player[ i ].Cam.Rot,0,2048,0);
		SetVector3(&Player[ i ].Rot,0,0,0);
		SetVector3(&Player[ i ].Vel,0,0,0);
		for (Count1=0;Count1<3;Count1++)
		{
			for (Count2=0;Count2<3;Count2++)
			{
				if (Count1==Count2)
				{
					Player[ i ].Cam.ViewMatrix.m[Count1][Count2]=0x1000;
				}
				else
				{
					Player[ i ].Cam.ViewMatrix.m[Count1][Count2]=0;
				}
			}
			Player[ i ].Cam.ViewMatrix.t[Count1]=0;
		}

		/* credibility */
	}

}




