#ifndef	MOVIE_H
#define	MOVIE_H

#define 	START_FRAME 0
#define 	END_FRAME   201
#define 	POS_X       0
#define 	POS_Y       0
#define 	SCR_WIDTH   320
#define 	SCR_HEIGHT  240
#define		STR_WIDTH	320		/* the dimensions of the input stream */
#define		STR_HEIGHT	240
#define 	PPW 3/2     			/* defines words per pixel ( 1 & 1/2 words per pixel or 3-bytes a pixel */
#define 	DCT_MODE    3   		/* 24bit flag for DCT initialisation */
#define 	RING_SIZE   32      		/* number of cd sectors in the streaming ring buffer */
#define 	VLC_BUFF_SIZE 320/2*240     	/* size of the de-huffman buffers */
#define 	SLICE_IMG_SIZE 16*PPW*SCR_HEIGHT /* size of the DCT strips in shorts */
#define 	SLICE_LONG_IMG_SIZE 12*SCR_HEIGHT /* size of the DCT strips in longs */
#define 	ANIM_PLYR_ADDR 0x80200000


#define 	MOVIE_NAME0	"\\STR\\BLASTXA.STR;1"	/* frames 0 - 124 */
#define 	MOVIE_NAME1	"\\STR\\SPIDERXA.STR;1"	/* frames 0 - 269 */
#define 	MOVIE_NAME2	"\\STR\\INTROXA.STR;1"	/* frames 0 - 474 */
#define 	MOVIE_NAME3	"\\STR\\FUMVXA.STR;1"	/* frames 0 - 676 */

#define		RUSS_WAIT_TIME	0x1

typedef struct {
    unsigned long  *Ring_Buff;	/* ptr to the CD loading circular sector buffer */
    unsigned long  *vlcbuf[2]; /* 2 buffers for decoding the huffman stuff One is decoded to an imgbuf , one is de DCT'd */
    int vlcid;      /*  VLC fR[hobt@ ID */
    unsigned short *imgbuf[2]; /* fR[h摜obt@i_uobt@j*/
    int imgid;      /* ݎgp̉摜obt@ID */
    RECT    rect[2];    /* VRAMWli_uobt@j */
    int rectid;     /* ݓ]̃obt@ ID */
    RECT    slice;      /* P DecDCTout Ŏö */
    int isdone;     /* Pt[̃f[^ł */
} DECENV;

extern	void	InitMoviePlayer();
extern  void	FreeMoviePlayer();

extern	long	PlayMovie(char *name,unsigned long start_frame,unsigned long end_frame);
int				VSync(int mode);


/* this is in tracks.c */
extern incomingtrackbuffer Ib1[2], Ib2[2], *IBuf[2], *LoadBuf[2];


#endif



