#ifndef CABLECAR_H
#define CABLECAR_H


#define MAX_CABLECARS		64
#define MAX_CABLECAR_POLES	16

#define CABLECAR_DISTANCE	(1024<<12)

#define CABLECAR_OBJECT_TYPE 50

typedef struct {
	long		visible;
	long		location;
	trackobject *objectptr;
	VECTOR		position;
	SVECTOR		cable_pos[2];
	//LINE_F2		cable_prims[2][4];
} CABLECAR_POLE;


typedef struct {
	short	direction;
	short	object_type;
	long	location;
} CABLECAR;

typedef struct {
	long			no_cars;
	long			no_poles;
	long			length;
	long			speed;
	short			first_car,last_car;
	CABLECAR		chair[MAX_CABLECARS];
	CABLECAR_POLE	pole[MAX_CABLECAR_POLES];
	long			pole_idx[MAX_CABLECAR_POLES];
	trackobject		bogus_poles[2];
} LIFT;

void	InitCablecars();
void	CheckCablecars(player *P);
void	ClearCablecars(player *P,long buffer,long	fileno);
void	DrawCablecars(player *P,long buffer);

#endif