#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
#include <LibCD.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>
#include <inline_o.h>
#include <gtemac.h>


#include "ourtypes.h"
#include "mathbits.h"

#include "main.h"
#include "skeleton.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "pads.h"

#include "screen.h"
#include "who.h"
#include "bored.h"
#include "animctrl.h"

#include "bonebag.h"
#include "trixbag.h"
#include "logic.h"
#include "plume.h"




long	rand_idx;
long	last_plume;

long	no_player_plumes[2];


PLUME			puffs[2][MAX_PLUMES];
unsigned long 	puffs_ot[8][PLUME_OT_SIZE];		/* ordering table so semitransparencies can happen */
DR_TPAGE		transparencies[8];	/* primitives to turn transparency on/off on sub ot */
long			current_plume[2],last_y_height[2];
SVECTOR			puff_verts[7];

/*************************************************/

void InitPlume()
{
	short	i,j;
	unsigned short trans_tpage,opaque_pad;

	for(i=0;i<MAX_PLUMES;i++)
	{
		puffs[0][i].timer = -1;
		puffs[1][i].timer = -1;
		
		puffs[0][i].inert.vx = puffs[0][i].inert.vy =
			puffs[0][i].inert.vz = puffs[0][i].inert.pad = 0;
		puffs[1][i].inert.vx = puffs[1][i].inert.vy =
			puffs[1][i].inert.vz = puffs[1][i].inert.pad = 0;


		puffs[0][i].SpeedScale.vx = puffs[0][i].SpeedScale.vy = puffs[0][i].SpeedScale.vz = 4096;
		puffs[1][i].SpeedScale.vx = puffs[1][i].SpeedScale.vy = puffs[1][i].SpeedScale.vz = 4096;


	}

	/* clear both buffers */

	ClearOTagR(&(puffs_ot[0][0]),PLUME_OT_SIZE);
	ClearOTagR(&(puffs_ot[1][0]),PLUME_OT_SIZE);
	ClearOTagR(&(puffs_ot[2][0]),PLUME_OT_SIZE);
	ClearOTagR(&(puffs_ot[3][0]),PLUME_OT_SIZE);
	ClearOTagR(&(puffs_ot[4][0]),PLUME_OT_SIZE);
	ClearOTagR(&(puffs_ot[5][0]),PLUME_OT_SIZE);
	ClearOTagR(&(puffs_ot[6][0]),PLUME_OT_SIZE);
	ClearOTagR(&(puffs_ot[7][0]),PLUME_OT_SIZE);
	

	trans_tpage = GetTPage(1,3,0,0);
	SetDrawTPage(&(transparencies[0]),1,1,(int)(trans_tpage));
	SetDrawTPage(&(transparencies[1]),1,1,(int)(trans_tpage));
	SetDrawTPage(&(transparencies[2]),1,1,(int)(trans_tpage));
	SetDrawTPage(&(transparencies[3]),1,1,(int)(trans_tpage));
	SetDrawTPage(&(transparencies[4]),1,1,(int)(trans_tpage));
	SetDrawTPage(&(transparencies[5]),1,1,(int)(trans_tpage));
	SetDrawTPage(&(transparencies[6]),1,1,(int)(trans_tpage));
	SetDrawTPage(&(transparencies[7]),1,1,(int)(trans_tpage));

	puff_verts[0].vx = 0;
	puff_verts[0].vy = 0;
	puff_verts[0].vz = 0;
	puff_verts[1].vx = -20;
	puff_verts[1].vy = 34;
	puff_verts[1].vz = 0;
	puff_verts[2].vx = -40;
	puff_verts[2].vy = 20;
	puff_verts[2].vz = 0;
	puff_verts[3].vx = -20;
	puff_verts[3].vy = -34;
	puff_verts[3].vz = 0;
	puff_verts[4].vx = 20;
	puff_verts[4].vy = -34;
	puff_verts[4].vz = 0;
	puff_verts[5].vx = 40;
	puff_verts[5].vy = 0;
	puff_verts[5].vz = 0;
	puff_verts[6].vx = 20;
	puff_verts[6].vy = 34;
	puff_verts[6].vz = 0;

	rand_idx = 0;
	current_plume[0] = 0;
	current_plume[1] = 0;
	last_y_height[0] = 0;
	last_y_height[1] = 0;

	last_plume = 0;

}
						

/*****************************************************/


//void	AddPlume(unsigned long *ot,long subotid)
//{
//	AddPrims(ot,&(puffs_ot[subotid][PLUME_OT_SIZE -1]),&(puffs_ot[subotid][0]));
//}





/************************************************/


long DrawPlume(unsigned long playerno,POLY_G3 *g3_ptr)
{
	POLY_F4 	*polysptr;
	VECTOR		plume_loc[MAX_PLUMES],plume_dir,new_inert;
	SVECTOR		rtp_pos[7],offset;
	long		address,i,temp,Yrot_angle;
	MATRIX		z_mat,ObjectTrans,SpeedScaleMat,Yturnmat,Xturnmat,arsemat;
	SVECTOR		sclear,ObjRot,plume_offset,plume_inert,arse,local_loc;
	VECTOR		clear,new_puff_pos,orig_puff_pos,trans_vector,new_plume_offset,Varse,offsets[4],inert;
	VECTOR 		ScaleDown = { 1024, 1024, 1024 };
	POLY_G3			*tripolysptr;
	long		ot_z;
	long		longarse,col;
	long		other_playerno;
	long		no_plume_tris = 0;
	
	long		cam_pos,plume_pos,cam_mat,update;
	long		subotid;


	/* backup rotation matrix */
	PushMatrix();

	sclear.vx = sclear.vy = sclear.vz = 0;
	clear.vx = clear.vy = clear.vz = 0;



	RotMatrix(&sclear,&Yturnmat);
	TransMatrix(&Yturnmat,&clear);
	RotMatrix(&sclear,&Xturnmat);
	TransMatrix(&Xturnmat,&clear);
	SetTransMatrix(&Yturnmat);

	/* clear the plumes sub ot */
	//ClearOTagR(&(puffs_ot[subotid][0]),PLUME_OT_SIZE);

	/* set semitransparent texture page mode in gpu at start of sub ot */
	//AddPrim(&(puffs_ot[subotid][PLUME_OT_SIZE -1]),&(transparencies[subotid]));	 		  

	temp = 0;

	if(puffs[0][last_plume].timer < 0)	/* if there is a spare plume available */
	{
		if((Player[playerno].Style == STY_ST_ROLL) ||	/* if the player is crashing */
			(Player[playerno].Style == STY_LANDONHEAD) ||
			(Player[playerno].Style == STY_LANDONLEFT) ||
			(Player[playerno].Style == STY_LANDONRIGHT))
		{
			last_y_height[playerno] = 2*4096;
			if((thiscollision[Player[playerno].Buffer].type == NONE) ||
				(thiscollision[Player[playerno].Buffer].type == RIVER))
				temp++;
		}
		else if(Player[playerno].JumpY == 0)	/* if the player is touching the ground */	 
		{
			if(thiscollision[Player[playerno].Buffer].type == NONE)
				temp++;
			else if(thiscollision[Player[playerno].Buffer].type == RIVER)
				temp++;
		}
		if(temp)
		{
			if(last_y_height[playerno] > 0)	/* generate a puff */
			{
				for(i=0;i<1;i++)
				{
					puffs[0][last_plume].SpeedScale.vx = puffs[0][last_plume].SpeedScale.vy = puffs[0][last_plume].SpeedScale.vz = last_y_height[playerno];
							puffs[0][last_plume].timer = PLUME_LIFE;
	
					puffs[0][last_plume].global_pos.vx = Player[playerno].Pos.X;
					puffs[0][last_plume].global_pos.vy = Player[playerno].Pos.Y;
					puffs[0][last_plume].global_pos.vz = Player[playerno].Pos.Z;
		
					puffs[0][last_plume].inert.vx = (Player[playerno].Pos.X  - Player[playerno].LastPos.X)>>1;
					puffs[0][last_plume].inert.vy = (Player[playerno].Pos.Y  - Player[playerno].LastPos.Y)>>1;
					puffs[0][last_plume].inert.vz = (Player[playerno].Pos.Z  - Player[playerno].LastPos.Z)>>1;
			
					/* setup random inert part */
					rand_idx += 7;
					rand_idx = rand_idx & 0x0000001f;
					puffs[0][last_plume].inert.vx += (((randarray[rand_idx] - 16384) * last_y_height[playerno])>>13);
					rand_idx += 7;
					rand_idx = rand_idx & 0x0000001f;
					puffs[0][last_plume].inert.vy += (((randarray[rand_idx] - 16384) * last_y_height[playerno])>>13);
					rand_idx += 7;
					rand_idx = rand_idx & 0x0000001f;
					puffs[0][last_plume].inert.vz += (((randarray[rand_idx] - 2048) * last_y_height[playerno])>>13);
					last_plume++;
					if(last_plume >= MAX_PLUMES)
						last_plume = 0;
				}
			}
			else	/* generate only one trail */
			{
				if((Player[playerno].Style == STY_BRAKE))	/* if we're doing a powerslide */
				{	
					/* rotate offset on board for start pos of plume */
					RotMatrix(&sclear,&arsemat);
					longarse = Player[playerno].BoardAzimuth>>12;
					if(Player[playerno].AnimStage > 1)
						longarse += (Player[playerno].AnimStage) * -170;
		
					RotMatrixY(longarse,&arsemat);
					TransMatrix(&arsemat,&clear);
					SetRotMatrix(&arsemat);
					SetTransMatrix(&arsemat);
					arse.vx = arse.vy = 0;
					for(i=0;i<3;i++)	/* do 3 sprites */
					{
						arse.vz = (-i) * 8192;
						ApplyRotMatrix(&arse,&(offsets[i]));
					}	
					/*	rotate the inertia based on the powerslide frame */
					Yrot_angle = (Player[playerno].AnimStage + 10) * -128;
					arse.vx = 0;
					arse.vy = 0;
					arse.vz = -4096*7;
					RotMatrix(&sclear,&arsemat);
					longarse = Player[playerno].BoardAzimuth>>12;
					longarse += Yrot_angle;
					RotMatrixY(longarse,&arsemat);
					TransMatrix(&arsemat,&clear);
					SetRotMatrix(&arsemat);
					SetTransMatrix(&arsemat);
					ApplyRotMatrix(&arse,&inert);
	
					for(i=0;i<3;i++)	/* do 3 sprites */
					{
						puffs[0][last_plume].timer = PLUME_LIFE;
			
						puffs[0][last_plume].global_pos.vx = 	Player[playerno].Pos.X;
						puffs[0][last_plume].global_pos.vy = 	Player[playerno].Pos.Y;
						puffs[0][last_plume].global_pos.vz = 	Player[playerno].Pos.Z;
			
						/* scale up the offset on board (12 bits are used for fractional bit) */
						puffs[0][last_plume].global_pos.vx += (offsets[i].vx)<<2;
						puffs[0][last_plume].global_pos.vy += (offsets[i].vy)<<2;
						puffs[0][last_plume].global_pos.vz += (offsets[i].vz)<<2;
						puffs[0][last_plume].inert.vx = inert.vx;
						puffs[0][last_plume].inert.vy = inert.vy;
						puffs[0][last_plume].inert.vz = inert.vz;
						/* setup random inert part */
						rand_idx += 7;
						rand_idx = rand_idx & 0x0000001f;
						puffs[0][last_plume].inert.vx += (randarray[rand_idx] - 16384)>>2;
						rand_idx += 7;
						rand_idx = rand_idx & 0x0000001f;
						puffs[0][last_plume].inert.vy += (randarray[rand_idx] - 16384)>>2;
						rand_idx += 7;
						rand_idx = rand_idx & 0x0000001f;
						puffs[0][last_plume].inert.vz += (randarray[rand_idx] - 2048)>>2;

						/* do a big powerslide plume except when we have stopped completely */
						if(Player[playerno].Vel > 0)
							puffs[0][last_plume].SpeedScale.vx = puffs[0][last_plume].SpeedScale.vy = puffs[0][last_plume].SpeedScale.vz = (Player[playerno].Vel>>5) + 2048;
						else
							puffs[0][last_plume].SpeedScale.vx = puffs[0][last_plume].SpeedScale.vy = puffs[0][last_plume].SpeedScale.vz = 0;

						last_plume++;
						if(last_plume >= MAX_PLUMES)
							last_plume = 0;
					}
				}
				else
				{
					puffs[0][last_plume].SpeedScale.vx = puffs[0][last_plume].SpeedScale.vy = puffs[0][last_plume].SpeedScale.vz = Player[playerno].Vel>>4;
			
					puffs[0][last_plume].timer = PLUME_LIFE;
	
		   			puffs[0][last_plume].global_pos.vx = 	Player[playerno].Pos.X;
					puffs[0][last_plume].global_pos.vy = 	Player[playerno].Pos.Y;
					puffs[0][last_plume].global_pos.vz = 	Player[playerno].Pos.Z;

					/* rotate offset on board for start pos of plume */
					arse.vx = arse.vy = 0;
					arse.vz = -(2<<12);
					RotMatrix(&sclear,&arsemat);
					longarse = Player[playerno].BoardAzimuth>>12;
					if((Player[playerno].Style == STY_BRAKE))	/* if we're doing a powerslide */
						Yrot_angle = (Player[playerno].AnimStage) * -170;
					else
						Yrot_angle = 0;
					longarse += Yrot_angle;
			
					RotMatrixY(longarse,&arsemat);
					TransMatrix(&arsemat,&clear);
					SetRotMatrix(&arsemat);
					SetTransMatrix(&arsemat);
					ApplyRotMatrix(&arse,&Varse);
					/* scale up the offset on board (12 bits are used for fractional bit) */
					puffs[0][last_plume].global_pos.vx += (Varse.vx)<<2;
					puffs[0][last_plume].global_pos.vy += (Varse.vy)<<2;
					puffs[0][last_plume].global_pos.vz += (Varse.vz)<<2;
	
					/*	rotate the inertia based on the turn inertia */
					Yrot_angle = -(Player[playerno].TurnInert>>9);
 					arse.vx = (Player[playerno].Pos.X  - Player[playerno].LastPos.X)>>4;
					arse.vy = (Player[playerno].Pos.Y  - Player[playerno].LastPos.Y)>>4;
					arse.vz = (Player[playerno].Pos.Z  - Player[playerno].LastPos.Z)>>4;
					RotMatrix(&sclear,&arsemat);
					longarse = Yrot_angle;
					RotMatrixY(longarse,&arsemat);
					TransMatrix(&arsemat,&clear);
					SetRotMatrix(&arsemat);
					SetTransMatrix(&arsemat);
					ApplyRotMatrix(&arse,&(puffs[0][last_plume].inert));
					puffs[0][last_plume].inert.vx = puffs[0][last_plume].inert.vx<<3;
					puffs[0][last_plume].inert.vy = puffs[0][last_plume].inert.vy<<3;
					puffs[0][last_plume].inert.vz = puffs[0][last_plume].inert.vz<<3;

					/* setup random inert part */
					rand_idx += 7;
					rand_idx = rand_idx & 0x0000001f;
					puffs[0][last_plume].inert.vx += (randarray[rand_idx] - 16384)>>2;
					rand_idx += 7;
					rand_idx = rand_idx & 0x0000001f;
					puffs[0][last_plume].inert.vy += (randarray[rand_idx] - 16384)>>2;
					rand_idx += 7;
					rand_idx = rand_idx & 0x0000001f;
					puffs[0][last_plume].inert.vz += (randarray[rand_idx] - 2048)>>2;
					last_plume++;
					if(last_plume >= MAX_PLUMES)
						last_plume = 0;
				}
			}
		}
	}
	
	last_y_height[playerno] = Player[playerno].JumpY>>2;

	SetRotMatrix(&(Player[playerno].Cam.ViewMatrix));

	for(i=0;i<MAX_PLUMES;i++)
	{
		if(puffs[0][i].timer >= 0)
		{
			local_loc.vx = (short)((-puffs[0][i].global_pos.vx>>12) + (Player[playerno].Cam.Pos.X>>12)); 
			local_loc.vy = (short)((puffs[0][i].global_pos.vy>>12) - (Player[playerno].Cam.Pos.Y>>12)); 
			local_loc.vz = (short)((puffs[0][i].global_pos.vz>>12) - (Player[playerno].Cam.Pos.Z>>12)); 

			ApplyRotMatrix(&local_loc,&(plume_loc[i]));
		}
	} 

    for(i=0;i<MAX_PLUMES;i++)
	{
		if(puffs[0][i].timer >= 0)
		{
			
			ObjectTrans.t[1] = plume_loc[i].vx;
			ObjectTrans.t[0] = plume_loc[i].vy;
			ObjectTrans.t[2] = plume_loc[i].vz;

			SetTransMatrix( &ObjectTrans );

			/* setup random z rot */
			rand_idx += 7;
			rand_idx = rand_idx & 0x0000001f;
			RotMatrix(&sclear,&z_mat);
			RotMatrixZ(randarray[rand_idx],&z_mat);

			ScaleMatrix(&z_mat,&(puffs[0][i].SpeedScale));
			SetRotMatrix(&z_mat);

			RotTransPers3(&(puff_verts[0]),&(puff_verts[1]),&(puff_verts[2]),
							&(rtp_pos[0]),&(rtp_pos[1]),&(rtp_pos[2]),&address,&address);
			RotTransPers3(&(puff_verts[3]),&(puff_verts[4]),&(puff_verts[5]),
				 			&(rtp_pos[3]),&(rtp_pos[4]),&(rtp_pos[5]),&address,&address);
			RotTransPers(&(puff_verts[6]),&(rtp_pos[6]),&address,&address);

			col = puffs[0][i].timer<<4;

			ot_z = (plume_loc[i].vz>>2);
			if((ot_z > 0) && (ot_z < OTLENGTH))
			{
				/* do 1st tri */
			
				setPolyG3(g3_ptr);
				SetSemiTrans(g3_ptr,1);
				setRGB0(g3_ptr,col,col,col);
				setRGB1(g3_ptr,0x00,0x00,0x00);
				setRGB2(g3_ptr,0x00,0x00,0x00);
				g3_ptr->x0 = rtp_pos[0].vy;
				g3_ptr->y0 = rtp_pos[0].vx;
				g3_ptr->x1 = rtp_pos[1].vy;
				g3_ptr->y1 = rtp_pos[1].vx;
				g3_ptr->x2 = rtp_pos[2].vy;
				g3_ptr->y2 = rtp_pos[2].vx;

				addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);	 		  
			
				g3_ptr++;
				no_plume_tris++;

				/* do 2nd tri */
				setPolyG3(g3_ptr);
				SetSemiTrans(g3_ptr,1);
				setRGB0(g3_ptr,col,col,col);  
				setRGB1(g3_ptr,0x00,0x00,0x00);
				setRGB2(g3_ptr,0x00,0x00,0x00);
				g3_ptr->x0 = rtp_pos[0].vy;
				g3_ptr->y0 = rtp_pos[0].vx;
				g3_ptr->x1 = rtp_pos[2].vy;
				g3_ptr->y1 = rtp_pos[2].vx;
				g3_ptr->x2 = rtp_pos[3].vy;
				g3_ptr->y2 = rtp_pos[3].vx;

				addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);	 		  
				g3_ptr++;
				no_plume_tris++;

				/* do 3rd tri */
				setPolyG3(g3_ptr);
				SetSemiTrans(g3_ptr,1);
				setRGB0(g3_ptr,col,col,col); 
				setRGB1(g3_ptr,0x00,0x00,0x00);
				setRGB2(g3_ptr,0x00,0x00,0x00);
				g3_ptr->x0 = rtp_pos[0].vy;
				g3_ptr->y0 = rtp_pos[0].vx;
				g3_ptr->x1 = rtp_pos[3].vy;
				g3_ptr->y1 = rtp_pos[3].vx;
				g3_ptr->x2 = rtp_pos[4].vy;
				g3_ptr->y2 = rtp_pos[4].vx;

				addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);	 		  
				g3_ptr++;
				no_plume_tris++;

				/* do 4th tri */
				setPolyG3(g3_ptr);
				SetSemiTrans(g3_ptr,1);
				setRGB0(g3_ptr,col,col,col);	
				setRGB1(g3_ptr,0x00,0x00,0x00);
				setRGB2(g3_ptr,0x00,0x00,0x00);
				g3_ptr->x0 = rtp_pos[0].vy;
				g3_ptr->y0 = rtp_pos[0].vx;
				g3_ptr->x1 = rtp_pos[4].vy;
				g3_ptr->y1 = rtp_pos[4].vx;
				g3_ptr->x2 = rtp_pos[5].vy;
				g3_ptr->y2 = rtp_pos[5].vx;

				addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);	 		  
				g3_ptr++;
				no_plume_tris++;

				/* do 5th tri */
				setPolyG3(g3_ptr);
				SetSemiTrans(g3_ptr,1);
				setRGB0(g3_ptr,col,col,col);
				setRGB1(g3_ptr,0x00,0x00,0x00);
				setRGB2(g3_ptr,0x00,0x00,0x00);
				g3_ptr->x0 = rtp_pos[0].vy;
				g3_ptr->y0 = rtp_pos[0].vx;
				g3_ptr->x1 = rtp_pos[5].vy;
				g3_ptr->y1 = rtp_pos[5].vx;
				g3_ptr->x2 = rtp_pos[6].vy;
				g3_ptr->y2 = rtp_pos[6].vx;

				addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);	 		  
				g3_ptr++;
				no_plume_tris++;


				/* do 6th tri */
				setPolyG3(g3_ptr);
				SetSemiTrans(g3_ptr,1);
				setRGB0(g3_ptr,col,col,col);  
				setRGB1(g3_ptr,0x00,0x00,0x00);
				setRGB2(g3_ptr,0x00,0x00,0x00);
				g3_ptr->x0 = rtp_pos[0].vy;
				g3_ptr->y0 = rtp_pos[0].vx;
				g3_ptr->x1 = rtp_pos[6].vy;
				g3_ptr->y1 = rtp_pos[6].vx;
				g3_ptr->x2 = rtp_pos[1].vy;
				g3_ptr->y2 = rtp_pos[1].vx;

				addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);	 		  
				g3_ptr++;
				no_plume_tris++;
			}
		}
	}
	
	/* restore old rotation matrix */
	PopMatrix();
	return(no_plume_tris);
}


/*******************************************************************/

void	UpdatePlume()
{
	long	i;

	for(i=0;i<MAX_PLUMES;i++)
	{
		if(puffs[0][i].timer >= 0)
		{
			puffs[0][i].timer--;
			
			puffs[0][i].global_pos.vx += puffs[0][i].inert.vx;
			puffs[0][i].global_pos.vy += puffs[0][i].inert.vy;
			puffs[0][i].global_pos.vz += puffs[0][i].inert.vz;
		}
	}
}



/************************************************/


void AddPlume(pos)
VECTOR 	*pos;
{
	long	i;

	if(puffs[0][last_plume].timer < 0)	/* if there is a spare plume available */
	{
		puffs[0][last_plume].timer = PLUME_LIFE;
	
		puffs[0][last_plume].global_pos.vx = pos->vx;
		puffs[0][last_plume].global_pos.vy = pos->vy;
		puffs[0][last_plume].global_pos.vz = pos->vz;

		puffs[0][last_plume].inert.vx = 0;
		puffs[0][last_plume].inert.vy = 0;
		puffs[0][last_plume].inert.vz = 0;	

		puffs[0][last_plume].SpeedScale.vx = puffs[0][last_plume].SpeedScale.vy = puffs[0][last_plume].SpeedScale.vz = 16000;
		
		last_plume++;
		if(last_plume >= MAX_PLUMES)
			last_plume = 0;
	
	}
}

