/*********************************************************/
//
//	Cablecar stuff:
//		only one cable car per seg!!!
//		at least 2 poles per seg!!!
//
/*********************************************************/

#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibEtc.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
#include "main.h"
#include "cd.h"
#include "sound.h"
#include "mathbits.h"
#include "screen.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "pads.h"
#include "profile.h"
#include "skeleton.h"
#include "who.h"
#include "frontend.h"
#include "plume.h"
#include "rotmeshs.h"
#include "animctrl.h"
#include <inline_o.h>
#include <gtemac.h>
#include "avalanch.h"
#include "boulder.h"
#include "parachut.h"
#include "bonebag.h"
#include "logic.h"
#include "tree.h"
#include "cablecar.h"
#include "rotmesh.h"

LIFT	 chairlift[2][2];		// 1for each player & 1 for each swap buffer
SVECTOR	 cable_offsets[2];
long	no_cable_lines[4];
LINE_F2	 cable_lines[4][64];

/******************************************/

void	InitCablecars()
{
	long	i,j;

	chairlift[0][0].no_cars = 0;
	chairlift[0][1].no_cars = 0;
	chairlift[1][0].no_cars = 0;
	chairlift[1][1].no_cars = 0;

	chairlift[0][0].no_poles = 0;
	chairlift[0][1].no_poles = 0;
	chairlift[1][0].no_poles = 0;
	chairlift[1][1].no_poles = 0;

	chairlift[0][0].speed = 0;
	chairlift[0][1].speed = 0;
	chairlift[1][0].speed = 0;
	chairlift[1][1].speed = 0;

	chairlift[0][0].first_car = 0;
	chairlift[0][1].first_car = 0;
	chairlift[1][0].last_car = 0;
	chairlift[1][1].last_car = 0;

	for(i=0;i<MAX_CABLECARS;i++)
	{
		chairlift[0][0].chair[i].direction = 1;
		chairlift[0][1].chair[i].direction = 1;
		chairlift[1][0].chair[i].direction = 1;
		chairlift[1][1].chair[i].direction = 1;
		chairlift[0][0].chair[i].object_type = 0;
		chairlift[0][1].chair[i].object_type = 0;
		chairlift[1][0].chair[i].object_type = 0;
		chairlift[1][1].chair[i].object_type = 0;
		chairlift[0][0].chair[i].location = 0;
		chairlift[0][1].chair[i].location = 0;
		chairlift[1][0].chair[i].location = 0;
		chairlift[1][1].chair[i].location = 0;
	}

	for(i=0;i<MAX_CABLECAR_POLES;i++)
	{
		chairlift[0][0].pole[i].visible= 0;
		chairlift[0][1].pole[i].visible= 0;
		chairlift[1][0].pole[i].visible= 0;
		chairlift[1][1].pole[i].visible= 0;
		chairlift[0][0].pole[i].location = 0;
		chairlift[0][1].pole[i].location = 0;
		chairlift[1][0].pole[i].location = 0;
		chairlift[1][1].pole[i].location = 0;
		chairlift[0][0].pole[i].objectptr = NULL;
		chairlift[0][1].pole[i].objectptr = NULL;
		chairlift[1][0].pole[i].objectptr = NULL;
		chairlift[1][1].pole[i].objectptr = NULL;
		chairlift[0][0].pole_idx[i] = -1;
		chairlift[0][1].pole_idx[i] = -1;
		chairlift[1][0].pole_idx[i] = -1;
		chairlift[1][1].pole_idx[i] = -1;
		chairlift[0][0].pole[i].cable_pos[0].vx = 0;
		chairlift[0][1].pole[i].cable_pos[0].vx = 0;
		chairlift[1][0].pole[i].cable_pos[0].vx = 0;
		chairlift[1][1].pole[i].cable_pos[0].vx = 0;
		chairlift[0][0].pole[i].cable_pos[0].vy = 0;
		chairlift[0][1].pole[i].cable_pos[0].vy = 0;
		chairlift[1][0].pole[i].cable_pos[0].vy = 0;
		chairlift[1][1].pole[i].cable_pos[0].vy = 0;
		chairlift[0][0].pole[i].cable_pos[0].vz = 0;
		chairlift[0][1].pole[i].cable_pos[0].vz = 0;
		chairlift[1][0].pole[i].cable_pos[0].vz = 0;
		chairlift[1][1].pole[i].cable_pos[0].vz = 0;
		chairlift[0][0].pole[i].cable_pos[1].vx = 0;
		chairlift[0][1].pole[i].cable_pos[1].vx = 0;
		chairlift[1][0].pole[i].cable_pos[1].vx = 0;
		chairlift[1][1].pole[i].cable_pos[1].vx = 0;
		chairlift[0][0].pole[i].cable_pos[1].vy = 0;
		chairlift[0][1].pole[i].cable_pos[1].vy = 0;
		chairlift[1][0].pole[i].cable_pos[1].vy = 0;
		chairlift[1][1].pole[i].cable_pos[1].vy = 0;
		chairlift[0][0].pole[i].cable_pos[1].vz = 0;
		chairlift[0][1].pole[i].cable_pos[1].vz = 0;
		chairlift[1][0].pole[i].cable_pos[1].vz = 0;
		chairlift[1][1].pole[i].cable_pos[1].vz = 0;
	}


	cable_offsets[0].vx = -20;
	cable_offsets[0].vy = 84;
	cable_offsets[0].vz = 0;

	cable_offsets[1].vx = 20;
	cable_offsets[1].vy = 84;
	cable_offsets[1].vz = 0;

	no_cable_lines[0] = 0;
	no_cable_lines[1] = 0;
	no_cable_lines[2] = 0;
	no_cable_lines[3] = 0;

	for(i=0;i<4;i++)
	{
		for(j=0;j<128;j++)
		{
			setRGB0(&(cable_lines[i][j]),32,32,32);
			setLineF2(&(cable_lines[i][j]));
		}
	}
}								  



/******************************************/


void	MakePoleIdx(sort_axis,P,buffer)
long	sort_axis;
player	*P;
long	buffer;
{
	long	i,idx_no,last_idx;
	long	lowest_val,previous_val;
	VECTOR	gap,Y;
	SVECTOR	temp_offset;
	SVECTOR	ObjRotVec,ObjectScale;
	MATRIX	ObjectRotation;

	
	previous_val = 0x7FFFFFFF;
	switch(sort_axis)
	{
		case 0:	 // sort poles by x
			idx_no = 0;

			lowest_val = 0x80000000;
			while(idx_no < chairlift[P->Buffer][buffer].no_poles)
			{
				last_idx = 0;
				for(i=0;i<chairlift[P->Buffer][buffer].no_poles;i++)
				{
					if(chairlift[P->Buffer][buffer].pole[i].objectptr->TransX > lowest_val)
					{
						if(chairlift[P->Buffer][buffer].pole[i].objectptr->TransX < previous_val)
						{
							previous_val = chairlift[P->Buffer][buffer].pole[i].objectptr->TransX;
							last_idx = i;
						}
					}
				}
				lowest_val = previous_val;
				chairlift[P->Buffer][buffer].pole_idx[idx_no] = last_idx;
				idx_no++;
				previous_val = 0x7FFFFFFF;
			}

			break;
		case 1:	// sort poles by y
			idx_no = 0;

			lowest_val = 0x80000000;
			while(idx_no < chairlift[P->Buffer][buffer].no_poles)
			{
				last_idx = 0;
				for(i=0;i<chairlift[P->Buffer][buffer].no_poles;i++)
				{
					if(chairlift[P->Buffer][buffer].pole[i].objectptr->TransY > lowest_val)
					{
						if(chairlift[P->Buffer][buffer].pole[i].objectptr->TransY < previous_val)
						{
							previous_val = chairlift[P->Buffer][buffer].pole[i].objectptr->TransY;
							last_idx = i;
						}
					}
				}
				lowest_val = previous_val;
				chairlift[P->Buffer][buffer].pole_idx[idx_no] = last_idx;
				idx_no++;
				previous_val = 0x7FFFFFFF;
			}
			break;
		case 2:	// sort poles by z
			idx_no = 0;

			lowest_val = 0x80000000;
			while(idx_no < chairlift[P->Buffer][buffer].no_poles)
			{
				last_idx = 0;
				for(i=0;i<chairlift[P->Buffer][buffer].no_poles;i++)
				{
					if(chairlift[P->Buffer][buffer].pole[i].objectptr->TransZ > lowest_val)
					{
						if(chairlift[P->Buffer][buffer].pole[i].objectptr->TransZ < previous_val)
						{
							previous_val = chairlift[P->Buffer][buffer].pole[i].objectptr->TransZ;
							last_idx = i;
						}
					}
				}
				lowest_val = previous_val;
				chairlift[P->Buffer][buffer].pole_idx[idx_no] = last_idx;
				idx_no++;
				previous_val = 0x7FFFFFFF;
			}
			break;
	}

	// calc length & place poles
	chairlift[P->Buffer][buffer].length = 0;
	chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].pole_idx[0]].location = 0;
	for(i=1;i<chairlift[P->Buffer][buffer].no_poles;i++)
	{
		gap.vx = chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].pole_idx[i]].objectptr->TransX - 
					chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].pole_idx[i - 1]].objectptr->TransX;
		gap.vy = chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].pole_idx[i]].objectptr->TransY - 
					chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].pole_idx[i - 1]].objectptr->TransY;
		gap.vz = chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].pole_idx[i]].objectptr->TransZ - 
					chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].pole_idx[i - 1]].objectptr->TransZ;
		chairlift[P->Buffer][buffer].length += ApproxMagnitude(&gap);
		chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].pole_idx[i]].location = chairlift[P->Buffer][buffer].length;
	}	

	// clear visible flags
	for(i=0;i<chairlift[P->Buffer][buffer].no_poles;i++)
		chairlift[P->Buffer][buffer].pole[i].visible = 0;

	// initialise cable attachment offsets
	for(i=0;i<chairlift[P->Buffer][buffer].no_poles;i++)
	{
		ObjRotVec.vx = 0;
		ObjRotVec.vy = chairlift[P->Buffer][buffer].pole[i].objectptr->RotY;
		ObjRotVec.vz = 0;
		RotMatrixYXZ(&ObjRotVec,&ObjectRotation);
	
		ObjectScale.vx=8192;
	   	ObjectScale.vy=8192;
  		ObjectScale.vz=8192;
	 	ScaleMatrix(&ObjectRotation,&ObjectScale);
	
		gte_SetRotMatrix(&ObjectRotation);
				
		temp_offset.vx = (cable_offsets[0].vx);
		temp_offset.vy = (cable_offsets[0].vy);
		temp_offset.vz = (cable_offsets[0].vz);
		gte_ApplyRotMatrix(&temp_offset,&Y);
		
		chairlift[P->Buffer][buffer].pole[i].cable_pos[0].vx = (short)Y.vx;
		chairlift[P->Buffer][buffer].pole[i].cable_pos[0].vy = (short)Y.vy;
		chairlift[P->Buffer][buffer].pole[i].cable_pos[0].vz = (short)Y.vz;

		temp_offset.vx = (cable_offsets[1].vx);
		temp_offset.vy = (cable_offsets[1].vy);
		temp_offset.vz = (cable_offsets[1].vz);
		gte_ApplyRotMatrix(&temp_offset,&Y);
		
		chairlift[P->Buffer][buffer].pole[i].cable_pos[1].vx = (short)Y.vx;
		chairlift[P->Buffer][buffer].pole[i].cable_pos[1].vy = (short)Y.vy;
		chairlift[P->Buffer][buffer].pole[i].cable_pos[1].vz = (short)Y.vz;
	}
}



/******************************************************/

void	AddBogusPoles(P,buffer)
player	*P;
long	buffer;
{
	long	i,temp;
	VECTOR	diff,Y;
	LIFT	*curr_lift;
	SVECTOR	ObjRotVec,temp_offset,ObjectScale;
	MATRIX	ObjectRotation;

	curr_lift = &(chairlift[P->Buffer][buffer]);
	
	// do 1st pole

	// shift all pole locations by difference of 1st 2 poles

	temp = curr_lift->pole[curr_lift->pole_idx[1]].location;
	for(i=0;i<curr_lift->no_poles;i++)
		curr_lift->pole[i].location += temp;
	
	curr_lift->length += temp;

	// add in 1st poles location
	curr_lift->pole[curr_lift->no_poles].location = 0;

	// do new end bogus poles location
	temp = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles-1]].location - 
			curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles-2]].location;
	curr_lift->pole[curr_lift->no_poles+1].location = 
		curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles-1]].location + temp;

	curr_lift->length += temp;
		

	// shift all pole idx's up by 1

	for(i=curr_lift->no_poles;i>0;i--)
		curr_lift->pole_idx[i] = curr_lift->pole_idx[i-1];
	
	// add in 1st poles idx
	curr_lift->pole_idx[0] = curr_lift->no_poles;

	// add last pole in idx's
	curr_lift->pole_idx[curr_lift->no_poles + 1] = curr_lift->no_poles + 1;

	
	// create first pole structure
	
		// create first poles object

	curr_lift->bogus_poles[0].StripTag = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->StripTag; 
	curr_lift->bogus_poles[0].Type = 23; 
	curr_lift->bogus_poles[0].ScaleX = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->ScaleX; 
	curr_lift->bogus_poles[0].ScaleY = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->ScaleY;  
	curr_lift->bogus_poles[0].ScaleZ = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->ScaleZ;  
	curr_lift->bogus_poles[0].RotX = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->RotX;  
	curr_lift->bogus_poles[0].RotY = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->RotY;  
	curr_lift->bogus_poles[0].RotZ = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->RotZ;  

		// find delta from 1st pole to 2nd

	diff.vx = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->TransX -
				curr_lift->pole[curr_lift->pole_idx[2]].objectptr->TransX;
	diff.vy = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->TransY -
				curr_lift->pole[curr_lift->pole_idx[2]].objectptr->TransY;
	diff.vz = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->TransZ -
				curr_lift->pole[curr_lift->pole_idx[2]].objectptr->TransZ;
	
		// add on delta to get bogus poles position

	curr_lift->bogus_poles[0].TransX = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->TransX + diff.vx;  
	curr_lift->bogus_poles[0].TransY = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->TransY + diff.vy;  
	curr_lift->bogus_poles[0].TransZ = curr_lift->pole[curr_lift->pole_idx[1]].objectptr->TransZ + diff.vz;  

	curr_lift->pole[curr_lift->no_poles].visible = 0;	
	// location is already done
	curr_lift->pole[curr_lift->no_poles].objectptr = &(curr_lift->bogus_poles[0]);	
	// position is done per frame
	// cable pos .... hmmm

	ObjRotVec.vx = 0;
	ObjRotVec.vy = (curr_lift->pole[curr_lift->no_poles].objectptr->RotY);
	ObjRotVec.vz = 0;
	RotMatrixYXZ(&ObjRotVec,&ObjectRotation);
	
	gte_SetRotMatrix(&ObjectRotation);
				
	temp_offset.vx = (cable_offsets[0].vx)<<1;
	temp_offset.vy = (cable_offsets[0].vy)<<1;
	temp_offset.vz = (cable_offsets[0].vz)<<1;
	gte_ApplyRotMatrix(&temp_offset,&Y);
		
	curr_lift->pole[curr_lift->no_poles].cable_pos[0].vx = (short)Y.vx;
	curr_lift->pole[curr_lift->no_poles].cable_pos[0].vy = (short)Y.vy;
	curr_lift->pole[curr_lift->no_poles].cable_pos[0].vz = (short)Y.vz;

	temp_offset.vx = (cable_offsets[1].vx)<<1;
	temp_offset.vy = (cable_offsets[1].vy)<<1;
	temp_offset.vz = (cable_offsets[1].vz)<<1;
	gte_ApplyRotMatrix(&temp_offset,&Y);
		
	curr_lift->pole[curr_lift->no_poles].cable_pos[1].vx = (short)Y.vx;
	curr_lift->pole[curr_lift->no_poles].cable_pos[1].vy = (short)Y.vy;
	curr_lift->pole[curr_lift->no_poles].cable_pos[1].vz = (short)Y.vz;
	// cable prims already initialised


	// create last pole structure
	
		// create last poles object

	curr_lift->bogus_poles[1].StripTag = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->StripTag; 
	curr_lift->bogus_poles[1].Type = 23; 
	curr_lift->bogus_poles[1].ScaleX = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->ScaleX; 
	curr_lift->bogus_poles[1].ScaleY = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->ScaleY;  
	curr_lift->bogus_poles[1].ScaleZ = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->ScaleZ;  
	curr_lift->bogus_poles[1].RotX = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->RotX;  
	curr_lift->bogus_poles[1].RotY = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->RotY;  
	curr_lift->bogus_poles[1].RotZ = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->RotZ;  

		// find delta from 2nd last pole to last pole

	diff.vx = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->TransX -
				curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles - 1]].objectptr->TransX;
	diff.vy = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->TransY -
				curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles -1]].objectptr->TransY;
	diff.vz = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->TransZ -
				curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles - 1]].objectptr->TransZ;
		
		// add on delta to get bogus poles position

	curr_lift->bogus_poles[1].TransX = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->TransX + diff.vx;  
	curr_lift->bogus_poles[1].TransY = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->TransY + diff.vy;  
	curr_lift->bogus_poles[1].TransZ = curr_lift->pole[curr_lift->pole_idx[curr_lift->no_poles]].objectptr->TransZ + diff.vz;  

	curr_lift->pole[curr_lift->no_poles + 1].visible = 0;	
	// location is already done
	curr_lift->pole[curr_lift->no_poles + 1].objectptr = &(curr_lift->bogus_poles[1]);	
	// position is done per frame
	// cable pos .... hmmm

	ObjRotVec.vx = 0;
	ObjRotVec.vy = (curr_lift->pole[curr_lift->no_poles + 1].objectptr->RotY);
	ObjRotVec.vz = 0;
	RotMatrixYXZ(&ObjRotVec,&ObjectRotation);
	
	ObjectScale.vx=8192;
   	ObjectScale.vy=8192;
  	ObjectScale.vz=8192;
 	ScaleMatrix(&ObjectRotation,&ObjectScale);
	
	gte_SetRotMatrix(&ObjectRotation);
				
	temp_offset.vx = (cable_offsets[0].vx);
	temp_offset.vy = (cable_offsets[0].vy);
	temp_offset.vz = (cable_offsets[0].vz);
	gte_ApplyRotMatrix(&temp_offset,&Y);
		
	curr_lift->pole[curr_lift->no_poles+1].cable_pos[0].vx = (short)Y.vx;
	curr_lift->pole[curr_lift->no_poles+1].cable_pos[0].vy = (short)Y.vy;
	curr_lift->pole[curr_lift->no_poles+1].cable_pos[0].vz = (short)Y.vz;

	temp_offset.vx = (cable_offsets[1].vx);
	temp_offset.vy = (cable_offsets[1].vy);
	temp_offset.vz = (cable_offsets[1].vz);
	gte_ApplyRotMatrix(&temp_offset,&Y);
		
	curr_lift->pole[curr_lift->no_poles+1].cable_pos[1].vx = (short)Y.vx;
	curr_lift->pole[curr_lift->no_poles+1].cable_pos[1].vy = (short)Y.vy;
	curr_lift->pole[curr_lift->no_poles+1].cable_pos[1].vz = (short)Y.vz;

	curr_lift->no_poles += 2;	

}

/*****************************************************/
void	AddCars(P,buffer)
player	*P;
long	buffer;
{
	long	current_loc;

	// do forward ones	
	chairlift[P->Buffer][buffer].no_cars = 0;
	current_loc = 0;
	chairlift[P->Buffer][buffer].first_car = chairlift[P->Buffer][buffer].no_cars = 0;
	while(current_loc < chairlift[P->Buffer][buffer].length)
	{
		chairlift[P->Buffer][buffer].chair[chairlift[P->Buffer][buffer].no_cars].direction = 1;
		chairlift[P->Buffer][buffer].chair[chairlift[P->Buffer][buffer].no_cars].object_type = 50;
		chairlift[P->Buffer][buffer].chair[chairlift[P->Buffer][buffer].no_cars].location = current_loc;

		chairlift[P->Buffer][buffer].no_cars++;
		current_loc +=	CABLECAR_DISTANCE;
	}

	// do reverse ones	
	current_loc = chairlift[P->Buffer][buffer].length;
	chairlift[P->Buffer][buffer].first_car = chairlift[P->Buffer][buffer].no_cars;
	while(current_loc > 0)
	{
		chairlift[P->Buffer][buffer].chair[chairlift[P->Buffer][buffer].no_cars].direction = -1;
		chairlift[P->Buffer][buffer].chair[chairlift[P->Buffer][buffer].no_cars].object_type = 50;
		chairlift[P->Buffer][buffer].chair[chairlift[P->Buffer][buffer].no_cars].location = current_loc;

		chairlift[P->Buffer][buffer].no_cars++;
		current_loc -=	CABLECAR_DISTANCE;
	}
}


/******************************************/

void	CheckCablecars(P)
player	*P;
{
	long	k;
	uint32	address;
	trackobject *newobjectptr;
	long	max_x_diff,diff,start_pole,end_pole;
	long	max_y_diff,max_z_diff,sort_axis,buffer;

	if(IBuf[P->Buffer] == &(Ib1[P->Buffer]))
		buffer = 0;
	else
		buffer = 1;



	chairlift[P->Buffer][buffer].no_cars = 0;
	chairlift[P->Buffer][buffer].no_poles = 0;
	chairlift[P->Buffer][buffer].speed = 8192;

	address = (uint32)&(IBuf[P->Buffer]->CurrentStripPtr);
	address = address + IBuf[P->Buffer]->CurrentObjectPtr;
	newobjectptr = (trackobject *)address;

	if(1)//currentfile[P->Buffer] < 11)	// if its on the forest track
	{
		for (k=0;k<IBuf[P->Buffer]->NumObjects;k++)  // count & point to all the poles
		{		
			if(newobjectptr->Type == 23)
			{
				chairlift[P->Buffer][buffer].pole[chairlift[P->Buffer][buffer].no_poles].objectptr = newobjectptr;
				chairlift[P->Buffer][buffer].no_poles++;
			}	
			newobjectptr++;
		}
	}
	if(chairlift[P->Buffer][buffer].no_poles > 0)	// sort the poles by their greatest difference
	{
		start_pole = 0;
		end_pole = chairlift[P->Buffer][buffer].no_poles - 1;
	
		// find max x diffreence
		max_x_diff = 0;
		for(start_pole=0;start_pole<(chairlift[P->Buffer][buffer].no_poles-1);start_pole++)
		{
			for(end_pole=start_pole+1;end_pole<chairlift[P->Buffer][buffer].no_poles;end_pole++)
			{
				diff = abs(chairlift[P->Buffer][buffer].pole[start_pole].objectptr->TransX - chairlift[P->Buffer][buffer].pole[end_pole].objectptr->TransX);
				if(diff > max_x_diff)
					max_x_diff = diff;
			}
		}
	
		// find max y difference
		max_y_diff = 0;
		for(start_pole=0;start_pole<(chairlift[P->Buffer][buffer].no_poles-1);start_pole++)
		{
			for(end_pole=start_pole+1;end_pole<chairlift[P->Buffer][buffer].no_poles;end_pole++)
			{
				diff = abs(chairlift[P->Buffer][buffer].pole[start_pole].objectptr->TransY - chairlift[P->Buffer][buffer].pole[end_pole].objectptr->TransY);
				if(diff > max_y_diff)
					max_y_diff = diff;
			}
		}
	
		// find max z difference
		max_z_diff = 0;
		for(start_pole=0;start_pole<(chairlift[P->Buffer][buffer].no_poles-1);start_pole++)
		{
			for(end_pole=start_pole+1;end_pole<chairlift[P->Buffer][buffer].no_poles;end_pole++)
			{
				diff = abs(chairlift[P->Buffer][buffer].pole[start_pole].objectptr->TransZ - chairlift[P->Buffer][buffer].pole[end_pole].objectptr->TransZ);
				if(diff > max_z_diff)
					max_z_diff = diff;
			}
		}
	
		sort_axis = 0;
		if(max_y_diff > max_x_diff)
		{
			if(max_y_diff > max_z_diff)
				sort_axis = 1;
			else
				sort_axis = 2;
		}
		else
		{
			if(max_x_diff < max_z_diff)
				sort_axis = 2;
		}
	
		MakePoleIdx(sort_axis,P,buffer);	  // sort poles, & place along length
		AddBogusPoles(P,buffer);			// obvious really
		AddCars(P,buffer);				  // place cars

		// need to figure out which one was the first on each cable, so I know when to introduce a new one		
	}
}


/********************************************/

void	ClearCablecars(P,buffer,fileno)
player	*P;
long	buffer;
long	fileno;
{
	chairlift[P->Buffer][buffer].no_poles = 0;
	chairlift[P->Buffer][buffer].no_cars = 0;
	buffer_filenumbers[P->Buffer][buffer] = fileno;	
}


/******************************************/

void	DrawCablecars(P,buffer)
player	*P;
long	buffer;
{
	long	i,j,objecttype,z[2],car,pole,location,thisouter;
	SVECTOR	X,ObjRotVec,sclear;
	VECTOR	Y,ObjectScale,start,end,diff;
	MATRIX	ObjectTrans,ObjectRotation;
	CABLECAR_POLE	*poleptr0,*poleptr1;
	RUSS_SVECTOR	newsxy[2][5];
	long	numverts,numpolys;
	SVECTOR		*vertexptr,svectemp;
	objpolygon	*polyptr;
	RUSS_SVECTOR	*outverts;
	objpolygon	*thispolyptr;
	uint32	polyvertptr;
	uint32 	polyustore;
	uint32	polyvstore;
	uint32	tmatid;
	POLY_FT4 *polystptr;
	long	mask=0x0ff;
	POLY_FT3 *polystptr2;
	long	location2;
	short	vert_idx[4];
	LIFT	*curr_lift;

	PushMatrix();

	curr_lift = (LIFT *)(&(chairlift[P->Buffer][buffer]));
	if(curr_lift->no_poles > 0)
	{
		no_cable_lines[otid] = 0;
			
		sclear.vx = sclear.vy = sclear.vz = 0;
		// need to draw for both buffers

			
		// do visibility of poles
		for(i=0;i<curr_lift->no_poles;i++)
		{
			curr_lift->pole[curr_lift->pole_idx[i]].visible = 0;
			for(j=0;j<MAX_VIEW_STRIPS;j++)
			{
				if(striptab[P->Buffer][j].fileno == buffer_filenumbers[P->Buffer][buffer])
				{
					if(striptab[P->Buffer][j].stripno == curr_lift->pole[curr_lift->pole_idx[i]].objectptr->StripTag)
					{
						curr_lift->pole[curr_lift->pole_idx[i]].visible = 1;
						break;
					}
				}
			}
	
		}

		// make the pole before the first & after the last visible as well
		i = 0;
		while(i<curr_lift->no_poles)
		{
			if(curr_lift->pole[curr_lift->pole_idx[i]].visible)
			{
				if(i != 0)
					curr_lift->pole[curr_lift->pole_idx[i-1]].visible = 1;
				break;
			}	
			i++;
		}

		i = curr_lift->no_poles - 1;
		while(i>=0)
		{
			if(curr_lift->pole[curr_lift->pole_idx[i]].visible)
			{
				if(i != (curr_lift->no_poles - 1))
					curr_lift->pole[curr_lift->pole_idx[i+1]].visible = 1;
				break;
			}	
			i--;
		}
		// need to introduce new cars here
		// move cars
		for(i=0;i<curr_lift->no_cars;i++)
		{
			curr_lift->chair[i].location +=	(curr_lift->speed * curr_lift->chair[i].direction);
			if(curr_lift->chair[i].location > curr_lift->length)
				curr_lift->chair[i].location = 0;
			if(curr_lift->chair[i].location < 0)
				curr_lift->chair[i].location = curr_lift->length;
		}
		// draw cables
	
		// place first pole
		poleptr1 = &(curr_lift->pole[curr_lift->pole_idx[0]]);
		X.vx= (poleptr1->objectptr->TransX + P->Cam.Pos.X)>>12;
		X.vy= (poleptr1->objectptr->TransY - P->Cam.Pos.Y)>>12;
		X.vz= (poleptr1->objectptr->TransZ - P->Cam.Pos.Z)>>12;
		
		if(buffer)
		{
			X.vx+= Ib2[P->Buffer].OffsetX;
			X.vz+= Ib2[P->Buffer].OffsetZ;
		}
		else
		{
			X.vx+= Ib1[P->Buffer].OffsetX;
			X.vz+= Ib1[P->Buffer].OffsetZ;
		}

		poleptr1->position.vx = X.vx;
		poleptr1->position.vy = X.vy;
		poleptr1->position.vz = X.vz;
		
		// draw cables
		for(i=1;i<curr_lift->no_poles;i++)
		{
			if((curr_lift->pole[curr_lift->pole_idx[i]].visible) ||	
				(curr_lift->pole[curr_lift->pole_idx[i-1]].visible))
			{

				// do cable 0			

				poleptr0 = &(curr_lift->pole[curr_lift->pole_idx[i-1]]);
				poleptr1 = &(curr_lift->pole[curr_lift->pole_idx[i]]);
	
		
				X.vx= (poleptr1->objectptr->TransX + P->Cam.Pos.X)>>12;
				X.vy= (poleptr1->objectptr->TransY - P->Cam.Pos.Y)>>12;
				X.vz= (poleptr1->objectptr->TransZ - P->Cam.Pos.Z)>>12;
		
				if(buffer)
				{
					X.vx+= Ib2[P->Buffer].OffsetX;
					X.vz+= Ib2[P->Buffer].OffsetZ;
				}
				else
				{
					X.vx+= Ib1[P->Buffer].OffsetX;
					X.vz+= Ib1[P->Buffer].OffsetZ;
				}

				poleptr1->position.vx = X.vx;
				poleptr1->position.vy = X.vy;
				poleptr1->position.vz = X.vz;
	
		
				X.vx= (poleptr0->objectptr->TransX + P->Cam.Pos.X)>>12;
				X.vy= (poleptr0->objectptr->TransY - P->Cam.Pos.Y)>>12;
				X.vz= (poleptr0->objectptr->TransZ - P->Cam.Pos.Z)>>12;
		
				if(buffer)
				{
					X.vx+= Ib2[P->Buffer].OffsetX;
					X.vz+= Ib2[P->Buffer].OffsetZ;
				}
				else
				{
					X.vx+= Ib1[P->Buffer].OffsetX;
					X.vz+= Ib1[P->Buffer].OffsetZ;
				}

				poleptr0->position.vx = X.vx;
				poleptr0->position.vy = X.vy;
				poleptr0->position.vz = X.vz;
	
		

		
				end.vx = poleptr1->position.vx +
						poleptr1->cable_pos[0].vx;
				end.vy = poleptr1->position.vy +
						 poleptr1->cable_pos[0].vy;
				end.vz = poleptr1->position.vz +
						poleptr1->cable_pos[0].vz;

				start.vx = poleptr0->position.vx +
						poleptr0->cable_pos[0].vx;
				start.vy = poleptr0->position.vy +
						poleptr0->cable_pos[0].vy;
				start.vz = poleptr0->position.vz +
						poleptr0->cable_pos[0].vz;
	
				diff.vx = end.vx - start.vx;
				diff.vy = end.vy - start.vy;
				diff.vz = end.vz - start.vz;

				gte_SetRotMatrix(&P->Cam.ViewMatrix);
				location = 0;
				for(j=0;j<5;j++)
				{
					Y.vx = (diff.vx * location)>>12;
					Y.vy = (diff.vy * location)>>12;
					Y.vz = (diff.vz * location)>>12;
	
					Y.vx += start.vx;
					Y.vy += start.vy;
					Y.vz += start.vz;

					X.vx = (short)Y.vx;
					X.vy = (short)Y.vy;
					X.vz = (short)Y.vz;
	
					gte_ApplyRotMatrix(&X,&Y);

					ObjectTrans.t[1]=Y.vx;
					ObjectTrans.t[0]=Y.vy;
					ObjectTrans.t[2]=Y.vz;
	
					gte_SetTransMatrix(&ObjectTrans);

					gte_ldv0(&sclear);
	    	        gte_rtps();
	 		    
	 			    gte_stsxy(&(newsxy[0][j].vx));
					gte_stszotz(&(newsxy[0][j].vz));
			
					location += 1024;
				}
	
				for(j=0;j<4;j++)
				{
					z[0] = (newsxy[0][j].vz + newsxy[0][j+1].vz)>>1;
					
					// they wanna see more cables
					if(z[0]>0)
					{
						if(z[0] > (OTLENGTH - 16))
							z[0] = OTLENGTH - 16;
  						cable_lines[otid][no_cable_lines[otid]].y0 = newsxy[0][j].vx;
  						cable_lines[otid][no_cable_lines[otid]].x0 = newsxy[0][j].vy;
				
  						cable_lines[otid][no_cable_lines[otid]].y1 = newsxy[0][j+1].vx;
  						cable_lines[otid][no_cable_lines[otid]].x1 = newsxy[0][j+1].vy;
				
  						AddPrim(&(OrderingTable[otid][z[0]]),&(cable_lines[otid][no_cable_lines[otid]]));
	  					no_cable_lines[otid]++;
					}
				}
	

				// do cable 1

				end.vx = poleptr1->position.vx +
						poleptr1->cable_pos[1].vx;
				end.vy = poleptr1->position.vy +
						 poleptr1->cable_pos[1].vy;
				end.vz = poleptr1->position.vz +
						poleptr1->cable_pos[1].vz;

				start.vx = poleptr0->position.vx +
						poleptr0->cable_pos[1].vx;
				start.vy = poleptr0->position.vy +
						poleptr0->cable_pos[1].vy;
				start.vz = poleptr0->position.vz +
						poleptr0->cable_pos[1].vz;
	
				diff.vx = end.vx - start.vx;
				diff.vy = end.vy - start.vy;
				diff.vz = end.vz - start.vz;

				gte_SetRotMatrix(&P->Cam.ViewMatrix);
				location = 0;
				for(j=0;j<5;j++)
				{
					Y.vx = (diff.vx * location)>>12;
					Y.vy = (diff.vy * location)>>12;
					Y.vz = (diff.vz * location)>>12;
	
					Y.vx += start.vx;
					Y.vy += start.vy;
					Y.vz += start.vz;

					X.vx = (short)Y.vx;
					X.vy = (short)Y.vy;
					X.vz = (short)Y.vz;
	
					gte_ApplyRotMatrix(&X,&Y);

					ObjectTrans.t[1]=Y.vx;
					ObjectTrans.t[0]=Y.vy;
					ObjectTrans.t[2]=Y.vz;
		
					gte_SetTransMatrix(&ObjectTrans);
				 
					gte_ldv0(&sclear);
	    	        gte_rtps();
	 		    
	 			    gte_stsxy(&(newsxy[1][j].vx));
					gte_stszotz(&(newsxy[1][j].vz));
			
					location += 1024;
				}
	
				for(j=0;j<4;j++)
				{
					z[0] = (newsxy[1][j].vz + newsxy[1][j+1].vz)>>1;
					if(z[0]>0) 
					{
						// they wanna see more cables
						if(z[0] > (OTLENGTH - 16))
							z[0] = OTLENGTH - 16;
  						
  						cable_lines[otid][no_cable_lines[otid]].y0 = newsxy[1][j].vx;
  						cable_lines[otid][no_cable_lines[otid]].x0 = newsxy[1][j].vy;
				
  						cable_lines[otid][no_cable_lines[otid]].y1 = newsxy[1][j+1].vx;
  						cable_lines[otid][no_cable_lines[otid]].x1 = newsxy[1][j+1].vy;
				
  						AddPrim(&(OrderingTable[otid][z[0]]),&(cable_lines[otid][no_cable_lines[otid]]));
	  					no_cable_lines[otid]++;
					}
				} 
	

			}
		}
	
		//Draw cars
	
		car = 0;
		//pole = 1;
		pole = 0;
		while(car<curr_lift->no_cars)
		{

			//find pole after car
			pole = 1;
			while(curr_lift->chair[car].location > curr_lift->pole[curr_lift->pole_idx[pole]].location)
				pole++;
			if((curr_lift->pole[curr_lift->pole_idx[pole]].visible) ||	
				(curr_lift->pole[curr_lift->pole_idx[pole-1]].visible))
			{
				location = (curr_lift->chair[car].location - curr_lift->pole[curr_lift->pole_idx[pole - 1]].location);
				location2 = (curr_lift->pole[curr_lift->pole_idx[pole]].location - curr_lift->pole[curr_lift->pole_idx[pole - 1]].location)>>12;
			
				location = location / location2;
				
				if(curr_lift->chair[car].direction == 1)
				{
					end.vx = curr_lift->pole[curr_lift->pole_idx[pole]].position.vx +
							curr_lift->pole[curr_lift->pole_idx[pole]].cable_pos[0].vx;
					end.vy = curr_lift->pole[curr_lift->pole_idx[pole]].position.vy +
							curr_lift->pole[curr_lift->pole_idx[pole]].cable_pos[0].vy;
					end.vz = curr_lift->pole[curr_lift->pole_idx[pole]].position.vz +
							curr_lift->pole[curr_lift->pole_idx[pole]].cable_pos[0].vz;

					start.vx = curr_lift->pole[curr_lift->pole_idx[pole - 1]].position.vx +
							curr_lift->pole[curr_lift->pole_idx[pole - 1]].cable_pos[0].vx;
					start.vy = curr_lift->pole[curr_lift->pole_idx[pole - 1]].position.vy +
							curr_lift->pole[curr_lift->pole_idx[pole - 1]].cable_pos[0].vy;
					start.vz = curr_lift->pole[curr_lift->pole_idx[pole - 1]].position.vz +
							curr_lift->pole[curr_lift->pole_idx[pole - 1]].cable_pos[0].vz;
	
					Y.vx = end.vx - start.vx;
					Y.vy = end.vy - start.vy;
					Y.vz = end.vz - start.vz;
				}
				else
				{
					end.vx = curr_lift->pole[curr_lift->pole_idx[pole]].position.vx +
							curr_lift->pole[curr_lift->pole_idx[pole]].cable_pos[1].vx;
					end.vy = curr_lift->pole[curr_lift->pole_idx[pole]].position.vy +
							curr_lift->pole[curr_lift->pole_idx[pole]].cable_pos[1].vy;
					end.vz = curr_lift->pole[curr_lift->pole_idx[pole]].position.vz +
							curr_lift->pole[curr_lift->pole_idx[pole]].cable_pos[1].vz;

					start.vx = curr_lift->pole[curr_lift->pole_idx[pole - 1]].position.vx +
							curr_lift->pole[curr_lift->pole_idx[pole - 1]].cable_pos[1].vx;
					start.vy = curr_lift->pole[curr_lift->pole_idx[pole - 1]].position.vy +
							curr_lift->pole[curr_lift->pole_idx[pole - 1]].cable_pos[1].vy;
					start.vz = curr_lift->pole[curr_lift->pole_idx[pole - 1]].position.vz +
							curr_lift->pole[curr_lift->pole_idx[pole - 1]].cable_pos[1].vz;
	
					Y.vx = end.vx - start.vx;
					Y.vy = end.vy - start.vy;
					Y.vz = end.vz - start.vz;
				}

				Y.vx = (Y.vx * location)>>12;
				Y.vy = (Y.vy * location)>>12;
				Y.vz = (Y.vz * location)>>12;
	
				Y.vx += start.vx;
				Y.vy += start.vy;
				Y.vz += start.vz;

				X.vx = (short)Y.vx;
				X.vy = (short)Y.vy;
				X.vz = (short)Y.vz;
	
				gte_SetRotMatrix(&P->Cam.ViewMatrix);
	
				gte_ApplyRotMatrix(&X,&Y);

				ObjectTrans.t[1]=Y.vx;
				ObjectTrans.t[0]=Y.vy;
				ObjectTrans.t[2]=Y.vz;
				 	
				ObjRotVec.vx = 0;//curr_lift->pole[curr_lift->pole_idx[pole]].objectptr->RotX;
				ObjRotVec.vy = -curr_lift->pole[curr_lift->pole_idx[pole]].objectptr->RotY;
				ObjRotVec.vz = 0;//curr_lift->pole[curr_lift->pole_idx[pole]].objectptr->RotZ;
			
				if(curr_lift->chair[car].direction == 1)
					ObjRotVec.vy += 2048;

				RotMatrixYXZ(&ObjRotVec,&ObjectRotation);
	
				gte_SetRotMatrix(&P->Cam.ObjectView);
				MulRotMatrix(&ObjectRotation);
	
				ObjectScale.vx=8192;
				ObjectScale.vy=8192;
				ObjectScale.vz=8192;
				ScaleMatrix(&ObjectRotation,&ObjectScale);
	
				gte_SetRotMatrix(&ObjectRotation);
				gte_SetTransMatrix(&ObjectTrans);
		
				numverts=ChillObjects[CABLECAR_OBJECT_TYPE].numverts;
				numpolys=ChillObjects[CABLECAR_OBJECT_TYPE].numpolys;
				vertexptr=ChillObjects[CABLECAR_OBJECT_TYPE].vertptr;
				polyptr=ChillObjects[CABLECAR_OBJECT_TYPE].polyptr;
		
				outverts = (RUSS_SVECTOR *)(0x1f800000);
	 			for (i=0;i<numverts;i++)
				{
					gte_ldv0(vertexptr);
		           	gte_rtps();
		 		   	gte_stsxy(&(outverts->vx));
					gte_stszotz(&z[0]);
					outverts->vz = z[0];
					vertexptr++;
					outverts++;
				}
		
				outverts = (RUSS_SVECTOR *)(0x1f800000);
				for (i=0;i<numpolys;i++)
				{
					thispolyptr=(polyptr+i);
				
					polyvertptr=thispolyptr->vertptr;
					vert_idx[0] = polyvertptr&mask;
					z[0] = outverts[vert_idx[0]].vz; 
					if (z[0]>=1)
					{
						
						if(z[0]>(OTLENGTH-16))
							z[0] = OTLENGTH - 16;

						vert_idx[1] = (polyvertptr>>8)&mask;
						vert_idx[2] = (polyvertptr>>24)&mask;

						if((NormalClip(*((long *)(&(outverts[((polyvertptr)&mask)].vx))),
					   				*((long *)(&(outverts[((polyvertptr>>8)&mask)].vx))),
									*((long *)(&(outverts[((polyvertptr>>16)&mask)].vx))))) < 0)
						{
							if (thispolyptr->numverts==4)
							{
								if (thispolyptr->polytype>0)
								{
								 	polyustore=thispolyptr->textus;
								 	polyvstore=thispolyptr->textvs;
								 	tmatid=thispolyptr->tmatid;
									polystptr=&(polyf4s[otid][nopolyf4s]);

									*(uint32 *)&(polystptr->r0)=(44<<24)|(127<<16)|(127<<8)|127;
									polystptr->tpage=tids[tmatid].textpage;
									polystptr->clut=tids[tmatid].clutline[0];
				
									*(uint16 *)&(polystptr->u0)=(polyvstore<<8)|(polyustore&mask);
									*(uint16 *)&(polystptr->u1)=((polyvstore>>8)&mask)<<8|((polyustore>>8)&mask);
									*(uint16 *)&(polystptr->u2)=((polyvstore>>24)&mask)<<8|((polyustore>>24)&mask);
									*(uint16 *)&(polystptr->u3)=((polyvstore>>16)&mask)<<8|((polyustore>>16)&mask);
						
									svectemp.vx = outverts[vert_idx[0]].vy; 
									svectemp.vy = outverts[vert_idx[0]].vx; 
							   		LONG_MOVE(&svectemp,&(polystptr->x0));
						   		
							   		svectemp.vx = outverts[vert_idx[1]].vy; 
									svectemp.vy = outverts[vert_idx[1]].vx; 
						   			LONG_MOVE(&svectemp,&(polystptr->x1));

							   		svectemp.vx = outverts[vert_idx[2]].vy; 
									svectemp.vy = outverts[vert_idx[2]].vx; 
							   		LONG_MOVE(&svectemp,&(polystptr->x2));
								
									vert_idx[3] = (polyvertptr>>16)&mask;
						   			svectemp.vx = outverts[vert_idx[3]].vy; 
									svectemp.vy = outverts[vert_idx[3]].vx; 
						   			LONG_MOVE(&svectemp,&(polystptr->x3));
								
									OTPtr=&(OrderingTable[otid][z[0]]);
				
									AddPrim(OTPtr,polystptr);
	
								  	nopolyf4s++;
								}
							}
							else
							{
								if (thispolyptr->polytype>0)
								{
									polystptr2=&polyf3s[otid][nopolyf3s];
									polyustore=thispolyptr->textus;
									polyvstore=thispolyptr->textvs;
									tmatid=thispolyptr->tmatid;
									*(uint32 *)&(polystptr2->r0)=(36<<24)|(127<<16)|(127<<8)|127;
	
									polystptr2->tpage=tids[tmatid].textpage;
									polystptr2->clut=tids[tmatid].clutline[0];
								
									*(uint16 *)&(polystptr2->u0)=(polyvstore<<8)|(polyustore&mask);
									*(uint16 *)&(polystptr2->u1)=((polyvstore>>8)&mask)<<8|((polyustore>>8)&mask);
									*(uint16 *)&(polystptr2->u2)=((polyvstore>>16)&mask)<<8|((polyustore>>16)&mask);
								
									svectemp.vx = outverts[vert_idx[0]].vy; 
									svectemp.vy = outverts[vert_idx[0]].vx; 
							   		LONG_MOVE(&svectemp,&(polystptr2->x0));
	
									svectemp.vx = outverts[vert_idx[1]].vy; 
									svectemp.vy = outverts[vert_idx[1]].vx; 
						   			LONG_MOVE(&svectemp,&(polystptr2->x1));
	
									vert_idx[2] = (polyvertptr)>>16&mask;
									svectemp.vx = outverts[vert_idx[2]].vy; 
									svectemp.vy = outverts[vert_idx[2]].vx; 
						   			LONG_MOVE(&svectemp,&(polystptr2->x2));
	
									OTPtr=&(OrderingTable[otid][z[0]]);
									AddPrim(OTPtr,polystptr2);
									nopolyf3s++;
								} 
							}
						}
				   	}
				}
			}
			car++;			
		}
	}  		
	PopMatrix();
}