#include <stdio.h>
#include <sys/types.h>
#include <LibGTE.h>
#include <LibGPU.h>
#include <LibCD.h>
#include <LibComb.h>
#include <LibEtc.h>
#include <LibGS.h>
#include <LibMath.h>
#include <LibPress.h>
#include <LibSN.h>
#include <LibSnd.h>
#include <LibSPU.h>
#include <inline_o.h>
#include <gtemac.h>


#include "ourtypes.h"
#include "mathbits.h"

#include "main.h"
#include "skeleton.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "pads.h"

#include "screen.h"
#include "who.h"
#include "bored.h"
#include "animctrl.h"

#include "bonebag.h"
#include "trixbag.h"
#include "logic.h"
#include "plume.h"




long	rand_idx;
long	last_plume;

long	no_player_plumes[2];
//long	turninertboost = -96;
//long	turnextrarot = 0;
//long	carvedivisor = 220;
//long	offset_z = 8192;
//long	speed_divisor = 24;


PLUME			puffs[MAX_PLUMES];
unsigned long 	puffs_ot[8][PLUME_OT_SIZE];		/* ordering table so semitransparencies can happen */
DR_TPAGE		transparencies[4][MAX_TPAGES];	/* primitives to turn transparency on/off on sub ot */
long			no_plume_tpages[4];
long			current_plume[2],last_y_height[2];
SVECTOR			puff_verts[7];

/*************************************************/

void InitPlume()
{
	short	i,j;
	unsigned short trans_tpage,opaque_pad;

	for(i=0;i<MAX_PLUMES;i++)
	{
		puffs[i].timer = -1;

		puffs[i].inert.vx = puffs[i].inert.vy =
			puffs[i].inert.vz = puffs[i].inert.pad = 0;

		puffs[i].SpeedScale.vx = puffs[i].SpeedScale.vy = puffs[i].SpeedScale.vz = 4096;


	}

	/* clear both buffers */

	no_plume_tpages[0] = 0;
	no_plume_tpages[1] = 0;
	no_plume_tpages[2] = 0;
	no_plume_tpages[3] = 0;

	trans_tpage = GetTPage(1,3,0,0);
	for(i=0;i<MAX_TPAGES;i++)
	{
		SetDrawTPage(&(transparencies[0][i]),1,1,(int)(trans_tpage));
		SetDrawTPage(&(transparencies[1][i]),1,1,(int)(trans_tpage));
		SetDrawTPage(&(transparencies[2][i]),1,1,(int)(trans_tpage));
		SetDrawTPage(&(transparencies[3][i]),1,1,(int)(trans_tpage));
	}


	puff_verts[0].vx = 0;
	puff_verts[0].vy = 0;
	puff_verts[0].vz = 0;
	puff_verts[1].vx = -20;
	puff_verts[1].vy = 34;
	puff_verts[1].vz = 0;
	puff_verts[2].vx = -40;
	puff_verts[2].vy = 20;
	puff_verts[2].vz = 0;
	puff_verts[3].vx = -20;
	puff_verts[3].vy = -34;
	puff_verts[3].vz = 0;
	puff_verts[4].vx = 20;
	puff_verts[4].vy = -34;
	puff_verts[4].vz = 0;
	puff_verts[5].vx = 40;
	puff_verts[5].vy = 0;
	puff_verts[5].vz = 0;
	puff_verts[6].vx = 20;
	puff_verts[6].vy = 34;
	puff_verts[6].vz = 0;

	rand_idx = 0;
	current_plume[0] = 0;
	current_plume[1] = 0;
	last_y_height[0] = 0;
	last_y_height[1] = 0;

	last_plume = 0;

}


/*****************************************************/


//void	AddPlume(unsigned long *ot,long subotid)
//{
//	AddPrims(ot,&(puffs_ot[subotid][PLUME_OT_SIZE -1]),&(puffs_ot[subotid][0]));
//}





/************************************************/


long DrawPlume(unsigned long playerno,POLY_G3 *g3_ptr)
{
	POLY_F4 	*polysptr;
	VECTOR		plume_loc[MAX_PLUMES],plume_dir,new_inert;
	SVECTOR		rtp_pos[7],offset;
	long		address,i,temp,Yrot_angle;
	MATRIX		z_mat,ObjectTrans,SpeedScaleMat,Yturnmat,Xturnmat,arsemat;
	SVECTOR		sclear,ObjRot,plume_offset,plume_inert,arse,local_loc;
	VECTOR		clear,new_puff_pos,orig_puff_pos,trans_vector,new_plume_offset,Varse,offsets[4],inert;
	VECTOR 		ScaleDown = { 1024, 1024, 1024 };
	POLY_G3			*tripolysptr;
	long		ot_z;
	long		longarse,col;
	long		other_playerno;
	long		no_plume_tris = 0;

	long		cam_pos,plume_pos,cam_mat,update;
	long		subotid;



	if(Ingame)
	{
		/* backup rotation matrix */
		PushMatrix();

		sclear.vx = sclear.vy = sclear.vz = 0;
		clear.vx = clear.vy = clear.vz = 0;

		RotMatrix(&sclear,&Yturnmat);
		TransMatrix(&Yturnmat,&clear);
		RotMatrix(&sclear,&Xturnmat);
		TransMatrix(&Xturnmat,&clear);
		SetTransMatrix(&Yturnmat);

		/* clear the plumes sub ot */
		//ClearOTagR(&(puffs_ot[subotid][0]),PLUME_OT_SIZE);
	
		/* set semitransparent texture page mode in gpu at start of sub ot */
		//AddPrim(&(puffs_ot[subotid][PLUME_OT_SIZE -1]),&(transparencies[subotid]));
	
		temp = 0;
	
		if(!paused)
		{
			if(puffs[last_plume].timer < 0)	/* if there is a spare plume available */
			{
				if((Player[playerno].Style == STY_ST_ROLL) ||	/* if the player is crashing */
					(Player[playerno].Style == STY_LANDONHEAD) ||
					(Player[playerno].Style == STY_LANDONLEFT) ||
					(Player[playerno].Style == STY_LANDONRIGHT))
					{
						last_y_height[playerno] = 2*4096;
					if((thiscollision[Player[playerno].Buffer].type == NONE) ||
						(thiscollision[Player[playerno].Buffer].type == RIVER))
						temp++;
				}
				else if(Player[playerno].JumpY == 0)	/* if the player is touching the ground */
				{
					if(thiscollision[Player[playerno].Buffer].type == NONE)
						temp++;
					else if(thiscollision[Player[playerno].Buffer].type == RIVER)
						temp++;
				}
				if(temp)
				{
					if(last_y_height[playerno] > 0)	/* generate a puff */
					{
						for(i=0;i<1;i++)
						{
							puffs[last_plume].SpeedScale.vx = puffs[last_plume].SpeedScale.vy = puffs[last_plume].SpeedScale.vz = last_y_height[playerno];
									puffs[last_plume].timer = PLUME_LIFE;
	
							puffs[last_plume].global_pos.vx = Player[playerno].Pos.X;
							puffs[last_plume].global_pos.vy = Player[playerno].Pos.Y;
							puffs[last_plume].global_pos.vz = Player[playerno].Pos.Z;
	
							puffs[last_plume].inert.vx = (Player[playerno].Pos.X  - Player[playerno].LastPos.X)>>1;
							puffs[last_plume].inert.vy = (Player[playerno].Pos.Y  - Player[playerno].LastPos.Y)>>1;
							puffs[last_plume].inert.vz = (Player[playerno].Pos.Z  - Player[playerno].LastPos.Z)>>1;
	
							/* setup random inert part */
							rand_idx += 7;
							rand_idx = rand_idx & 0x0000001f;
							puffs[last_plume].inert.vx += (((randarray[rand_idx] - 16384) * last_y_height[playerno])>>13);
							rand_idx += 7;
							rand_idx = rand_idx & 0x0000001f;
							puffs[last_plume].inert.vy += (((randarray[rand_idx] - 16384) * last_y_height[playerno])>>13);
							rand_idx += 7;
							rand_idx = rand_idx & 0x0000001f;
							puffs[last_plume].inert.vz += (((randarray[rand_idx] - 2048) * last_y_height[playerno])>>13);
							last_plume++;
							if(last_plume >= MAX_PLUMES)
								last_plume = 0;
						}
					}
					else	/* generate only one trail */
					{
						/* rotate offset on board for start pos of plume */
						RotMatrix(&sclear,&arsemat);
	
						longarse = (Player[playerno].BoardAzimuth)>>12;
						RotMatrixY(longarse,&arsemat);
						TransMatrix(&arsemat,&clear);
						SetRotMatrix(&arsemat);
						SetTransMatrix(&arsemat);
						arse.vx = arse.vy = 0;

						/* place one sprite at each end of the board */
						arse.vz = 8192;
						ApplyRotMatrix(&arse,&(offsets[0]));

						arse.vz = -8192;
						ApplyRotMatrix(&arse,&(offsets[1]));

						/*	rotate the inertia based on the powerslide frame */
						arse.vx = 0;
						arse.vy = 0;

						temp = Player[playerno].Vel / 24;
						arse.vz = (-96 * temp)>>12;
						RotMatrix(&sclear,&arsemat);
						temp = Player[playerno].TurnInert>>8;
						longarse += temp;
						RotMatrixY(longarse,&arsemat);
						TransMatrix(&arsemat,&clear);
						SetRotMatrix(&arsemat);
						SetTransMatrix(&arsemat);
						ApplyRotMatrix(&arse,&inert);

						inert.vx = inert.vx<<8;
						inert.vy = inert.vy<<8;
						inert.vz = inert.vz<<8;


						arse.vx = (Player[playerno].Pos.X  - Player[playerno].LastPos.X)>>4;
						arse.vy = (Player[playerno].Pos.Y  - Player[playerno].LastPos.Y)>>4;
						arse.vz = (Player[playerno].Pos.Z  - Player[playerno].LastPos.Z)>>4;

						inert.vx += arse.vx<<3;
						inert.vy += arse.vy<<3;
						inert.vz += arse.vz<<3;
				
						for(i=0;i<2;i++)	/* do both sprites */
						{
							puffs[last_plume].timer = PLUME_LIFE;
	
							puffs[last_plume].global_pos.vx = 	Player[playerno].Pos.X;
							puffs[last_plume].global_pos.vy = 	Player[playerno].Pos.Y;
							puffs[last_plume].global_pos.vz = 	Player[playerno].Pos.Z;
	
							/* scale up the offset on board (12 bits are used for fractional bit) */
							puffs[last_plume].global_pos.vx += (offsets[i].vx)<<2;
							puffs[last_plume].global_pos.vy += (offsets[i].vy)<<2;
							puffs[last_plume].global_pos.vz += (offsets[i].vz)<<2;

							puffs[last_plume].global_pos.vx += (inert.vx);
							puffs[last_plume].global_pos.vy += (inert.vy);
							puffs[last_plume].global_pos.vz += (inert.vz);

							puffs[last_plume].inert.vx = inert.vx;
							puffs[last_plume].inert.vy = inert.vy;
							puffs[last_plume].inert.vz = inert.vz;
							
							/* setup random inert part */
							rand_idx += 7;
							rand_idx = rand_idx & 0x0000001f;
							arse.vx = (randarray[rand_idx] - 16384)>>2;
							rand_idx += 7;
							rand_idx = rand_idx & 0x0000001f;
							arse.vy = (randarray[rand_idx] - 16384)>>2;
							rand_idx += 7;
							rand_idx = rand_idx & 0x0000001f;
							arse.vz = (randarray[rand_idx] - 2048)>>2;

							ApplyRotMatrix(&arse,&Varse);
	
							puffs[last_plume].inert.vx += Varse.vx; 
							puffs[last_plume].inert.vy += Varse.vy;
							puffs[last_plume].inert.vz += Varse.vz;


							/* do a big powerslide plume except when we have stopped completely */
							if(Player[playerno].Vel > 0)
							{
								puffs[last_plume].SpeedScale.vx = puffs[last_plume].SpeedScale.vy = puffs[last_plume].SpeedScale.vz = (Player[playerno].Vel>>5) + 2048;
								if(Player[playerno].Fakie)
								{
									puffs[last_plume].SpeedScale.vx = puffs[last_plume].SpeedScale.vx<<1; 
									puffs[last_plume].SpeedScale.vy = puffs[last_plume].SpeedScale.vy<<1;
									puffs[last_plume].SpeedScale.vz = puffs[last_plume].SpeedScale.vz<<1;
								}
							}
							else
								puffs[last_plume].SpeedScale.vx = puffs[last_plume].SpeedScale.vy = puffs[last_plume].SpeedScale.vz = 0;
	
							last_plume++;
							if(last_plume >= MAX_PLUMES)
								last_plume = 0;
						}
				  	}
				}
			}		
		}
		last_y_height[playerno] = Player[playerno].JumpY>>2;
	
		SetRotMatrix(&(Player[playerno].Cam.ViewMatrix));
	
		for(i=0;i<MAX_PLUMES;i++)
		{
			if(puffs[i].timer >= 0)
			{
				local_loc.vx = (short)((-puffs[i].global_pos.vx>>12) + (Player[playerno].Cam.Pos.X>>12));
				local_loc.vy = (short)((puffs[i].global_pos.vy>>12) - (Player[playerno].Cam.Pos.Y>>12));
				local_loc.vz = (short)((puffs[i].global_pos.vz>>12) - (Player[playerno].Cam.Pos.Z>>12));
	
				ApplyRotMatrix(&local_loc,&(plume_loc[i]));
			}
		}
	
	    for(i=0;i<MAX_PLUMES;i++)
		{
			if(puffs[i].timer >= 0)
			{
	
				ObjectTrans.t[1] = plume_loc[i].vx;
				ObjectTrans.t[0] = plume_loc[i].vy;
				ObjectTrans.t[2] = plume_loc[i].vz;
	
				SetTransMatrix( &ObjectTrans );
	
				/* setup random z rot */
				if(paused)
				{
					RotMatrix(&sclear,&z_mat);
					RotMatrixZ(0,&z_mat);
				}
				else
				{
					rand_idx += 7;
					rand_idx = rand_idx & 0x0000001f;
					RotMatrix(&sclear,&z_mat);
					RotMatrixZ(randarray[rand_idx],&z_mat);
				}
				ScaleMatrix(&z_mat,&(puffs[i].SpeedScale));
				SetRotMatrix(&z_mat);
	
				RotTransPers3(&(puff_verts[0]),&(puff_verts[1]),&(puff_verts[2]),
								&(rtp_pos[0]),&(rtp_pos[1]),&(rtp_pos[2]),&address,&address);
				RotTransPers3(&(puff_verts[3]),&(puff_verts[4]),&(puff_verts[5]),
					 			&(rtp_pos[3]),&(rtp_pos[4]),&(rtp_pos[5]),&address,&address);
				RotTransPers(&(puff_verts[6]),&(rtp_pos[6]),&address,&address);
	
				col = puffs[i].timer<<4;
	
				ot_z = (plume_loc[i].vz>>2);
				if((ot_z > 0) && (ot_z < OTLENGTH))
				{
					/* do 1st tri */
	
					setPolyG3(g3_ptr);
					SetSemiTrans(g3_ptr,1);
					setRGB0(g3_ptr,col,col,col);
					setRGB1(g3_ptr,0x00,0x00,0x00);
					setRGB2(g3_ptr,0x00,0x00,0x00);
					g3_ptr->x0 = rtp_pos[0].vy;
					g3_ptr->y0 = rtp_pos[0].vx;
					g3_ptr->x1 = rtp_pos[1].vy;
					g3_ptr->y1 = rtp_pos[1].vx;
					g3_ptr->x2 = rtp_pos[2].vy;
					g3_ptr->y2 = rtp_pos[2].vx;
	
					addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);
	
					g3_ptr++;
					no_plume_tris++;
	
					/* do 2nd tri */
					setPolyG3(g3_ptr);
					SetSemiTrans(g3_ptr,1);
					setRGB0(g3_ptr,col,col,col);
					setRGB1(g3_ptr,0x00,0x00,0x00);
					setRGB2(g3_ptr,0x00,0x00,0x00);
					g3_ptr->x0 = rtp_pos[0].vy;
					g3_ptr->y0 = rtp_pos[0].vx;
					g3_ptr->x1 = rtp_pos[2].vy;
					g3_ptr->y1 = rtp_pos[2].vx;
					g3_ptr->x2 = rtp_pos[3].vy;
					g3_ptr->y2 = rtp_pos[3].vx;
	
					addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);
					g3_ptr++;
					no_plume_tris++;
	
					/* do 3rd tri */
					setPolyG3(g3_ptr);
					SetSemiTrans(g3_ptr,1);
					setRGB0(g3_ptr,col,col,col);
					setRGB1(g3_ptr,0x00,0x00,0x00);
					setRGB2(g3_ptr,0x00,0x00,0x00);
					g3_ptr->x0 = rtp_pos[0].vy;
					g3_ptr->y0 = rtp_pos[0].vx;
					g3_ptr->x1 = rtp_pos[3].vy;
					g3_ptr->y1 = rtp_pos[3].vx;
					g3_ptr->x2 = rtp_pos[4].vy;
					g3_ptr->y2 = rtp_pos[4].vx;
	
					addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);
					g3_ptr++;
					no_plume_tris++;
	
					/* do 4th tri */
					setPolyG3(g3_ptr);
					SetSemiTrans(g3_ptr,1);
					setRGB0(g3_ptr,col,col,col);
					setRGB1(g3_ptr,0x00,0x00,0x00);
					setRGB2(g3_ptr,0x00,0x00,0x00);
					g3_ptr->x0 = rtp_pos[0].vy;
					g3_ptr->y0 = rtp_pos[0].vx;
					g3_ptr->x1 = rtp_pos[4].vy;
					g3_ptr->y1 = rtp_pos[4].vx;
					g3_ptr->x2 = rtp_pos[5].vy;
					g3_ptr->y2 = rtp_pos[5].vx;
	
					addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);
					g3_ptr++;
					no_plume_tris++;
	
					/* do 5th tri */
					setPolyG3(g3_ptr);
					SetSemiTrans(g3_ptr,1);
					setRGB0(g3_ptr,col,col,col);
					setRGB1(g3_ptr,0x00,0x00,0x00);
					setRGB2(g3_ptr,0x00,0x00,0x00);
					g3_ptr->x0 = rtp_pos[0].vy;
					g3_ptr->y0 = rtp_pos[0].vx;
					g3_ptr->x1 = rtp_pos[5].vy;
					g3_ptr->y1 = rtp_pos[5].vx;
					g3_ptr->x2 = rtp_pos[6].vy;
					g3_ptr->y2 = rtp_pos[6].vx;
	
					addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);
					g3_ptr++;
					no_plume_tris++;
	
	
					/* do 6th tri */
					setPolyG3(g3_ptr);
					SetSemiTrans(g3_ptr,1);
					setRGB0(g3_ptr,col,col,col);
					setRGB1(g3_ptr,0x00,0x00,0x00);
					setRGB2(g3_ptr,0x00,0x00,0x00);
					g3_ptr->x0 = rtp_pos[0].vy;
					g3_ptr->y0 = rtp_pos[0].vx;
					g3_ptr->x1 = rtp_pos[6].vy;
					g3_ptr->y1 = rtp_pos[6].vx;
					g3_ptr->x2 = rtp_pos[1].vy;
					g3_ptr->y2 = rtp_pos[1].vx;
	
					addPrim(&(OrderingTable[otid][ot_z]),g3_ptr);
					g3_ptr++;
					no_plume_tris++;

					addPrim(&(OrderingTable[otid][ot_z]),&(transparencies[otid][no_plume_tpages[otid]]));
					no_plume_tpages[otid]++;

					//if(no_plume_tpages[otid] >= MAX_TPAGES)
					//	asm("break 0");
				}
			}
		}
	
		/* restore old rotation matrix */
		PopMatrix();
	}

	return(no_plume_tris);
}
	

/*******************************************************************/

void	UpdatePlume()
{
	long	i;

	for(i=0;i<MAX_PLUMES;i++)
	{
		if(puffs[i].timer >= 0)
		{
			puffs[i].timer--;

			puffs[i].global_pos.vx += puffs[i].inert.vx;
			puffs[i].global_pos.vy += puffs[i].inert.vy;
			puffs[i].global_pos.vz += puffs[i].inert.vz;
		}
	}
}



/************************************************/


void AddPlume(pos)
VECTOR 	*pos;
{
	long	i;

	if(puffs[last_plume].timer < 0)	/* if there is a spare plume available */
	{
		puffs[last_plume].timer = PLUME_LIFE;

		puffs[last_plume].global_pos.vx = pos->vx;
		puffs[last_plume].global_pos.vy = pos->vy;
		puffs[last_plume].global_pos.vz = pos->vz;

		puffs[last_plume].inert.vx = 0;
		puffs[last_plume].inert.vy = 0;
		puffs[last_plume].inert.vz = 0;

		puffs[last_plume].SpeedScale.vx = puffs[last_plume].SpeedScale.vy = puffs[last_plume].SpeedScale.vz = 16000;

		last_plume++;
		if(last_plume >= MAX_PLUMES)
			last_plume = 0;

	}
}

