
	opt	w+		; assembly warnings
	opt	at-		; temporary variable use
	opt	c+		; case sensitivity

	SECTION	.text

	include	"russ\i\gte.i"
	include	"russ\i\russ.i"
	Global	RussRotMeshG3Szmax
	Global	RussRotMeshG3SzmaxPara

	xref	storepcount
	xref	normalspot
	

*************************************************************************************************************
*
*	RussRotMeshS() - Called from tracks.c .
*				  
*				  
*				 
*				 
*				 
*
*				 a0: points to the tmesh structure
*				 a1: points to the 1st primitive G3
*				 a2: points to start of ot
*
*
*				 a0 used 4: storing rgb0 result
*				 a1 used 4: storing rgb1 result
*				 a2 used 4: storing head of ot
*				 a3 used 4: storing normals ptr
*				 s0 used 4: various work area bits
*							colour loading
*							normal loading
*							addprim tag calcs
*				 s1 used 4: various work area bits
*							colour loading
*							normal loading
*				 s2 used 4: various work area bits
*							colour loading
*							addprim tag calcs
*				 s3 used 4: addprim calcs
*				 s4 used 4: addprim calcs
*				 s5 used 4: storing the dpq p val
*				 s6 used 4: various 
*							max z calcs
*							vertex loading
*				 s7 used 4:	various
*							max z calcs
*							vertex loading
*				 t0 used 4: vertex ptr
*			 	 t1 used 4: colours ptr
*				 t2 used 4: poly ptr
*				 t3 used 4: end verts ptr
*				 t4 used 4: various
*							vertex loading
*							max z calc
*				 t5 used 4: sxy storing of previous frame
*				 t6 used 4: sxy storing
*				 t7 used 4: sxy storing
*				 t8 used 4: various
*							sxy storing
*							max z calc
*				 t9 used 4: various
*							z clip
*							normal clip
*							addprim
*				 v0 used 4: col2
*				 v1 used 4: col3
*
*
*************************************************************************************************************

RegSave	dw	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dw	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


;***********************************************************
; RussRotMeshG3Szmax
; does 2 rtp each cell instead of 1 rtp3 & 1 rtp
; uses max(z0,z1,z2,z3) for depth sorting
;************************************************************** 

RussRotMeshG3Szmax

	RUSSPUSHREGS

	lw		t3,$10(a0)		; load the length of the mesh in t3
	lw		t0,(a0)			; load source verts ptr to t0
	lw		t1,$c(a0)		; load source colours ptr to t1
	lw		a3,$4(a0)		; load source normal ptr to a3
	addi	t2,a1,$0		; shift the 1st prim ptr to t2

	sll		t3,t3,3			; calc how many bytes to end of vert list
	add		t3,t3,t0		; calc verts end address
	;addi	t3,t3,-$8		; calc verts end address - 2

		; do the 1st 2 verts
do_first_2
	lw		t4,(t0)			; load verts+0, verts+1
	lw		t5,$4(t0)
	lw		t6,$8(t0)
	lw		t7,$c(t0)
	
	mtc2	t4,C2_VXY0		; move 1st vert to the gte
	mtc2	t5,C2_VZ0
	nop
	nop
	cop2	RotTransPers	; do the do
	mfc2	t4,C2_SZ2		; get the z
	mfc2	t5,C2_SXY2		; get x n y

	
		; set up colour 0
	lw		s0,(a3)			; get xy of normal
	lw		s1,$4(a3)		; get z of normal
	lw		s2,(t1)			; get col
	
	mtc2	s0,C2_VXY0		; load xy
	mtc2	s1,C2_VZ0		; load z
	mtc2	s2,C2_RGB0		; load the col
	mtc2	s2,C2_RGB		; load the col?
	nop						; leave the p value there from the last rtp
	nop
	cop2	NormalColorDpq	; do col 0
	nop
	nop
	mfc2	a0,C2_RGB0		; get rgb0 from gte
	

	mtc2	t6,C2_VXY0		; move 2nd vert to the gte
	mtc2	t7,C2_VZ0
	nop
	nop
	cop2	RotTransPers	; do the do
	mfc2	s6,C2_SZ2		; get the z
	mfc2	t6,C2_SXY2		; get the x n y	


		; set up colour 1
	lw		s0,$8(a3) 		; get xy of normal
	lw		s1,$c(a3)		; get z of normal
	lw		s2,$4(t1)		; get col


	mtc2	s0,C2_VXY0		; load xy
	mtc2	s1,C2_VZ0		; load z
	mtc2	s2,C2_RGB0		; load the col
	mtc2	s2,C2_RGB		; load the col?
	nop						; leave the p value there from the last rtp
	nop
	cop2	NormalColorDpq	; do col 1
	nop
	nop
	mfc2	a1,C2_RGB0		; get rgb1 from gte
	

	addi	t0,t0,$10		; increment the verts ptr by 2
	addi	a3,a3,$10		; increment the normals ptr by 2
	
		; figure out if z0 > z1

	sub		s7,t4,s6		; s7 = z0 - z1
	bgtz	s7,bigger_z0	
	nop
	move	t4,s6			

bigger_z0

lets_go2   ; here t4 = max(z0,z1), t5 = sxy0, t6 = sxy1
	
		; do the next 2 verts
	lw		t7,(t0)		; load vert+2
	lw		t8,$4(t0)
	
	mtc2	t7,C2_VXY0		; move vert 2 to the gte
	mtc2	t8,C2_VZ0
	nop
	nop
	cop2	RotTransPers	; do the do

	mfc2	t7,C2_SXY2		; get the x n y
	mfc2	t8,C2_SZ2		; get the z


		; set up colour 2
	lw		s0,(a3)			; get xy of normal
	lw		s1,$4(a3)		; get z of normal
	lw		s2,$8(t1) 		; get col


	mtc2	s0,C2_VXY0		; load xy
	mtc2	s1,C2_VZ0		; load z
	mtc2	s2,C2_RGB0		; load the col
	mtc2	s2,C2_RGB		; load the col?
	nop						; leave the p value there from the last rtp
	nop
	cop2	NormalColorDpq	; do col 2
	nop
	nop
	mfc2	v0,C2_RGB0		; get rgb2 from gte


	lw		s6,$8(t0)		; load vert+3
	lw		s7,$c(t0)
	
	mtc2	s6,C2_VXY0		; move vert 3 to the gte
	mtc2	s7,C2_VZ0
	nop
	nop
	cop2	RotTransPers	; do the do

	mfc2	s7,C2_SZ2		; get the z
	nop
	

		; set up colour 3
	lw		s0,$8(a3) 		; get xy of normal
	lw		s1,$c(a3)		; get z of normal
	lw		s2,$c(t1)		; get col
	
	
	mtc2	s0,C2_VXY0		; load xy
	mtc2	s1,C2_VZ0		; load z
	mtc2	s2,C2_RGB0		; load the col
	mtc2	s2,C2_RGB		; load the col?
	nop						; leave the p value there from the last rtp
	nop
	cop2	NormalColorDpq	; do col 1
	nop
	nop
	mfc2	v1,C2_RGB0		; get rgb1 from gte
	

		; figure out if z2 > z3
	sub		s6,t8,s7		; s6 = z2 - z3 
	bgtz	s6,bigger_z2	
	nop
	move	t8,s7			

bigger_z2
	
		;figure out if max(z0,z1) > max(z2,z3)
	sub		s7,t4,t8	; s7 = max(z0,z1) - max(z2,z3)
	bgtz 	s7,bigger_maxz0z1
	nop
	move	t4,t8		; store max(z0,z1,z2,z3) in t4
	move	s6,t8		; store max(z2,z3) in s6 for next loop
	j		next0
	nop		

bigger_maxz0z1		
	move	s6,t8		; store max(z2,z3) in s6 for next loop

next0
	srl		t4,t4,2			; t4 now = max(z0,z1,z2,z3), s6 = max(z2,z3)
	sll		t4,t4,2			; clear lower 2 bits 
	mfc2	t8,C2_SXY2		; now t5 = sxy0, t6 = sxy1, t7 = sxy2 t8 = sxy3

		; do the next loop code

	addi	t0,t0,$10		; increment the verts ptr by 2
	addi	t1,t1,$8		; increment the colours pointer by 2
	addi	t2,t2,$38		; increment the poly_g3 pointer by 2
	addi	a3,a3,$10		; increment normal ptr by 2

	mfc2	s5,C2_IR0		; get the dpq

	nop

	addi	t9,t4,-$1c18		; check if too far (1398)
  	bgtz	t9,crap_cell2
   	nop
	addi	t9,t4,-$20		; check if too near (32)
  	bltz	t9,crap_cell2
   	nop

	mtc2	t5,C2_SXY0		; load sxy 0,1,2 for normal clip
	mtc2	t6,C2_SXY1	
	mtc2	t7,C2_SXY2	
	nop
	nop

	cop2	NormalClip		; check the back face on the 1st tri, the sxys are still in the gte
	mfc2	t9,C2_MAC0		; get result
	nop
	bltz	t9,crap_tri2	; forget the 1st tri
	nop

		; do the 1st tri

	sw		t5,-$30(t2)		; put xys in
	sw		t6,-$28(t2)			
	sw		t7,-$20(t2)			
	
	; addprim

	add		t9,t4,a2		; add on the base address of the ot WITH THE MAX(Z0,Z1,Z2,Z3)
	move	s4,t9			; duplicate tag address
	lui		s2,$0600		; get the tag val of the prim
	lw		s0,(t9)			; get the tag val of the ot
	addi	s3,t2,-$38
	or		s2,s2,s0		; combine polys len with ots next ptr
	sll		s3,s3,8	
	srl		s3,s3,8			; clear the top 8 bits (get the 24 bit address of prim)
	sw		s2,-$38(t2)			; store in prim header
	sw		s3,(s4)			; put in ot

	lui		t9,$3000		; set code
	or		t9,t9,a0
	sw		t9,-$34(t2)		; put rgbs in
	sw		a1,-$2c(t2)			
	sw		v0,-$24(t2)		


	
crap_tri2

	mtc2	t6,C2_SXY0		; set the normalclip regs (132)
	mtc2	t8,C2_SXY1		
	mtc2	t7,C2_SXY2		
	nop
	nop
	cop2	NormalClip		; do the do
	mfc2	t9,C2_MAC0		; get result
	nop
	bltz	t9,crap_cell2		
	nop

	addi	t2,t2,$1c		; increment the poly_g3 pointer by 1

	sw		t6,-$30(t2)		; put xys in (123)
	sw		t7,-$28(t2)			
	sw		t8,-$20(t2)			
	

		; do addprim

	add		t9,t4,a2		; add on the base address of the ot with max(z0,z1,z2,z3)
	move	s4,t9			; duplicate tag address
	lui		s2,$0600		; get the tag val of the prim
	lw		s0,(t9)			; get the tag val of the ot
	addi	s3,t2,-$38
	or		s2,s2,s0		; combine polys len with ots next ptr
	sll		s3,s3,8	
	srl		s3,s3,8			; clear the top 8 bits (get the 24 bit address of prim)
	sw		s2,-$38(t2)			; store in prim header
	sw		s3,(s4)			; put in ot
	
	lui		t9,$3000		; set code
	or		t9,t9,a1
	sw		t9,-$34(t2)		; put rgbs in
	sw		v0,-$2c(t2)			
	sw		v1,-$24(t2)		
	
	addi	t2,t2,-$1c		; increment the poly_g3 pointer by 1

		; end addprim

crap_cell2
	move 	t4,s6			; move max(z2,z3) into max(z0,z1) register for next loop
	move	t5,t7			; move sxy2 into sxy0 register register for next loop
	move	t6,t8			; move sxy3 into sxy1 register register for next loop
	move	a0,v0			; move col2 into col0 register
	move	a1,v1			; move col3 into col1 register

	bne		t0,t3,lets_go2	
	nop


ending2
	RUSSPOPREGS
	j 	ra
	nop			; leave this here cos of the 1 intruction delay after the jump
	


;***********************************************************
; RussRotMeshG3SzmaxPara
; does same as RussRotMeshG3S, but ther is no max z &
; all depth zds are at otlength -2;
;************************************************************** 

RussRotMeshG3SzmaxPara

	RUSSPUSHREGS	
		
	lw		t3,$10(a0)		; load the length of the mesh in t3
	lw		t0,(a0)			; load source verts ptr to t0
	lw		t1,$c(a0)		; load source colours ptr to t1
	lw		a3,$4(a0)		; load source normal ptr to a3
	addi	t2,a1,$0		; shift the 1st prim ptr to t2

	sll		t3,t3,3			; calc how many bytes to end of vert list
	add		t3,t3,t0		; calc verts end address
			
		
		; do the 1st 2 verts
do_first_2a
	lw		t4,(t0)			; load verts+0, verts+1
	lw		t5,$4(t0)
	lw		t6,$8(t0)
	lw		t7,$c(t0)
	
	mtc2	t4,C2_VXY0		; move 1st vert to the gte
	mtc2	t5,C2_VZ0
	nop
	nop
	cop2	RotTransPers	; do the do
	mfc2	t4,C2_SZ2		; get the z
	mfc2	t5,C2_SXY2		; get x n y

		; set up colour 0
	lw		s0,(a3)			; get xy of normal
	lw		s1,$4(a3)		; get z of normal
	lw		s2,(t1)			; get col
	mtc2	s0,C2_VXY0		; load xy
	mtc2	s1,C2_VZ0		; load z
	mtc2	s2,C2_RGB0		; load the col
	mtc2	s2,C2_RGB		; load the col?
	nop						; leave the p value there from the last rtp
	nop
	cop2	NormalColorDpq	; do col 0
	nop
	nop
	mfc2	a0,C2_RGB0		; get rgb0 from gte
	



	mtc2	t6,C2_VXY0		; move 2nd vert to the gte
	mtc2	t7,C2_VZ0
	nop
	nop
	cop2	RotTransPers	; do the do
	mfc2	s6,C2_SZ2		; get the z
	mfc2	t6,C2_SXY2		; get the x n y	

		; set up colour 1
	lw		s0,$8(a3) 		; get xy of normal
	lw		s1,$c(a3)		; get z of normal
	lw		s2,$4(t1)		; get col
	mtc2	s0,C2_VXY0		; load xy
	mtc2	s1,C2_VZ0		; load z
	mtc2	s2,C2_RGB0		; load the col
	mtc2	s2,C2_RGB		; load the col?
	nop						; leave the p value there from the last rtp
	nop
	cop2	NormalColorDpq	; do col 1
	nop
	nop
	mfc2	a1,C2_RGB0		; get rgb1 from gte
	

		
	addi	t0,t0,$10		; increment the verts ptr by 2
	addi	a3,a3,$10		; increment the normals ptr by 2
	
		; figure out if z0 > z1

	sub		s7,t4,s6		; s7 = z0 - z1
	bgtz	s7,bigger_z0a	
	nop
	move	t4,s6			

bigger_z0a



lets_go2a   ; here t4 = max(z0,z1), t5 = sxy0, t6 = sxy1
	
		; do the next 2 verts
	lw		t7,(t0)		; load vert+2
	
	lw		t8,$4(t0)
	nop
	nop
	mtc2	t7,C2_VXY0		; move vert 2 to the gte
	
	mtc2	t8,C2_VZ0
	
	nop
	nop
	cop2	RotTransPers	; do the do

	mfc2	t7,C2_SXY2		; get the x n y

		; set up colour 2
	lw		s0,(a3)			; get xy of normal
	lw		s1,$4(a3)		; get z of normal
	lw		s2,$8(t1) 		; get col
	mtc2	s0,C2_VXY0		; load xy
	mtc2	s1,C2_VZ0		; load z
	mtc2	s2,C2_RGB0		; load the col
	mtc2	s2,C2_RGB		; load the col?
	nop						; leave the p value there from the last rtp
	nop
	cop2	NormalColorDpq	; do col 2
	nop
	nop
	mfc2	v0,C2_RGB0		; get rgb2 from gte






	lw		s6,$8(t0)		; load vert+3
	lw		s7,$c(t0)
	
	mtc2	s6,C2_VXY0		; move vert 3 to the gte
	mtc2	s7,C2_VZ0
	nop
	nop
	cop2	RotTransPers	; do the do

	mfc2	t4,C2_SZ2		; get the z
	nop


		; set up colour 3
	lw		s0,$8(a3) 		; get xy of normal
	lw		s1,$c(a3)		; get z of normal
	lw		s2,$c(t1)		; get col
	mtc2	s0,C2_VXY0		; load xy
	mtc2	s1,C2_VZ0		; load z
	mtc2	s2,C2_RGB0		; load the col
	mtc2	s2,C2_RGB		; load the col?
	nop						; leave the p value there from the last rtp
	nop
	cop2	NormalColorDpq	; do col 1
	nop
	nop
	mfc2	v1,C2_RGB0		; get rgb1 from gte
	

	
next0a
	srl		t4,t4,2			; t4 now = max(z0,z1,z2,z3), s6 = max(z2,z3)
	sll		t4,t4,2			; clear lower 2 bits 
	
	mfc2	t8,C2_SXY2		; now t5 = sxy0, t6 = sxy1, t7 = sxy2 t8 = sxy3

		; do the next loop code

	addi	t0,t0,$10		; increment the verts ptr by 2
	addi	t1,t1,$8		; increment the colours pointer by 2
	addi	t2,t2,$38		; increment the poly_g3 pointer by 2
	addi	a3,a3,$10		; increment the normals ptr by 2

	mfc2	s5,C2_IR0		; get the dpq

	nop

   	nop

	mtc2	t5,C2_SXY0		; load sxy 0,1,2 for normal clip
	mtc2	t6,C2_SXY1	
	mtc2	t7,C2_SXY2	
	nop
	nop

	;cop2	NormalClip		; check the back face on the 1st tri, the sxys are still in the gte
	;mfc2	t9,C2_MAC0		; get result
	;nop
	;bltz	t9,crap_tri2	; forget the 1st tri
	nop

		; do the 1st tri

	sw		t5,-$30(t2)		; put xys in
	sw		t6,-$28(t2)			
	sw		t7,-$20(t2)			
	
	; gots still to finish cols


	; addprim


	move	t9,a2			; set z depth to ot entry passed in 
	move	s4,t9			; duplicate tag address
	lui		s2,$0600		; get the tag val of the prim
	lw		s0,(t9)			; get the tag val of the ot
	addi	s3,t2,-$38
	or		s2,s2,s0		; combine polys len with ots next ptr
	sll		s3,s3,8	
	srl		s3,s3,8			; clear the top 8 bits (get the 24 bit address of prim)
	sw		s2,-$38(t2)			; store in prim header
	sw		s3,(s4)			; put in ot




	;mfc2	s0,C2_RGB0		; get rgbs from gte
	;mfc2	s1,C2_RGB1	
	;mfc2	s2,C2_RGB2	

	lui		t9,$3000		; set code
	or		t9,t9,a0
	sw		t9,-$34(t2)		; put rgbs in
	sw		a1,-$2c(t2)			
	sw		v0,-$24(t2)		


	
crap_tri2a

	mtc2	t6,C2_SXY0		; set the normalclip regs (132)
	
	mtc2	t8,C2_SXY1		
	
	mtc2	t7,C2_SXY2		
	nop
	nop
	nop

	addi	t2,t2,$1c		; increment the poly_g3 pointer by 1

	sw		t6,-$30(t2)		; put xys in (123)
	sw		t7,-$28(t2)			
	
	sw		t8,-$20(t2)			
	

		; do addprim

	move	t9,a2			; set z depth to ot entry passed in 
	move	s4,t9			; duplicate tag address
	lui		s2,$0600		; get the tag val of the prim
	lw		s0,(t9)			; get the tag val of the ot
	addi	s3,t2,-$38
	or		s2,s2,s0		; combine polys len with ots next ptr
	sll		s3,s3,8	
	srl		s3,s3,8			; clear the top 8 bits (get the 24 bit address of prim)
	sw		s2,-$38(t2)			; store in prim header
	sw		s3,(s4)			; put in ot
	
	lui		t9,$3000		; set code
	or		t9,t9,a1
	sw		t9,-$34(t2)		; put rgbs in
	sw		v0,-$2c(t2)			
	sw		v1,-$24(t2)		
	
	addi	t2,t2,-$1c		; increment the poly_g3 pointer by 1

		; end addprim

crap_cell2a
	move 	t4,s6			; move max(z2,z3) into max(z0,z1) register for next loop
	move	t5,t7			; move sxy2 into sxy0 register register for next loop
	
	move	t6,t8			; move sxy3 into sxy1 register register for next loop
	move	a0,v0			; move col2 into col0 register
	move	a1,v1			; move col3 into col1 register


	bne		t0,t3,lets_go2a	
	nop


;ending2a
	RUSSPOPREGS

	j 	ra
	nop			; leave this here cos of the 1 intruction delay
	





		



 