#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "buildobj.h"
#include <inline_o.h>
#include <gtemac.h>


typedef long 	 			int32;
typedef unsigned long		uint32;
typedef short int			int16;
typedef unsigned short int	uint16;
typedef char				int8;
typedef unsigned char		uint8;


long				fin,count1,count2,count3;
long				filesize;
long				namelength;
long				notexturedmats;
long				tempanswer;
long				z,d;		/* temp */
long				geomx,geomy;
long				geomscreen;
long				noboundboxes;
char				filebuffer[200000];
char				ObjectSpace[400000];
char				tidfilebuffer[5000];
char				*tidfileptr;
char				outbuffer[200000];
char 				*fileptr;
char 				*polystartptr;
char				*boundstartptr;
char				mvfilename[21]={'o','b','j','l','i','s','t','s','/',0,0,0,0,0,0,0,0,0,0,0,0 };
char				psxobjname[18]={'p','s','x','/',0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
char				psxchname[18]={'p','s','x','/',0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

unsigned short		charindex,filecharindex,outcharindex;
unsigned int		textpage,clutpage;
unsigned int		x=255;
unsigned int		y=255;
long				flipvs=0;
long				paddebounced=0;
long				parseend=0;
int					i,j,k;
long				speed;
uint8				trackno;

TIM_IMAGE	timheader;
char		cdres[2];

typedef	struct moveobj
{
	unsigned char	trackno;
	unsigned char	startstrip;
	unsigned char 	endstrip;
	unsigned char	objectno;
	unsigned short	roty;
	unsigned short	flag;
	long			startx;
	long			starty;
	long			startz;
	long			movex;
	long			movey;
	long			movez;
	long			posx;
	long			posy;
	long			posz;
	long			finx;
	long			finy;
	long			finz;
}moveobj;

typedef struct objpolygon
{
	long	numverts;
	long	polytype;
	long	tmatid;
	long 	vertptr;
	SVECTOR normals[4];
	long	textus;
	long	textvs;
	CVECTOR basecolour;
}objpolygon;

typedef struct objcoll
{
	uint32	type;
	VECTOR	info[4];
}objcoll;


typedef struct objheader
{
	uint8		type;	/* for special types like cable cars etc. */
	uint8		loaded;
	SVECTOR 	*vertptr;
	objpolygon  *polyptr;
	objcoll		*collptr;
	long		numpolys;
	long		numverts;
	long		numcolls;
} objheader;

char	objectname[15][400][60];

objheader	ChillObjects[210];

moveobj	*moveobjptr;
long	totalmovables;
long	checksum;
long	checksum2;
unsigned char	thistrack;
unsigned char	nomovables;

long				fntid1;
long				fntid2;
long				fntid3;
long				fntid4;
long				fntid5;
long				fntid6;
long				c1,c2;
POLY_F4  			clearsquare[2];
MATRIX				MyLocalLight;
MATRIX				MyColourMatrix;
CVECTOR	    		PrimaryColourVector;
CVECTOR				fc,bc;		/* temp */
DRAWENV				drawenv[2];
DISPENV				dispenv[2];
long				OT[2][4096];
long				*otptr;
long				firstscreendrawn=0;
long				arseexit=0;
long				otid=0;
long				display_id=0;
long				thisotz;
long				thisp;
char				primstr[10]={'f','t','4',20,0,0,0,0,0,0};
long				checksum;
long				issaved=0;
long				checkvalue;
long				tempvz;

uint32		fh;
long		filesize;
uint8		*objloadptr;
uint32		objaddress;
uint32		a1,a2,a3,a4;
long		*longptr;
uint8		thisobj;


/* playstation stuff */
void initialiseobjectnames(void)
{
/* forest objects */

	sprintf(&objectname[0][0][0],"objects/forest/wrap.obj");
	sprintf(&objectname[0][1][0],"objects/forest/tree2.obj");
	sprintf(&objectname[0][2][0],"objects/forest/tree1.obj");
	sprintf(&objectname[0][3][0],"objects/forest/tree3.obj");
	sprintf(&objectname[0][4][0],"objects/forest/tree4.obj");
	sprintf(&objectname[0][5][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][6][0],"objects/forest/pik1.obj");
	sprintf(&objectname[0][7][0],"objects/forest/pik2.obj");
	sprintf(&objectname[0][8][0],"objects/forest/pik3.obj");
	sprintf(&objectname[0][9][0],"objects/forest/pik4.obj");
	sprintf(&objectname[0][10][0],"objects/forest/pik5.obj");
	sprintf(&objectname[0][11][0],"objects/forest/col11.obj");
	sprintf(&objectname[0][12][0],"objects/forest/car12.obj");
	sprintf(&objectname[0][13][0],"objects/forest/car13.obj");
	sprintf(&objectname[0][14][0],"objects/forest/trn14.obj");
	sprintf(&objectname[0][15][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][16][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][17][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][18][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][19][0],"objects/forest/vbarn.obj");
	sprintf(&objectname[0][20][0],"objects/forest/barn.obj");
	sprintf(&objectname[0][21][0],"objects/forest/stump.obj");
	sprintf(&objectname[0][22][0],"objects/forest/loggy.obj");
	sprintf(&objectname[0][23][0],"objects/forest/pole.obj");
	sprintf(&objectname[0][24][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][25][0],"objects/forest/start.obj");
	sprintf(&objectname[0][26][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][27][0],"objects/forest/church.obj");
	sprintf(&objectname[0][28][0],"objects/forest/hotel.obj");
	sprintf(&objectname[0][29][0],"objects/forest/shed.obj");
	sprintf(&objectname[0][30][0],"objects/forest/house1.obj");
	sprintf(&objectname[0][31][0],"objects/forest/stnhs.obj");
	sprintf(&objectname[0][32][0],"objects/forest/cabin.obj");
	sprintf(&objectname[0][33][0],"objects/forest/fence.obj");
	sprintf(&objectname[0][34][0],"objects/forest/picnic.obj");
	sprintf(&objectname[0][35][0],"objects/forest/bush.obj");
	sprintf(&objectname[0][36][0],"objects/forest/bale.obj");
	sprintf(&objectname[0][37][0],"objects/forest/wall.obj");
	sprintf(&objectname[0][38][0],"objects/forest/bigsign.obj");
	sprintf(&objectname[0][39][0],"objects/forest/sign1.obj");
	sprintf(&objectname[0][40][0],"objects/forest/sign2.obj");
	sprintf(&objectname[0][41][0],"objects/forest/sign3.obj");
	sprintf(&objectname[0][42][0],"objects/forest/bin.obj");
	sprintf(&objectname[0][43][0],"objects/forest/crock.obj");
	sprintf(&objectname[0][44][0],"objects/forest/rjump.obj");
	sprintf(&objectname[0][45][0],"objects/forest/gate.obj");
	sprintf(&objectname[0][46][0],"objects/forest/rbrid.obj");
	sprintf(&objectname[0][47][0],"objects/forest/snowcat.obj");
	sprintf(&objectname[0][48][0],"objects/forest/tent.obj");
	sprintf(&objectname[0][49][0],"objects/forest/van.obj");
	sprintf(&objectname[0][50][0],"objects/forest/ccar.obj");
	sprintf(&objectname[0][51][0],"objects/forest/cend.obj");
	sprintf(&objectname[0][52][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][53][0],"objects/forest/cow.obj");
	sprintf(&objectname[0][54][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][55][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][56][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][57][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][58][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][59][0],"objects/forest/bbrid.obj");
	sprintf(&objectname[0][60][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][61][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][62][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][63][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][64][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][65][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][66][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][67][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][68][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][69][0],"objects/forest/tower.obj");
	sprintf(&objectname[0][70][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][71][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][72][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][73][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][74][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][75][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][76][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][77][0],"objects/forest/exhut.obj");
	sprintf(&objectname[0][78][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][79][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][80][0],"objects/forest/hmpbd.obj");
	sprintf(&objectname[0][81][0],"objects/forest/tree5.obj");    /* icicl */
	sprintf(&objectname[0][82][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][83][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][84][0],"objects/forest/slog1.obj");
	sprintf(&objectname[0][85][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][86][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][87][0],"objects/forest/minsh.obj");
	sprintf(&objectname[0][88][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][89][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][90][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][91][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][92][0],"objects/forest/rbri2.obj");
	sprintf(&objectname[0][93][0],"objects/forest/stalc.obj");
	sprintf(&objectname[0][94][0],"objects/forest/stalg.obj");
	sprintf(&objectname[0][95][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][96][0],"objects/forest/tree5.obj");     /* stilt */
	sprintf(&objectname[0][97][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][98][0],"objects/forest/stnsk.obj");
	sprintf(&objectname[0][99][0],"objects/forest/tree5.obj");
	sprintf(&objectname[0][100][0],"objects/forest/chute.obj");
	sprintf(&objectname[0][101][0],"objects/forest/bigtr.obj");
	sprintf(&objectname[0][102][0],"objects/forest/fenc1.obj");
	sprintf(&objectname[0][103][0],"objects/forest/fenc2.obj");
	sprintf(&objectname[0][104][0],"objects/forest/targ1.obj");
	sprintf(&objectname[0][105][0],"objects/forest/targ2.obj");
	sprintf(&objectname[0][106][0],"objects/forest/campos.obj");
	sprintf(&objectname[0][107][0],"objects/forest/rount.obj");



/* sports */

	sprintf(&objectname[2][0][0],"objects/sport/wrap.obj");
	sprintf(&objectname[2][1][0],"objects/sport/tree1.obj");
	sprintf(&objectname[2][2][0],"objects/sport/tree2.obj");
	sprintf(&objectname[2][3][0],"objects/sport/tree3.obj");
	sprintf(&objectname[2][4][0],"objects/sport/tree4.obj");
	sprintf(&objectname[2][5][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][6][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][7][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][8][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][9][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][10][0],"objects/sport/sgate.obj");
	sprintf(&objectname[2][11][0],"objects/sport/sign4.obj");
	sprintf(&objectname[2][12][0],"objects/sport/sign5.obj");
	sprintf(&objectname[2][13][0],"objects/sport/skilift.obj");
	sprintf(&objectname[2][14][0],"objects/sport/snowblow.obj");
	sprintf(&objectname[2][15][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][16][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][17][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][18][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][19][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][20][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][21][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][22][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][23][0],"objects/sport/bigpole1.obj");
	sprintf(&objectname[2][24][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][25][0],"objects/sport/stple.obj");
	sprintf(&objectname[2][26][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][27][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][28][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][29][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][30][0],"objects/sport/hoos1.obj");
	sprintf(&objectname[2][31][0],"objects/sport/stonhoos.obj");
	sprintf(&objectname[2][32][0],"objects/sport/logcabin.obj");
	sprintf(&objectname[2][33][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][34][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][35][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][36][0],"objects/sport/bale.obj");
	sprintf(&objectname[2][37][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][38][0],"objects/sport/bigsign.obj");
	sprintf(&objectname[2][39][0],"objects/sport/sign1.obj");
	sprintf(&objectname[2][40][0],"objects/sport/sign2.obj");
	sprintf(&objectname[2][41][0],"objects/sport/sign3.obj");
	sprintf(&objectname[2][42][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][43][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][44][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][45][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][46][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][47][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][48][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][49][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][50][0],"objects/sport/ccar.obj");
	sprintf(&objectname[2][51][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][52][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][53][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][54][0],"objects/sport/pylon.obj");
	sprintf(&objectname[2][55][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][56][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][57][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][58][0],"objects/sport/dubpole.obj");
	sprintf(&objectname[2][59][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][60][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][61][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][62][0],"objects/sport/bcable.obj");
	sprintf(&objectname[2][63][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][64][0],"objects/sport/bhotel.obj");
	sprintf(&objectname[2][65][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][66][0],"objects/sport/booth.obj");
	sprintf(&objectname[2][67][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][68][0],"objects/sport/bigpole.obj");
	sprintf(&objectname[2][69][0],"objects/sport/tower.obj");
	sprintf(&objectname[2][70][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][71][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][72][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][73][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][74][0],"objects/sport/vehbarn.obj");
	sprintf(&objectname[2][75][0],"objects/sport/chbot.obj");
	sprintf(&objectname[2][76][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][77][0],"objects/sport/explshak.obj");
	sprintf(&objectname[2][78][0],"objects/sport/glcarbot.obj");
	sprintf(&objectname[2][79][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][80][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][81][0],"objects/sport/tree5.obj");    /* icicl */
	sprintf(&objectname[2][82][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][83][0],"objects/sport/kiosk.obj");
	sprintf(&objectname[2][84][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][85][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][86][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][87][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][88][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][89][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][90][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][91][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][92][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][93][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][94][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][95][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][96][0],"objects/sport/stilts.obj");     /* stilt */
	sprintf(&objectname[2][97][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][98][0],"objects/sport/stonshak.obj");
	sprintf(&objectname[2][99][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][100][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][101][0],"objects/sport/slalo.obj");
	sprintf(&objectname[2][102][0],"objects/sport/slalo.obj");
	sprintf(&objectname[2][103][0],"objects/sport/bil01.obj");
	sprintf(&objectname[2][104][0],"objects/sport/bil02.obj");
	sprintf(&objectname[2][105][0],"objects/sport/bil03.obj");
	sprintf(&objectname[2][106][0],"objects/sport/campos.obj");
	sprintf(&objectname[2][107][0],"objects/sport/bil05.obj");
	sprintf(&objectname[2][108][0],"objects/sport/bil06.obj");
	sprintf(&objectname[2][109][0],"objects/sport/bil07.obj");
	sprintf(&objectname[2][110][0],"objects/sport/bil08.obj");
	sprintf(&objectname[2][111][0],"objects/sport/bil04.obj");
	sprintf(&objectname[2][112][0],"objects/sport/bri112a.obj");
	sprintf(&objectname[2][113][0],"objects/sport/bri113a.obj");

	sprintf(&objectname[2][114][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][115][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][116][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][117][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][118][0],"objects/sport/tree5.obj");
	sprintf(&objectname[2][119][0],"objects/sport/ove119a.obj");
	sprintf(&objectname[2][120][0],"objects/sport/ove120a.obj");
	sprintf(&objectname[2][121][0],"objects/sport/ove121a.obj");
	sprintf(&objectname[2][122][0],"objects/sport/ove122a.obj");
	sprintf(&objectname[2][123][0],"objects/sport/ove123a.obj");
	sprintf(&objectname[2][124][0],"objects/sport/ove124a.obj");
	sprintf(&objectname[2][125][0],"objects/sport/ove125a.obj");
	sprintf(&objectname[2][126][0],"objects/sport/ove126a.obj");
	sprintf(&objectname[2][127][0],"objects/sport/ove127a.obj");
	sprintf(&objectname[2][128][0],"objects/sport/ove128a.obj");
	sprintf(&objectname[2][129][0],"objects/sport/ove129a.obj");
	sprintf(&objectname[2][130][0],"objects/sport/ove130a.obj");
	sprintf(&objectname[2][131][0],"objects/sport/ove131a.obj");
	sprintf(&objectname[2][132][0],"objects/sport/ove132a.obj");
	sprintf(&objectname[2][135][0],"objects/sport/barr1.obj");
	sprintf(&objectname[2][136][0],"objects/sport/sgate.obj");




/* glacier objects */
	sprintf(&objectname[3][0][0],"objects/glacier/wrap.obj");
	sprintf(&objectname[3][1][0],"objects/glacier/tree2.obj");
	sprintf(&objectname[3][2][0],"objects/glacier/tree1.obj");
	sprintf(&objectname[3][3][0],"objects/glacier/tree3.obj");
	sprintf(&objectname[3][4][0],"objects/glacier/tree4.obj");
	sprintf(&objectname[3][5][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][6][0],"objects/glacier/pik1.obj");
	sprintf(&objectname[3][7][0],"objects/glacier/pik2.obj");
	sprintf(&objectname[3][8][0],"objects/glacier/pik3.obj");
	sprintf(&objectname[3][9][0],"objects/glacier/pik4.obj");
	sprintf(&objectname[3][10][0],"objects/glacier/pik5.obj");
	sprintf(&objectname[3][11][0],"objects/glacier/col11.obj");
	sprintf(&objectname[3][12][0],"objects/glacier/car12.obj");
	sprintf(&objectname[3][13][0],"objects/glacier/car13.obj");
	sprintf(&objectname[3][14][0],"objects/glacier/trn14.obj");
	sprintf(&objectname[3][15][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][16][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][17][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][18][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][19][0],"objects/glacier/vbarn.obj");
	sprintf(&objectname[3][20][0],"objects/glacier/barn.obj");
	sprintf(&objectname[3][21][0],"objects/glacier/stump.obj");
	sprintf(&objectname[3][22][0],"objects/glacier/logs.obj");
	sprintf(&objectname[3][23][0],"objects/glacier/pole.obj");
	sprintf(&objectname[3][24][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][25][0],"objects/glacier/start.obj");
	sprintf(&objectname[3][26][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][27][0],"objects/glacier/church.obj");
	sprintf(&objectname[3][28][0],"objects/glacier/hotel.obj");
	sprintf(&objectname[3][29][0],"objects/glacier/shed.obj");
	sprintf(&objectname[3][30][0],"objects/glacier/house1.obj");
	sprintf(&objectname[3][31][0],"objects/glacier/stnhs.obj");
	sprintf(&objectname[3][32][0],"objects/glacier/cabin.obj");
	sprintf(&objectname[3][33][0],"objects/glacier/fence.obj");
	sprintf(&objectname[3][34][0],"objects/glacier/picnic.obj");
	sprintf(&objectname[3][35][0],"objects/glacier/bush.obj");
	sprintf(&objectname[3][36][0],"objects/glacier/bale.obj");
	sprintf(&objectname[3][37][0],"objects/glacier/wall.obj");
	sprintf(&objectname[3][38][0],"objects/glacier/bigsign.obj");
	sprintf(&objectname[3][39][0],"objects/glacier/sign1.obj");
	sprintf(&objectname[3][40][0],"objects/glacier/sign2.obj");
	sprintf(&objectname[3][41][0],"objects/glacier/sign3.obj");
	sprintf(&objectname[3][42][0],"objects/glacier/bin.obj");
	sprintf(&objectname[3][43][0],"objects/glacier/crk43.obj");
	sprintf(&objectname[3][44][0],"objects/glacier/rkj44.obj");
	sprintf(&objectname[3][45][0],"objects/glacier/gate.obj");
	sprintf(&objectname[3][46][0],"objects/glacier/rbrid.obj");
	sprintf(&objectname[3][47][0],"objects/glacier/snowcat.obj");
	sprintf(&objectname[3][48][0],"objects/glacier/tent.obj");
	sprintf(&objectname[3][49][0],"objects/glacier/van.obj");
	sprintf(&objectname[3][50][0],"objects/glacier/ccar.obj");
	sprintf(&objectname[3][51][0],"objects/glacier/cend.obj");
	sprintf(&objectname[3][52][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][53][0],"objects/glacier/cow.obj");
	sprintf(&objectname[3][54][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][55][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][56][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][57][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][58][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][59][0],"objects/glacier/bbrid.obj");
	sprintf(&objectname[3][60][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][61][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][62][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][63][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][64][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][65][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][66][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][67][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][68][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][69][0],"objects/glacier/cabin.obj");
	sprintf(&objectname[3][70][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][71][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][72][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][73][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][74][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][75][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][76][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][77][0],"objects/glacier/exshk.obj");
	sprintf(&objectname[3][78][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][79][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][80][0],"objects/glacier/hmpbd.obj");
	sprintf(&objectname[3][81][0],"objects/glacier/tree5.obj");    /* icicl */
	sprintf(&objectname[3][82][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][83][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][84][0],"objects/glacier/slog1.obj");
	sprintf(&objectname[3][85][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][86][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][87][0],"objects/glacier/minsh.obj");
	sprintf(&objectname[3][88][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][89][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][90][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][91][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][92][0],"objects/glacier/rbri2.obj");
	sprintf(&objectname[3][93][0],"objects/glacier/stalc.obj");
	sprintf(&objectname[3][94][0],"objects/glacier/stalg.obj");
	sprintf(&objectname[3][95][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][96][0],"objects/glacier/tree5.obj");     /* stilt */
	sprintf(&objectname[3][97][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][98][0],"objects/glacier/stnsk.obj");
	sprintf(&objectname[3][99][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][101][0],"objects/glacier/cha101.obj");
	sprintf(&objectname[3][102][0],"objects/glacier/cha102.obj");
	sprintf(&objectname[3][103][0],"objects/glacier/out103a.obj");
	sprintf(&objectname[3][104][0],"objects/glacier/out104a.obj");
	sprintf(&objectname[3][105][0],"objects/glacier/out105a.obj");
	sprintf(&objectname[3][106][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][107][0],"objects/glacier/out107.obj");
	sprintf(&objectname[3][109][0],"objects/glacier/rbr109.obj");
	sprintf(&objectname[3][110][0],"objects/glacier/rbr110a.obj");
	sprintf(&objectname[3][112][0],"objects/glacier/log112.obj");
	sprintf(&objectname[3][113][0],"objects/glacier/log113.obj");
	sprintf(&objectname[3][114][0],"objects/glacier/log114.obj");
	sprintf(&objectname[3][119][0],"objects/glacier/out119a.obj");
	sprintf(&objectname[3][120][0],"objects/glacier/ral120a.obj");
	sprintf(&objectname[3][121][0],"objects/glacier/ral121a.obj");
	sprintf(&objectname[3][122][0],"objects/glacier/ral122a.obj");
	sprintf(&objectname[3][123][0],"objects/glacier/ral123a.obj");
	sprintf(&objectname[3][124][0],"objects/glacier/ral124.obj");
	sprintf(&objectname[3][125][0],"objects/glacier/bould.obj");
	sprintf(&objectname[3][130][0],"objects/glacier/str130a.obj");
	sprintf(&objectname[3][131][0],"objects/glacier/str131.obj");
	sprintf(&objectname[3][132][0],"objects/glacier/sign4.obj");
	sprintf(&objectname[3][133][0],"objects/glacier/sign5.obj");
	sprintf(&objectname[3][134][0],"objects/glacier/out106a.obj");


	sprintf(&objectname[3][148][0],"objects/glacier/avb01.obj");
	sprintf(&objectname[3][149][0],"objects/glacier/avb01.obj");
	sprintf(&objectname[3][150][0],"objects/glacier/tun150.obj");
	sprintf(&objectname[3][151][0],"objects/glacier/tun151.obj");
	sprintf(&objectname[3][152][0],"objects/glacier/tun152.obj");
	sprintf(&objectname[3][153][0],"objects/glacier/tun153.obj");
	sprintf(&objectname[3][154][0],"objects/glacier/tun154.obj");
	sprintf(&objectname[3][155][0],"objects/glacier/tun155.obj");
	sprintf(&objectname[3][156][0],"objects/glacier/tun156.obj");
	sprintf(&objectname[3][157][0],"objects/glacier/tun157.obj");
	sprintf(&objectname[3][158][0],"objects/glacier/tun158.obj");
	sprintf(&objectname[3][159][0],"objects/glacier/tun159.obj");
	sprintf(&objectname[3][160][0],"objects/glacier/tun160.obj");
	sprintf(&objectname[3][161][0],"objects/glacier/tun161.obj");
	sprintf(&objectname[3][162][0],"objects/glacier/tun162.obj");
	sprintf(&objectname[3][163][0],"objects/glacier/tun163.obj");
	sprintf(&objectname[3][164][0],"objects/glacier/tun164.obj");
	sprintf(&objectname[3][165][0],"objects/glacier/tun165.obj");
	sprintf(&objectname[3][166][0],"objects/glacier/tun166.obj");
	sprintf(&objectname[3][167][0],"objects/glacier/tun167.obj");
	sprintf(&objectname[3][168][0],"objects/glacier/tun168.obj");
	sprintf(&objectname[3][169][0],"objects/glacier/tun169.obj");
	sprintf(&objectname[3][170][0],"objects/glacier/tun170.obj");
	sprintf(&objectname[3][171][0],"objects/glacier/tun171.obj");
	sprintf(&objectname[3][172][0],"objects/glacier/tun172.obj");
	sprintf(&objectname[3][173][0],"objects/glacier/tun173.obj");
	sprintf(&objectname[3][174][0],"objects/glacier/tun174.obj");
	sprintf(&objectname[3][175][0],"objects/glacier/tun175.obj");
	sprintf(&objectname[3][176][0],"objects/glacier/tun176.obj");
	sprintf(&objectname[3][177][0],"objects/glacier/tun177.obj");
	sprintf(&objectname[3][178][0],"objects/glacier/tun178.obj");
	sprintf(&objectname[3][179][0],"objects/glacier/tun179.obj");
	sprintf(&objectname[3][180][0],"objects/glacier/tun180.obj");
	sprintf(&objectname[3][181][0],"objects/glacier/tun181.obj");
	sprintf(&objectname[3][182][0],"objects/glacier/tun182.obj");
	sprintf(&objectname[3][183][0],"objects/glacier/tree5.obj");
	sprintf(&objectname[3][184][0],"objects/glacier/tun184.obj");
	sprintf(&objectname[3][185][0],"objects/glacier/tun185.obj");
	sprintf(&objectname[3][186][0],"objects/glacier/tun186.obj");
	sprintf(&objectname[3][187][0],"objects/glacier/tun187.obj");
	sprintf(&objectname[3][188][0],"objects/glacier/tun188.obj");
	sprintf(&objectname[3][189][0],"objects/glacier/tun189.obj");
	sprintf(&objectname[3][190][0],"objects/glacier/tun190.obj");
	sprintf(&objectname[3][191][0],"objects/glacier/tun191.obj");
	sprintf(&objectname[3][192][0],"objects/glacier/tun192.obj");
	sprintf(&objectname[3][193][0],"objects/glacier/tun193.obj");
	sprintf(&objectname[3][194][0],"objects/glacier/tun194.obj");
	sprintf(&objectname[3][195][0],"objects/glacier/tun195.obj");
	sprintf(&objectname[3][196][0],"objects/glacier/tun196.obj");
	sprintf(&objectname[3][197][0],"objects/glacier/tun197.obj");
	sprintf(&objectname[3][198][0],"objects/glacier/tun198.obj");
	sprintf(&objectname[3][199][0],"objects/glacier/tun199.obj");
	sprintf(&objectname[3][200][0],"objects/glacier/tun200.obj");
	sprintf(&objectname[3][201][0],"objects/glacier/tun201.obj");
	sprintf(&objectname[3][202][0],"objects/glacier/tun202.obj");
	sprintf(&objectname[3][203][0],"objects/glacier/tun203.obj");

/* freeride */

	sprintf(&objectname[4][0][0],"objects/freeride/wrap.obj");
	sprintf(&objectname[4][1][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][2][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][3][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][4][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][5][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][6][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][7][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][8][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][9][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][10][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][11][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][12][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][13][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][14][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][15][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][16][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][17][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][18][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][19][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][20][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][21][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][22][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][23][0],"objects/freeride/lifta.obj");
	sprintf(&objectname[4][24][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][25][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][26][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][27][0],"objects/freeride/church.obj");
	sprintf(&objectname[4][28][0],"objects/freeride/hotel.obj");
	sprintf(&objectname[4][29][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][30][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][31][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][32][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][33][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][34][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][35][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][36][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][37][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][38][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][39][0],"objects/freeride/drsig.obj");
	sprintf(&objectname[4][40][0],"objects/freeride/exsig.obj");
	sprintf(&objectname[4][41][0],"objects/freeride/sqsig.obj");
	sprintf(&objectname[4][42][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][43][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][44][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][45][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][46][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][47][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][48][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][49][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][50][0],"objects/freeride/chair.obj");
	sprintf(&objectname[4][51][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][52][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][53][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][54][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][55][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][56][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][57][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][58][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][59][0],"objects/freeride/bridge.obj");
	sprintf(&objectname[4][60][0],"objects/freeride/pylon.obj");
	sprintf(&objectname[4][61][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][62][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][63][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][64][0],"objects/freeride/hotel.obj");
	sprintf(&objectname[4][65][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][66][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][67][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][68][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][69][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][70][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][71][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][72][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][73][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][74][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][75][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][76][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][77][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][78][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][79][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][80][0],"objects/freeride/hmpbrid.obj");
	sprintf(&objectname[4][81][0],"objects/freeride/tree1.obj");    /* icicl */
	sprintf(&objectname[4][82][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][83][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][84][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][85][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][86][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][87][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][88][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][89][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][90][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][91][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][92][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][93][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][94][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][95][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][96][0],"objects/freeride/tree1.obj");     /* stilt */
	sprintf(&objectname[4][97][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][98][0],"objects/freeride/stnsk.obj");
	sprintf(&objectname[4][99][0],"objects/freeride/tree1.obj");
	sprintf(&objectname[4][100][0],"objects/freeride/barr1.obj");
	sprintf(&objectname[4][101][0],"objects/freeride/barr2.obj");
	sprintf(&objectname[4][102][0],"objects/freeride/barr3.obj");
	sprintf(&objectname[4][103][0],"objects/freeride/snowm.obj");
	sprintf(&objectname[4][104][0],"objects/freeride/teleg.obj");
	sprintf(&objectname[4][105][0],"objects/freeride/campr.obj");
	sprintf(&objectname[4][106][0],"objects/freeride/campos.obj");
	sprintf(&objectname[4][107][0],"objects/freeride/bcars.obj");


	sprintf(&objectname[10][0][0],"objects/2play/wrap.obj");
	sprintf(&objectname[10][1][0],"objects/2play/tree2.obj");
	sprintf(&objectname[10][2][0],"objects/2play/tree1.obj");
	sprintf(&objectname[10][3][0],"objects/2play/tree3.obj");
	sprintf(&objectname[10][4][0],"objects/2play/tree4.obj");
	sprintf(&objectname[10][5][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][6][0],"objects/2play/pik1.obj");
	sprintf(&objectname[10][7][0],"objects/2play/pik2.obj");
	sprintf(&objectname[10][8][0],"objects/2play/pik3.obj");
	sprintf(&objectname[10][9][0],"objects/2play/pik4.obj");
	sprintf(&objectname[10][10][0],"objects/2play/pik5.obj");
	sprintf(&objectname[10][11][0],"objects/2play/col11.obj");
	sprintf(&objectname[10][12][0],"objects/2play/car12.obj");
	sprintf(&objectname[10][13][0],"objects/2play/car13.obj");
	sprintf(&objectname[10][14][0],"objects/2play/trn14.obj");
	sprintf(&objectname[10][15][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][16][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][17][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][18][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][19][0],"objects/2play/vbarn.obj");
	sprintf(&objectname[10][20][0],"objects/2play/barn.obj");
	sprintf(&objectname[10][21][0],"objects/2play/stump.obj");
	sprintf(&objectname[10][22][0],"objects/2play/logs.obj");
	sprintf(&objectname[10][23][0],"objects/2play/pole.obj");
	sprintf(&objectname[10][24][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][25][0],"objects/2play/start.obj");
	sprintf(&objectname[10][26][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][27][0],"objects/2play/church.obj");
	sprintf(&objectname[10][28][0],"objects/2play/hotel.obj");
	sprintf(&objectname[10][29][0],"objects/2play/shed.obj");
	sprintf(&objectname[10][30][0],"objects/2play/house1.obj");
	sprintf(&objectname[10][31][0],"objects/2play/stnhs.obj");
	sprintf(&objectname[10][32][0],"objects/2play/cabin.obj");
	sprintf(&objectname[10][33][0],"objects/2play/fence.obj");
	sprintf(&objectname[10][34][0],"objects/2play/picnic.obj");
	sprintf(&objectname[10][35][0],"objects/2play/bush.obj");
	sprintf(&objectname[10][36][0],"objects/2play/bale.obj");
	sprintf(&objectname[10][37][0],"objects/2play/wall.obj");
	sprintf(&objectname[10][38][0],"objects/2play/bigsign.obj");
	sprintf(&objectname[10][39][0],"objects/2play/sign1.obj");
	sprintf(&objectname[10][40][0],"objects/2play/sign2.obj");
	sprintf(&objectname[10][41][0],"objects/2play/sign3.obj");
	sprintf(&objectname[10][42][0],"objects/2play/bin.obj");
	sprintf(&objectname[10][43][0],"objects/2play/crock.obj");
	sprintf(&objectname[10][44][0],"objects/2play/rjump.obj");
	sprintf(&objectname[10][45][0],"objects/2play/gate.obj");
	sprintf(&objectname[10][46][0],"objects/2play/rbrid.obj");
	sprintf(&objectname[10][47][0],"objects/2play/snowcat.obj");
	sprintf(&objectname[10][48][0],"objects/2play/tent.obj");
	sprintf(&objectname[10][49][0],"objects/2play/van.obj");
	sprintf(&objectname[10][50][0],"objects/2play/ccar.obj");
	sprintf(&objectname[10][51][0],"objects/2play/cend.obj");
	sprintf(&objectname[10][52][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][53][0],"objects/2play/cow.obj");
	sprintf(&objectname[10][54][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][55][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][56][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][57][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][58][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][59][0],"objects/2play/bbrid.obj");
	sprintf(&objectname[10][60][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][61][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][62][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][63][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][64][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][65][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][66][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][67][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][68][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][69][0],"objects/2play/cabin.obj");
	sprintf(&objectname[10][70][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][71][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][72][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][73][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][74][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][75][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][76][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][77][0],"objects/2play/exshk.obj");
	sprintf(&objectname[10][78][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][79][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][80][0],"objects/2play/hmpbr.obj");
	sprintf(&objectname[10][81][0],"objects/2play/tree5.obj");    /* icicl */
	sprintf(&objectname[10][82][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][83][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][84][0],"objects/2play/slog1.obj");
	sprintf(&objectname[10][85][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][86][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][87][0],"objects/2play/minsh.obj");
	sprintf(&objectname[10][88][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][89][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][90][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][91][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][92][0],"objects/2play/rbri2.obj");
	sprintf(&objectname[10][93][0],"objects/2play/stalc.obj");
	sprintf(&objectname[10][94][0],"objects/2play/stalg.obj");
	sprintf(&objectname[10][95][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][96][0],"objects/2play/tree5.obj");     /* stilt */
	sprintf(&objectname[10][97][0],"objects/2play/tree5.obj");
	sprintf(&objectname[10][98][0],"objects/2play/stnsk.obj");
	sprintf(&objectname[10][99][0],"objects/2play/tree5.obj");

}


void findchar( char a )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
}

long findcheckflagchar( char a )
{
	long found,flagfound;

	found=0;
	flagfound=0;
	while (found==0)
	{
		if ((*fileptr=='f')&&(*(fileptr+1)=='l')&&(*(fileptr+2)=='a'))
		{
			flagfound=1;
		}
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
	return flagfound;
}


char *ptrfindchar( char a, char *p )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*p==a)
		{
			found=1;
		}
		else
		{
			p++;
		}
	}
	return p;
}


long findbackchar( char a )
{
	long found,c;

	found=0;
	c=0;
	while (found==0)
	{
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr--;
			c++;
		}
	}
	return c;
}

void findcharupeof( char a )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*fileptr=='j')
		{
			if ((*(fileptr+1)=='e')&&(*(fileptr+2)=='b'))
			{
				found=1;
				fileptr--;
			}
		}
		if (*fileptr=='c')
		{
			if ((*(fileptr+1)=='u')&&(*(fileptr+2)=='b'))
			{
				found=1;
				fileptr--;
			}
		}
		if (*fileptr=='r')
		{
			if ((*(fileptr+1)=='a')&&(*(fileptr+2)=='d'))
			{
				found=1;
				fileptr--;
			}
		}

		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
}

void findnumericalchar( void )
{
	long found;

	found=0;
	while (found==0)
	{
		if (((*fileptr>='0')&&(*fileptr<='9'))||(*fileptr=='-'))
		{
			found=1;
		}
		else
		{
			if ((*fileptr=='j')&&(*(fileptr+1)=='e')&&(*(fileptr+2)=='b'))
			{
				parseend=1;
				return;
			}
			if ((*fileptr=='r')&&(*(fileptr+1)=='e')&&(*(fileptr+2)=='m'))
			{
				while (*fileptr!=0x0a)
				{
					fileptr++;
				}
				fileptr++;
			}
			else
			{
			 	fileptr++;
			}
		}
	}
}

void findafterspace( void )
{
	long found;

	found=0;
	while (found==0)
	{
		if ((*fileptr==0x20)&&(*(fileptr+1)!=0x20))
		{
			found=1;
			fileptr++;
		}
		else
		{
			fileptr++;
		}
	}
}

long inttexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;
	long negans;

	tenscount=1;
	intans=0;
	negans=0;
	if (*fileptr=='-')
	{
		fileptr++;
		negans=1;
	}
	storeptr=fileptr;
	while ((*fileptr!=0x20)&&(*fileptr!=0x0d)&&(*fileptr!=0x09))
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	if (negans==1)
	{
		intans=-intans;
	}
	return intans/10;
}

long eoltexttoint( char *fileptr )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fileptr;
	tenscount=1;
	intans=0;
	fileptr++;
	while (*fileptr!=0x0d)
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans;
}

long ptrtexttoint( char *fp )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fp;
	tenscount=1;
	intans=0;
	fp++;
	while (*fp!=0x20)
	{
 		tenscount*=10;
 		fp++;
	}
	while (storeptr!=fp)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans;
}


long verttexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fileptr;
	tenscount=1;
	intans=0;
	fileptr++;
	while (*fileptr!=0x20)
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans/10;
}


long floattexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,gencount,intans;
	long negative=0;

	if (*fileptr=='-')
	{
		negative=1;
		fileptr++;
	}
	storeptr=fileptr;
	tenscount=1000;
	gencount=0;
	intans=0;
	fileptr++;
	while (*fileptr!='.')
	{
		tenscount*=10;
		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	fileptr++;
	tenscount=100;
	while (*fileptr!=0x20)
	{
		thischar[0]=*fileptr;
		intans+=atoi(&thischar[0])*tenscount;
		fileptr++;
		tenscount/=10;
	}
	if (negative==1)
	{
		intans=-intans;
	}
	return intans;
}

long	roundit( long a )
{
	a/=100;
	if ((a%10)>4)
	{
		a/=10;
		a++;
	}
	else
	{
		a/=10;
	}
	return a;
}

void getpadshit( void )
{
	long	thisvalue;

	thisvalue=PadRead( 0 );
	thisvalue&=0xffff;
	if (thisvalue==0)
	{
		paddebounced=0;
	}
	if (thisvalue&PADstart)
	{
		arseexit=1;
	}
	if (thisvalue&PADRdown)
	{
		if (issaved==0)
		{
			issaved=1;
		}
	}
}

long savefile(void)
{
	long addr1,addr2,addrdiff;

	addr1=objloadptr;
	addr2=&ObjectSpace[0];
	addrdiff=addr1-addr2;
	fin	=	PCcreat( &psxobjname, 0 );
	fileptr = &ObjectSpace;
	checksum=PCwrite(fin,fileptr,addrdiff);			/* write numverts */
	PCclose(fin);
	fin	=	PCcreat( &psxchname, 0 );
	fileptr = &ChillObjects[0];
	checksum2=PCwrite(fin,fileptr,(sizeof(objheader)*210));			/* write numverts */
	PCclose(fin);
	if ((checksum==(addrdiff))&&(checksum2==(sizeof(objheader)*210)))
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

void main ( void )
{

	long	parsefound,vertindex;
	char 	*pointerstore;
	long	*timsizeptr;
	long	timsize;
	long	tempus,tempvs;
	char	*tpageptr;
	long	i,j,k;

	PCinit();
	PadInit(0);
	ResetGraph(0);
//	SetGraphDebug(2);
	InitGeom();
	srand(1);
	initialiseobjectnames();
	for (i=0;i<210;i++)
	{
		ChillObjects[i].loaded=0;
	}

	fin			=	PCopen( "control.txt", 0, 0 );
	filesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	fileptr		=	&filebuffer;
	PCread( fin, (char *)fileptr, filesize );
	PCclose( fin );

	/* copy filenames from control file */

	filecharindex=9;
	for (count1=0;count1<12;count1++)
	{
		if (*fileptr!='.')
		{
			mvfilename[filecharindex]=*fileptr;
			fileptr++;
			filecharindex++;
		}
	}
	mvfilename[filecharindex]='.';
	mvfilename[filecharindex+1]='o';
	mvfilename[filecharindex+2]='l';
	mvfilename[filecharindex+3]=0;
	filecharindex=9;
	outcharindex=4;
	while (mvfilename[filecharindex]!='.')
	{
		psxobjname[outcharindex]=mvfilename[filecharindex];
		psxchname[outcharindex]=mvfilename[filecharindex];
		filecharindex++;
		outcharindex++;
	}
	psxobjname[outcharindex]='.';
	psxobjname[outcharindex+1]='o';
	psxobjname[outcharindex+2]='b';
	psxobjname[outcharindex+3]='t';
	psxobjname[outcharindex+4]=0;

	psxchname[outcharindex]='.';
	psxchname[outcharindex+1]='c';
	psxchname[outcharindex+2]='h';
	psxchname[outcharindex+3]='o';
	psxchname[outcharindex+4]=0;

	fin			=	PCopen( &mvfilename, 0, 0 );
	filesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	fileptr		=	&filebuffer;
	PCread( fin, (char *)fileptr, filesize );
	PCclose( fin );
	*(fileptr+filesize)='j';
	*(fileptr+filesize+1)='e';
	*(fileptr+filesize+2)='b';
	/* parse hrc file */
	parseend=0;
	moveobjptr=&outbuffer;
	totalmovables=0;
	objloadptr=&ObjectSpace;
	while (parseend==0)
	{
		findnumericalchar();
		if (parseend==1)
		{
			break;
		}
		nomovables=inttexttoint();
		findnumericalchar();
		trackno=inttexttoint();
		for (i=0;i<nomovables;i++)
		{
			findnumericalchar();
			thisobj=inttexttoint();
			fh			=	PCopen( &objectname[trackno][thisobj], 0, 0 );
			printf("loading %s \n",&objectname[trackno][thisobj]);
			filesize	=	PClseek( fh, 0, 2 );
			PClseek( fh, 0, 0 );
			PCread( fh, (char *)objloadptr, filesize );
			PCclose( fh );
			a4=&ObjectSpace[0];
			objaddress=objloadptr;
			longptr=objaddress;
			ChillObjects[thisobj].numverts=*longptr;
			objaddress+=4;
			longptr=objaddress;
			ChillObjects[thisobj].numpolys=*longptr;
			objaddress+=4;
			longptr=objaddress;
			ChillObjects[thisobj].type=*longptr;
			objaddress+=4;
			a1=objaddress;
			a1-=a4;
			ChillObjects[thisobj].vertptr=a1;

			objaddress+=(8*ChillObjects[thisobj].numverts);
			a2=objaddress;
			a2-=a4;
			ChillObjects[thisobj].polyptr=a2;

			objaddress+=(60*ChillObjects[thisobj].numpolys);
			longptr=objaddress;
			ChillObjects[thisobj].numcolls=*longptr;
			objaddress+=4;
			a3=objaddress;
			a3-=a4;
			ChillObjects[thisobj].collptr=a3;

			ChillObjects[thisobj].loaded=1;
			if ((filesize%4!=0))
			{
				filesize+=4-(filesize%4);
			}
			objloadptr+=filesize;
		}
	}
	SetDefDrawEnv(&drawenv[0],0,0,320,240);
	SetDefDispEnv(&dispenv[0],0,240,320,240);
	SetDefDrawEnv(&drawenv[1],0,240,320,240);
	SetDefDispEnv(&dispenv[1],0,0,320,240);
	PutDrawEnv(&drawenv[0]);
	PutDispEnv(&dispenv[0]);
	FntLoad(896,0);
	fntid1 = FntOpen(15,15,280,9,1,50);
	SetDumpFnt(fntid1);
	fntid2 = FntOpen(15,24,280,9,1,50);
	SetDumpFnt(fntid2);
	fntid3 = FntOpen(15,33,280,9,1,50);
	SetDumpFnt(fntid3);
	fntid4 = FntOpen(15,42,280,9,1,50);
	SetDumpFnt(fntid4);
	fntid6 = FntOpen(15,51,280,9,1,50);
	SetDumpFnt(fntid6);
	fntid5 = FntOpen(15,60,280,9,1,50);
	SetDumpFnt(fntid5);
	geomx=120;
	geomy=160;
	SetGeomOffset(geomx,geomy);      /* 160,120 */
	geomscreen=340;
	SetGeomScreen( geomscreen );        /* 512 */
	fc.r=0;    /* 148,148,196 */
	fc.g=0;
	fc.b=0;
	z=4000;
	d=800;
	bc.r=200;
	bc.g=200;
	bc.b=200;
	SetFarColor(fc.r,fc.g,fc.b);
	SetFogNear(z,d);
	SetBackColor(bc.r,bc.g,bc.b);
	for (c1=0;c1<2;c1++)
	{
		clearsquare[c1].x0=0;
		clearsquare[c1].x1=320;
		clearsquare[c1].y0=0;
		clearsquare[c1].y1=0;
		clearsquare[c1].x2=0;
		clearsquare[c1].x3=320;
		clearsquare[c1].y2=240;
		clearsquare[c1].y3=240;
		clearsquare[c1].r0=100;           /* 148 */
		clearsquare[c1].g0=100;           /* 148 */
		clearsquare[c1].b0=230;           /* 196 */
	}
	SetLightMatrix(&MyLocalLight);
	SetColorMatrix(&MyColourMatrix);
	PrimaryColourVector.r=128;
	PrimaryColourVector.g=128;
	PrimaryColourVector.b=128;
	while (arseexit==0)
	{
		getpadshit();
		pollhost();
		otptr=&OT[otid][0];
		ClearOTagR(otptr,4096);
		geomx=120; /* 180 */
		geomy=160;
		gte_SetGeomOffset(geomx,geomy);
		gte_SetGeomScreen(geomscreen);                   /* temp */

		SetFarColor(fc.r,fc.g,fc.b);
		SetFogNear(z,d);
		SetBackColor(bc.r,bc.g,bc.b);

		clearsquare[otid].y0=0;
		clearsquare[otid].y1=0;
 		clearsquare[otid].y2=240;
 		clearsquare[otid].y3=240;
		SetPolyF4(&clearsquare[otid]);
		otptr=&OT[otid][4095];
//		otptr=&OT[otid][0];

		AddPrim(otptr,&clearsquare[otid]);

		pollhost();
		DrawSync(0);
		VSync (0);
		FntPrint(fntid1,"BUILDOBJ ver: %s %s",__DATE__,__TIME__);
		FntFlush(fntid1);
		FntPrint(fntid2,"Finished Parsing %s\n",&mvfilename);
		FntFlush(fntid2);
		FntPrint(fntid3,"objs %d - X to save",nomovables);
		FntFlush(fntid3);
		if (issaved==1)
		{
			checkvalue=savefile();
			issaved=2;
		}
		if (issaved==2)
		{
			FntPrint(fntid4,"file %s saved",&psxobjname);
			FntFlush(fntid4);
			FntPrint(fntid6,"file %s saved ",&psxchname);
			FntFlush(fntid6);

			if (checkvalue==1)
			{
				FntPrint(fntid5,"file checksum was correct.");
			}
			else
			{
				FntPrint(fntid5,"file checksum was NOT correct.");
			}
			FntFlush(fntid5);
		}
		PutDrawEnv(&drawenv[display_id]);
		PutDispEnv(&dispenv[display_id]);
		otptr=&OT[otid][4095];
		DrawOTag(otptr);
		if (firstscreendrawn==0)
		{
			SetDispMask(1);
			firstscreendrawn=1;
		}
		display_id=(display_id+1)%2;
		otid=(otid+1)%2;
	}

	PadStop();
}
